package org.act.soap.authen;
import javax.security.auth.Subject;
import org.act.soap.util.logging.*;
import org.act.soap.soapsec.SOAPSecurity;
import org.act.soap.authen.LoginException;

public class LoginContext {
  private Subject subject;                  private LoginModule[] loginModules;       private SOAPSecurity soapsec = null;      
  public LoginContext() {
      this.subject = new Subject();
      this.loginModules = null;
      this.soapsec = null;
  }
  
  public boolean login() throws LoginException, Exception {
      if( loginModules != null ) {
          for( int i=0; i<loginModules.length; i++ ) {
                            if( loginModules[i] != null && loginModules[i].login(this) )
                  return true;                     }
      }
      return false;   }
  
  public Subject getSubject() {
      return this.subject;
  }
  
  public boolean logout() throws LoginException {
      if( loginModules != null ) {
          for( int i=0; i<loginModules.length; i++ ) {
                            if( loginModules[i] != null && loginModules[i].logout(this) )
                  return true;
          }
      }
      return false;     }
  
  public void setLoginModules( LoginModule[] loginModules ) {
      this.loginModules = loginModules;
  }
  
  public LoginModule[] getLoginModules() {
      return this.loginModules;
  }
  
  public void setSOAPSecurity( SOAPSecurity soapsec ) {
      this.soapsec = soapsec;
  }
  
  public SOAPSecurity getSOAPSecurity() {
      return this.soapsec;
  }
}
