package org.act.soap.authen;
import java.security.Principal;

public class LoginPrincipal implements Principal, java.io.Serializable {
  private String name;
  private String authType;
  
  public LoginPrincipal(String name) {
      if (name == null)
          throw new NullPointerException("illegal null input");
      this.name = name;
  }
  
  public String getName() {
      return name;
  }
  
  public String toString() {
      return("ActPrincipal:  " + name);
  }
  
  public boolean equals(Object o) {
      if (o == null)
          return false;
      if (this == o)
          return true;
      if (!(o instanceof LoginPrincipal))
          return false;
      LoginPrincipal that = (LoginPrincipal)o;
      if (this.getName().equals(that.getName()))
          return true;
      return false;
  }
  
  public int hashCode() {
      return name.hashCode();
  }
  public void setAuthType(String _authType){
      authType = _authType ;
  }
  public String getAuthType(){
      return authType ;
  }
  
   public String marshal(){
      return name ;
   }
   
    public static LoginPrincipal unmarshal(String str){
      return new LoginPrincipal(str);
    }
}
