package org.act.soap.authen;
import org.act.soap.soapsec.SOAPSecurity;
import org.act.soap.soapsec.securitytoken.SecurityToken;
import org.act.soap.soapsec.securitytoken.UsernameToken;
import org.act.soap.util.logging.Log;
import org.act.soap.util.logging.LogFactory;
import org.act.soap.util.i18n.Message;
import org.act.soap.authen.LoginPrincipal;
import org.act.soap.server.config.ConfigManager;
import org.act.soap.server.secmanager.UserManager;
import java.util.Set;

public class PasswordLoginModule implements LoginModule {
  
  private static Log log = LogFactory.getLog(PasswordLoginModule.class.getName());
  
  public PasswordLoginModule() {
  }
  
  public boolean login( LoginContext loginContext ) throws LoginException,
      Exception {
            UserManager usermanager = ConfigManager.getInstance().getUserManager();
            SOAPSecurity soapsec = loginContext.getSOAPSecurity();
      if( soapsec == null ) return false;
            SecurityToken[] tokens = soapsec.getSecurityTokens();
      if( tokens != null ) {
          for( int i=0; i<tokens.length; i++ ) {
              if( tokens[i] instanceof UsernameToken ) {
                  UsernameToken userToken = (UsernameToken)tokens[i];
                                    String username = userToken.getUsername();
                  int userID = usermanager.getUserID( username );
                  if( userID == -1 ) {
                      System.out.println(">>> ûڡû = " + username );
                      continue;
                  }
                  String password = usermanager.getPassword( userID );
                  if( userToken.verifyPassword( password ) ) {
                                            LoginPrincipal userPrincipal = new LoginPrincipal(String.valueOf(userID));
                      userPrincipal.setAuthType( "PASSWORD" );
                      Set principals = loginContext.getSubject().getPrincipals();
                      principals.add( userPrincipal );
                      System.out.println( "************************ ֤ģ ***********************");
                      System.out.println( "   û/֤ɹû = " + username );
                      System.out.println( "                        ûID = " + userID );
                      System.out.println( "*********************************************************" );
                      return true;
                  }else{
                      System.out.println( ">>> û" + username + "" );
                  }
              }
          }
      }
      System.out.println("ûЧUsernameToken");
      return false;
  }
  
  public boolean logout( LoginContext loginContext ) throws LoginException {
      return false;
  }
}
