package org.act.soap.client;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Vector;
import javax.wsdl.Binding;
import javax.wsdl.BindingInput;
import javax.wsdl.BindingOperation;
import javax.wsdl.Message;
import javax.wsdl.Operation;
import javax.wsdl.Part;
import javax.wsdl.Port;
import javax.wsdl.PortType;
import javax.wsdl.extensions.soap.SOAPAddress;
import javax.wsdl.extensions.soap.SOAPOperation;
import javax.xml.namespace.QName;
import javax.xml.rpc.JAXRPCException;
import javax.xml.rpc.ParameterMode;
import javax.xml.rpc.encoding.TypeMapping;
import javax.xml.rpc.soap.SOAPFaultException;
import javax.xml.soap.AttachmentPart;
import javax.xml.soap.MessageFactory;
import javax.xml.soap.Name;
import javax.xml.soap.SOAPBody;
import javax.xml.soap.SOAPBodyElement;
import javax.xml.soap.SOAPConnection;
import javax.xml.soap.SOAPConnectionFactory;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPEnvelope;
import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPFault;
import javax.xml.soap.SOAPHeader;
import javax.xml.soap.SOAPHeaderElement;
import javax.xml.soap.SOAPMessage;
import org.act.soap.client.handler.HandlerChain;
import org.act.soap.client.handler.HandlerRegistry;
import org.act.soap.encoding.DeserializationContextImpl;
import org.act.soap.encoding.DeserializerImpl;
import org.act.soap.encoding.SerializationContextImpl;
import org.act.soap.encoding.SerializerImpl;
import org.act.soap.encoding.TypeMappingImpl;
import org.act.soap.util.JavaUtils;
import org.act.soap.util.SOAPUtils;
import org.act.soap.util.TMConstants;
import javax.activation.DataHandler;

public class Call implements javax.xml.rpc.Call{
    
    private static HashMap validPropertyNameAndType = new HashMap( 7 );
        static {
        validPropertyNameAndType.put( Call.USERNAME_PROPERTY, String.class );
        validPropertyNameAndType.put( Call.PASSWORD_PROPERTY, String.class );
        validPropertyNameAndType.put( Call.SESSION_MAINTAIN_PROPERTY, Boolean.class );
        validPropertyNameAndType.put( Call.ENCODINGSTYLE_URI_PROPERTY, String.class );
        validPropertyNameAndType.put( Call.OPERATION_STYLE_PROPERTY, String.class );
        validPropertyNameAndType.put( Call.SOAPACTION_USE_PROPERTY, Boolean.class );
        validPropertyNameAndType.put( Call.SOAPACTION_URI_PROPERTY, String.class );
    }
    
    private List attachments = null;
    
    private List headers = null;
    
    private MessageContext msgContext = new MessageContext();
    
    private Operation operation = null;
    
    private QName operationName = null;
    
    private HashMap outputParams = new HashMap( 10 );
    
    private List outputValues = new Vector( 10 );
    
    private boolean paramAndRettypeNeed = true;
    
    private List parameterOrder = new ArrayList( 10 );
    
    private HashMap parameters = new HashMap( 10 );
    
    private QName portName = null;
    
    private QName portTypeName = null;
    
    private HashMap properties = new HashMap( 7 );
    
        protected ParamDescription returnType = new ParamDescription();
    
    private Service service = null;
    
    private URL serviceEndpointAdd = null;
    
    private TypeMapping typeMap = null;

    
    protected Call(){
                this.setProperty( Call.ENCODINGSTYLE_URI_PROPERTY,
                          TMConstants.URI_SOAP11_ENC );
    }
    
    protected Call( Service _service ){
        this.service = _service ;
                this.setProperty( Call.ENCODINGSTYLE_URI_PROPERTY,
                          TMConstants.URI_SOAP11_ENC );
                if( null != service.getBindingService() ) {
            this.paramAndRettypeNeed = false;
        }
    }


    
    public final void addParameter( String paramName, QName xmlType,
                             Class javaType, ParameterMode parameterMode ){
        if( !this.isParameterAndReturnSpecRequired( this.operationName ) ) {
            throw new JAXRPCException( org.act.soap.util.i18n.Message.getMessage( "ERR_Call_methodCallErr", "addParameter" ) );
        }
        ParamDescription paramDesc = new ParamDescription(
            paramName,
            parameterMode,
            xmlType,
            javaType );
        this.addParameter( paramDesc );
    }
    
    public final void addParameter( String paramName, QName xmlType,
            ParameterMode parameterMode ){
        if( !this.isParameterAndReturnSpecRequired( this.operationName ) ) {
            throw new JAXRPCException( org.act.soap.util.i18n.Message.getMessage( "ERR_Call_methodCallErr", "addParameter" ) );
        }
        ParamDescription paramDesc = new ParamDescription(
            paramName,
            parameterMode,
            xmlType,
            null );
        this.addParameter( paramDesc );
    }
    
    public void setTargetEndpointAddress( String address ){
        if( null == address ) {
            throw new JAXRPCException( org.act.soap.util.i18n.Message.getMessage( "ERR_Stub_nullPoint" , "EndpointAddress" ) );
        }
        try{
            URL url = new URL( address );
            this.serviceEndpointAdd = url;
        }catch( MalformedURLException e ){
            throw new JAXRPCException( e );
        }
    }
    
    public final QName getOperationName() {
        return operationName;
    }
    
    public final Map getOutputParams() {
        return this.outputParams;
    }
    
    public final List getOutputValues() {
        return this.outputValues;
    }
    
    public final QName getParameterTypeByName( String paramName ){
        ParamDescription paramDesc = ( ParamDescription )this
            .parameters.get( paramName );
        QName paramType = paramDesc.getXmlType();
        return paramType;
    }
    
    public final QName getPortTypeName() {
        return this.portTypeName;
    }
    
    public final Object getProperty( String name ){
        if( null == name ){
            throw new JAXRPCException( org.act.soap.util.i18n.Message.getMessage( "ERR_Call_invPropName" ) );
        }else if( ! validPropertyNameAndType.containsKey( name ) ){
            throw new JAXRPCException( org.act.soap.util.i18n.Message.getMessage( "ERR_Call_unsupportedProperty", name ) );
        }else{
            return this.properties.get( name );
        }
    }
    
    public final Iterator getPropertyNames(){
        return this.properties.keySet().iterator();
    }
    
    public QName getReturnType() {
        return this.returnType.getXmlType();
    }
    
    public String getTargetEndpointAddress() {
        if( null == this.serviceEndpointAdd ) {
            return null;
        }
        return this.serviceEndpointAdd.toString();
    }
    
    public Object invoke( Object[] params ) throws java.rmi.RemoteException {
                if( null != this.service.getBindingService() ){
            if ( null != this.portName ) {
                this.setInfoFromWSDL( params );
            }else{
                Iterator portNames = this.service.getBindingService()
                    .getPorts().keySet().iterator();
                int size = this.service.getBindingService().getPorts().size();
                for( int i = 0; i < size; i++ ){
                    this.portName = new QName( "", (String)portNames.next() );
                    this.setInfoFromWSDL( params );
                                        if( null != this.operation ) {
                        break;
                    }
                }
            }
        }
                this.consReqMsg( params );
                if( null == this.serviceEndpointAdd ) {
            throw new JAXRPCException( org.act.soap.util.i18n.Message.getMessage( "ERR_Call_noEndpointAdd" ) );
        }
        this.sendReqMsg();
        Object ret = this.handleResMsg(params);
        return ret;
    }
    
    public Object invoke( QName operationname, Object[] params )
        throws java.rmi.RemoteException {
        Object ret = null;
        if( null != operationname ) {
            this.setOperationName( operationname );
        }else{
            throw new JAXRPCException( org.act.soap.util.i18n.Message
                                       .getMessage( "ERR_Call_nullOpeName" ) );
        }
        ret = this.invoke( params );
        return ret;
    }
    
    public void invokeOneWay( Object[] params ) {
                final Call call = this;
        final Object[] tmpParams = params;
        Runnable runnable = new Runnable(){
            public void run() {
                                if( null != call.service.getBindingService() ){
                    if ( null != call.portName ) {
                        call.setInfoFromWSDL( tmpParams );
                    } else{
                        Iterator portNames = call.service.getBindingService()
                            .getPorts().keySet().iterator();
                        int size = call.service.getBindingService()
                            .getPorts().size();
                        for( int i = 0; i < size; i++ ){
                            call.portName = (QName)portNames.next();
                            call.setInfoFromWSDL( tmpParams );
                                                        if( null != call.operation ) {
                                break;
                            }
                        }
                    }
                }
                                call.consReqMsg( tmpParams );
                                if( null == call.getTargetEndpointAddress() ) {
                    throw new JAXRPCException( org.act.soap.util.i18n.Message.getMessage( "ERR_Call_noEndpointAdd" ) );
                }
                call.sendReqMsg();
            }
        };
        Thread thread = new Thread(runnable);
        thread.start();
    }
    
    public boolean isParameterAndReturnSpecRequired( QName operationname ) {
        return this.paramAndRettypeNeed;
    }
    
    public void removeAllParameters() {
        this.parameters.clear();
        this.parameterOrder.clear();
    }
    
    public void removeProperty( String name ){
                if( null == name ){
            throw new JAXRPCException( org.act.soap.util.i18n.Message.getMessage( "ERR_Call_invPropName" ) );
        }else if( ! validPropertyNameAndType.containsKey( name ) ) {
                throw new JAXRPCException( org.act.soap.util.i18n.Message.getMessage( "ERR_Call_unsupportedProperty", name ) );
        }else{
            this.properties.remove( name );
        }
    }
    
    public void setOperationName( QName opName ){
        operationName = opName;
    }
    
    public void setPortTypeName( QName portType ) {
        this.portTypeName = portType;
    }
    
    public void setProperty( String name, Object value ) {
                if( null == name ){
            throw new JAXRPCException( org.act.soap.util.i18n.Message.getMessage( "ERR_Call_invPropName" ) );
        }else if( null == value ){
            throw new JAXRPCException( org.act.soap.util.i18n.Message.getMessage( "ERR_Call_invPropValue" ) );
        }else if( ! validPropertyNameAndType.containsKey( name ) ) {
            throw new JAXRPCException( org.act.soap.util.i18n.Message.getMessage( "ERR_Call_unsupportedProperty", name ) );
        }else if( ! validPropertyNameAndType.get(name).equals( value.getClass() ) ) {
            throw new JAXRPCException( org.act.soap.util.i18n.Message.getMessage( "ERR_Call_invPropValType", ((Class)validPropertyNameAndType.get(name)).getName(), value.getClass().getName() ) );
        }else {
                        if( name.equals( Call.ENCODINGSTYLE_URI_PROPERTY ) ) {
                if( null == this.service ) {
                    try{
                        this.service =
                            (org.act.soap.client.Service)ServiceFactory.newInstance()
                            .createService( new QName( "" ) );
                    }catch( Exception e ){
                        throw new JAXRPCException( e );
                    }
                }
                this.typeMap = this.service.getTypeMappingRegistry()
                    .getTypeMapping( (String)value );
            }else if( name.equals( Call.OPERATION_STYLE_PROPERTY )
                      && ( ! value.equals( "rpc" ) )
                      && ( ! value.equals( "document" ) ) ) {
                throw new JAXRPCException( org.act.soap.util.i18n.Message.getMessage( "ERR_Call_invPropValue2" ) );
            }
                        this.properties.put( name, value );
        }
    }
    
    public void setReturnType( QName xmlType ){
        if( !this.isParameterAndReturnSpecRequired( this.operationName ) ) {
            throw new JAXRPCException( org.act.soap.util.i18n.Message.getMessage( "ERR_Call_methodCallErr", "setReturnType" ) );
        }
        this.returnType.setXmlType( xmlType );
        this.returnType.setReturned( true );
    }
    
    public void setReturnType( QName xmlType, Class javaType ){
        if( !this.isParameterAndReturnSpecRequired( this.operationName ) ) {
            throw new JAXRPCException( org.act.soap.util.i18n.Message.getMessage( "ERR_Call_methodCallErr", "setReturnType" ) );
        }
        this.returnType.setXmlType( xmlType );
        this.returnType.setJavaType( javaType );
        this.returnType.setReturned( true );
    }


    
    public final void addRequestAttachmentPart( AttachmentPart attch ){
        if( null == attch ) {
            throw new JAXRPCException( org.act.soap.util.i18n.Message.getMessage( "ERR_Stub_nullPoint" , "AttachmentPart" ) );
        }
        if( null == this.attachments ){
            this.attachments = new Vector( 1 );
        }
        this.attachments.add( attch );
    }
    
    public final void addRequestHeader( SOAPHeaderElement headerEle ){
        if( null == headerEle ) {
            throw new JAXRPCException( org.act.soap.util.i18n.Message.getMessage( "ERR_Stub_nullPoint" , "SOAPHeaderElement" ) );
        }
        if( null == this.headers ){
            this.headers = new Vector( 10 );
        }
        this.headers.add( headerEle );
    }
    
    public final MessageContext getMessageContext(){
        return this.msgContext;
    }
    
    public final Operation getOperation(){
        return this.operation;
    }
    
    public final QName getPortName(){
        return this.portName;
    }
    
    public SOAPMessage getRequestMessage(){
        if( null == this.msgContext.getRequestMessage() ) {
            return null;
        } else {
            return this.msgContext.getRequestMessage();
        }
    }
    
    public final AttachmentPart[] getResponseAttachments(){
        List ret = new Vector( 20 );
        SOAPMessage resMessage = this.msgContext.getResponseMessage();
        if( null == resMessage ) {
            return new AttachmentPart[0];
        }
        Iterator iter = resMessage.getAttachments();
        for( ; iter.hasNext(); ){
            ret.add( iter.next() );
        }
        return (AttachmentPart[])ret.toArray( new AttachmentPart[ret.size()] );
    }
    
    public SOAPHeaderElement[] getResponseHeaders(){
        List ret = new Vector( 20 );
        SOAPMessage resMessage = this.msgContext.getResponseMessage();
        if( null == resMessage ) {
            return new SOAPHeaderElement[0];
        }
        Iterator iter = resMessage.getMimeHeaders().getAllHeaders();
        for( ; iter.hasNext(); ){
            ret.add( iter.next() );
        }
        return (SOAPHeaderElement[])ret.toArray( new SOAPHeaderElement[ret.size()] );
    }
    
    public SOAPMessage getResponseMessage(){
        return this.msgContext.getResponseMessage();
    }
    
    public Service getService(){
        return this.service;
    }
    
    public TypeMapping getTypeMapping(){
        if( null == this.typeMap ) {
            this.typeMap = service.getTypeMappingRegistry().getTypeMapping(
                this.properties.get(
                    Call.ENCODINGSTYLE_URI_PROPERTY ).toString() );
        }
        return this.typeMap;
    }
    
    public void recycle(){
                this.attachments = null;
        this.headers = null;
        this.msgContext = new MessageContext();
        this.operation = null;
        this.operationName = null;
        this.outputParams = new HashMap( 10 );
        this.outputValues = new Vector( 10 );
        this.parameterOrder = new ArrayList( 10);
        this.parameters = new HashMap( 10 );
        this.returnType = new ParamDescription();
        if( null != this.service.getBindingService() ) {
            this.paramAndRettypeNeed = false;
        } else {
            this.paramAndRettypeNeed = true;
        }
    }
    
    public void setOperation( Operation _operation ){
        this.operation = _operation;
    }
    
    public void setPortName( QName portname ){
        this.portName = portname;
    }


    
    private void addParameter( ParamDescription paramDesc ){
        this.parameters.put( paramDesc.getParamName(), paramDesc );
        this.parameterOrder.add( paramDesc.getParamName() );
    }
    
    private void bindingOperation( Object[] params ){
        if( null == this.operation ){
            List operationList = this.service.getDefinition().
                getPortType( this.portTypeName ).getOperations();
            int index = -1;
            int size = operationList.size();
            for ( int i = 0; i < size; i++ ) {
                Operation tmpOperation = (Operation) operationList.get(i);
                boolean ret = validateParams( tmpOperation, params );
                if( ret ){
                    index = i;
                    break;
                }
            }
            if( -1 != index ) {
                this.operation = (Operation) operationList.get(index);
            }else{
                throw new JAXRPCException( org.act.soap.util.i18n.Message.getMessage( "ERR_Call_operationSetErr" ) );
            }
        }
    }
    
    private void consReqMsg( Object[] params ){
                copyProperties();
        int tmpSize = 0;
                SOAPMessage reqMessage = null;
        try {
            MessageFactory messageFactory = SOAPUtils.MESSAGEFACTORY_INSTANCE;
            reqMessage = messageFactory.createMessage();
                                    reqMessage.setProperty(SOAPMessage.CHARACTER_SET_ENCODING, "UTF-8" );
            reqMessage.setProperty( SOAPMessage.WRITE_XML_DECLARATION, "true" );
            SOAPEnvelope soapEnv = reqMessage.getSOAPPart().getEnvelope();
            soapEnv.addNamespaceDeclaration( TMConstants.URI_DEFAULT_SCHEMA_XSD_PREFIX,
                                             TMConstants.URI_2001_SCHEMA_XSD );
            soapEnv.addNamespaceDeclaration( TMConstants.NS_XSI_TYPE_PREFIX,
                                             TMConstants.URI_2001_SCHEMA_XSI );
            soapEnv.addNamespaceDeclaration( TMConstants.URI_DEFAULT_SOAP_ENC_PREFIX,
                                             TMConstants.URI_SOAP11_ENC );
            String encodingStyleURI = (String)this
                .getProperty( Call.ENCODINGSTYLE_URI_PROPERTY );
            soapEnv.setEncodingStyle( encodingStyleURI );
            SOAPHeader soapHeader = soapEnv.getHeader();
                        if ( null != this.headers && 0 != this.headers.size() ) {
                tmpSize = this.headers.size();
                for (int i = 0; i < tmpSize; i++) {
                    ( (SOAPHeaderElement) headers.get(i)).setParentElement( soapHeader );
                }
            }
            SOAPBody soapBody = soapEnv.getBody();
                        Name bodyEleName = soapEnv.createName( operationName.getLocalPart(),
                                                   null,
                                                   operationName.getNamespaceURI() );
            SOAPBodyElement soapBodyEle = soapBody.addBodyElement( bodyEleName );
                        if((params!=null) && (params.length>0)){
              Object obj = params[0];
              if(obj.getClass()==DataHandler[].class){
                                 DataHandler[] dhs=(DataHandler[])obj;
                 for(int i=0;i<dhs.length;i++){
                   if(dhs[i]!=null){
                     addRequestAttachmentPart(reqMessage.createAttachmentPart(dhs[i]));
                   }
                 }
              }
            }
                        writeParameters( soapBodyEle, params );
                        if ( null != this.attachments ) {
                tmpSize = this.attachments.size();
                for ( int i = 0; i < tmpSize; i++ ) {
                    reqMessage.addAttachmentPart( (AttachmentPart)this
                                                  .attachments.get(i) );
                }
            }
            this.msgContext.setRequestMessage( reqMessage );
        }catch( Exception e ) {
            throw new JAXRPCException(e);
        }
    }
    
    private void copyProperties(){
        this.msgContext.setServiceAdd( this.serviceEndpointAdd );
        if( null == this.getTypeMapping() ) {
            throw new JAXRPCException( org.act.soap.util.i18n.Message.getMessage( "ERR_Call_noCorrespondTM" ) );
        }
        this.msgContext.setTypeMapping( this.getTypeMapping() );
        Iterator iter = this.properties.keySet().iterator();
        for( ; iter.hasNext(); ) {
            String propName = (String)iter.next();
            this.msgContext.setProperty( propName, this.properties.get( propName ) );
        }
    }
    
    private Object handleResMsg(Object[] params){
        Object result = null;
                try {
            SOAPMessage msg = this.msgContext.getResponseMessage();
            SOAPEnvelope soapEnv = msg.getSOAPPart().getEnvelope();
            SOAPBody soapBody = soapEnv.getBody();
                        Iterator ite = soapBody.getChildElements();
            Object tmpObject = null;
            for( ; ite.hasNext(); ){
                tmpObject = ite.next();
                if( tmpObject instanceof SOAPElement ){
                    break;
                }
            }
            SOAPBodyElement soapBodyEle = null;
            if( tmpObject instanceof SOAPElement ){
                soapBodyEle = (SOAPBodyElement)tmpObject;
            }
            if ( null == soapBodyEle && null == soapBodyEle.getChildElements() ) {
                throw new JAXRPCException( org.act.soap.util.i18n.Message.getMessage( "ERR_Call_noSOAPEle" ) );
            }else{
                if ( null != this.returnType
                     && null != this.returnType.getXmlType()) {                                        DeserializationContextImpl dserContext = new DeserializationContextImpl(
                        null,
                        this.service.getTypeMappingRegistry());
                    if( null == typeMap ) {
                        throw new JAXRPCException( org.act.soap.util.i18n.Message.getMessage( "ERR_Call_noCorrespondTM" ) );
                    }
                                        if( null == this.returnType.getJavaType() ){
                        Class javaType = ((org.act.soap.encoding.TypeMappingImpl)typeMap)
                            .getJavaType( this.returnType.getXmlType() );
                        if( null == javaType ) {
                            throw new JAXRPCException( org.act.soap.util.i18n.Message.getMessage( "ERR_Call_unSupportedRetType" ) );
                        }
                        this.returnType.setJavaType( javaType );
                    }
                    DeserializerImpl ds = (org.act.soap.encoding.DeserializerImpl)this
                        .getTypeMapping().getDeserializer(
                        this.returnType.getJavaType(),
                        this.returnType.getXmlType()).getDeserializerAs(
                        TMConstants.ENCODING_MECHANISMTYPE );
                                        ite = soapBodyEle.getChildElements();
                    for( ; ite.hasNext(); ){
                        tmpObject = ite.next();
                        if( tmpObject instanceof SOAPElement ){
                            break;
                        }
                    }
                    SOAPElement resultEle = null;
                    if( tmpObject instanceof SOAPElement ){
                        resultEle = (SOAPElement)tmpObject;
                    }
                    try {
                        result = ds.deserialize( resultEle,
                                                 this.returnType.getXmlType(),
                                                 this.returnType.getJavaType(),
                                                 dserContext );
                    }catch( org.act.soap.encoding.TypeMappingException e ) {
                        throw new JAXRPCException( e );
                    }
                                        this.outputValues.add( result );
                    String paraName = resultEle.getElementName().getLocalName();
                    this.outputParams.put( paraName, result );
                }
                                if((params!=null) && (params.length>0)){
                  Object obj = params[0];
                  if(obj.getClass()==DataHandler[].class) {
                                            List vecDH=new Vector();
                      Iterator iterator = msg.getAttachments();
                      while (iterator.hasNext()) {
                        AttachmentPart attachmentPart = (AttachmentPart) iterator.next();
                        DataHandler dh = attachmentPart.getDataHandler();
                        vecDH.add(dh);
                      }
                      params[0]=(DataHandler[])vecDH.toArray(new DataHandler[vecDH.size()]);
                    }
                  }
            }
        }catch( javax.xml.rpc.soap.SOAPFaultException e ) {
            throw e;
        }catch( Exception e ) {
            throw new JAXRPCException( e );
        }
        return result;
    }
    
    private void sendReqMsg(){
                HandlerRegistry handlerRegistry =
            (org.act.soap.client.handler.HandlerRegistry)this.service
            .getHandlerRegistry();
        HandlerChain handlerChain =
            (HandlerChain)handlerRegistry.getHandlerChain( this.portName );
                if ( !handlerChain.handleRequest( this.msgContext ) ){
            throw new JAXRPCException( org.act.soap.util.i18n.Message
                                       .getMessage( "ERR_Call_HandlerErr" ) );
        }
                                                        try {
            SOAPConnectionFactory factory = SOAPConnectionFactory.newInstance();
            SOAPConnection connection = factory.createConnection();
            SOAPMessage reqMessage = msgContext.getRequestMessage();
                        Object sOAPActionUse =
                this.getProperty( Call.SOAPACTION_USE_PROPERTY );
            if( null != sOAPActionUse
                && sOAPActionUse.equals( Boolean.TRUE ) ){
                reqMessage.getMimeHeaders()
                    .setHeader( "SOAPAction", (String)this.getProperty(
                        Call.SOAPACTION_URI_PROPERTY ) );
            }else{
                reqMessage.getMimeHeaders().setHeader( "SOAPAction", "" );
            }
            msgContext.setResponseMessage( connection.call( reqMessage,
                this.serviceEndpointAdd ) );
            msgContext.setResponsing( true );
        }catch( Exception ex ) {
            throw new JAXRPCException(ex);
        }
                if( null != this.msgContext.getResponseMessage() ){
            try{
                SOAPEnvelope soapEnv = this.msgContext.getResponseMessage()
                    .getSOAPPart().getEnvelope();
                SOAPBody soapBody = soapEnv.getBody();
                                if ( soapBody.hasFault() ) {
                    handlerChain.handleFault( this.msgContext );
                    SOAPFault soapFault = soapBody.getFault();
                    throw new SOAPFaultException( new QName( "",
                                                      soapFault.getFaultCode()),
                                                  soapFault.getFaultString(),
                                                  soapFault.getFaultActor(),
                                                  soapFault.getDetail());
                }
            }catch( SOAPException e ){
                throw new JAXRPCException(e);
            }
        }
        if( !handlerChain.handleResponse( this.msgContext ) ){
            throw new JAXRPCException( org.act.soap.util.i18n.Message
                                       .getMessage( "ERR_Call_HandlerErr" ) );
        }
    }
    
    private void setInfoFromWSDL( Object[] params ){
        javax.wsdl.Service bindingService = service.getBindingService();
                Port port = bindingService.getPort(portName.getLocalPart());
        if ( null == port ) {
            throw new JAXRPCException( org.act.soap.util.i18n.Message.getMessage( "ERR_Call_noPortErr" ) );
        }
        List portList = port.getExtensibilityElements();
        if (null == portList) {
            throw new JAXRPCException( org.act.soap.util.i18n.Message.getMessage( "ERR_Call_noPortListErr" ) );
        }
                if( null == this.serviceEndpointAdd ){
            int size = portList.size();
            for (int i = 0; i < size; i++) {
                Object tmpObject = portList.get(i);
                if (tmpObject instanceof SOAPAddress) {
                    SOAPAddress add = (SOAPAddress) tmpObject;
                    this.setTargetEndpointAddress(add.getLocationURI());
                    break;
                }
            }
        }
                Binding binding = port.getBinding();
        if (null == binding) {
            throw new JAXRPCException( org.act.soap.util.i18n.Message.getMessage( "ERR_Call_noBindingErr" ) );
        }
        if( null == this.portTypeName ){
            PortType portType = binding.getPortType();
                        if (null == portType) {
                throw new JAXRPCException( org.act.soap.util.i18n.Message.getMessage( "ERR_Call_noPortTypeErr" ) );
            }
            this.portTypeName = portType.getQName();
        }
                bindingOperation( params );
                setSOAPAction( binding );
                setParasAndRettype( params );
    }
    
    private void setParasAndRettype( Object[] params ){
        Message inputMsg = operation.getInput().getMessage();
        if ( !inputMsg.getParts().isEmpty()
             && !operation.getParameterOrdering().isEmpty() ) {
            int size = operation.getParameterOrdering().size();
            for ( int i = 0; i < size; i++ ) {
                setParamFromWSDL( i, inputMsg, params );
            }
        }
                                                                if( null != this.returnType
            && null != this.returnType.getXmlType()
            && null != this.returnType.getJavaType() ){
            QName retXMLType = this.returnType.getXmlType();
            Class retJavaType = this.returnType.getJavaType();
                        if( null == this.getTypeMapping() ) {
                throw new JAXRPCException( org.act.soap.util.i18n.Message.getMessage( "ERR_Call_noCorrespondTM" ) );
            }
            if( null == getTypeMapping().getDeserializer( retJavaType, retXMLType ) ) {
                throw new JAXRPCException( org.act.soap.util.i18n.Message.getMessage( "ERR_Call_typeDismatch" ) );
            }
        }else{
                        Message outputMsg = operation.getOutput().getMessage();
            if ( !outputMsg.getParts().isEmpty() ) {
                QName xmlType = ((Part) outputMsg.getParts().values()
                                 .iterator().next()).getTypeName();
                this.returnType.setXmlType( xmlType );
                if( this.returnType.getJavaType() == null ) {
                    Class javaType = ((TypeMappingImpl)getTypeMapping())
                        .getJavaType( xmlType );
                    this.returnType.setJavaType( javaType );
                }
                this.returnType.setReturned( true );
            }
        }
                this.paramAndRettypeNeed = false;
    }
    
    private void setSOAPAction( Binding binding ){
        BindingOperation bindingOperation = binding.getBindingOperation(
            this.operationName.getLocalPart(),
            this.operation.getInput().getName(),
            this.operation.getOutput().getName());
        if ( null == bindingOperation ) {
            throw new JAXRPCException( org.act.soap.util.i18n.Message.
                                       getMessage( "ERR_Call_noBindingOpeErr" ) );
        }
        List elementList = bindingOperation.getExtensibilityElements();
        if ( null == elementList ) {
            throw new JAXRPCException( org.act.soap.util.i18n.Message.
                                       getMessage( "ERR_Call_noExEleErr" ) );
        }
                if( null == this.properties.get( Call.SOAPACTION_URI_PROPERTY ) ){
            int size = elementList.size();
            for ( int i = 0; i < size; i++ ) {
                Object tmpElement = elementList.get(i);
                if ( tmpElement instanceof SOAPOperation ) {
                    SOAPOperation soapOperation = (SOAPOperation)tmpElement;
                    String actionURI = soapOperation.getSoapActionURI();
                    if ( null == actionURI ) {
                        this.properties.put( Call.SOAPACTION_URI_PROPERTY, null );
                        this.properties.put( Call.SOAPACTION_USE_PROPERTY,
                                             new Boolean(false) );
                    }else{
                        this.properties.put( Call.SOAPACTION_URI_PROPERTY,
                                             actionURI );
                        this.properties.put( Call.USERNAME_PROPERTY,
                                             new Boolean(true) );
                    }
                    break;
                }
            }
        }
                setEncodingProperties( bindingOperation );
    }
    
    private void writeParameters( SOAPBodyElement soapBodyEle, Object[] params ){
                SerializationContextImpl serContext = new SerializationContextImpl( null,
            this.service.getTypeMappingRegistry() );
                if ( null != this.parameters && null != params ) {
            if ( this.parameters.size() != params.length ) {
                throw new JAXRPCException( org.act.soap.util.i18n.Message. getMessage(  "ERR_Call_paramsDismatch") );
            }else{
                try{
                  for ( int i = 0; i < params.length; i++ ) {
                                                String paramName = (String)this.parameterOrder.get(i);
                        ParamDescription paramDesc = (ParamDescription)this
                            .parameters.get( paramName );
                                                QName xmlType = paramDesc.getXmlType();
                        Class javaType = paramDesc.getJavaType();
                        if( null != javaType ){
                            if ( ! ( javaType.equals( params[i].getClass() )
                                     || JavaUtils.getWrapperClass( javaType )
                                     .equals( params[i].getClass() ) ) ) {
                              throw new JAXRPCException( org.act.soap.util.i18n.Message.getMessage( "ERR_Call_paramsDismatch" ) );
                            }
                        }else {
                            if (null != params[i]){
                                javaType = params[i].getClass();
                            }else{
                                javaType = ((TypeMappingImpl) getTypeMapping()).getJavaType(xmlType);
                            }
                        }
                                                if( null == getTypeMapping().getSerializer( javaType, xmlType ) ) {
                            throw new JAXRPCException( org.act.soap.util.i18n.Message.getMessage( "ERR_Call_typeDismatch" ) );
                        }
                                                if( null == paramDesc.getJavaType() ) {
                            paramDesc.setJavaType( javaType );
                        }
                                                SerializerImpl serial =
                            (org.act.soap.encoding.SerializerImpl) this
                                .getTypeMapping()
                                .getSerializer( javaType, xmlType ).getSerializerAs(
                                TMConstants.ENCODING_MECHANISMTYPE );
                        SOAPElement paramEle = serial.serialize( params[i],
                                                        new QName("", paramDesc.getParamName()),
                            paramDesc.getJavaType(),
                            paramDesc.getXmlType(),
                            serContext );
                        soapBodyEle.addChildElement( paramEle );
                      }
                    }catch( Exception e ) {
                      throw new JAXRPCException(e);
                }
            }
        }
    }
    
    private void setEncodingProperties( BindingOperation bindingOperation){
        BindingInput bindingInput = bindingOperation.getBindingInput();
        if ( null == bindingInput ) {
            throw new JAXRPCException( org.act.soap.util.i18n.Message.
                                       getMessage( "ERR_Call_noBindingInpErr" ) );
        }
        List inputList = bindingInput.getExtensibilityElements();
        if ( null == inputList ) {
            throw new JAXRPCException( org.act.soap.util.i18n.Message.
                                       getMessage( "ERR_Call_noInpExtEleErr" ) );
        }
        int size = inputList.size();
        for ( int i = 0; i < size; i++ ) {
            Object tmpInputEle = inputList.get(i);
            if ( tmpInputEle instanceof SOAPBody ) {
                javax.wsdl.extensions.soap.SOAPBody soapBody =
                    (javax.wsdl.extensions.soap.SOAPBody) tmpInputEle;
                                if( null == this.properties
                    .get( Call.ENCODINGSTYLE_URI_PROPERTY ) ){
                    List encodingStyles = soapBody.getEncodingStyles();
                    if (null != encodingStyles && 0 < encodingStyles.size()) {
                        this.setProperty( Call.ENCODINGSTYLE_URI_PROPERTY,
                                          (String) encodingStyles.get(0) );
                    }
                }
                                if( null == this.operationName.getNamespaceURI() ){
                    String namespaceURI = soapBody.getNamespaceURI();
                    if ( null != namespaceURI && !"".equals( namespaceURI ) ) {
                        this.setOperationName( new QName( namespaceURI,
                                                          operationName.getLocalPart() ) );
                    }
                }
                break;
            }
        }
    }
    
    private void setParamFromWSDL( int index, Message inputMsg, Object[] params ){
        ParamDescription paramDesc = new ParamDescription();
        String paraName =
            operation.getParameterOrdering().get(index).toString();
        paramDesc.setParamName( inputMsg.getPart(paraName).getName() );
        paramDesc.setParameterMode( ParameterMode.IN );
        paramDesc.setReturned( false );
        if( params[index] != null && params[index].getClass().isArray() ) {
                        paramDesc.setXmlType( TMConstants.SOAP_ARRAY );
        }
        else {
            Part part = inputMsg.getPart( paraName );
            QName xmlType = null;
            if( part == null ){
                throw new JAXRPCException( org.act.soap.util.i18n.Message
                                           .getMessage( "ERR_Call_noPartErr" ) );
            }else{
                xmlType = part.getTypeName();
            }
                        if (null != xmlType && xmlType.getLocalPart().startsWith( "ArrayOf" )) {
                paramDesc.setXmlType( TMConstants.SOAP_ARRAY );
            }
            else {
                paramDesc.setXmlType( xmlType );
            }
        }

        this.addParameter( paramDesc );
    }
    
    private boolean validateParams( Operation tmpOperation, Object[] params ){
                if ( !tmpOperation.getName().
             equals( this.operationName.getLocalPart() ) ) {
            return false;
        }
                QName xmlType = null;
        Class javaType = null;
        String paraName = null;
                if ( (null == tmpOperation.getParameterOrdering()
              || tmpOperation.getParameterOrdering().isEmpty())
             && ( null == params || 0 == params.length ) ) {
            return true;
        }
                if( !tmpOperation.getParameterOrdering().isEmpty() &&
                  params.length == tmpOperation.
                  getParameterOrdering().size() ) {
            boolean paramMatch = true;
            int size1 = tmpOperation.getParameterOrdering().size();
            TypeMapping _typeMap = this.getTypeMapping();
            if( null == _typeMap ) {
                throw new JAXRPCException( org.act.soap.util.i18n.Message
                                           .getMessage( "ERR_Call_noCorrespondTM" ) );
            }
            for( int j = 0; j < size1; j++ ) {
                paraName = tmpOperation.getParameterOrdering()
                    .get(j).toString();
                xmlType = tmpOperation.getInput().getMessage()
                    .getPart( paraName ).getTypeName();
                if (null != params[j]) {
                    javaType = params[j].getClass();
                    if ( null == _typeMap.getSerializer( javaType, xmlType ) ) {
                                                paramMatch = false;
                        break;
                    }
                }
            }
                        return paramMatch ? true : false;
        }
                return false;
    }

}
