package org.act.soap.client;
import java.io.Serializable;
import javax.xml.namespace.QName;
import javax.xml.rpc.ParameterMode;

public class ParamDescription implements Serializable {
    
    private static final long serialVersionUID = -3895789157938198300L;
    
    private String paramName = null;
    
    private ParameterMode parameterMode = ParameterMode.IN;
    
    private QName xmlType = null;      
    private Class javaType = null;
    
    private boolean returned = false;

    
    public ParamDescription() {
    }


    
    public ParamDescription( ParamDescription paramDesc ) {
        if( null != paramDesc ){
            this.paramName = paramDesc.paramName;
            this.parameterMode = paramDesc.parameterMode;
            this.xmlType = paramDesc.xmlType;
            this.javaType = paramDesc.javaType;
            this.returned = paramDesc.returned;
        }
    }
    
    public ParamDescription( String paramname,
                             ParameterMode parametermode,
                             QName xmltype ) {
        this.paramName = paramname;
        this.parameterMode = parametermode;
        this.xmlType = xmltype;
    }
    
    public ParamDescription( String paramname, ParameterMode parametermode,
                             QName xmltype, Class javatype ) {
        this( paramname, parametermode, xmltype );
        this.javaType = javatype;
    }
    
    public ParamDescription( String paramname, ParameterMode parametermode,
                                 QName xmltype, Class javatype, boolean isReturn ) {
            this( paramname, parametermode, xmltype, javatype );
            this.returned = isReturn;
        }
    
    public final String getParamName() {
        return this.paramName;
    }
    
    public final void setParamName( String paramname ) {
        this.paramName = paramname;
    }
    
    public final QName getXmlType() {
        return this.xmlType;
    }
    
    public final void setXmlType( QName xmltype ) {
        this.xmlType = xmltype;
    }
    
    public final Class getJavaType() {
        return javaType;
    }
    
    public final void setJavaType(Class javatype) {
        this.javaType = javatype;
    }
    
    public final ParameterMode getParameterMode() {
        return this.parameterMode;
    }
    
    public final void setParameterMode( ParameterMode parametermode ) {
        this.parameterMode = parametermode ;
    }
    
    public final boolean isReturned() {
        return this.returned;
    }
    
    public final void setReturned( boolean value ) {
        this.returned = value;
    }

}
