package org.act.soap.client;
import java.net.*;
import java.io.*;
import java.util.Iterator;
import javax.xml.rpc.*;
import javax.xml.soap.*;
import org.act.soap.util.SOAPUtils;

public class Transport {

    
    public Transport(){
    }


    
    public void request( URL serviceEndpointAdd, MessageContext msgContext ){
        String protocol = serviceEndpointAdd.getProtocol();
        if( protocol == null ){
            throw new JAXRPCException( "Protocol must be set." );
        }
        if( protocol.equalsIgnoreCase( "http" ) ){
                        String hostAdd = serviceEndpointAdd.getHost();
            int portNum = serviceEndpointAdd.getPort();
            try{
                HttpURLConnection connection = (HttpURLConnection)serviceEndpointAdd.openConnection();
                connection.setAllowUserInteraction(true);
                connection.setDoOutput(true);
                connection.setDoInput(true);
                connection.setRequestMethod("POST");
                connection.setRequestProperty("Content-Type", "text/xml");
                if( ((Boolean)msgContext.getProperty( Call.SOAPACTION_USE_PROPERTY )).booleanValue() == true ){
                    msgContext.getRequestMessage().getMimeHeaders().setHeader( "SOAPAction", msgContext.getProperty( Call.SOAPACTION_URI_PROPERTY ).toString() );
                }else{
                    msgContext.getRequestMessage().getMimeHeaders().setHeader( "SOAPAction", "\"\"" );
                }
                                MimeHeader header;
                Iterator iter = msgContext.getRequestMessage().getMimeHeaders().getAllHeaders();
                for( ; iter.hasNext();  ){
                    header = (MimeHeader) iter.next();
                    connection.setRequestProperty( header.getName(), header.getValue() );
                }
                                OutputStream contentOut = connection.getOutputStream();
                msgContext.getRequestMessage().writeTo(contentOut);
                contentOut.flush();
                contentOut.close();
                                boolean isReqFailed = false;
                connection.connect();
                int statusCode = connection.getResponseCode();
                if ( connection.getResponseCode() == HttpURLConnection.HTTP_INTERNAL_ERROR ) {
                    isReqFailed = true;
                }else{
                    if ( connection.getResponseCode() == HttpURLConnection.HTTP_UNAUTHORIZED )
                        throw new ServiceException( "http.client.unauthorized" );
                    if ( connection.getResponseCode() == HttpURLConnection.HTTP_NOT_FOUND )
                        throw new ServiceException("http.server.not.found");
                                        if ( statusCode < 200 || statusCode >= 300 && statusCode < 500 )
                        throw new ServiceException( "Unknow Exception" );
                    if ( statusCode >= 500 )
                        isReqFailed = true;
                }
                InputStream resStream = null;
                if ( connection.getResponseCode() == HttpURLConnection.HTTP_UNAUTHORIZED )
                    throw new ServiceException( "http.client.unauthorized" );
                else if ( connection.getResponseCode() == HttpURLConnection.HTTP_NOT_FOUND )
                    throw new ServiceException("http.server.not.found");
                else if ( statusCode < 200 || statusCode >= 300 && statusCode < 500 )
                                        throw new ServiceException( "Unknow Exception" );
                else if ( connection.getResponseCode() >= HttpURLConnection.HTTP_INTERNAL_ERROR )
                    resStream = connection.getErrorStream();
                else
                    resStream = connection.getInputStream();
                                MimeHeaders headers = new MimeHeaders();
                for( int i = 1; ; i++ ){
                    String key = connection.getHeaderFieldKey( i );
                    if( key != null ){
                        String value = connection.getHeaderField( i );
                        headers.addHeader( key, value );
                    }else{
                        break;
                    }
                }
                byte[] resBytes = null;
                byte b = 0;
                int length = 0;
                if( resStream == null ){
                    resBytes =  new byte[0];
                }else{
                    ByteArrayOutputStream tmpStream = new ByteArrayOutputStream();
                    for ( int i = 0; ; i++ ) {
                        b = (byte) resStream.read();
                                                if ( b == -1 ) {
                            length = i;
                            break;
                        }
                                                tmpStream.write( b );
                    }
                    resBytes = tmpStream.toByteArray();
                }
                ByteArrayInputStream resByteStream = new ByteArrayInputStream( resBytes );
                                SOAPMessage resMessage = SOAPUtils.MESSAGEFACTORY_INSTANCE.createMessage( headers, resByteStream );
                msgContext.setResponseMessage( resMessage );
                resStream.close();
            }catch( Exception e ){
                new ServiceException( e );
            }
        }else if( protocol.equalsIgnoreCase( "mailto" ) ){
            
        }
    }

}
