package org.act.soap.client.handler;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import javax.xml.rpc.JAXRPCException;
import javax.xml.rpc.handler.Handler;
import javax.xml.rpc.handler.HandlerInfo;
import javax.xml.rpc.handler.MessageContext;
import org.act.soap.util.i18n.Message;

public class HandlerChain extends java.util.ArrayList implements javax.xml.rpc.handler.HandlerChain{
	
    private String[] _roles = null;
    
    private HashMap handlers = new HashMap();

    
    protected HandlerChain(){
    }


    
    public boolean handleRequest( MessageContext context ){
        org.act.soap.client.MessageContext msgContext =
            (org.act.soap.client.MessageContext)context;
		int tmpSize = this.size();
        for( int i = 0; i < tmpSize; i++ ) {
            HandlerInfo handlerInfo = (HandlerInfo)this.get( i );
                        org.act.soap.client.handler.Handler handler = null;
            handler = (org.act.soap.client.handler.Handler)this.handlers.get( handlerInfo );
                        try{
                if ( false == handler.handleRequest( msgContext ) ) {
                    return false;
                }
            }catch( Exception e ){
                            System.out.println( e.getMessage() );
            }
        }
        return true;
    }
    
    public boolean handleResponse( MessageContext context ){
        org.act.soap.client.MessageContext msgContext =
            (org.act.soap.client.MessageContext)context;
        int endIndex = this.size() -1 ;
        for( int i = endIndex; 0 <= i; i-- ){
          HandlerInfo handlerInfo = (HandlerInfo)this.get(i);
          org.act.soap.client.handler.Handler handler = null;
          handler = (org.act.soap.client.handler.Handler)this.handlers.get(
              handlerInfo );
          try {
              if ( false == handler.handleResponse( msgContext ) ) {
                  return false;
              }
          }catch( Exception e ){
                      }
        }
        return true;
    }
    
    public boolean handleFault( MessageContext context ){
        org.act.soap.client.MessageContext msgContext =
            (org.act.soap.client.MessageContext)context;
        int endIndex = this.size() - 1;
        for( int i = endIndex; 0 <= i; i-- ){
            HandlerInfo handlerInfo = (HandlerInfo)this.get( i );
            org.act.soap.client.handler.Handler handler = null;
            handler = (org.act.soap.client.handler.Handler)this.handlers.get(
                handlerInfo );
            try{
                if( false == handler.handleFault( msgContext ) ) {
                    return false;
                }
            }catch( Exception e ){
                            }
        }
        return true;
    }
    
    public void init( Map map ){
            }
    
    public void destroy(){
                int tmpSize = this.size();
        for( int i = 0; i < tmpSize; i++ ){
            HandlerInfo handlerInfo = (HandlerInfo)this.get( i );
            Handler handler = (Handler)this.handlers.get( handlerInfo );
            handler.destroy();
        }
        this.clear();
    }
    
    public void setRoles( String[] stringArray ){
        _roles = stringArray;
    }
    
    public String[] getRoles(){
        return _roles;
    }


    
    public boolean add( Object handlerInfo ){
                if( !(handlerInfo instanceof HandlerInfo ) ) {
            throw new JAXRPCException( Message.getMessage( "ERR_HandlerChain_elementTypeErr" ) );
        }
        super.add( handlerInfo );
        Class handlerClass = ((HandlerInfo)handlerInfo).getHandlerClass();
        if( null == handlerClass ) {
            throw new JAXRPCException( Message.getMessage( "ERR_HandlerChain_classNullErr" ) );
        }
        org.act.soap.client.handler.Handler handler = null;
        try{
            handler = HandlerFactory.newInstance().createHandler( handlerClass.getName() );
            handler.init( (HandlerInfo)handlerInfo );
        }catch( Exception e ){
            throw new JAXRPCException( e );
        }
        this.handlers.put( handlerInfo, handler );
        return true;
    }
    
    public void add( int index, Object handlerInfo ){
                if( !(handlerInfo instanceof HandlerInfo ) ) {
            throw new JAXRPCException( Message.getMessage( "ERR_HandlerChain_elementTypeErr" ) );
        }
        super.add( index, handlerInfo );
        Class handlerClass = ((HandlerInfo)handlerInfo).getHandlerClass();
        if( null == handlerClass ) {
            throw new JAXRPCException( Message.getMessage( "ERR_HandlerChain_classNullErr" ) );
        }
        Object handler = null;
        try{
            handler = handlerClass.newInstance();
        }catch( Exception e ){
            throw new JAXRPCException( e );
        }
        ((Handler)handler).init( (HandlerInfo)handlerInfo );
        this.handlers.put( handlerInfo, handler );
    }
    
    public boolean addAll( Collection c ){
                Iterator ite = c.iterator();
        int tmpSize = c.size();
        for( int i = 0; i < tmpSize; i++ ){
            if( !(ite.next() instanceof HandlerInfo ) ) {
                throw new JAXRPCException( Message.getMessage( "ERR_HandlerChain_elementTypeErr" ) );
            }
        }
        super.addAll( c );
        ite = c.iterator();
        try{
            tmpSize = c.size();
        	for( int i = 0; i < tmpSize; i++ ){
            	Object handlerInfo = ite.next();
            	Class handlerClass = ((HandlerInfo)handlerInfo).getHandlerClass();
            	if( null == handlerClass ) {
            		throw new JAXRPCException( Message.getMessage( "ERR_HandlerChain_classNullErr" ) );
            	}
	            Object handler = null;
        	    handler = handlerClass.newInstance();
            	((Handler)handler).init( (HandlerInfo)handlerInfo );
            	this.handlers.put( handlerInfo, handler );
        	}
        }catch( Exception e ){
			throw new JAXRPCException( e );
		}
        return true;
    }
    
    public boolean addAll( int index, Collection c ){
                Iterator ite = c.iterator();
        int tmpSize = c.size();
        for( int i = 0; i < tmpSize; i++ ){
            if( !(ite.next() instanceof HandlerInfo ) ) {
                throw new JAXRPCException( Message.getMessage( "ERR_HandlerChain_elementTypeErr" ) );
            }
        }
        super.addAll( index, c );
        ite = c.iterator();
        try{
            tmpSize = c.size();
            for( int i = 0; i < tmpSize; i++ ){
                Object handlerInfo = ite.next();
                Class handlerClass = ((HandlerInfo)handlerInfo).getHandlerClass();
                if( null == handlerClass ) {
                    throw new JAXRPCException( Message.getMessage( "ERR_HandlerChain_classNullErr" ) );
                }
                Object handler = null;
                handler = handlerClass.newInstance();
                ((Handler)handler).init( (HandlerInfo)handlerInfo );
                this.handlers.put( handlerInfo, handler );
            }
        }catch( Exception e ){
            throw new JAXRPCException( e );
        }
        return true;
    }
    
    public void clear(){
        super.clear();
        this.handlers.clear();
    }
    
    public Object remove( int index ){
        Object ret = super.remove( index );
        this.handlers.remove( ret );
        return ret;
    }
    
    public boolean remove( Object handlerInfo ){
                if( !(handlerInfo instanceof HandlerInfo ) ) {
            throw new JAXRPCException( Message.getMessage( "ERR_HandlerChain_elementTypeErr" ) );
        }
        super.remove( handlerInfo );
        this.handlers.remove( handlerInfo );
        return true;
    }
    
    public boolean removeAll( Collection c ){
                Iterator ite = c.iterator();
        int tmpSize = c.size();
        for( int i = 0; i < tmpSize; i++ ){
            if( !(ite.next() instanceof HandlerInfo ) ) {
                throw new JAXRPCException( Message.getMessage( "ERR_HandlerChain_elementTypeErr" ) );
            }
        }
        super.removeAll( c );
        ite = c.iterator();
        tmpSize = c.size();
        for( int i = 0; i < tmpSize; i++ ){
            Object handlerInfo = ite.next();
            this.handlers.remove( handlerInfo );
        }
        return true;
    }
    
    public boolean retainAll( Collection c ){
                Iterator ite = c.iterator();
        int tmpSize = c.size();
        for( int i = 0; i < tmpSize; i++ ){
            if( !(ite.next() instanceof HandlerInfo ) ) {
                throw new JAXRPCException( Message.getMessage( "ERR_HandlerChain_elementTypeErr" ) );
            }
        }
        super.retainAll( c );
        ite = c.iterator();
        tmpSize = c.size();
        HashMap tmpHandlers = new HashMap( tmpSize );
        for( int i = 0; i < tmpSize; i++ ){
            Object handlerInfo = ite.next();
            Object handler = this.handlers.get( handlerInfo );
            tmpHandlers.put( handlerInfo, handler );
        }
        this.handlers = tmpHandlers;
        return true;
    }
    
    public Object set( int index, Object handlerInfo ){
                if( !(handlerInfo instanceof HandlerInfo ) ) {
            throw new JAXRPCException( Message.getMessage( "ERR_HandlerChain_elementTypeErr" ) );
        }
        Object ret = super.set( index, handlerInfo );
        this.handlers.remove( ret );
        Class handlerClass = ((HandlerInfo)handlerInfo).getHandlerClass();
        if( null == handlerClass ) {
            throw new JAXRPCException( Message.getMessage( "ERR_HandlerChain_classNullErr" ) );
        }
        Object handler = null;
        try{
            handler = handlerClass.newInstance();
        }catch( Exception e ){
            throw new JAXRPCException( e );
        }
        ((Handler)handler).init( (HandlerInfo)handlerInfo );
        this.handlers.put( handlerInfo, handler );
        return ret;
    }

}
