package org.act.soap.client.handler;

public class HandlerFactory {
    
    protected HandlerFactory() {
    }
    
    public static HandlerFactory newInstance() {
        return new HandlerFactory();
    }
    
    public Handler createHandler( final String className ) {
        if ( null != className ) {
            try {
                ClassLoader classLoader =
                    Thread.currentThread().getContextClassLoader();
                Class clazz = classLoader.loadClass( className );
                return (Handler) clazz.newInstance();
            }
            catch (Exception ex) {
                
            }
        }
        return null;
    }
}
