package org.act.soap.encoding;
import java.util.HashMap;
import javax.xml.namespace.QName;
import javax.xml.rpc.encoding.DeserializationContext;
import javax.xml.rpc.encoding.TypeMappingRegistry;
import javax.xml.soap.SOAPMessage;

public class DeserializationContextImpl
    implements DeserializationContext {
    
    public DeserializationContextImpl () {
    }
    
    private HashMap idMap = null;
    
    
    private SOAPMessage mSoapMessage = null;
    
    private TypeMappingRegistry mTypeMappingRegistry = null;
    
    public DeserializationContextImpl (SOAPMessage soapMessage,
                                       TypeMappingRegistry typeMappingRegistry) {
        this.mSoapMessage = soapMessage;
        this.mTypeMappingRegistry = typeMappingRegistry;
    }
    
    public void registerObject (Object obj, String id) {
        if (null == idMap) {
            idMap = new HashMap();
        }
        idMap.put(id, obj);
    }
    
    public Object lookupObject (String id) {
        return null == idMap ? null : idMap.get(id);
    }
    
    public TypeMappingRegistry getTypeMappingRegistry () {
        return this.mTypeMappingRegistry;
    }
    
    public Class getJavaType (QName xmlType) {
        TypeMappingImpl tmi = (TypeMappingImpl)this.mTypeMappingRegistry.
            getDefaultTypeMapping();
        return tmi.getJavaType(xmlType);
    }
    
    public QName getXmlType (Class javaType) {
        TypeMappingImpl tmi = (TypeMappingImpl)this.mTypeMappingRegistry.
            getDefaultTypeMapping();
        return tmi.getXmlType(javaType);
    }
}
