package org.act.soap.encoding;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;
import javax.xml.namespace.QName;
import javax.xml.rpc.JAXRPCException;
import javax.xml.rpc.encoding.Deserializer;
import javax.xml.rpc.encoding.DeserializerFactory;
import org.act.soap.util.TMConstants;

public class DeserializerFactoryImpl
    implements DeserializerFactory {
    
    public DeserializerFactoryImpl () {
    }
    
    private static List mechanisms = null;
    
    private Deserializer deser = null;
    
    protected Class mDeserClass = null;
    
    protected QName mXmlType = null;
    
    protected Class mJavaType = null;
    
    public DeserializerFactoryImpl (Class deserClass,
                                    QName xmlType, Class javaType) {
        this.mDeserClass = deserClass;
        this.mXmlType = xmlType;
        this.mJavaType = javaType;
    }
    
    public Iterator getSupportedMechanismTypes () {
        if (null == mechanisms) {
            mechanisms = new Vector();
            mechanisms.add(TMConstants.ENCODING_MECHANISMTYPE);
        }
        return mechanisms.iterator();
    }
    
    public Deserializer
        getDeserializerAs (String mechanismType) throws JAXRPCException {
        try {
            if (null == deser) {
                                deser = (Deserializer) mDeserClass.newInstance();
            }
            return deser;
        }
        catch (Exception ex) {
            throw new JAXRPCException(ex);
        }
    }
}
