package org.act.soap.encoding;
import javax.xml.namespace.QName;
import javax.xml.rpc.encoding.Deserializer;
import javax.xml.soap.Name;
import javax.xml.soap.SOAPElement;
import org.act.soap.encoding.DeserializationContextImpl;
import org.act.soap.encoding.TypeMappingException;
import org.act.soap.util.TMConstants;
import org.act.soap.util.XMLUtils;

public abstract class DeserializerImpl
    implements Deserializer {
    
    public String getMechanismType() {
        return TMConstants.ENCODING_MECHANISMTYPE;
    }
    
    public abstract Object deserialize(SOAPElement element, QName xmlType,
                                       Class javaType,
                                       DeserializationContextImpl context) throws
        TypeMappingException;
    
    protected static boolean isNil(SOAPElement soapElement) {
                Name nameXsiNil = TMConstants.NAME_NIL;
                String strNil = soapElement.getAttributeValue(nameXsiNil);
                if (null == strNil) {
            return false;
        }
        else {
            if ("true".equals(strNil)) {
                return true;
            }
            else {
                return false;
            }
        }
    }
    
    protected static QName getXsitypeAttr(SOAPElement soapElement) throws
        TypeMappingException {
        String strXsiType = soapElement.getAttributeValue(
            TMConstants.NAME_XSITYPE);
                String strPrefix = XMLUtils.getPrefixFromQName(strXsiType);
                String strLocalName = XMLUtils.getLocalPartFromQName(strXsiType);
        if (null != strPrefix) {
            String strURI = soapElement.getNamespaceURI(strPrefix);
            return new QName(strURI, strLocalName, strPrefix);
        }
        else {
            return new QName(strLocalName);
        }
    }
}
