package org.act.soap.encoding;
import java.util.HashMap;
import javax.xml.namespace.QName;
import javax.xml.rpc.encoding.SerializationContext;
import javax.xml.rpc.encoding.TypeMappingRegistry;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPMessage;

public class SerializationContextImpl
    implements SerializationContext {
    
    public SerializationContextImpl () {
    }
    
    private HashMap idMap = null;
    
    
    private SOAPMessage mSoapMessage = null;
    
    private TypeMappingRegistry mTypeMappingRegistry = null;
    
    public SerializationContextImpl (SOAPMessage soapMessage,
                                     TypeMappingRegistry typeMappingRegistry) {
        this.mSoapMessage = soapMessage;
        this.mTypeMappingRegistry = typeMappingRegistry;
    }
    
    public SOAPElement[] serializeTrailingBlocks () throws TypeMappingException {
                return null;
    }
    
    public void registrySOAPElement (SOAPElement element, String id) {
        if (null == idMap) {
            idMap = new HashMap();
        }
        idMap.put(id, element);
    }
    
    public SOAPElement lookupSOAPElement (String id) {
        return null == idMap ? null : (SOAPElement) idMap.get(id);
    }
    
    public TypeMappingRegistry getTypeMappingRegistry () {
        return this.mTypeMappingRegistry;
    }
    
    public Class getJavaType (QName xmlType) {
        TypeMappingImpl tmi = (TypeMappingImpl)this.mTypeMappingRegistry.
            getDefaultTypeMapping();
        return tmi.getJavaType(xmlType);
    }
    
    public QName getXmlType (Class javaType) {
        TypeMappingImpl tmi = (TypeMappingImpl)this.mTypeMappingRegistry.
            getDefaultTypeMapping();
        return tmi.getXmlType(javaType);
    }
}
