package org.act.soap.encoding;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;
import javax.xml.namespace.QName;
import javax.xml.rpc.JAXRPCException;
import javax.xml.rpc.encoding.Serializer;
import javax.xml.rpc.encoding.SerializerFactory;
import org.act.soap.util.TMConstants;

public class SerializerFactoryImpl
    implements SerializerFactory {
    
    private static List mechanisms = null;
    
    protected Serializer ser = null;
    
    protected Class mSerClass = null;
    
    protected QName mXmlType = null;
    
    protected Class mJavaType = null;
    
    public SerializerFactoryImpl () {
    }
    
    public SerializerFactoryImpl (Class serClass,
                                  QName xmlType, Class javaType) {
        this.mSerClass = serClass;
        this.mXmlType = xmlType;
        this.mJavaType = javaType;
    }
    
    public Iterator getSupportedMechanismTypes () {
        if (null == mechanisms) {
            mechanisms = new Vector();
            mechanisms.add(TMConstants.ENCODING_MECHANISMTYPE);
        }
        return mechanisms.iterator();
    }
    
    public Serializer
        getSerializerAs (String mechanismType) throws JAXRPCException {
        try {
            if (null == ser) {
                                ser = (Serializer) mSerClass.newInstance();
            }
            return ser;
        }
        catch (Exception ex) {
            throw new JAXRPCException(ex);
        }
    }
}
