package org.act.soap.encoding;
import javax.xml.namespace.QName;
import javax.xml.rpc.encoding.Serializer;
import javax.xml.rpc.encoding.SerializerFactory;
import javax.xml.rpc.encoding.TypeMapping;
import javax.xml.soap.Name;
import javax.xml.soap.SOAPElement;
import org.act.soap.encoding.ser.BeanSerializerFactory;
import org.act.soap.encoding.ser.EnumSerializerFactory;
import org.act.soap.util.JavaUtils;
import org.act.soap.util.logging.Log;
import org.act.soap.util.logging.LogFactory;
import org.act.soap.util.TMConstants;
import org.act.soap.wsdl.java2wsdl.Types;
import org.w3c.dom.Element;

public abstract class SerializerImpl
    implements Serializer {
    
    private static Log log = LogFactory.getLog(SerializerImpl.class.getName());
    
    public String getMechanismType() {
        return TMConstants.ENCODING_MECHANISMTYPE;
    }
    
    public abstract SOAPElement serialize(Object value, QName valueName,
                                          Class javaType, QName xmlType,
                                          SerializationContextImpl context) throws
        TypeMappingException;
    
    protected static void addNilAttr(SOAPElement soapElement) {
        try {
                        Name nameXsiNil = TMConstants.NAME_NIL;
                        soapElement.addAttribute(nameXsiNil, "true");
        }
        catch (Exception e) {
            
            log.error(e);
        }
    }
    
    protected static void addXsitypeAttr(SOAPElement soapElement,QName xmlType
                                         ) throws
        TypeMappingException {
        try {
                                    String strXmlTypePrefix = xmlType.getPrefix();
            String strXmlTypeNS = xmlType.getNamespaceURI();
                        if ( (null == strXmlTypePrefix) || "".equals(strXmlTypePrefix)) {
                                if ( (null == strXmlTypeNS) || "".equals(strXmlTypeNS)) {
                    strXmlTypePrefix = "";
                }
                else {
                                                                                if (strXmlTypeNS.equals(TMConstants.URI_DEFAULT_SCHEMA_XSD)) {
                        strXmlTypePrefix = TMConstants.
                            URI_DEFAULT_SCHEMA_XSD_PREFIX;
                    }
                    else if (strXmlTypeNS.equals(TMConstants.
                                                 URI_DEFAULT_SOAP_ENC)) {
                        strXmlTypePrefix = TMConstants.
                            URI_DEFAULT_SOAP_ENC_PREFIX;
                    }
                    else {
                        strXmlTypePrefix = "tns0";
                    }
                }
            }
                        if ("".equals(strXmlTypePrefix)) {
                soapElement.addAttribute(TMConstants.NAME_XSITYPE, xmlType.getLocalPart());
            }
            else if (strXmlTypePrefix.equals(TMConstants.
                                             URI_DEFAULT_SCHEMA_XSD_PREFIX) ||
                     strXmlTypePrefix.equals(TMConstants.
                                             URI_DEFAULT_SOAP_ENC_PREFIX)) {
                soapElement.addAttribute(TMConstants.NAME_XSITYPE,
                                         strXmlTypePrefix + ':' +
                                         xmlType.getLocalPart());
            }
            else {
                soapElement.addNamespaceDeclaration(strXmlTypePrefix,
                    strXmlTypeNS);
                soapElement.addAttribute(TMConstants.NAME_XSITYPE,
                                         strXmlTypePrefix + ':' +
                                         xmlType.getLocalPart());
            }
        }
        catch (Exception ex) {
            throw new TypeMappingException(ex);
        }
    }
    
    public abstract Element writeSchema(Class javaType, QName xmlType,
                                        Types types) throws
        TypeMappingException;
}
