package org.act.soap.encoding.ser;
import javax.xml.namespace.QName;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPFactory;
import org.act.soap.encoding.SerializationContextImpl;
import org.act.soap.encoding.SerializerImpl;
import org.act.soap.encoding.TypeMappingException;
import org.act.soap.util.Base64Utils;
import org.act.soap.util.TMConstants;
import org.act.soap.wsdl.java2wsdl.Types;
import org.w3c.dom.Element;

public class Base64Serializer
    extends SerializerImpl {
    
    public Base64Serializer () {
    }
    
    public SOAPElement serialize (Object value, QName valueName, Class javaType,
                                  QName xmlType,
                                  SerializationContextImpl context) throws
        TypeMappingException {
        try {
                        SOAPFactory sef = TMConstants.SOAPFACTORY_INSTANCE;
            SOAPElement soapElement = sef.createElement(valueName.getLocalPart());
                        super.addXsitypeAttr(soapElement,xmlType);
                                    if (null == value) {
                super.addNilAttr(soapElement);
                return soapElement;
            }
                        soapElement.addTextNode(getValueAsString(value, javaType));
            return soapElement;
        }
        catch (Exception ex) {
            throw new TypeMappingException(ex);
        }
    }
    
    private static String getValueAsString (Object value, Class javaType) {
        byte[] data = null;
        if (javaType == byte[].class) {
            data = (byte[]) value;
        }
        else {
            data = new byte[ ( (Byte[]) value).length];
            for (int i = 0; i < data.length; i++) {
                Byte b1 = ( (Byte[]) value)[i];
                if (null != b1) {
                    data[i] = b1.byteValue();
                }
            }
        }
        return Base64Utils.base64Encode(data, 0, data.length).toString();
    }
    
    public Element writeSchema (Class javaType, QName xmlType, Types types) throws
        TypeMappingException {
        return null;
    }
}
