package org.act.soap.encoding.ser;
import java.util.Iterator;
import java.util.Map;
import javax.xml.namespace.QName;
import javax.xml.rpc.encoding.TypeMapping;
import javax.xml.soap.SOAPElement;
import org.act.soap.encoding.DeserializationContextImpl;
import org.act.soap.encoding.DeserializerImpl;
import org.act.soap.encoding.TypeMappingException;
import org.act.soap.encoding.ser.bean.BeanPropertyDescriptor;
import org.act.soap.encoding.ser.bean.BeanUtils;
import org.act.soap.util.JavaUtils;
import org.act.soap.util.TMConstants;
import org.act.soap.util.XMLUtils;
import org.act.soap.util.i18n.Message;

public class BeanDeserializer
    extends DeserializerImpl {
    
    public BeanDeserializer () {
    }
    
    public Object deserialize (SOAPElement element, QName xmlType,
                               Class javaType,
                               DeserializationContextImpl context) throws
        TypeMappingException {
                        if (super.isNil(element)) {
            return null;
        }
                Object rtnValue = null;
        try {
            rtnValue = javaType.newInstance();
        }
        catch (Exception ex) {
            throw new TypeMappingException(Message.getMessage(
                "ERR_TM_cantCreateBean",
                javaType.getName()), ex);
        }
        try {
                        Map propertyMap = BeanUtils.getProperties(javaType);
                        TypeMapping tm = context.getTypeMappingRegistry().
                getDefaultTypeMapping();
                                    Iterator iteratorItem = element.getChildElements();
            String strURI = "";
            QName innerQName = null;
            while (iteratorItem.hasNext()) {
                                Object childObject = iteratorItem.next();
                if (! (childObject instanceof SOAPElement)) {
                    continue;
                }
                SOAPElement soapChildElementItem = (SOAPElement) childObject;
                                String strChildType = soapChildElementItem.getAttributeValue(
                    TMConstants.NAME_XSITYPE);
                                                String strPrefix = XMLUtils.getPrefixFromQName(strChildType);
                                String strLocalName = XMLUtils.getLocalPartFromQName(strChildType);
                                if (null != strPrefix) {
                    strURI = soapChildElementItem.getNamespaceURI(strPrefix);
                    innerQName = new QName(strURI, strLocalName, strPrefix);
                }
                else {
                    innerQName = new QName(strLocalName);
                }
                                String localName = soapChildElementItem.getElementName().
                    getLocalName();
                                BeanPropertyDescriptor propDesc = (BeanPropertyDescriptor)
                    propertyMap.
                    get(localName);
                if (null == propDesc) {
                    throw new TypeMappingException(
                        Message.getMessage("ERR_TM_badElem", javaType.getName(),
                                           localName));
                }
                                                                Class clsInner = propDesc.getType();
                                                DeserializerImpl di = (DeserializerImpl) tm.getDeserializer(
                    clsInner,
                    innerQName).
                    getDeserializerAs(TMConstants.ENCODING_MECHANISMTYPE);
                Object desObject = di.deserialize(soapChildElementItem,
                                                  innerQName,
                                                  clsInner,
                                                  context);
                                                try {
                    propDesc.set(rtnValue, desObject);
                }
                catch (Exception ex) {
                    try {
                                                Class type = propDesc.getType();
                        if (JavaUtils.isConvertable(desObject, type)) {
                            desObject = JavaUtils.convert(desObject, type);
                            propDesc.set(rtnValue, desObject);
                        }
                        else {
                            throw new TypeMappingException(ex);
                        }
                    }
                    catch (Exception e) {
                        throw new TypeMappingException(e);
                    }
                }
            }
        }
        catch (Exception ex) {
            throw new TypeMappingException(ex);
        }
                return rtnValue;
    }
}
