package org.act.soap.encoding.ser;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.TimeZone;
import javax.xml.namespace.QName;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPFactory;
import org.act.soap.encoding.SerializationContextImpl;
import org.act.soap.encoding.SerializerImpl;
import org.act.soap.encoding.TypeMappingException;
import org.act.soap.util.TMConstants;
import org.act.soap.wsdl.java2wsdl.Types;
import org.w3c.dom.Element;

public class CalendarSerializer
    extends SerializerImpl {
    
    public CalendarSerializer () {
    }
    
    private static final SimpleDateFormat ZULU =
        new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS'Z'");
    static {
        ZULU.setTimeZone(TimeZone.getTimeZone("GMT"));
    }
    
    public SOAPElement serialize (Object value, QName valueName, Class javaType,
                                  QName xmlType,
                                  SerializationContextImpl context) throws
        TypeMappingException {
        try {
                        SOAPFactory sef = TMConstants.SOAPFACTORY_INSTANCE;
            SOAPElement soapElement = sef.createElement(valueName.getLocalPart());
                        super.addXsitypeAttr(soapElement,xmlType);
                                    if (null == value) {
                super.addNilAttr(soapElement);
                return soapElement;
            }
                        soapElement.addTextNode(getValueAsString(value));
            return soapElement;
        }
        catch (Exception ex) {
            throw new TypeMappingException(ex);
        }
    }
    
    private static String getValueAsString (Object value) {
        Date date = value instanceof Date ? (Date) value :
            ( (Calendar) value).getTime();
        synchronized (ZULU) {
            return ZULU.format(date);
        }
    }
    
    public Element writeSchema (Class javaType, QName xmlType, Types types) throws
        TypeMappingException {
        return null;
    }
}
