package org.act.soap.encoding.ser;
import javax.xml.namespace.QName;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPFactory;
import javax.activation.DataHandler;
import org.act.soap.encoding.SerializationContextImpl;
import org.act.soap.encoding.SerializerImpl;
import org.act.soap.encoding.TypeMappingException;
import org.act.soap.util.TMConstants;
import org.act.soap.util.XMLUtils;
import org.act.soap.util.i18n.Message;
import org.act.soap.wsdl.java2wsdl.Types;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class DataHandlerSerializer
    extends SerializerImpl {
  
  public DataHandlerSerializer() {
  }
  
  public SOAPElement serialize(Object value, QName valueName, Class javaType,
                               QName xmlType,
                               SerializationContextImpl context) throws
      TypeMappingException {
    try {
            SOAPFactory sef = TMConstants.SOAPFACTORY_INSTANCE;
      SOAPElement soapElement = sef.createElement(valueName.getLocalPart());
            super.addXsitypeAttr(soapElement, xmlType);
                  if (null == value) {
        super.addNilAttr(soapElement);
        return soapElement;
      }
            if (! (value instanceof DataHandler)) {
        throw new TypeMappingException(
            Message.getMessage("ERR_TM_noDataHandler",
                               value.getClass().getName()));
      }
            return soapElement;
    }
    catch (Exception ex) {
      throw new TypeMappingException(ex);
    }
  }
  
  public Element writeSchema(Class javaType, QName xmlType, Types types) throws
      TypeMappingException {
    try {
            Document doc = XMLUtils.getDOMBuilder().newDocument();
            Element complexType = doc.createElement(TMConstants.
                                              SCHEMA_COMPLEXTYPE);
      complexType.setAttribute(TMConstants.SCHEMA_NAME, "DataHandler");
      Element seq = doc.createElement(TMConstants.SCHEMA_SEQUENCE);
      complexType.appendChild(seq);
            types.putSchemaElement(xmlType, complexType);
            return complexType;
    }
    catch (Exception ex) {
      throw new TypeMappingException(ex);
    }
  }
}
