package org.act.soap.encoding.ser;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import javax.xml.namespace.QName;
import javax.xml.soap.SOAPElement;
import org.act.soap.encoding.DeserializationContextImpl;
import org.act.soap.encoding.DeserializerImpl;
import org.act.soap.encoding.TypeMappingException;
import org.act.soap.util.i18n.Message;

public class DateDeserializer
    extends DeserializerImpl {
    
    public DateDeserializer () {
    }
    
    private static final SimpleDateFormat ZULU =
        new SimpleDateFormat("yyyy-MM-dd");
    
    private static Calendar calendar = Calendar.getInstance();
    
    public Object deserialize (SOAPElement element, QName xmlType,
                               Class javaType,
                               DeserializationContextImpl context) throws
        TypeMappingException {
                if (super.isNil(element)) {
            return null;
        }
                String strNodeValue = element.getValue();
                return makeValue(strNodeValue, javaType);
    }
    
    private static Object makeValue (String source, Class javaType) throws
        TypeMappingException {
        Date result = null;
        boolean bc = false;
                                if (null != source) {
            if ('+' == source.charAt(0)) {
                source = source.substring(1);
            }
            if ('-' == source.charAt(0)) {
                source = source.substring(1);
                bc = true;
            }
            if (10 > source.length()) {
                throw new TypeMappingException(
                    Message.getMessage("ERR_TM_badDate"));
            }
                        if ( ('-' != source.charAt(4)) || ('-' != source.charAt(7))) {
                throw new TypeMappingException(
                    Message.getMessage("ERR_TM_badDate"));
            }
        }
                synchronized (calendar) {
            try {
                result = ZULU.parse(null == source ? null :
                                    (source.substring(0, 10)));
            }
            catch (Exception e) {
                throw new TypeMappingException(e);
            }
                        if (bc) {
                calendar.set(Calendar.ERA, GregorianCalendar.BC);
            }
            calendar.setTime(result);
        }
                return calendar;
    }
}
