package org.act.soap.encoding.ser;
import java.lang.reflect.Method;
import javax.xml.namespace.QName;
import javax.xml.soap.SOAPElement;
import org.act.soap.encoding.DeserializationContextImpl;
import org.act.soap.encoding.DeserializerImpl;
import org.act.soap.encoding.TypeMappingException;

public class EnumDeserializer
    extends DeserializerImpl {
    
    public Object deserialize (SOAPElement element, QName xmlType,
                               Class javaType,
                               DeserializationContextImpl context) throws
        TypeMappingException {
                        if (super.isNil(element)) {
            return null;
        }
                String strNodeValue = element.getValue();
                return makeValue(strNodeValue, javaType);
    }
    
    private static Object makeValue (String source, Class javaType) throws
        TypeMappingException {
        try {
            Method fromStringMethod = javaType.getMethod("fromString",
                new Class[] {java.lang.String.class});
            return fromStringMethod.invoke(null, new Object[] {source});
        }
        catch (Exception e) {
            throw new TypeMappingException(e);
        }
    }
}
