package org.act.soap.encoding.ser;
import javax.xml.namespace.QName;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPFactory;
import org.act.soap.encoding.SerializationContextImpl;
import org.act.soap.encoding.SerializerImpl;
import org.act.soap.encoding.TypeMappingException;
import org.act.soap.util.HexBinary;
import org.act.soap.util.JavaUtils;
import org.act.soap.util.TMConstants;
import org.act.soap.wsdl.java2wsdl.Types;
import org.w3c.dom.Element;

public class HexSerializer
    extends SerializerImpl {
    
    public HexSerializer () {
    }
    
    public SOAPElement serialize (Object value, QName valueName, Class javaType,
                                  QName xmlType,
                                  SerializationContextImpl context) throws
        TypeMappingException {
        try {
                        SOAPFactory sef = TMConstants.SOAPFACTORY_INSTANCE;
            SOAPElement soapElement = sef.createElement(valueName.getLocalPart());
                        super.addXsitypeAttr(soapElement,xmlType );
                                    if (null == value) {
                super.addNilAttr(soapElement);
                return soapElement;
            }
                        soapElement.addTextNode(getValueAsString(value, javaType));
            return soapElement;
        }
        catch (Exception ex) {
            throw new TypeMappingException(ex);
        }
    }
    
    private static String getValueAsString (Object value, Class javaType) {
        return HexBinary.encode( (byte[]) value);
    }
    
    public Element writeSchema (Class javaType, QName xmlType, Types types) throws
        TypeMappingException {
        return null;
    }
}
