package org.act.soap.encoding.ser;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Map;
import javax.xml.namespace.QName;
import javax.xml.rpc.encoding.TypeMapping;
import javax.xml.soap.SOAPElement;
import org.act.soap.encoding.DeserializationContextImpl;
import org.act.soap.encoding.DeserializerImpl;
import org.act.soap.encoding.TypeMappingException;
import org.act.soap.util.TMConstants;
import org.act.soap.util.XMLUtils;
import org.act.soap.util.i18n.Message;

public class MapDeserializer
    extends DeserializerImpl {
    
    public MapDeserializer () {
    }
    
    public Object deserialize (SOAPElement element, QName xmlType,
                               Class javaType,
                               DeserializationContextImpl context) throws
        TypeMappingException {
                        if (super.isNil(element)) {
            return null;
        }
                Map rtnValue=null;
        try{
              rtnValue=(Map)javaType.newInstance();
        }
        catch(Exception  ex){
            if(javaType==Map.class){
                rtnValue=new HashMap();
            }
            else{
                throw new TypeMappingException(ex);
            }
        }
                Iterator iteratorItem = element.getChildElements();
        while (iteratorItem.hasNext()) {
                        Object childObject = iteratorItem.next();
            if (! (childObject instanceof SOAPElement)) {
                continue;
            }
            SOAPElement soapChildElementItem = (SOAPElement) childObject;
                        Iterator iteratorKeyValue = soapChildElementItem.getChildElements();
            Object keyObject = null;
            Object valueObject = null;
                        int i=0;
            while(iteratorKeyValue.hasNext()){
                Object tempObject=iteratorKeyValue.next();
                if(tempObject instanceof SOAPElement){
                    if(i==0){
                        keyObject=tempObject;
                        i=1;
                    }
                    else{
                        valueObject=tempObject;
                        break;
                    }
                }
            }
            if ( keyObject ==null || valueObject==null) {
                continue;
            }
            SOAPElement soapKeyElementItem = (SOAPElement) keyObject;
            SOAPElement soapValueElementItem = (SOAPElement) valueObject;
                        Object oKey = null;
            Object oValue = null;
            if (super.isNil(soapKeyElementItem)) {
                throw new TypeMappingException(Message.getMessage("ERR_TM_keyIsNull"));
            }
            else {
                oKey = myDeserialize(soapKeyElementItem, context);
            }
            if (super.isNil(soapValueElementItem)) {
                oValue = null;
            }
            else {
                oValue = myDeserialize(soapValueElementItem, context);
            }
                        rtnValue.put(oKey, oValue);
        }
                return rtnValue;
    }
    
    private static Object myDeserialize (SOAPElement element,
                                         DeserializationContextImpl context) throws
        TypeMappingException {
                QName innerQName = DeserializerImpl.getXsitypeAttr(element);
                Class clsInner = context.getJavaType(innerQName);
                TypeMapping tm = context.getTypeMappingRegistry().
            getDefaultTypeMapping();
        DeserializerImpl di = (DeserializerImpl) tm.getDeserializer(clsInner,
            innerQName).
            getDeserializerAs(TMConstants.ENCODING_MECHANISMTYPE);
                Object desObject = di.deserialize(element, innerQName,
                                          clsInner,
                                          context);
                return desObject;
    }
}
