package org.act.soap.encoding.ser;
import javax.xml.namespace.QName;
import javax.xml.soap.SOAPElement;
import org.act.soap.encoding.DeserializationContextImpl;
import org.act.soap.encoding.DeserializerImpl;
import org.act.soap.encoding.TypeMappingException;

public class QNameDeserializer
    extends DeserializerImpl {
    
    public QNameDeserializer () {
    }
    
    public Object deserialize (SOAPElement element, QName xmlType,
                               Class javaType,
                               DeserializationContextImpl context) throws
        TypeMappingException {
                if (super.isNil(element)) {
            return null;
        }
                String strNodeValue = element.getValue();
                return makeValue(strNodeValue, javaType,element);
    }
    
    private static Object makeValue (String source, Class javaType,SOAPElement element) {
        if (null == source) {
            return null;
        }
        final int colon = source.lastIndexOf(":");
        String prefix = 0 > colon ? "" : source.substring(0, colon);
        String localPart = 0 > colon ? source : source.substring(colon + 1);
        String namespace="";
        if(!prefix.equals("")){
            namespace=element.getNamespaceURI(prefix);
        }
        return new QName(namespace, localPart);
    }
}
