package org.act.soap.encoding.ser;
import javax.xml.namespace.QName;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPFactory;
import org.act.soap.encoding.SerializationContextImpl;
import org.act.soap.encoding.SerializerImpl;
import org.act.soap.encoding.TypeMappingException;
import org.act.soap.util.TMConstants;
import org.act.soap.wsdl.java2wsdl.Types;
import org.w3c.dom.Element;

public class QNameSerializer
    extends SerializerImpl {
    
    public QNameSerializer () {
    }
    
    public SOAPElement serialize (Object value, QName valueName, Class javaType,
                                  QName xmlType,
                                  SerializationContextImpl context) throws
        TypeMappingException {
        try {
                        SOAPFactory sef = TMConstants.SOAPFACTORY_INSTANCE;
            SOAPElement soapElement = sef.createElement(valueName.getLocalPart());
                        super.addXsitypeAttr(soapElement,xmlType);
                                    if (null == value) {
                super.addNilAttr(soapElement);
                return soapElement;
            }
                        QName qName = (QName) value;
            String namespaceURI = qName.getNamespaceURI();
            if ( (null == namespaceURI) || (0 == namespaceURI.length())) {
                soapElement.addTextNode(qName.getLocalPart());
            }
            else{
                String prefix="tns0";
                StringBuffer sb = new StringBuffer(prefix);
                sb.append(':');
                sb.append(qName.getLocalPart());
                soapElement.addNamespaceDeclaration(prefix,namespaceURI) ;
                soapElement.addTextNode(sb.toString());
            }
            return soapElement;
        }
        catch (Exception ex) {
            throw new TypeMappingException(ex);
        }
    }
    
    private static String getValueAsString (Object value) {
        QName qName = (QName) value;
        String prefix = null;
        String namespaceURI = qName.getNamespaceURI();
        if ( (null == namespaceURI) || (0 == namespaceURI.length())) {
            return qName.getLocalPart();
        }
        prefix = namespaceURI;
        StringBuffer sb = new StringBuffer(prefix);
        sb.append(':');
        sb.append(qName.getLocalPart());
        return sb.toString();
    }
    
    public Element writeSchema (Class javaType, QName xmlType, Types types) throws
        TypeMappingException {
        return null;
    }
}
