package org.act.soap.encoding.ser;
import javax.xml.namespace.QName;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPFactory;
import org.act.soap.encoding.SerializationContextImpl;
import org.act.soap.encoding.SerializerImpl;
import org.act.soap.encoding.TypeMappingException;
import org.act.soap.util.TMConstants;
import org.act.soap.util.i18n.Message;
import org.act.soap.wsdl.java2wsdl.Types;
import org.w3c.dom.Element;

public class SimpleSerializer
    extends SerializerImpl {
    
    public SimpleSerializer() {
    }
    
    public SOAPElement serialize(Object value, QName valueName, Class javaType,
                                 QName xmlType,
                                 SerializationContextImpl context) throws
        TypeMappingException {
        try {
                        SOAPFactory sef = TMConstants.SOAPFACTORY_INSTANCE;
            SOAPElement soapElement = sef.createElement(valueName.getLocalPart());
                        super.addXsitypeAttr(soapElement, xmlType);
                                                if (null == value) {
                if (javaType.isPrimitive()) {
                    throw new TypeMappingException(Message.getMessage(
                        "ERR_TM_badPrimitiveNull"));
                }
                else {
                    super.addNilAttr(soapElement);
                    return soapElement;
                }
            }
                        String strValue = getValueAsString(value, xmlType);
            soapElement.addTextNode(strValue);
            return soapElement;
        }
        catch (Exception ex) {
            throw new TypeMappingException(ex);
        }
    }
    
    private static String getValueAsString(Object value, QName xmlType) {
                if (value instanceof Float || value instanceof Double) {
            double data = 0.0;
            if (value instanceof Float) {
                data = ( (Float) value).doubleValue();
            }
            else {
                data = ( (Double) value).doubleValue();
            }
            if (Double.isNaN(data)) {
                return "NaN";
            }
            else if (data == Double.POSITIVE_INFINITY) {
                return "INF";
            }
            else if (data == Double.NEGATIVE_INFINITY) {
                return "-INF";
            }
        }
                return value.toString();
    }
    
    public Element writeSchema(Class javaType, QName xmlType, Types types) throws
        TypeMappingException {
        return null;
    }
}
