package org.act.soap.encoding.ser;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import javax.xml.namespace.QName;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPFactory;
import org.act.soap.encoding.SerializationContextImpl;
import org.act.soap.encoding.SerializerImpl;
import org.act.soap.encoding.TypeMappingException;
import org.act.soap.util.TMConstants;
import org.act.soap.wsdl.java2wsdl.Types;
import org.w3c.dom.Element;

public class TimeSerializer
    extends SerializerImpl {
    
    public TimeSerializer() {
    }
    
    private static final SimpleDateFormat ZULU =
        new SimpleDateFormat("HH:mm:ss.SSS'Z'");
    
    public SOAPElement serialize(Object value, QName valueName, Class javaType,
                                 QName xmlType,
                                 SerializationContextImpl context) throws
        TypeMappingException {
        try {
                        SOAPFactory sef = TMConstants.SOAPFACTORY_INSTANCE;
            SOAPElement soapElement = sef.createElement(valueName.getLocalPart());
                        super.addXsitypeAttr(soapElement, xmlType);
                                    if (null == value) {
                super.addNilAttr(soapElement);
                return soapElement;
            }
                        String strValue = getValueAsString(value);
            soapElement.addTextNode(strValue);
            return soapElement;
        }
        catch (Exception ex) {
            throw new TypeMappingException(ex);
        }
    }
    
    private static String getValueAsString(Object value) {
        Calendar _value = (Calendar) value;
                _value.set(0, 0, 0);
        return ZULU.format(_value.getTime());
    }
    
    public Element writeSchema(Class javaType, QName xmlType, Types types) throws
        TypeMappingException {
        return null;
    }
}
