package org.act.soap.encoding.ser;
import java.util.Iterator;
import java.util.Vector;
import javax.xml.namespace.QName;
import javax.xml.rpc.encoding.TypeMapping;
import javax.xml.soap.Name;
import javax.xml.soap.SOAPElement;
import org.act.soap.encoding.DeserializationContextImpl;
import org.act.soap.encoding.DeserializerImpl;
import org.act.soap.encoding.TypeMappingException;
import org.act.soap.util.TMConstants;
import org.act.soap.util.XMLUtils;

public class VectorDeserializer
    extends DeserializerImpl {
    
    public VectorDeserializer () {
    }
    
    public Object deserialize (SOAPElement element, QName xmlType,
                               Class javaType,
                               DeserializationContextImpl context) throws
        TypeMappingException {
                if (super.isNil(element)) {
            return null;
        }
                Vector rtnValue = new Vector();
                TypeMapping tm = context.getTypeMappingRegistry().
            getDefaultTypeMapping();
                Iterator iteratorItem = element.getChildElements();
        while (iteratorItem.hasNext()) {
                        Object childObject = iteratorItem.next();
            if (! (childObject instanceof SOAPElement)) {
                continue;
            }
            SOAPElement soapChildElementItem = (SOAPElement) childObject;
            if (super.isNil(soapChildElementItem)) {
                rtnValue.addElement(null);
                continue;
            }
                        QName innerQName = super.getXsitypeAttr(soapChildElementItem);
                        Class clsInner = context.getJavaType(innerQName);
                        DeserializerImpl di = (DeserializerImpl) tm.getDeserializer(
                clsInner,
                innerQName).
                getDeserializerAs(TMConstants.ENCODING_MECHANISMTYPE);
                        Object desObject = di.deserialize(soapChildElementItem, innerQName,
                                              clsInner,
                                              context);
                        rtnValue.addElement(desObject);
        }
                return rtnValue;
    }
}
