package org.act.soap.encoding.ser;
import java.util.HashMap;
import java.util.Vector;
import javax.xml.namespace.QName;
import javax.xml.rpc.encoding.TypeMapping;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPFactory;
import org.act.soap.encoding.SerializationContextImpl;
import org.act.soap.encoding.SerializerImpl;
import org.act.soap.encoding.TypeMappingException;
import org.act.soap.util.TMConstants;
import org.act.soap.util.XMLUtils;
import org.act.soap.util.i18n.Message;
import org.act.soap.wsdl.java2wsdl.Types;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class VectorSerializer
    extends SerializerImpl {
    
    public VectorSerializer () {
    }
    
    public SOAPElement serialize (Object value, QName valueName, Class javaType,
                                  QName xmlType,
                                  SerializationContextImpl context) throws
        TypeMappingException {
        try {
                        SOAPFactory sef = TMConstants.SOAPFACTORY_INSTANCE;
            SOAPElement soapElement = sef.createElement(valueName.getLocalPart());
                        super.addXsitypeAttr(soapElement,xmlType);
                                    if (null == value) {
                super.addNilAttr(soapElement);
                return soapElement;
            }
                        if (! (value instanceof Vector)) {
                throw new TypeMappingException(
                    Message.getMessage("ERR_TM_noVector",
                                       value.getClass().getName()));
            }
            Vector vector = (Vector) value;
                        if (isRecursive(new HashMap(), vector)) {
                throw new TypeMappingException(Message.getMessage(
                    "ERR_TM_badVector"));
            }
                        TypeMapping tm = context.getTypeMappingRegistry().
                getDefaultTypeMapping();
            QName elementName = new QName(TMConstants.LITERAL_ITEM);
            for (int i = 0; i < vector.size(); i++) {
                                Object aValue = vector.elementAt(i);
                                SOAPElement childElement=null;
                if (null == aValue) {
                    childElement=soapElement.addChildElement(TMConstants.LITERAL_ITEM);
                    super.addNilAttr(childElement);
                    continue;
                }
                Class aClass = aValue.getClass();
                SerializerImpl si = null;
                                                QName aXmlType = context.getXmlType(aClass);
                                si = (SerializerImpl) tm.getSerializer(aClass, aXmlType).
                    getSerializerAs(TMConstants.ENCODING_MECHANISMTYPE);
                                childElement = si.serialize(aValue, elementName, aClass,
                                            aXmlType, context);
                                soapElement.addChildElement(childElement);
            }
                        return soapElement;
        }
        catch (Exception ex) {
            throw new TypeMappingException(ex);
        }
    }
    
    private boolean isRecursive (HashMap map, Vector vector) {
                map.put(Integer.toString(System.identityHashCode(vector)), vector);
        boolean recursive = false;
                for (int i = 0; (i < vector.size()); i++) {
            Object o = vector.get(i);
            if (o instanceof Vector) {
                if (map.containsValue(o)) {
                    recursive = true;
                    break;
                }
                else {
                    recursive = isRecursive(map, (Vector) o);
                    if (recursive) {
                        break;
                    }
                }
            }
        }
        return recursive;
    }
    
    public Element writeSchema (Class javaType, QName xmlType, Types types) throws
        TypeMappingException {
        try {
                        Document doc = XMLUtils.getDOMBuilder().newDocument();
                        Element complexType = doc.createElement(TMConstants.
                SCHEMA_COMPLEXTYPE);
            complexType.setAttribute(TMConstants.SCHEMA_NAME, "Vector");
            Element seq = doc.createElement(TMConstants.SCHEMA_SEQUENCE);
            complexType.appendChild(seq);
            Element element = doc.createElement(TMConstants.SCHEMA_ELEMENT);
            element.setAttribute(TMConstants.SCHEMA_NAME,
                                 TMConstants.SCHEMA_ITEM);
            element.setAttribute(TMConstants.SCHEMA_MINOCCURS,
                                 TMConstants.SCHEMA_0);
            element.setAttribute(TMConstants.SCHEMA_MAXOCCURS,
                                 TMConstants.SCHEMA_UNBOUNDED);
            element.setAttribute(TMConstants.SCHEMA_TYPE,
                                 TMConstants.SCHEMA_ANYTYPE);
            seq.appendChild(element);
                        types.putSchemaElement(xmlType, complexType);
                        return complexType;
        }
        catch (Exception ex) {
            throw new TypeMappingException(ex);
        }
    }
}
