package org.act.soap.encoding.ser.bean;
import java.beans.Introspector;
import java.beans.PropertyDescriptor;
import java.lang.reflect.Field;
import java.lang.reflect.Modifier;
import java.security.AccessController;
import java.security.PrivilegedAction;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.act.soap.util.TMConstants;

public class BeanUtils {
    
    private BeanUtils () {}
    
    public static BeanPropertyDescriptor[] getPd (Class javaType) {
        BeanPropertyDescriptor[] pd = null;
        try {
            final Class secJavaType = javaType;
                        PropertyDescriptor[] rawPd = getPropertyDescriptors(secJavaType);
                        pd = processPropertyDescriptors(rawPd, javaType);
        }
        catch (Exception ex) {}
        return pd;
    }
    
    public static BeanPropertyDescriptor[] processPropertyDescriptors (
        PropertyDescriptor[] rawPd, Class cls) {
        BeanPropertyDescriptor[] myPd = null;
        try {
            List pd = new ArrayList();
            for (int i = 0; i < rawPd.length; i++) {
                                                                               pd.add(new BeanPropertyDescriptor(rawPd[i]));
            }
                        Field[] fields = cls.getFields();
            if ( (null != fields) && (0 < fields.length)) {
                                for (int i = 0; i < fields.length; i++) {
                    Field f = fields[i];
                                        String clsName = f.getDeclaringClass().getName();
                    if (clsName.startsWith("java.") ||
                        clsName.startsWith("javax.")) {
                        continue;
                    }
                                        if (! (Modifier.isStatic(f.getModifiers()) ||
                           Modifier.isFinal(f.getModifiers()) ||
                           Modifier.isTransient(f.getModifiers()))) {
                        String fName = f.getName();
                        boolean found = false;
                        for (int j = 0; (j < rawPd.length) && !found; j++) {
                            String pName =
                                ( (BeanPropertyDescriptor) pd.get(j)).getName();
                            if ( (pName.length() == fName.length()) &&
                                pName.substring(0,
                                                1).equalsIgnoreCase(fName.
                                substring(0, 1))) {
                                found = (1 == pName.length()) ||
                                    pName.substring(1).equals(fName.substring(1));
                            }
                        }
                        if (!found) {
                            pd.add(new FieldPropertyDescriptor(f.getName(), f));
                        }
                    }
                }
            }
            myPd = new BeanPropertyDescriptor[pd.size()];
            pd.toArray(myPd);
        }
        catch (Exception ex) {}
        return myPd;
    }
    
    public static Map getProperties (Class javaType) {
        Map propertyMap = null;
        BeanPropertyDescriptor[] pd = BeanUtils.getPd(javaType);
        propertyMap = new HashMap();
        for (int i = 0; i < pd.length; i++) {
            BeanPropertyDescriptor descriptor = pd[i];
            propertyMap.put(descriptor.getName(), descriptor);
        }
        return propertyMap;
    }
    
    private static PropertyDescriptor[] getPropertyDescriptors (final Class
        secJavaType) {
        return (PropertyDescriptor[]) AccessController.doPrivileged(
            new PrivilegedAction() {
            public Object run () {
                PropertyDescriptor[] result = null;
                try {
                    if (Throwable.class.isAssignableFrom(secJavaType)) {
                        result = Introspector.getBeanInfo(secJavaType,
                            Throwable.class).
                            getPropertyDescriptors();
                    }
                    else {
                        result = Introspector.getBeanInfo(secJavaType).
                            getPropertyDescriptors();
                    }
                }
                catch (java.beans.IntrospectionException ex) {}
                return result;
            }
        });
    }
}
