package org.act.soap.encoding.ser.bean;
import java.beans.PropertyDescriptor;
import java.lang.reflect.Array;
import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import org.act.soap.util.i18n.Message;

public class FieldPropertyDescriptor
    extends BeanPropertyDescriptor {
    
    public FieldPropertyDescriptor () {
    }
    
    private Field field = null;
    
    public FieldPropertyDescriptor (String _name,
                                    Field _field) {
        field = _field;
        try {
            myPD = new PropertyDescriptor(_name, null, null);
        }
        catch (Exception e) {}
        if ( (null == _field) || (null == _name)) {
            throw new IllegalArgumentException(
                Message.getMessage(null == _field ?
                                   "ERR_TM_badField" : "ERR_TM_badProp"));
        }
    }
    
    public String getName () {
        return field.getName();
    }
    
    public boolean isReadable () {
        return true;
    }
    
    public boolean isWriteable () {
        return true;
    }
    
    public boolean isIndexed () {
        return null != field.getType().getComponentType();
    }
    
    public Object get (Object obj) throws InvocationTargetException,
        IllegalAccessException {
        return field.get(obj);
    }
    
    public Object get (Object obj, int i) throws InvocationTargetException,
        IllegalAccessException {
        if (!isIndexed()) {
            throw new IllegalAccessException("Not an indexed property");
        }
        Object array = field.get(obj);
        return Array.get(array, i);
    }
    
    public void set (Object obj, Object newValue) throws
        InvocationTargetException,
        IllegalAccessException {
        field.set(obj, newValue);
    }
    
    public void set (Object obj, int i, Object newValue) throws
        InvocationTargetException, IllegalAccessException {
        if (!isIndexed()) {
            throw new IllegalAccessException("Not an indexed field!");
        }
        Class componentType = field.getType().getComponentType();
        growArrayToSize(obj, componentType, i);
        Array.set(get(obj), i, newValue);
    }
    
    public Class getType () {
        if (isIndexed()) {
            return field.getType().getComponentType();
        }
        else {
            return field.getType();
        }
    }
}
