package org.act.soap.message;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPException;
import javax.xml.soap.Text;
import org.w3c.dom.Node;
import org.apache.xerces.dom.CDATASectionImpl;
import org.act.soap.util.i18n.Message;

final class CDATAImpl extends CDATASectionImpl implements Text{
    
    CDATAImpl (SOAPDocumentImpl ownerDoc, String text) {  
        super(ownerDoc, text);
    }
    
    public void detachNode () {  
        Node parent = getParentNode();
        if (null != parent) {
            parent.removeChild(this);
        }
    }
    
    public void recycleNode () {  
        detachNode();
    }
    
    public boolean isComment () {  
        return false;
    }
    
    public String getValue () {  
        return getNodeValue();
    }
    
    public void setValue (String text) {  
        setNodeValue(text);
    }
    
    public SOAPElement getParentElement () {  
        return (SOAPElement) getParentNode();
    }
    
    public void setParentElement (SOAPElement parent)
        throws SOAPException {  
        if ( null == parent ) {
            throw new IllegalArgumentException(
                    Message.getMessage("SAAJ_E_ELE_NULL_PARENT"));
        } else {
            parent.appendChild(this);
        }
    }
}
