package org.act.soap.message;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPException;
import org.w3c.dom.DOMException;
import org.w3c.dom.Node;
import org.act.soap.util.i18n.Message;

final class CommentImpl extends org.apache.xerces.dom.CommentImpl 
                        implements javax.xml.soap.Text {  
    
    CommentImpl (SOAPDocumentImpl ownerDoc, String text) {
        super(ownerDoc, text);
    }
    
    public final void detachNode () {  
        Node parent = getParentNode();
        if (null != parent) {
            parent.removeChild(this);
        }
    }
    
    public final void recycleNode () {  
        detachNode();
    }
    
    public final boolean isComment () {  
        return true;
    }
    
    public final String getValue () {  
        return getNodeValue();
    }
    
    public final void setValue (String text) {  
        setNodeValue(text);
    }
    
    public final SOAPElement getParentElement () {  
        return (SOAPElement) getParentNode();
    }
    
    public final void setParentElement (SOAPElement parent)
        throws SOAPException {  
        if ( null == parent ) {
            throw new IllegalArgumentException(
                    Message.getMessage("SAAJ_E_ELE_NULL_PARENT"));
        } else {
            parent.appendChild(this);
        }
    }
    
    public final org.w3c.dom.Text splitText (int offset) throws DOMException {  
        throw new UnsupportedOperationException(
                    Message.getMessage("SAAJ_E_TEXT_UNABLE_SPLIT_COMMENT"));
    }
}
