package org.act.soap.message;
import javax.xml.soap.Detail;
import javax.xml.soap.Name;
import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPFault;
import org.act.soap.util.i18n.Message;
import javax.xml.soap.SOAPElement;

public abstract class FaultImpl extends BodyElementImpl implements SOAPFault {
    
    protected FaultImpl (SOAPDocumentImpl ownerDoc, Name name) {
        super(ownerDoc, name);
    }
            
    public final Detail addDetail () throws SOAPException {
        if (null != getDetail()) {
            throw new SOAPException(
                        Message.getMessage("SAAJ_E_FAULT_DETAIL_EXIST"));
        } else {
            Detail detail = createDetail();
            appendChild(detail);
            return detail;
        }
    }
    
    public final Detail getDetail () {
        return findDetail();
    }
            
    protected abstract Detail createDetail();
    
    protected abstract Name getDetailName();
    protected Detail findDetail() {
        SOAPElement oldDetail = _getFirstChildElement(getDetailName());
        if (null == oldDetail)
            return null;
        if (oldDetail instanceof Detail)
            return (Detail) oldDetail;
        Detail newDetail = createDetail();
        _replaceWith(oldDetail, newDetail);
        return newDetail;
    }
}
