package org.act.soap.message;
import javax.xml.soap.Name;
import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPHeaderElement;

public abstract class HeaderElementImpl extends ElementImpl
                                        implements SOAPHeaderElement {
    
    protected HeaderElementImpl (SOAPDocumentImpl ownerDoc, Name name) {
        super(ownerDoc, name);
    }
            
    public final void setActor (String actorURI) {
        try {
                        Name name = getAttrRoleOrActorName(_getSOAPEnvPrefix());
                        addAttribute(name, actorURI);
        }
        catch ( SOAPException soape ) {
        }
    }
    
    public final String getActor () {
        return getAttributeValue(getAttrRoleOrActorName(_getSOAPEnvPrefix()));
    }
    
    public final void setMustUnderstand (boolean mustUnderstand) {
        try {
            Name name = getAttrMustUnderstandName(_getSOAPEnvPrefix());
            if ( mustUnderstand )
                addAttribute(name, "true");
            else
                addAttribute(name, "false");
        }
        catch ( SOAPException soape ) {
        }
    }
    
    public final boolean getMustUnderstand () {
        String value =
            getAttributeValue(getAttrMustUnderstandName(_getSOAPEnvPrefix()));
        return ("true".equals(value) || "1".equals(value)) ? true : false;
    }
            
    protected abstract Name getAttrRoleOrActorName(String prefix);
    
    protected abstract Name getAttrMustUnderstandName(String prefix);
}
