package org.act.soap.message;
import javax.xml.soap.Detail;
import javax.xml.soap.Name;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPFactory;

public abstract class SOAPFactoryImpl extends SOAPFactory {
    
    private static SOAPDocumentImpl doc = null;
            
    
    public Detail createDetail () throws SOAPException {
        return _createDetail();
    }
    
    public SOAPElement createElement (String localName) throws SOAPException {
        return new ElementImpl(initSOAPDocument(), new NameImpl(localName));
    }
    
    public SOAPElement createElement (Name name) throws SOAPException {
        return new ElementImpl(initSOAPDocument(), name);
    }
    
    public SOAPElement createElement (String localName, 
                                      String prefix, 
                                      String uri)
        throws SOAPException {
        return new ElementImpl(initSOAPDocument(),
                               new NameImpl(localName, prefix, uri));
    }
    
    public Name createName (String localName, String prefix, String uri)
        throws SOAPException {
        return new NameImpl(localName, prefix, uri);
    }
    
    public Name createName (String localName) throws SOAPException {
        return new NameImpl(localName);
    }
    
    
    
    protected abstract Detail _createDetail();
    
    protected static final SOAPDocumentImpl initSOAPDocument () {
        if ( null != doc )
            return doc;
        doc = new SOAPDocumentImpl();
        return doc;
    }
}
