package org.act.soap.message;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPException;
import org.act.soap.util.i18n.Message;

final class TextImpl extends org.apache.xerces.dom.TextImpl
                     implements javax.xml.soap.Text {
    
    TextImpl (SOAPDocumentImpl ownerDoc, String text) {
        super(ownerDoc, text);
    }
    
    public final boolean isComment () {
        String txt = getNodeValue();
        return txt.startsWith("<!--") && txt.endsWith("-->");
    }
    
    public final String getValue () {
        return getNodeValue();
    }
    
    public final void setParentElement (SOAPElement parent) 
        throws SOAPException {
        if (null == parent) {
            throw new IllegalArgumentException(
                    Message.getMessage("SAAJ_E_ELE_NULL_PARENT"));
        } else {
            parent.appendChild(this);
        }
    }
    
    public final SOAPElement getParentElement () {
        return (SOAPElement) getParentNode();
    }
    
    public final void detachNode () {
        org.w3c.dom.Node parent = getParentNode();
        if (null != parent) {
            parent.removeChild(this);
        }
    }
    
    public final void recycleNode () {
        detachNode();
    }
    
    public final void setValue (String text) {
        setNodeValue(text);
    }
}
