package org.act.soap.message.ver1_1;
import javax.xml.soap.Name;
import javax.xml.soap.SOAPBody;
import javax.xml.soap.SOAPHeader;
import org.act.soap.message.EnvelopeImpl;
import org.act.soap.message.NameImpl;
import org.act.soap.message.SOAPDocumentImpl;

public final class Envelope1_1Impl extends EnvelopeImpl {
    
    public Envelope1_1Impl (SOAPDocumentImpl ownerDoc, String prefix) {  
        this(ownerDoc, prefix, false, false);
    }
    
    Envelope1_1Impl (SOAPDocumentImpl ownerDoc, String prefix,
                    boolean createHeader, boolean createBody) {  
        super(ownerDoc, 
              NameImpl.createEnvelope1_1Name(prefix), 
              createHeader, 
              createBody);
    }
    
    protected Name getBodyName (String prefix) {  
        return NameImpl.createBody1_1Name(prefix);
    }
    
    protected Name getHeaderName (String prefix) {  
        return NameImpl.createHeader1_1Name(prefix);
    }
    
    protected SOAPHeader createHeader (String prefix) {  
        return new Header1_1Impl((SOAPDocumentImpl) getOwnerDocument(), prefix);
    }
    
    protected SOAPBody createBody (String prefix) {  
        return new Body1_1Impl((SOAPDocumentImpl) getOwnerDocument(), prefix);
    }
}
