package org.act.soap.message.ver1_1;
import java.util.Locale;
import javax.xml.soap.*;
import org.act.soap.message.*;
import org.act.soap.util.i18n.Message;

public class Fault1_1Impl extends FaultImpl {
    private Name codeName;
    private Name stringName;
    private Name actorName;
    private Name detailName;
          public Fault1_1Impl(SOAPDocumentImpl ownerDocument, String prefix) {
        super(ownerDocument, NameImpl.createFault1_1Name(prefix));
                                        codeName = NameImpl.FAULT_CODE11_NAME;
        stringName = NameImpl.FAULT_STRING11_NAME;
        actorName = NameImpl.FAULT_ACTOR_11_NAME;
        detailName = NameImpl.FAULT_DETAIL_11_NAME;
    }
    protected FaultCode1_1Impl findFaultCode() {
                return convertToFaultCode(_getFirstChildElement(codeName));
            }
    protected FaultString1_1Impl findFaultString() {
        return convertToFaultString(_getFirstChildElement(stringName));
    }
    protected FaultActor1_1Impl findFaultActor() {
        return convertToFaultActor(_getFirstChildElement(actorName));
    }
    
    protected Name getDetailName() {
        return detailName;
    }
    protected Detail createDetail() {
        return new Detail1_1Impl((SOAPDocumentImpl)getOwnerDocument());
    }
    
    private final FaultCode1_1Impl convertToFaultCode(SOAPElement oldEle) {
        if (null == oldEle)
            return null;
        if (oldEle instanceof FaultCode1_1Impl)
            return (FaultCode1_1Impl) oldEle;
        FaultCode1_1Impl faultCode = new FaultCode1_1Impl((SOAPDocumentImpl)getOwnerDocument());
        _replaceWith(oldEle, faultCode);
        return faultCode;
    }
    private final FaultString1_1Impl convertToFaultString(SOAPElement oldEle) {
        if (null == oldEle)
            return null;
        if (oldEle instanceof FaultString1_1Impl)
            return (FaultString1_1Impl) oldEle;
        FaultString1_1Impl faultStr = new FaultString1_1Impl((SOAPDocumentImpl)getOwnerDocument());
        _replaceWith(oldEle, faultStr);
        return faultStr;
    }
    private final FaultActor1_1Impl convertToFaultActor(SOAPElement oldEle) {
        if (null == oldEle)
            return null;
        if (oldEle instanceof FaultActor1_1Impl)
            return (FaultActor1_1Impl) oldEle;
        FaultActor1_1Impl actor = new FaultActor1_1Impl((SOAPDocumentImpl)getOwnerDocument());
        _replaceWith(oldEle, actor);
        return actor;
    }
    
    
    public void setFaultCode(String faultCode) throws SOAPException {
        FaultCode1_1Impl code = findFaultCode();
        if ( null == code ) {
            code = new FaultCode1_1Impl((SOAPDocumentImpl)getOwnerDocument());
            appendChild(code);
        }
        code.setFaultCodeValue(faultCode);
    }
    
    public String getFaultCode() {
        FaultCode1_1Impl code = findFaultCode();
        return (null == code) ? null : code.getFaultCodeValue();
    }
    
    public void setFaultCode(Name faultCodeQName) throws SOAPException {
        FaultCode1_1Impl code = findFaultCode();
        if ( null == code ) {
            code = new FaultCode1_1Impl((SOAPDocumentImpl)getOwnerDocument());
            appendChild(code);
        }
        code.setFaultCodeValue(faultCodeQName);
    }
    
    public Name getFaultCodeAsName() {
        FaultCode1_1Impl code = findFaultCode();
        return null==code ? null : code.getFaultCodeAsName();
    }
    
    public void setFaultString(String faultString) throws SOAPException {
        if (null == faultString)
            throw new IllegalArgumentException(Message.getMessage("SAAJ_E_NULL_ARG"));
        FaultString1_1Impl faultStr =findFaultString();
        if ( null == faultStr ) {
            faultStr = new FaultString1_1Impl( (SOAPDocumentImpl) getOwnerDocument());
            appendChild(faultStr);
        }
        faultStr.setFaultStringValue(faultString);
    }
    
    public String getFaultString() {
        FaultString1_1Impl faultStr = findFaultString();
        return null==faultStr ? null : faultStr.getFaultStringValue();
    }
    
    public void setFaultString(String faultString, Locale locale)
        throws SOAPException
    {
        FaultString1_1Impl faultStr = findFaultString();
        if ( null == faultStr ) {
            faultStr = new FaultString1_1Impl( (SOAPDocumentImpl) getOwnerDocument());
            appendChild(faultStr);
        }
        faultStr.setFaultStringValue(faultString, locale);
    }
    
    public Locale getFaultStringLocale() {
        FaultString1_1Impl faultStr = findFaultString();
        return null==faultStr ? null : faultStr.getLocale();
    }
    
    public void setFaultActor(String faultActor) throws SOAPException {
        FaultActor1_1Impl actor = findFaultActor();
        if ( null == actor ) {
            actor = new FaultActor1_1Impl( (SOAPDocumentImpl) getOwnerDocument());
            appendChild(actor);
        }
        actor.setFaultActorValue(faultActor);
    }
    
    public String getFaultActor() {
        FaultActor1_1Impl actor = findFaultActor();
        return null==actor ? null : actor.getFaultActorValue();
    }
    
}
