package org.act.soap.message.ver1_1;
import javax.xml.soap.Name;
import javax.xml.soap.SOAPException;
import org.act.soap.message.FaultElementImpl;
import org.act.soap.message.NameImpl;
import org.act.soap.message.SOAPDocumentImpl;
import org.act.soap.message.Utils;

public final class FaultCode1_1Impl extends FaultElementImpl {
    
    public FaultCode1_1Impl (SOAPDocumentImpl ownerDoc, String prefix) {
        super(ownerDoc, NameImpl.createFaultCode1_1Name(prefix));
    }
    
    public FaultCode1_1Impl (SOAPDocumentImpl ownerDoc) {
        super(ownerDoc, NameImpl.FAULT_CODE11_NAME);
    }
    
    final void setFaultCodeValue (String faultCode) throws SOAPException {
        setValue(faultCode);
    }
    
    final void setFaultCodeValue (Name faultCodeQName) throws SOAPException {
        setValue(faultCodeQName.getQualifiedName());
    }
    
    final String getFaultCodeValue () {
        return getValue();
    }
    
    final Name getFaultCodeAsName () {
        String[] s = Utils.splitQName(getValue());
                String uri = getNamespaceURI(s[0]);
        return new NameImpl(s[1], s[0], uri);
    }
}
