package org.act.soap.message.ver1_1;
import java.util.Locale;
import javax.xml.soap.SOAPException;
import org.act.soap.message.Constants;
import org.act.soap.message.FaultElementImpl;
import org.act.soap.message.NameImpl;
import org.act.soap.message.SOAPDocumentImpl;
import org.act.soap.message.Utils;

public final class FaultString1_1Impl extends FaultElementImpl {
    
    public FaultString1_1Impl (SOAPDocumentImpl ownerDoc, String prefix) {
        super(ownerDoc, NameImpl.createFaultString1_1Name(prefix));
    }
    
    public FaultString1_1Impl (SOAPDocumentImpl ownerDoc) {
        super(ownerDoc, NameImpl.FAULT_STRING11_NAME);
    }
    
    final void setFaultStringValue (String faultString) throws SOAPException {
        this.setValue(faultString);
    }
    
    final void setFaultStringValue (String faultString, Locale locale) {
        this.setValue(faultString);
                setAttributeNS(Constants.XML_URI,
                       "xml:lang",
                       Utils.localeToXmlLang(locale));
    }
    
    final String getFaultStringValue () {
        return this.getValue();
    }
    
    final Locale getLocale () {
                String lang = getAttributeValue(
                            new NameImpl("lang", "xml", Constants.XML_URI));
        return Utils.xmlLangToLocale(lang);
    }
}
