package org.act.soap.message.ver1_2;
import java.util.Locale;
import javax.xml.soap.*;
import org.act.soap.message.*;

public class Fault1_2Impl extends FaultImpl {
    private Name codeName;
    private Name reasonName;
    private Name nodeName;
    private Name roleName;
    private Name detailName;
    private FaultCode1_2Impl code;
    private FaultReason1_2Impl reason;
    private FaultNode1_2Impl node;
    private FaultRole1_2Impl role;
    public Fault1_2Impl(SOAPDocumentImpl ownerDocument, String prefix) {
        super(ownerDocument, NameImpl.createFault1_2Name(prefix));
        codeName = NameImpl.createFaultCode1_2Name(prefix);
        reasonName = NameImpl.createFaultReason1_2Name(prefix);
        nodeName = NameImpl.createFaultNode1_2Name(prefix);
        roleName = NameImpl.createFaultRole1_2Name(prefix);
        detailName = NameImpl.createFaultDetail1_2Name(prefix);
    }
    protected void initFaultCode() {
        code = (FaultCode1_2Impl)_getFirstChildElement(codeName);
    }
    protected void initFaultReason() {
        reason = (FaultReason1_2Impl)_getFirstChildElement(reasonName);
    }
    protected void initFaultNode() {
        node = (FaultNode1_2Impl)_getFirstChildElement(nodeName);
    }
    protected void initFaultRole() {
                role = (FaultRole1_2Impl)_getFirstChildElement(roleName);
    }
    
    protected Name getDetailName() {
        return detailName;
    }
    protected Detail createDetail() {
        return new Detail1_2Impl((SOAPDocumentImpl)getOwnerDocument(), getPrefix());
    }
    
    
    public void setFaultCode(String faultCode) throws SOAPException {
        initFaultCode();
        if ( null == code ) {
            code = new FaultCode1_2Impl((SOAPDocumentImpl)getOwnerDocument(), getPrefix());
            appendChild(code);
        }
        code.setFaultCodeValue(faultCode);
    }
    public String getFaultCode() {
        initFaultCode();
        if ( null == code )
            return null;
        else
            return code.getFaultCodeValue();
    }
    public void setFaultCode(Name faultCodeQName) throws SOAPException {
        initFaultCode();
        if ( null == code ) {
            code = new FaultCode1_2Impl((SOAPDocumentImpl)getOwnerDocument(), getPrefix());
            appendChild(code);
        }
        code.setFaultCodeValue(faultCodeQName);
    }
    public Name getFaultCodeAsName() {
        initFaultCode();
        return code==null ? null : code.getFaultCodeAsName();
    }
    public void setFaultString(String faultReason) throws SOAPException {
        initFaultReason();
        if ( null == reason ) {
            reason = new FaultReason1_2Impl( (SOAPDocumentImpl) getOwnerDocument(), getPrefix());
            appendChild(reason);
        }
        reason.setFaultReasonValue(faultReason);
    }
    public String getFaultString() {
        initFaultReason();
        return reason==null ? null : reason.getFaultReasonValue();
    }
    public void setFaultString(String faulstReason, Locale locale) throws SOAPException {
        initFaultReason();
        if ( null == reason ) {
            reason = new FaultReason1_2Impl((SOAPDocumentImpl) getOwnerDocument(), getPrefix());
            appendChild(reason);
        }
        reason.setFaultReasonValue(faulstReason, locale);
    }
    public Locale getFaultStringLocale() {
        initFaultReason();
        return reason==null ? null : reason.getLocale();
    }
    public void setFaultActor(String actor) throws SOAPException {
        initFaultNode();
        if ( null == node ) {
            node = new FaultNode1_2Impl((SOAPDocumentImpl) getOwnerDocument(), getPrefix());
            appendChild(node);
        }
        node.setFaultNodeValue(actor);
    }
    public String getFaultActor() {
        initFaultNode();
        return node==null ? null : node.getFaultNodeValue();
    }
}
