package org.act.soap.message.ver1_2;
import javax.xml.soap.Name;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPException;
import org.act.soap.message.ElementImpl;
import org.act.soap.message.FaultElementImpl;
import org.act.soap.message.NameImpl;
import org.act.soap.message.SOAPDocumentImpl;
import org.act.soap.message.Utils;

public class FaultCode1_2Impl extends FaultElementImpl {
    
    private SOAPElement value;
    private Name valueName;
    
    public FaultCode1_2Impl(SOAPDocumentImpl ownerDoc, String prefix) {
        super(ownerDoc, NameImpl.createFaultCode1_2Name(prefix));
        valueName = NameImpl.createFaultValue1_2Name(prefix);
    }
    private void initValue() {
        value = _getFirstChildElement(valueName);
    }
    
    public void setFaultCodeValue(String faultCode) throws SOAPException {
        initValue();
        if ( null == value ) {
            value = new ElementImpl((SOAPDocumentImpl)getOwnerDocument(), valueName);
            appendChild(value);
        }
        value.setValue(faultCode);
    }
    public void setFaultCodeValue(Name faultCodeQName) throws SOAPException {
        initValue();
        if ( null == value ) {
            value = new ElementImpl((SOAPDocumentImpl)getOwnerDocument(), valueName);
            appendChild(value);
        }
        value.setValue(faultCodeQName.getQualifiedName());
    }
    public String getFaultCodeValue() {
        initValue();
        return value==null ? null : value.getValue();
    }
    public Name getFaultCodeAsName() {
        initValue();
        if ( value == null )
            return null;
        String[] s = Utils.splitQName(value.getValue());
                String uri = getNamespaceURI(s[0]);
        return new NameImpl(s[1], s[0], uri);
    }
}
