package org.act.soap.message.ver1_2;
import java.util.Locale;
import javax.xml.soap.Name;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPException;
import org.act.soap.message.Constants;
import org.act.soap.message.ElementImpl;
import org.act.soap.message.FaultElementImpl;
import org.act.soap.message.NameImpl;
import org.act.soap.message.SOAPDocumentImpl;
import org.act.soap.message.Utils;

public class FaultReason1_2Impl extends FaultElementImpl {
    private SOAPElement firstText;
    private Name textName;
    public FaultReason1_2Impl(SOAPDocumentImpl ownerDoc, String prefix) {
        super(ownerDoc, NameImpl.createFaultReason1_2Name(prefix));
        textName = NameImpl.createFaultText1_2Name(prefix);
    }
    private void initFirstText() {
        firstText = _getFirstChildElement(textName);
    }
    public void addText(String faultString, Locale locale) {
        SOAPElement text = new ElementImpl((SOAPDocumentImpl)getOwnerDocument(), textName);
        appendChild(text);
        text.setValue(faultString);
        text.setAttributeNS(Constants.XML_URI, "xml:lang",
                                     Utils.localeToXmlLang(locale));
    }
    public void setFaultReasonValue(String faultString) throws SOAPException {
        initFirstText();
        if ( firstText == null )
            addText(faultString, Locale.getDefault());
        else
            firstText.setValue(faultString);
    }
    public void setFaultReasonValue(String faultString, Locale locale) {
        initFirstText();
        if ( firstText == null )
            addText(faultString, locale);
        else {
            firstText.setValue(faultString);
                        firstText.setAttributeNS(Constants.XML_URI, "xml:lang",
                                     Utils.localeToXmlLang(locale));
        }
    }
    public String getFaultReasonValue() {
        initFirstText();
        return firstText==null ? null : firstText.getValue();
    }
    public Locale getLocale() {
        initFirstText();
        if ( firstText == null )
            return null;
                String lang = firstText.getAttributeValue(new NameImpl("lang", "xml", Constants.XML_URI));
        return Utils.xmlLangToLocale(lang);
    }
}
