package org.act.soap.server;
import java.util.ArrayList;
import javax.management.MBeanServer;
import javax.management.MBeanServerFactory;
import javax.management.ObjectName;
import org.act.soap.server.config.ConfigManager;
import org.act.soap.server.deploy.DeployManager;
import org.act.soap.server.management.EngineManager;
import org.act.soap.server.management.EngineManagerMBean;
import org.act.soap.util.logging.Log;
import org.act.soap.util.logging.LogFactory;

public class EmbededWSServer
    implements WSServer {
    
    private static Log log = LogFactory.getLog(EmbededWSServer.class.getName());
    
    private EngineManager engineManager = null;
    
    public EmbededWSServer() {
    }
    
    public void init() {
        try {
                        ConfigManager configManager = ConfigManager.getInstance();
            configManager.load();
                        SOAPEngine soapEngine = SOAPEngine.getInstance();
                        DeployManager deployManager = DeployManager.getInstance();
                        deployManager.addDeployEventListener(soapEngine);
                        engineManager = new EngineManager();
                        MBeanServer mbeanServer = null;
            ArrayList mbeanServers = MBeanServerFactory.findMBeanServer(null);
            if ( (null != mbeanServers) && (0 < mbeanServers.size())) {
                mbeanServer = (MBeanServer) mbeanServers.get(0);
            }
            else {
                mbeanServer = MBeanServerFactory.createMBeanServer();
            }
                        mbeanServer.registerMBean(engineManager,
                                      new ObjectName(EngineManagerMBean.
                                                     OBJECT_NAME));
                        soapEngine.start();
                        deployManager.init();
        }
        catch (Exception ex) {
            log.error(ex);
        }
    }
    
    public EngineManager getEngineManager() {
        return this.engineManager;
    }
    
    public final String getVersion() {
        return WSServer.WSSERVER_VERSION;
    }
}
