package org.act.soap.server;
import org.act.soap.util.logging.Log;
import org.act.soap.util.logging.LogFactory;
import org.act.soap.server.config.ConfigManager;
import org.act.soap.server.deploy.DeployManager;
import org.act.soap.server.management.EngineManager;
import javax.management.MBeanServer;
import javax.management.MBeanServerFactory;
import java.util.ArrayList;
import javax.management.ObjectName;
import org.act.soap.server.management.EngineManagerMBean;
import org.act.soap.util.Constants;
import org.act.soap.server.transport.http.StandAloneWebServer;

public class StandaloneWSServer
    implements WSServer {
    
    private static Log log = LogFactory.getLog(StandaloneWSServer.class.getName());
    
    private EngineManager engineManager = null;
    
    public StandaloneWSServer() {
    }
    
    public void init() {
        try {
            System.setProperty(Constants.PROPERTY_NAME_CONFIG_FILE_PATH,
                               "ACTSoap/" + Constants.DEFAULT_CONFIG_FILE_PATH);
                        ConfigManager configManager = ConfigManager.getInstance();
            configManager.load();
                        SOAPEngine soapEngine = SOAPEngine.getInstance();
                        DeployManager deployManager = DeployManager.getInstance();
                        deployManager.addDeployEventListener(soapEngine);
                        engineManager = new EngineManager();
                        MBeanServer mbeanServer = null;
            ArrayList mbeanServers = MBeanServerFactory.findMBeanServer(null);
            if ( (null != mbeanServers) && (0 < mbeanServers.size())) {
                mbeanServer = (MBeanServer) mbeanServers.get(0);
            }
            else {
                mbeanServer = MBeanServerFactory.createMBeanServer();
            }
                        mbeanServer.registerMBean(engineManager,
                                      new ObjectName(EngineManagerMBean.
                                                     OBJECT_NAME));
                        soapEngine.start();
                        deployManager.init();
                        new StandAloneWebServer();
        }
        catch (Exception ex) {
            log.error(ex);
        }
    }
    
    public final String getVersion() {
        return WSServer.WSSERVER_VERSION;
    }
    
    public static void main(String[] args) {
        StandaloneWSServer myWSServer = new StandaloneWSServer();
        try {
            myWSServer.init();
        }
        catch (Exception ex) {
            ex.printStackTrace();
        }
    }
}
