package org.act.soap.server;
import java.util.ArrayList;
import java.util.HashMap;
import javax.wsdl.Definition;
import javax.xml.rpc.encoding.TypeMappingRegistry;
import org.act.soap.server.handler.Handler;
import org.act.soap.server.provider.Provider;
import org.act.soap.server.rbac.RBAC;
import org.act.soap.util.i18n.Message;
import org.act.soap.wsdd.Deployment;

public class WebServiceObject {
    
    private String mServiceName;
    
    private String mWorkingPath;
    
    private Deployment mWSDDDeployment;
    
    private Definition mWSDLDefinition;
    
    private ArrayList mHandlersList = new ArrayList();
    
    private TypeMappingRegistry mTypeMappingRegistry;
    
    private Provider mProvider;
    
    private HashMap mPropertyMap = new HashMap();
    
    private ClassLoader mClassLoader;
    
    private RBAC mRBAC;
    
    public void clearup () {
        this.mServiceName = null;
        this.mWorkingPath = null;
        this.mWSDDDeployment = null;
        this.mWSDLDefinition = null;
        this.mHandlersList = null;
        this.mTypeMappingRegistry = null;
        this.mProvider = null;
        this.mRBAC = null;
        this.mPropertyMap = null;
        this.mClassLoader = null;
    }
    
    public String getServiceName () {
        return this.mServiceName;
    }
    
    public void setServiceName (String newServiceName) {
        this.mServiceName = newServiceName;
    }
    
    public String getWorkingPath () {
        return this.mWorkingPath;
    }
    
    public void setWorkingPath (String newWorkingPath) {
        this.mWorkingPath = newWorkingPath;
    }
    
    public Deployment getWSDDDeployment () {
        return this.mWSDDDeployment;
    }
    
    public void setWSDDDeployment (Deployment newDeployment) {
        this.mWSDDDeployment = newDeployment;
    }
    
    public void setWSDLDefinition (Definition newDefinition) {
        this.mWSDLDefinition = newDefinition;
    }
    
    public Definition getWSDLDefinition () {
        return this.mWSDLDefinition;
    }
    
    public void addHandler (org.act.soap.server.handler.Handler newHandler) {
        if (null == this.mHandlersList) {
            this.mHandlersList = new ArrayList();
        }
        this.mHandlersList.add(newHandler);
    }
    
    public ArrayList getHandlersList () {
        return this.mHandlersList;
    }
    
    public void clearHandlersList () {
        for (int i = 0; i < this.mHandlersList.size(); i++) {
            Handler handler = (Handler)this.mHandlersList.get(i);
            handler.cleanup();
        }
        this.mHandlersList.clear();
    }
    
    public void setTypeMappingRegistry (TypeMappingRegistry newRegistry) {
        this.mTypeMappingRegistry = newRegistry;
    }
    
    public TypeMappingRegistry getTypeMappingRegistry () {
        return this.mTypeMappingRegistry;
    }
    
    public Provider getProvider () {
        return this.mProvider;
    }
    
    public void setProvider (Provider newProvider) {
        this.mProvider = newProvider;
    }
    
    public RBAC getRBAC () {
        return this.mRBAC;
    }
    
    public void setRBAC (RBAC newRBAC) {
        this.mRBAC = newRBAC;
    }
    
    public ClassLoader getClassLoader () {
        return this.mClassLoader;
    }
    
    public void setClassLoader (ClassLoader newClassLoader) {
        this.mClassLoader = newClassLoader;
    }
    
    public MessageContext createMessageContext () {
        return new MessageContext(this);
    }
    
    
    
    public Object getProperty (String name) {
        Object tagValue = null;
        if ( (null != name) && (null != mPropertyMap)) {
            tagValue = mPropertyMap.get(name);
        }
        return tagValue;
    }
    
    public void setProperty (String name, Object value) throws
        IllegalArgumentException {
        if ( (null == name) || (null == value)) {
            throw new IllegalArgumentException(Message.getMessage(
                "invalidPropety"));
        }
        if (null == mPropertyMap) {
            mPropertyMap = new HashMap();
        }
        mPropertyMap.put(name, value);
    }
    
    public void clearPropertyMap () {
        this.mPropertyMap.clear();
    }
}
