package org.act.soap.server.config;
import java.util.Vector;
import org.act.soap.util.i18n.Message;
import org.act.soap.server.config.ConfigManager;

public class CredDevice {
  private String type = "";
  private String className = "";
  private String deviceName = "";
  private String keyStoreFile = "";
  private String keyStorePassWord = "";
  private String credType = "";
  private Vector credTypes = new Vector();
  
  public CredDevice() {
  }
  
  public String getType()
  {
    return this.type;
  }
  
  public void setType(String type) throws ConfigException {
    if ( (null == type) || "".equals(type)) {
      throw new ConfigException(Message.getMessage(
        "ERR_CONF_badConfigFormat",
         ConfigManager.ATTR_NAME_TYPE));
     }
    this.type =type;
  }
  
  public String getClassName()
  {
    return this.className;
  }
  
  public void setClassName(String className) throws ConfigException {
    if ( (null == className) || "".equals(className)) {
      throw new ConfigException(Message.getMessage(
          "ERR_CONF_badConfigFormat",
          ConfigManager.ATTR_NAME_CLASSNAME));
    }
    this.className = className;
  }
  
  public String getDeviceName()
  {
    return this.deviceName;
  }
  
  public void setDeviceName(String deviceName) throws ConfigException {
    if ( (null == deviceName) || "".equals(deviceName)) {
      throw new ConfigException(Message.getMessage(
          "ERR_CONF_badConfigFormat",
          ConfigManager.TAG_NAME_DEVICENAME));
    }
    this.deviceName =deviceName;
  }
  
  public String getKeyStoreFile()
  {
    return this.keyStoreFile;
  }
  
  public void setKeyStoreFile(String keyStoreFile) throws ConfigException {
    if ( (null == keyStoreFile) || "".equals(keyStoreFile)) {
      throw new ConfigException(Message.getMessage(
          "ERR_CONF_badConfigFormat",
          ConfigManager.TAG_NAME_KEYSTOREFILE));
    }
    this.keyStoreFile =keyStoreFile;
  }
  
  public String getKeyStorePassWord()
  {
    return this.keyStorePassWord;
  }
  
  public void setKeyStorePassWord(String keyStorePassWord) throws ConfigException {
    if ( (null == keyStorePassWord) || "".equals(keyStorePassWord)) {
      throw new ConfigException(Message.getMessage(
          "ERR_CONF_badConfigFormat",
          ConfigManager.TAG_NAME_KEYSTOREPASSWORD));
    }
    this.keyStorePassWord =keyStorePassWord;
  }
  
  public String getCredType()
  {
    return this.credType;
  }
  
  public void setCredType(String credType) throws ConfigException {
    if ( (null == credType) || "".equals(credType)) {
      throw new ConfigException(Message.getMessage(
          "ERR_CONF_badConfigFormat",
          ConfigManager.TAG_NAME_CREDTYPE));
    }
    this.credType =credType;
  }
  
  public Vector getCredTypes()
  {
    return this.credTypes;
  }
  
  public void setCredTypes(Vector credTypes)
  {
    this.credTypes =credTypes;
  }
}
