package org.act.soap.server.config;
import org.act.soap.util.i18n.Message;
import org.act.soap.util.logging.Log;
import org.act.soap.util.logging.LogFactory;
import org.act.soap.server.config.ConfigManager;

public class RBACDevice {
  private String type = "";
  private String classname = "";
  private String driver = "";
  private String url = "";
  private String username = "";
  private String password = "";
  
  public RBACDevice() {
  }
  
  public String getType()
  {
    return this.type;
  }
  
  public void setType(String type) throws ConfigException {
    if ( (null == type) || "".equals(type)) {
      throw new ConfigException(Message.getMessage(
          "ERR_CONF_badConfigFormat",
          ConfigManager.ATTR_NAME_TYPE));
    }
    this.type =type;
  }
  
  public String getClassName()
  {
    return this.classname;
  }
  
  public void setClassName(String classname) throws ConfigException {
    if ( (null == classname) || "".equals(classname)) {
      throw new ConfigException(Message.getMessage(
          "ERR_CONF_badConfigFormat",
          ConfigManager.ATTR_NAME_CLASSNAME));
    }
    this.classname =classname;
  }
  
  public String getDriver()
  {
    return this.driver;
  }
  
  public void setDriver(String driver) throws ConfigException {
    if ( (null == driver) || "".equals(driver)) {
      throw new ConfigException(Message.getMessage(
          "ERR_CONF_badConfigFormat",
          ConfigManager.TAG_NAME_DRIVER));
    }
    this.driver =driver;
  }
  
  public String getURL()
  {
    return this.url;
  }
  
  public void setURL(String url) throws ConfigException {
    if ( (null == url) || "".equals(url)) {
      throw new ConfigException(Message.getMessage(
          "ERR_CONF_badConfigFormat",
          ConfigManager.TAG_NAME_URL));
    }
    this.url =url;
  }
  
  public String getUsername()
  {
    return this.username;
  }
  
  public void setUsername(String username)  {
    if (null == username) {
        this.username = "";
    }
    else {
        this.username = username;
    }
  }
  
  public String getPassword()
  {
    return this.password;
  }
  
  public void setPassword(String password)  {
    if (null == password) {
        this.password = "";
    }
    else {
        this.password = password;
    }
  }
}
