package org.act.soap.server.exception;
import javax.xml.soap.*;
import java.util.Locale;
import org.act.soap.server.MessageContext;
import org.act.soap.util.logging.*;
import org.act.soap.util.SOAPUtils;
import java.io.*;

public class DefaultExceptionHandler
    implements ExceptionHandler {
    
    public static final String CODE_11_SERVER = "Server";
    
    public static final String CODE_11_CLIENT = "Client";
    
    public static final String CODE_11_MUSTUNDERSTAND = "MustUnderstand";
    
    public static final String CODE_11_VERSIONMISMATCH = "VersionMismatch";
    
    public static final String NAME_PREFIX = "m";
    
    public static final String NAME_SPACE_URI = "http://act.buaa.edu.cn/";
    
    private static Log log = LogFactory.getLog(DefaultExceptionHandler.class.
                                               getName());
    
    private MessageFactory messageFactory;
    
    private SOAPMessage message;
    
    private SOAPPart soapPart;
    
    private SOAPEnvelope envelope;
    
    private SOAPBody body;
    
    public DefaultExceptionHandler () {
    }
    
    private void setSOAPFault_11 (SOAPFaultException ex, SOAPFault fault) throws
        SOAPException {
        if (null != ex) {
            String faultCode = ex.getCode();
            if (!faultCode.equals(this.CODE_11_SERVER) &&
                !faultCode.equals(this.CODE_11_CLIENT) &&
                !faultCode.equals(this.CODE_11_MUSTUNDERSTAND) &&
                !faultCode.equals(this.CODE_11_VERSIONMISMATCH)) {
                faultCode = this.CODE_11_SERVER;
            }
                                                fault.setFaultCode(envelope.getElementName().getPrefix() + ":" +
                               faultCode);
            fault.setFaultString((null == ex.getMessage())?"Unknown Error":ex.getMessage());
            Detail detail = fault.addDetail();
            detail.addNamespaceDeclaration(this.NAME_PREFIX,
                                           this.NAME_SPACE_URI);
                                                                                                int i = 1;
            for (Throwable throwable = ex; null != throwable;
                 throwable = (throwable instanceof ServerInternalException)?((ServerInternalException)throwable).getCause():null) {                 Name name = envelope.createName("Exception",                                                 this.NAME_PREFIX,
                                                this.NAME_SPACE_URI);
                DetailEntry detailEntry = detail.addDetailEntry(name);
                detailEntry.addAttribute(envelope.
                                         createName("ExpNo"),
                                         Integer.toString(i));
                detailEntry.addAttribute(envelope.
                                         createName("ExpName"),
                                         throwable.getClass().getName());
                detailEntry.addAttribute(envelope.
                                         createName("Message"),
                                         (null == throwable.getMessage())?"Unknown Error":throwable.getMessage());
                i += 1;
            }
        }
    }
    
    private void setSOAPFault_11_1 (Throwable ex, SOAPFault fault) throws
        SOAPException {
        if (null != ex) {
                                                fault.setFaultCode(envelope.getElementName().getPrefix() + ":" +
                               "Server");
            fault.setFaultString((null == ex.getMessage())?"Unknown Error":ex.getMessage());
            Detail detail = fault.addDetail();
            detail.addNamespaceDeclaration(this.NAME_PREFIX,
                                           this.NAME_SPACE_URI);
                                                                                                int i = 1;
            for (Throwable throwable = ex; null != throwable;
                 throwable = (throwable instanceof ServerInternalException)?((ServerInternalException)throwable).getCause():null) {                 Name name = envelope.createName("Exception",                                                 this.NAME_PREFIX,
                                                this.NAME_SPACE_URI);                 DetailEntry detailEntry = detail.addDetailEntry(name);
                detailEntry.addAttribute(envelope.
                                         createName("ExpNo"),
                                         Integer.toString(i));
                detailEntry.addAttribute(envelope.
                                         createName("ExpName"),
                                         throwable.getClass().getName());
                detailEntry.addAttribute(envelope.
                                         createName("Message"),
                                         (null == throwable.getMessage())?"Unknown Error":throwable.getMessage());
                i += 1;
            }
        }
    }
    
    private void setSOAPFault_12 (Throwable ex, SOAPFault fault) {
        
    }
    
    private void recordLog (Throwable ex) {
        log.error(ex.getMessage(), ex);
    }
    
    public void process (Throwable ex, MessageContext msgContext) {
        try {
            if (null != ex && null != msgContext) {
                                                                                                messageFactory = SOAPUtils.MESSAGEFACTORY_INSTANCE;
                message = messageFactory.createMessage();
                message.setProperty(SOAPMessage.CHARACTER_SET_ENCODING, "gb2312");
                message.setProperty(SOAPMessage.WRITE_XML_DECLARATION, "true");
                soapPart = message.getSOAPPart();
                envelope = soapPart.getEnvelope();
                body = envelope.getBody();
                                                SOAPFault fault;
                if (null != body.getFault()) {
                    fault = body.getFault();
                }
                else {
                    fault = body.addFault();
                }
                
                if (ex instanceof SOAPFaultException) {
                    this.setSOAPFault_11( (SOAPFaultException) ex, fault);
                } else if (ex instanceof Exception) {
                    this.setSOAPFault_11_1(ex, fault);
                }
                                message.saveChanges();
                try {
                    message.writeTo(System.out);
                } catch (IOException ex2) {
                } catch (SOAPException ex2) {
                }
                                msgContext.setResponseMessage(message);
                                                this.recordLog(ex);
            }
        }
        catch (SOAPException ex1) {
                        this.recordLog(ex);
            this.recordLog(ex1);
        }
    }
}
