package org.act.soap.server.exception;

import java.util.HashMap;
import org.act.soap.util.i18n.Message;
public class ExceptionHandlerFactory {
    
    private HashMap handlerMap;
    
    ExceptionHandler defaultHandler;
    
    public ExceptionHandlerFactory() {
        this.defaultHandler = new DefaultExceptionHandler();
    }
    
            
                                                                                
                       
                
    public ExceptionHandler getExceptionHandler(Exception exception) {
        try {
            if (exception == null) {
                return null;
            }
            
            if (handlerMap != null) {
                if (handlerMap.get(exception.getClass().getName()) != null) {
                    ClassLoader classLoader =
                        Thread.currentThread().getContextClassLoader();
                    return (ExceptionHandler) classLoader.loadClass( (String)
                        handlerMap.get(exception.
                                       getClass().
                                       getName())).newInstance();
                }
            }
        }
        catch (Exception ex) {
        }
                 return this.defaultHandler;
    }
    
    public void registerExceptionHandler(String exceptionClassName,
                                         String handlerClassName) throws
        ExceptionHandlerException {
        try {
            ClassLoader classLoader =
                Thread.currentThread().getContextClassLoader();
            classLoader.loadClass(handlerClassName);
        }
        catch (ClassNotFoundException ex) {
            throw new ExceptionHandlerException(
                Message.getMessage("javaClassNotFound", ex.getMessage()));
        }
        this.handlerMap.put(exceptionClassName, handlerClassName);
    }
    
    public void registerDefaultExceptionHandler(ExceptionHandler handler) {
        if (handler != null)
            this.defaultHandler = handler;
    }
    
    public void removeExceptionHandler(String exceptionClassName) {
        if (this.handlerMap != null) {
            if (exceptionClassName != null)
                this.handlerMap.remove(exceptionClassName);
        }
    }
}
