package org.act.soap.server.handler;
import javax.security.auth.*;
import org.act.soap.authen.*;
import org.act.soap.server.*;
import org.act.soap.server.config.*;
import org.act.soap.server.secmanager.*;
import org.act.soap.soapsec.*;
import org.act.soap.util.*;
import org.act.soap.util.logging.*;
import org.act.soap.wsdd.*;
import org.w3c.dom.*;

public class AuthenHandler
    extends BasicHandler {
    private static final String PARAM_NAME = "LoginModules";
    private static final String TAG_LOGINMODULE = "LoginModule";
    private static final String ATTR_NAME = "Name";
    private static final String ATTR_CLASSNAME = "ClassName";
    private static Log log = LogFactory.getLog( AuthenHandler.class.getName() );
        private LoginModule[] loginModules = null;
        private LoginContext loginContext;
        private String authmethod;
        private SOAPSecHandler soapSecHandler;
    
    
    private static LoginModule[] createLoginModules ( Element elmLoginModules ) throws
        ConfigException {
        Element[] elmLoginModule = XMLUtils.getChildElements( elmLoginModules,
            TAG_LOGINMODULE );
        if ( elmLoginModule != null ) {
            LoginModule[] result = new LoginModule[elmLoginModule.length];
            for ( int i = 0; i < elmLoginModule.length; i++ ) {
                try {
                                        String name = elmLoginModule[i].getAttribute( ATTR_NAME );
                    String classname = elmLoginModule[i].getAttribute(
                        ATTR_CLASSNAME );
                    Class clsLoginModule = Class.forName( classname );
                    LoginModule lm = ( LoginModule ) clsLoginModule.newInstance();
                    result[i] = lm;
                                        System.out.println( "֤ģ飺" + name );
                }
                catch ( ClassNotFoundException ex ) {
                                        throw new ConfigException( "֤ڵô", ex );
                }
                catch ( IllegalAccessException ex ) {
                                        throw new ConfigException( "֤ڵô", ex );
                }
                catch ( java.lang.InstantiationException ex ) {
                                        throw new ConfigException( "֤ڵô", ex );
                }
            }
            return result;
        }
        else {
            return null;
        }
    }
    public void init ( org.act.soap.wsdd.Handler wsddHandler ) {
        System.out.println(
            "************************ ʼ֤ģ ***************************" );
        Parameter param = wsddHandler.getParameter( PARAM_NAME );
        if ( param != null ) {
            try {
                this.loginModules = AuthenHandler.createLoginModules( param.
                    getParameterElement() );
            }
            catch ( ConfigException ex ) {
            }
        }
        System.out.println(
            "*******************************************************************" );
    }
        public void cleanup () {
    }
    
    public void process ( MessageContext msgContext ) throws Exception {
        LoginContext lc = new LoginContext();
        lc.setLoginModules( loginModules );
        lc.setSOAPSecurity( ( SOAPSecurity ) msgContext.getProperty(
            SOAPSecurity.class.getName() ) );
        if ( lc.login() ) {
                        msgContext.setUserSubject( lc.getSubject() );
            msgContext.setProperty( "LoginContext", lc );
        }
        else {
            throw new LoginFailedException( "֤ʧ" );
        }
    }
    
    public void postProcess ( MessageContext msgContext ) throws Exception {
        LoginContext lc = ( LoginContext ) msgContext.getProperty(
            "LoginContext" );
        lc.logout();
    }
        private static boolean loginByPass ( LoginContext loginContext ) throws
        Exception {
        PasswordLoginModule passLoginModule = new PasswordLoginModule();
        passLoginModule.login( loginContext );
        return true;
    }
        private static boolean loginByX509Cert ( LoginContext loginContext ) throws
        Exception {
        X509CertLoginModule x509certLoginModule = new X509CertLoginModule();
        x509certLoginModule.login( loginContext );
        return true;
    }
    private static Subject createGuest ( Subject sub ) {
        Subject subject;
        if ( sub == null ) {
            subject = new Subject();
        }
        else {
            subject = sub;
        }
        LoginPrincipal prin = new LoginPrincipal( String.valueOf( UserManager.
            GUEST_USERID ) );
        subject.getPrincipals().add( prin );
        return subject;
    }
    private String getAuthMethod ( MessageContext msgContext ) {
        String method = null;
        return method;
    }
}
