package org.act.soap.server.handler;
import java.util.*;
import org.act.soap.util.i18n.*;

public class HandlerFactory {
    
    private HashMap handlerMap;
    
    protected HandlerFactory () {
        this.handlerMap = new HashMap();
    }
    
    public static HandlerFactory newInstance () {
        return new HandlerFactory();
    }
    
    public Handler createHandler ( final String type ) {
        if ( null != type ) {
            try {
                String className = ( String )this.handlerMap.get( type );
                if ( null != className ) {
                    ClassLoader classLoader =
                        Thread.currentThread().getContextClassLoader();
                    Class clazz = classLoader.loadClass( className );
                    return ( Handler ) clazz.newInstance();
                }
            }
            catch ( Exception ex ) {
                
            }
        }
        return null;
    }
    
    public void registerHandler ( String type, String className ) throws
        IllegalArgumentException {
                if ( ( null == type ) || ( null == className ) ) {
            throw new IllegalArgumentException( Message.getMessage(
                "ERR_null_Handler_type_or_className" ) );
        }
        handlerMap.put( type, className );
    }
    
    public String removeHandler ( String type ) {
        return ( String )this.handlerMap.remove( type );
    }
    
    public HashMap getHandlerRegistryMap () {
        return this.handlerMap;
    }
}
