package org.act.soap.server.management;
import java.util.*;
import javax.wsdl.*;
import org.act.soap.server.*;
import org.act.soap.server.config.*;
import org.act.soap.server.deploy.*;
import org.act.soap.wsdd.*;
public interface EngineManagerMBean {
    
    public static final String OBJECT_NAME = "ACT:service=ACTSOAPEngine";
    
    public void saveEngineConfig () throws ConfigException;
    
    public void loadEngineConfig () throws ConfigException;
    
    public void setEngineName(String engineName);
    
    public String getEngineName();
    
    public void setEngineDescription(String engineName);
    
    public String getEngineDescription();
    
    public void setMaxProcessors(int maxProcessors);
    
    public int getMaxProcessors();
    
    public boolean isAutoDeployStart();
    
    public boolean startAutoDeploy();
    
    public boolean stopAutoDeploy();
    
    public void setDeployDir (String deployPath) throws DeployException;
    
    public String getDeployDir();
    
    public void setWorkingDir (String dir) throws DeployException;
    
    public String getWorkingDir();
    
    public void setDeployerUpdateInterval(long interval);
    
    public long getDeployerUpdateInterval();
    
    public boolean isWebServiceDeployed(String serviceName);
    
    public void deploy (String serviceName, byte[] src) throws DeployException;
    
    public void undeploy (String serviceName) throws DeployException;
    
    public HashMap getDeployedWebServices();
    
    public Deployment getWSDDDeployment(String serviceName);
    
    public Definition getWSDLDefinition(String serviceName);
    
    public List getOperations(String serviceName);
    
    public void startEngine() throws SOAPEngineException;
    
    public void stopEngine() throws SOAPEngineException;
    
    public int getEngineState();
}
