package org.act.soap.server.management.admin.Engine;
import java.io.*;
import java.util.*;
import javax.management.*;
import javax.servlet.*;
import javax.servlet.http.*;
import org.act.soap.server.management.admin.*;
import org.act.soap.server.SOAPEngine;
import org.apache.struts.*;
import org.apache.struts.action.*;
import org.apache.struts.util.*;

public class ListPropertiesAction extends Action {
    public ActionForward execute(ActionMapping mapping,
                                 ActionForm form,
                                 HttpServletRequest request,
                                 HttpServletResponse response)
        throws IOException, ServletException {
                MBeanServer mbServer = Utils.getMBeanServer();
        ObjectName mbName = null;
        try {
            mbName = Utils.getXLinkerMBeanName();
        }
        catch (MalformedObjectNameException ex) {
            throw new ServletException(ex);
        }
                String engineName = null;
        String engineDesc = null;
        int maxProcessors = 0;
        String deployDir = null;
        String workingDir = null;
        long deployerUpdateInterval = 0;
        int engineState;
        try {
            engineName = (String) mbServer.getAttribute(mbName, "EngineName");
            engineDesc = (String) mbServer.getAttribute(mbName, "EngineDescription");
            maxProcessors = ( (Integer) mbServer.getAttribute(mbName, "MaxProcessors")).intValue();
            deployDir = (String) mbServer.getAttribute(mbName, "DeployDir");
            workingDir = (String) mbServer.getAttribute(mbName, "WorkingDir");
            deployerUpdateInterval = ( (Long) mbServer.getAttribute(mbName, "DeployerUpdateInterval")).longValue();
            engineState = ((Integer)mbServer.getAttribute(mbName, "EngineState")).intValue();
        } catch(Exception e) {
            throw new ServletException(e);
        }
                EngineForm engineFm = new EngineForm();
        engineFm.setEngineName(engineName);
        engineFm.setEngineDesc(engineDesc);
        engineFm.setMaxProcessors(maxProcessors);
        engineFm.setDeployDir(deployDir);
        engineFm.setWorkingDir(workingDir);
        engineFm.setDeployerUpdateInterval(deployerUpdateInterval);
        MessageResources resources = (MessageResources)
            servlet.getServletContext().getAttribute(Globals.MESSAGES_KEY);
        Locale locale = (Locale) request.getSession().getAttribute(Globals.LOCALE_KEY);
        String stateStr = null;
        switch(engineState) {
            case SOAPEngine.SOAPENGINE_STATE_RUNNING:
                stateStr = resources.getMessage(locale, "engine.state.running");
                break;
            case SOAPEngine.SOAPENGINE_STATE_STARTING:
                stateStr = resources.getMessage(locale, "engine.state.starting");
                break;
            case SOAPEngine.SOAPENGINE_STATE_STOPING:
                stateStr = resources.getMessage(locale, "engine.state.stoping");
                break;
            case SOAPEngine.SOAPENGINE_STATE_STOPPED:
                stateStr = resources.getMessage(locale, "engine.state.stopped");
                break;
            case SOAPEngine.SOAPENGINE_STATE_SUSPEND:
                stateStr = resources.getMessage(locale, "engine.state.suspend");
                break;
        }
        engineFm.setEngineStateStr(stateStr);
                request.getSession().setAttribute("engineForm", engineFm);
                return mapping.findForward("Engine");
    }
}
