package org.act.soap.server.management.admin;
import java.util.*;
import javax.management.*;
import javax.servlet.http.*;
import org.apache.struts.*;
import org.apache.struts.action.*;
import org.apache.struts.util.*;

public class ServicesTreeBuilder implements TreeBuilder {
    
    public void buildTree(TreeControl treeControl,
                          ActionServlet servlet,
                          HttpServletRequest request) {
        MessageResources resources = (MessageResources)
            servlet.getServletContext().getAttribute(Globals.MESSAGES_KEY);
        HttpSession session = request.getSession();
        Locale locale = (Locale) session.getAttribute(Globals.LOCALE_KEY);
        try {
            addSubtree(treeControl.getRoot(), resources, locale);
        } catch(Exception e) {
            e.printStackTrace();
        }
    }
        
    protected void addSubtree(TreeControlNode root,
                              MessageResources resources,
                              Locale locale)
        throws Exception {
                MBeanServer mbServer = Utils.getMBeanServer();
        ObjectName mbName = Utils.getXLinkerMBeanName();
                HashMap services = (HashMap) mbServer.getAttribute(mbName, "DeployedWebServices");
                TreeControlNode subtree = new TreeControlNode
            ("Services",
             "XLinker.gif",
             resources.getMessage(locale, "services.treeBuilder.subtreeNode"),
             "service/listServices.do",
             "content",
             true, "Services");
        root.addChild(subtree);
        Iterator serviceNames = services.keySet().iterator();
        while (serviceNames.hasNext()) {
            String serviceName = (String) serviceNames.next();
            TreeControlNode serviceNode = new TreeControlNode
                        (serviceName,
                         "XLinker.gif",
                         serviceName,
                         "service/showServiceDetail.do?service="+serviceName,
                         "content",
                         false, "Services");
            subtree.addChild(serviceNode);
        }
    }
}
