package org.act.soap.server.management.admin;
import org.apache.struts.action.*;
import javax.servlet.http.*;
import javax.servlet.ServletException;
import java.io.IOException;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class SetUpTreeAction extends Action {
    public static final String DOMAIN_KEY = "domain";
    public static final int INIT_PLUGIN_MAX = 10;
    public static final String TREEBUILDER_KEY = "treebuilders";
    public static final String ROOTNODENAME_KEY = "rootnodename";
        
    public ActionForward execute(ActionMapping mapping,
                                 ActionForm form,
                                 HttpServletRequest request,
                                 HttpServletResponse response)
        throws IOException, ServletException
    {
        ActionServlet servlet = getServlet();
                        String rootnodeName =
            (String) servlet.getServletConfig().getInitParameter(
            ROOTNODENAME_KEY);
        String treeBuildersStr =
            (String) servlet.getServletConfig().getInitParameter(
            TREEBUILDER_KEY);
        String domain =
            (String) servlet.getServletConfig().getInitParameter(DOMAIN_KEY);
                                TreeControlNode root =
            new TreeControlNode("ROOT-NODE",
                                null, rootnodeName,
                                "setUpTree.do?select=ROOT-NODE",
                                "content", true, domain);
        TreeControl control = new TreeControl(root);
        if (treeBuildersStr != null) {
            Class treeBuilderImpl;
            TreeBuilder treeBuilderBase;
            ArrayList treeBuilders = new ArrayList(INIT_PLUGIN_MAX);
            int i = 0;
            StringTokenizer st = new StringTokenizer(treeBuildersStr, ",");
            while (st.hasMoreTokens()) {
                treeBuilders.add(st.nextToken().trim());
            }
            if (treeBuilders.size() == 0)
                treeBuilders.add(treeBuildersStr.trim());
            for (i = 0; i < treeBuilders.size(); i++) {
                try {
                    treeBuilderImpl = Class.forName( (String) treeBuilders.get(
                        i));
                    treeBuilderBase =
                        (TreeBuilder) treeBuilderImpl.newInstance();
                    treeBuilderBase.buildTree(control, servlet, request);
                }
                catch (Throwable t) {
                    t.printStackTrace(System.out);
                }
            }
        }
        HttpSession session = request.getSession();
        session.setAttribute("treeControlTest", control);
        String name = request.getParameter("select");
        if (name != null) {
            control.selectNode(name);
                        return (mapping.findForward("Blank"));
        }
        return (mapping.findForward("SetUpTree"));
    }
}
