package org.act.soap.server.management.admin;
import java.io.IOException;
import java.net.URLEncoder;
import java.util.ArrayList;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.tagext.BodyTagSupport;

public class TableTag extends BodyTagSupport {
        
                
    protected ArrayList labels = new ArrayList();
    
    protected ArrayList datas = new ArrayList();
    
    protected ArrayList labelStyles = new ArrayList();
    
    protected ArrayList dataStyles = new ArrayList();
    
    protected ArrayList headers = new ArrayList();
    
    protected ArrayList styleIds = new ArrayList();
        
    protected int columns = 2;
    public int getColumns() {
        return (this.columns);
    }
    public void setColumns(int columns) {
        this.columns = columns;
    }
    
    protected String tableStyle = null;
    public String getTableStyle() {
        return (this.tableStyle);
    }
    public void setTableStyle(String tableStyle) {
        this.tableStyle = tableStyle;
    }
    
    protected String lineStyle = null;
    public String getLineStyle() {
        return (this.lineStyle);
    }
    public void setLineStyle(String lineStyle) {
        this.lineStyle = lineStyle;
    }
        public int doStartTag() throws JspException {
        this.headers.clear();
        this.labels.clear();
        this.datas.clear();
        this.labelStyles.clear();
        this.dataStyles.clear();
        this.styleIds.clear();
        return (EVAL_BODY_TAG);
     }
    
    public int doEndTag() throws JspException {
        JspWriter out = pageContext.getOut();
        try {
                        out.println();
            out.print("<table ");
            if (columns > 2) {
                out.print(" columns=\"");
                out.print(columns);
                out.print("\"");
            }
            if (tableStyle != null) {
                out.print(" class=\"");
                out.print(tableStyle);
                out.print("\"");
                out.print(" border=\"1\" cellspacing=\"0\" ");
                out.print(" cellpadding=\"0\" width=\"100%\" ");
            }
            out.println(">");
                        int n = labels.size();
            for (int i = 0; i < n; i++) {
                String label = (String) labels.get(i);
                boolean header = ((Boolean) headers.get(i)).booleanValue();
                String data = (String) datas.get(i);
                String labelStyle = (String) labelStyles.get(i);
                String dataStyle = (String) dataStyles.get(i);
                String styleId = (String) styleIds.get(i);
                if (header) {
                    out.println("<tr class=\"header-row\" >");
                    out.println("  <th scope=\"col\" width=\"27%\"> ");
                    out.print("    <div align=\"left\"");
                    if (labelStyle != null)
                        out.print( " class=\"" + labelStyle +"\"");
                    out.print(">");
                    if (styleId != null) {
                        out.print("<label for=\"" + styleId + "\">");
                    }
                    out.print(label);
                    if (styleId != null) {
                        out.print("</label>");
                    }
                    out.println("    </div>");
                    out.println("  </th>");
                    out.println("  <th scope=\"col\" width=\"73%\"> ");
                    out.print("    <div align=\"left\"" );
                    if (dataStyle != null)
                        out.print(" class=\"" + dataStyle + "\"");
                    out.print(">");
                    out.print(data);
                    out.println("    </div>");
                    out.print("  </th>");
                    out.println("</tr>");
                } else {
                    out.println("<tr>");
                    out.println("  <td scope=\"row\" width=\"27%\"> ");
                    out.print("    <div align=\"left\"");
                    if (labelStyle != null)
                        out.print( " class=\"" + labelStyle +"\"");
                    out.print(">");
                    if (styleId != null) {
                        out.print("<label for=\"" + styleId + "\">");
                    }
                    out.print(label);
                    if (styleId != null) {
                        out.print("</label>");
                    }
                    out.println("    </div>");
                    out.println("  </td>");
                    out.println("  <td width=\"73%\"> ");
                    out.print("    <div align=\"left\"" );
                    if (dataStyle != null)
                        out.print(" class=\"" + dataStyle + "\"");
                    out.print(">");
                    out.print(data);
                    out.println("    </div>");
                    out.print("  </td>");
                    out.println("</tr>");
                }
                
            }
                        out.println("</table>");
            out.println();
        } catch (IOException e) {
            throw new JspException(e);
        }
        return (EVAL_PAGE);
    }
    
    public void release() {
        this.headers.clear();
        this.labels.clear();
        this.datas.clear();
        this.labelStyles.clear();
        this.dataStyles.clear();
        this.columns = 2;
        this.tableStyle = null;
        this.lineStyle = null;
        this.styleIds.clear();
    }
        
    void addRow(boolean header, String label, String data,
    String labelStyle, String dataStyle, String styleId) {
        headers.add(new Boolean(header));
        labels.add(label);
        datas.add(data);
        labelStyles.add(labelStyle);
        dataStyles.add(dataStyle);
        styleIds.add(styleId);
    }
    }
