package org.act.soap.server.management.admin;
import java.util.*;
import javax.servlet.http.*;
import org.apache.struts.*;
import org.apache.struts.action.*;
import org.apache.struts.util.*;

public class XLinkerTreeBuilder implements TreeBuilder {
            
    public void buildTree(TreeControl treeControl,
                          ActionServlet servlet,
                          HttpServletRequest request) {
        MessageResources resources = (MessageResources)
            servlet.getServletContext().getAttribute(Globals.MESSAGES_KEY);
        HttpSession session = request.getSession();
        Locale locale = (Locale) session.getAttribute(Globals.LOCALE_KEY);
        addSubtree(treeControl.getRoot(), resources, locale);
    }
        
    protected void addSubtree(TreeControlNode root,
                              MessageResources resources,
                              Locale locale) {
        TreeControlNode subtree = new TreeControlNode
            ("XLinker",
             "XLinker.gif",
             resources.getMessage(locale, "engine.treeBuilder.subtreeNode"),
             null,
             "content",
             true, "Engine");
        TreeControlNode properties = new TreeControlNode
            ("XLinker Properties",
             "XLinker.gif",
             resources.getMessage(locale, "engine.treeBuilder.propertiesNode"),
             "engine/listProperties.do",
             "content",
             false, "Engine");
        TreeControlNode deployNew = new TreeControlNode
            ("Deploy New Service",
             "XLinker.gif",
             resources.getMessage(locale, "engine.treeBuilder.deploynewNode"),
             "deploy/upload.do",
             "content",
             false, "Engine");
        TreeControlNode start = new TreeControlNode
            ("Start XLinker",
             "XLinker.gif",
             resources.getMessage(locale, "engine.treeBuilder.startNode"),
             "engine/startEngine.do",
             "content",
             false, "Engine");
        TreeControlNode stop = new TreeControlNode
            ("Stop XLinker",
             "XLinker.gif",
             resources.getMessage(locale, "engine.treeBuilder.stopNode"),
             "engine/stopEngine.do",
             "content",
             false, "Engine");
        root.addChild(subtree);
        subtree.addChild(properties);
        subtree.addChild(deployNew);
        subtree.addChild(start);
        subtree.addChild(stop);
    }
}
