package org.act.soap.server.management.ui;
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.net.*;
import java.util.*;
public class InstallValidator extends HttpServlet {
    private static final String CONTENT_TYPE = "text/html; charset=GBK";
        public void init() throws ServletException {
    }
        public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        response.setContentType(CONTENT_TYPE);
        PrintWriter out = response.getWriter();
        out.println("<html>");
        out.println("<head>");
        out.println("<title>ACTSoapװ֤</title>");
        out.println("</head>");
        out.println("<body>");
        out.println("<div class=\"nav\" align=\"right\"><font size=\"-2\"><a href=\"http://act.buaa.edu.cn/\">BUAA - ACT</a></font></div>");
        out.println("<h1>ACTSoapװ֤</h1>");
        out.println("<div class=\"announcement\">");
        out.println("<p>");
        out.println("<h3>ӭʹACTSoap <i>v0.9</i></h3>");
        out.println("<h4>:</h4>");
        out.println("<pre>");
        String[] classArray = {
            "javax.xml.soap.SOAPMessage",
            "org.act.soap.message.MessageFactoryImpl",
            "javax.activation.DataHandler",
            "javax.wsdl.factory.WSDLFactory",
            "com.ibm.wsdl.factory.WSDLFactoryImpl",
            "javax.xml.rpc.ServiceFactory",
            "javax.xml.rpc.Service",
            "javax.xml.parsers.SAXParserFactory",
            "javax.xml.parsers.DocumentBuilderFactory",
            "javax.xml.parsers.DocumentBuilder",
            "javax.xml.namespace.QName",
            "org.w3c.dom.Document",
            "org.xml.sax.InputSource",
            "javax.xml.transform.Transformer",

        };
        for (int i=0; i<classArray.length; i++)
        {
            out.write("<b>Looking for</b>: "+classArray[i]+"<br>");
            String result = lookupClass(classArray[i]);
            if (result == null)
            {
                out.write("<font color=\"red\">-Not Found</font><br>");
            }
            else if (result.length() == 0)
            {
                out.write("<font color=\"blue\">+Found in an unknown location</font><br>");
            }
            else
            {
                out.write("<font color=\"green\">+Found in: "+ result +"</font><br>");
            }
        }
        out.println("</pre>");
        out.println("<h4>Դ:</h4>");
        out.println("<pre>");
        String[] resourceArray = {
            "jdklog.properties",
            "ActResourceFile_en.properties",
            "ActResourceFile_zh.properties"
        };
        for (int i=0; i<resourceArray.length; i++)
        {
            out.write("<b>Looking for</b>: "+resourceArray[i]+"<br>");
            String result = lookupResource(resourceArray[i]);
            if (result == null)
            {
                out.write("<font color=\"red\">-Not Found</font><br>");
            }
            else if (result.length() == 0)
            {
                out.write("<font color=\"blue\">+Found in an unknown location</font><br>");
            }
            else
            {
                out.write("<font color=\"green\">+Found in: "+ result +"</font><br>");
            }
        }
        out.println("</pre>");
        out.println("<h4>ϵͳ</h4>");
        out.println("<pre>");
        try
        {
            Properties sysProps = System.getProperties();
            SortedSet sortedProperties = new TreeSet(sysProps.keySet());
            for (Iterator keys = sortedProperties.iterator(); keys.hasNext();)
            {
                String key = (String)keys.next();
                out.println(key + ": " + sysProps.getProperty(key));
            }
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
        out.println("</pre>");
        out.println("<hr>");
        out.println("Web Serverƽ̨:" + getServletConfig().getServletContext().getServerInfo() );
        out.println("</body>");
        out.println("</html>");
    }
        public void destroy() {
    }
    
    String lookupClass(String className)
      throws IOException
    {
            Class clazz = null;
      try {
        clazz = Class.forName(className);
        if (clazz == null)
          return null;
      }
      catch (ClassNotFoundException e) {
        return null;
      }
            URL url = null;
      try {
        url = clazz.getProtectionDomain().getCodeSource().getLocation();
        if (url == null)
          return "";
      }
      catch(Throwable t) {
        return "";
      }
            String location = getLocation(url);
      if (location == null)
        return "";
      else
        return location;
    }
    
    String lookupResource(String resourceName)
    {
      URL url = null;
      ClassLoader classLoader = null;
      classLoader = this.getClass().getClassLoader();
      if (classLoader != null)
      {
        url = classLoader.getResource(resourceName);
        if (url != null) {
          return getLocation(url);
        }
      }
      else
      {
        classLoader = System.class.getClassLoader();
        if (classLoader != null)
        {
          url = classLoader.getResource(resourceName);
          if (url != null) {
            return getLocation(url);
          }
        }
      }
      return null;
    }
    
    String getLocation(URL url)
    {
      try
      {
        String location = url.toString();
        if (location.startsWith("jar:file:/"))
        {
          File file = new File(url.getFile());
          return file.getPath().substring(6);
        }
        else if (location.startsWith("jar"))
        {
          url = ((JarURLConnection)url.openConnection()).getJarFileURL();
          return url.toString();
        }
        else if (location.startsWith("file"))
        {
          File file = new File(url.getFile());
          return file.getAbsolutePath();
        }
        else
        {
          return url.toString();
        }
      }
      catch (Throwable t) {
        return null;
      }
    }
}
