package org.act.soap.server.management.ui;
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import org.act.soap.server.management.*;
import javax.wsdl.*;
import javax.wsdl.extensions.soap.*;
import javax.management.*;
import org.act.soap.client.*;
import javax.xml.namespace.QName;
import javax.xml.rpc.handler.*;
import javax.xml.rpc.ParameterMode;
import javax.xml.rpc.encoding.XMLType;
import org.act.soap.util.i18n.Message;

public class WebServiceInfo
    extends HttpServlet {
  private static final String CONTENT_TYPE = "text/html; charset=GBK";
    public void init() throws ServletException {
  }
    public void doGet(HttpServletRequest request, HttpServletResponse response) throws
      ServletException, IOException {
    response.setContentType(CONTENT_TYPE);
    StringBuffer retString = new StringBuffer("");
    response.reset();
    try {
      if (request.getParameter("serviceName") != null) {
        if (request.getParameter("operationName") == null) {
                    retString = displayServiceInfo(request);
        }
        else {
          if (request.getParameter("invokeop") == null) {
                        retString = displayOperaionInfo(request);
          }
          else {
            retString = displayOperationInvokeResult(request);
          }
        }
      }
      else if (request.getParameter("doing") != null) {
        if (request.getParameter("doing").equals("displayOverview"))
                    retString = displayOverview( request );
      }
      else {
        retString.append("<html>");
        retString.append("<head><title>WebServiceInfo</title></head>");
        retString.append("<body bgcolor=\"#ffffff\">");
        retString.append("<p>The servlet has received a " + request.getMethod() +
                         ". This is the reply.</p>");
        retString.append("</body></html>");
      }
    }
    catch (Exception e) {}
    response.setContentType(CONTENT_TYPE);
    OutputStream out = response.getOutputStream();
    out.write(retString.toString().getBytes("GBK"));
  }
    public void doPost(HttpServletRequest request, HttpServletResponse response) throws
      ServletException, IOException {
    doGet(request, response);
  }
    public void destroy() {
  }
  
  private StringBuffer displayOverview( HttpServletRequest request )
      throws Exception {
    StringBuffer retString = new StringBuffer("");
    MBeanServer server = (MBeanServer) MBeanServerFactory.
        findMBeanServer(null).get(0);
    String add = request.getContextPath();
    retString.append("<html>\n");
    retString.append("<head><title>ѲWebб</title></head>\n");
    retString.append("<BODY>\n");
        ObjectName mbName = null;
    HashMap services = null;
    try {
      mbName = new ObjectName(org.act.soap.server.management.
                              EngineManagerMBean.OBJECT_NAME);
      services = (HashMap) server.getAttribute(mbName, "DeployedWebServices");
    }
    catch (Exception ex) {
      throw ex;
    }
    Iterator serviceNames = services.keySet().iterator();
    while (serviceNames.hasNext()) {
      String serviceName = (String) serviceNames.next();
      retString.append("<li>\n");
      retString.append("<font color=\"#225268\"><b><span>\n");
      retString.append(
          "<A HREF=\"webserviceinfo?serviceName="
          + serviceName
          + "\" TARGET=serverinfoDetail>"
          + serviceName + "</A><BR>\n");
      retString.append("</span> </b> </font>\n");
      retString.append("<p></p>\n");
      retString.append("</li>\n");
    }
    retString.append("</BODY>\n");
    retString.append("</html>\n");
    return retString;
  }
  
  private StringBuffer displayServiceInfo(HttpServletRequest request) throws
      Exception {
    StringBuffer retString = new StringBuffer("");
    String serviceName = request.getParameter("serviceName");
    MBeanServer server = (MBeanServer) MBeanServerFactory.findMBeanServer(null).
        get(0);
    String add = request.getContextPath();
    retString.append("<html>\n");
    retString.append("<head><title>Web" + serviceName +
                     "Ϣб</title></head>\n");
    retString.append("<BODY>\n");
    retString.append("<span><br>֧²:</span>");
    retString.append("<hr size=1>");
        ObjectName mbName = null;
    Definition def = null;
    try {
      mbName = new ObjectName(org.act.soap.server.management.EngineManagerMBean.
                              OBJECT_NAME);
      def = (Definition) server.invoke(mbName, "getWSDLDefinition",
                                       new Object[] {serviceName}
                                       , new String[] {"java.lang.String"});
    }
    catch (Exception ex) {
      throw ex;
    }
    PortType porttype = (PortType) def.getPortTypes().values().iterator().next();
    Iterator operations = porttype.getOperations().iterator();
    while (operations.hasNext()) {
      Operation op = (Operation) operations.next();
      String sOperationName = op.getName();
      retString.append("<li>\n");
      retString.append("<font color=\"#225268\"><b><span>\n");
      retString.append(
          "<a href=\"webserviceinfo?serviceName=" +
          serviceName + "&operationName=" + sOperationName + "\">" +
          sOperationName + "</a>\n");
      retString.append("</span> </b> </font>\n");
      retString.append("<p></p>\n");
      retString.append("</li>\n");
    }
    retString.append("</BODY>\n");
    retString.append("</html>\n");
    return retString;
  }
  
  private StringBuffer displayOperaionInfo(HttpServletRequest request) throws
      Exception {
    StringBuffer retString = new StringBuffer("");
    String serviceName = request.getParameter("serviceName");
    String operationName = request.getParameter("operationName");
    MBeanServer server = (MBeanServer) MBeanServerFactory.findMBeanServer(null).
        get(0);
    retString.append("<html>\n");
    retString.append("<head><title>Զ̲" + operationName +
                     "Ϣб</title></head>\n");
    retString.append("<BODY>\n");
    retString.append("<span><br>Զ̲" + operationName + "ҪϢ</span>");
    retString.append("<hr size=1>");
        ObjectName mbName = null;
    Definition def = null;
    try {
      mbName = new ObjectName(org.act.soap.server.management.EngineManagerMBean.
                              OBJECT_NAME);
      def = (Definition) server.invoke(mbName, "getWSDLDefinition",
                                       new Object[] {serviceName}
                                       , new String[] {"java.lang.String"});
    }
    catch (Exception ex) {
      throw ex;
    }
    PortType porttype = (PortType) def.getPortTypes().values().iterator().next();
        Operation op = porttype.getOperation(operationName, null, null);
    if (op == null) {
            return null;
    }
    else {
            Binding binding = (Binding) def.getBindings().values().iterator().next();
      SOAPBinding soapBinding = (SOAPBinding) binding.getExtensibilityElements().
          get(0);
      BindingOperation bindingOperation = binding.getBindingOperation(
          operationName, null, null);
      SOAPOperation soapOperation = (SOAPOperation) bindingOperation.
          getExtensibilityElements().get(0);
      String style = soapOperation.getStyle() != null ? soapOperation.getStyle() :
          soapBinding.getStyle();
            retString.append("<form target=\"_blank\" method=\"GET\">\n");
      retString.append("<input name=\"serviceName\" type=\"hidden\" value=\"" +
                       serviceName + "\">\n");
      retString.append("<input name=\"operationName\" type=\"hidden\" value=\"" +
                       operationName + "\">\n");
      retString.append("<table cellspacing=\"0\" cellpadding=\"4\" frame=\"box\" bordercolor=\"#dcdcdc\" rules=\"none\" style=\"border-collapse: collapse;\">\n");
      if (style.equals("rpc")) {
                Input input = op.getInput();
        javax.wsdl.Message inputmessage = input.getMessage();
        List parts = inputmessage.getOrderedParts(null);
        if (parts == null || parts.size() <= 0) {
                    retString.append("<tr>\n");
          retString.append("<td colspan=\"2\" class=\"frmHeader\" background=\"#dcdcdc\" style=\"color: #000000;border-right: 2px solid white; font-family: Verdana; font-size: .7em; font-weight: normal;\">ûв</td>\n");
          retString.append("</tr>\n");
        }
        else {
                    retString.append("<tr>\n");
          retString.append("<td class=\"frmHeader\" background=\"#dcdcdc\" style=\"color: #000000;border-right: 2px solid white; font-family: Verdana; font-size: .7em; font-weight: normal;\"></td>\n");
          retString.append("<td class=\"frmHeader\" background=\"#dcdcdc\" style=\"color: #000000;border-right: 2px solid white; font-family: Verdana; font-size: .7em; font-weight: normal;\"></td>\n");
          retString.append("<td class=\"frmHeader\" background=\"#dcdcdc\" style=\"color: #000000; font-family: Verdana; font-size: .7em; font-weight: normal;\">ֵ</td>\n");
          retString.append("</tr>\n");
          for (int i = 0; i < parts.size(); i++) {
            Part part = (Part) parts.get(i);
            String sParaName = part.getName();
            String sParaType = part.getTypeName().getLocalPart();
            retString.append("<tr>\n");
            retString.append("<td class=\"frmText\" style=\"color: #000000; font-family: Verdana; font-size: .7em; font-weight: normal;\">" +
                             sParaName + "</td>\n");
            retString.append("<td class=\"frmText\" style=\"color: #000000; font-family: Verdana; font-size: .7em; font-weight: normal;\">" +
                             sParaType + "</td>\n");
            retString.append(
                "<td><input class=\"frmInput\" type=\"text\" size=\"50\" name=\"paraname" +
                sParaName + "\"></td>\n");
            retString.append("</tr>\n");
          }
        }
      }
      else {
                retString.append("<tr>\n");
        retString.append("<td class=\"frmHeader\" background=\"#dcdcdc\" style=\"color: #000000;border-right: 2px solid white; font-family: Verdana; font-size: .7em; font-weight: normal;\">\n");
        retString.append(
            "SOAPϢ<font color=\"red\"><br>ע⣺֧UTF-8롣<br>뽫ΪUTF-8롣<br>\n");
        retString.append("ҲҪSOAPϢмXMLԤָ(&lt;?xml version=\"1.0\" encoding=\"...\"?&gt;)</font><br>\n");
        retString.append(
            "ϸ˵<a href=\"help.html\">Web SASEлҳʹ˵</a>\n");
        retString.append("</td>\n");
        retString.append("</tr>\n");
        retString.append("<tr>\n");
        retString.append(
            "<td><textarea rows=\"10\" name=\"request\" cols=\"80\"></textarea></td>\n");
        retString.append("</tr>\n");
      }
            retString.append("<tr>\n");
      retString.append("<td></td>\n");
      retString.append("<td></td>\n");
      retString.append(
          "<input name=\"invokeop\" type=\"hidden\" value=\"true\">\n");
      retString.append("<td align=\"center\"> <input type=\"submit\" value=\"\" class=\"button\"></td>\n");
      retString.append("</tr>\n");
      retString.append("</table>\n");
      retString.append("</form>\n");
    }
    retString.append("</BODY>\n");
    retString.append("</html>\n");
    return retString;
  }
  
  private StringBuffer displayOperationInvokeResult(HttpServletRequest req) throws
      Exception {
    StringBuffer retString = new StringBuffer("");
        String sServiceName = req.getParameter("serviceName");
        String sOperationName = req.getParameter("operationName");
        MBeanServer server = (MBeanServer) MBeanServerFactory.findMBeanServer(null).
        get(0);
        ObjectName mbName = null;
    Definition def = null;
    try {
      mbName = new ObjectName(org.act.soap.server.management.EngineManagerMBean.
                              OBJECT_NAME);
      def = (Definition) server.invoke(mbName, "getWSDLDefinition",
                                       new Object[] {sServiceName}
                                       , new String[] {"java.lang.String"});
    }
    catch (Exception ex) {
      throw ex;
    }
    PortType porttype = (PortType) def.getPortTypes().values().iterator().next();
            Operation op = porttype.getOperation(sOperationName, null, null);
    if (op == null) {
            return this.displayWebOperationNotFoundHtml(req, sOperationName);
    }
    else {
            retString.append("<html>\n");
      retString.append("     <head>\n");
      retString.append("          <meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n");
      retString.append("          <style type=\"text/css\">\n");
      retString.append("          <!--\n");
      retString.append("          pre { margin-left: 30px; background-color: #e5e5cc; padding: 5px; font-family: \"Courier New\"; font-size: x-small; margin-top: -5px; border: 1px #f0f0e0 solid; }\n");
      retString.append("          .unnamed1 {  font-size: 12px; text-decoration: none; line-height: 21px; font-family: \"Arial\", \"Helvetica\", \"sans-serif\"}\n");
      retString.append("          .frmheader { color: #000000; background: #dcdcdc; font-family: \"Verdana\"; font-size: .7em; font-weight: normal; border-bottom: 1px solid #dcdcdc; padding-top: 2px; padding-bottom: 2px; }\n");
      retString.append("          .frmtext { font-family: \"Verdana\"; font-size: .7em; margin-top: 8px; margin-bottom: 0px; margin-left: 32px; }\n");
      retString.append("          -->\n");
      retString.append("          </style>\n");
      retString.append("          <title>Web Operation: " + sServiceName + "." +
                       sOperationName + "</title>\n");
      retString.append("     </head>\n");
      retString.append("     <body bgcolor=\"#FFFFFF\" text=\"#000000\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\">\n");
      retString.append("          <table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n");
      retString.append("            <tr>\n");
                  retString.append("            </tr>\n");
      retString.append("            <tr>\n");
      retString.append("              <td colspan=\"2\" class=\"unnamed1\" valign=\"middle\" align=\"left\" height=\"25\" bgcolor=\"#13628C\"><font color=\"#FFFFFF\" size=\"5\" face=\"Arial, Helvetica, sans-serif\">&nbsp;&nbsp;&nbsp;&nbsp;<font size=\"4\">" +
                       sServiceName + "</font></font></td>\n");
      retString.append("            </tr>\n");
      retString.append("          </table>\n");
      retString.append("          <table width=\"95%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" align=\"center\" class=\"unnamed1\">\n");
      retString.append("            <tr>\n");
      retString.append("              <td><br>\n");
      retString.append("                <h2><span><font size=\"3\">" +
                       sOperationName + "</font></span></h2>\n");
      retString.append("                <p></p>\n");
      retString.append("              </td>\n");
      retString.append("            </tr>\n");
      retString.append("          </table>\n");
            Binding binding = (Binding) def.getBindings().values().iterator().next();
      SOAPBinding soapBinding = (SOAPBinding) binding.getExtensibilityElements().
          get(0);
      BindingOperation bindingOperation = binding.getBindingOperation(
          sOperationName, null, null);
      SOAPOperation soapOperation = (SOAPOperation) bindingOperation.
          getExtensibilityElements().get(0);
      String sStyle = soapOperation.getStyle() != null ? soapOperation.getStyle() :
          soapBinding.getStyle();
      if (sStyle.equals("rpc")) {
                StringBuffer sParaTable = new StringBuffer("");
        String sResult = null;
        String sError = null;
        String requestMessage = null;
        String responseMessage = null;
                System.setProperty("javax.xml.rpc.ServiceFactory",
                           "org.act.soap.client.ServiceFactory");
        System.setProperty("javax.xml.soap.SOAPConnectionFactory",
                           "org.act.soap.message.transport.ConnectionFactoryImpl");
        System.setProperty("javax.xml.soap.MessageFactory",
                           "org.act.soap.message.MessageFactoryImpl");
        try {
          javax.xml.rpc.Service service = ServiceFactory.newInstance().
              createService(new QName(""));
          Call call = (org.act.soap.client.Call) service.createCall(new QName(
              ""));
          javax.wsdl.Service srv = (javax.wsdl.Service) def.getServices().
              values().iterator().next();
          javax.wsdl.Port port = (javax.wsdl.Port) srv.getPorts().values().
              iterator().next();
          javax.wsdl.extensions.soap.SOAPAddress address = (javax.wsdl.
              extensions.soap.SOAPAddress) port.
              getExtensibilityElements().iterator().next();
          String accessPoint = address.getLocationURI();
          call.setTargetEndpointAddress(accessPoint);
          call.setOperationName(new QName(sOperationName));
                    Vector paramValues = new Vector();
          List requestParts = bindingOperation.getOperation().getInput().
              getMessage().getOrderedParts(null);
                    if (requestParts == null || requestParts.size() <= 0) {
            sParaTable.append("          <table width=\"95%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" align=\"center\" class=\"unnamed1\">\n");
            sParaTable.append("            <tr>\n");
            sParaTable.append("              <td>\n");
            sParaTable.append("                <p><span><font face=\"Times New Roman, Times, serif\"><b><font size=\"2\" face=\"Georgia, Times New Roman, Times, serif\">û<br></font></b></font></span></p>\n");
            sParaTable.append("              </td>\n");
            sParaTable.append("            </tr>\n");
            sParaTable.append("          </table>\n");
          }
          else {
                        sParaTable.append("          <table width=\"95%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" align=\"center\" class=\"unnamed1\">\n");
            sParaTable.append("            <tr>\n");
            sParaTable.append("              <td>\n");
            sParaTable.append("                <p><span><font face=\"Times New Roman, Times, serif\"><b><font size=\"2\" face=\"Georgia, Times New Roman, Times, serif\"><br></font></b></font></span></p>\n");
            sParaTable.append("              </td>\n");
            sParaTable.append("            </tr>\n");
            sParaTable.append("          </table>\n");
            sParaTable.append("          <table width=\"85%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" align=\"center\" class=\"unnamed1\">\n");
            sParaTable.append("            <tr>\n");
            sParaTable.append("              <td>\n");
            sParaTable.append("                <table style=\"BORDER-COLLAPSE: collapse\" bordercolor=\"#dcdcdc\" cellspacing=\"1\" rules=\"none\" frame=\"box\" bgcolor=\"#CCCCCC\">\n");
            sParaTable.append("                  <tbody>\n");
            sParaTable.append("                    <tr>\n");
            sParaTable.append("                      <td class=frmHeader\n");
            sParaTable.append("                        style=\"BORDER-RIGHT: white 2px solid; FONT-WEIGHT: normal; FONT-SIZE: 0.7em; COLOR: #000000; FONT-FAMILY: Verdana\" \n");
            sParaTable.append(
                "                        bgcolor=\"#CCCCCC\"><span></span></td>\n");
            sParaTable.append("                      <td class=frmHeader \n");
            sParaTable.append("                        style=\"BORDER-RIGHT: white 2px solid; FONT-WEIGHT: normal; FONT-SIZE: 0.7em; COLOR: #000000; FONT-FAMILY: Verdana\" \n");
            sParaTable.append(
                "                        bgcolor=\"#CCCCCC\"><span>ֵ</span></td>\n");
            sParaTable.append("                    </tr>\n");
            boolean paramsError = false;             for (int i = 0; i < requestParts.size(); i++) {
              Part requestPart = (Part) requestParts.get(i);
              String name = requestPart.getName();
              String value = req.getParameter("paraname" + name);
              if (value != null) {
                value = new String(value.getBytes("ISO-8859-1"), "UTF-8");
              }
              String encodedName = getHtmlEncodedString(name);
              String encodedVelue = getHtmlEncodedString(value);
              String encodedError = null;
              try {
                call.addParameter(name, requestPart.getTypeName(),
                                  ParameterMode.IN);
                paramValues.add(getParaValue(value, requestPart.getTypeName()));
              }
              catch (Exception ex) {
                encodedName = "<font color=\"red\">" + encodedName + "</font>";
                encodedVelue = "<font color=\"red\">" + encodedVelue +
                    "</font>";
                encodedError = "<font color=\"red\">" +
                    getHtmlEncodedString(ex.getMessage()) + "</font>";
                paramsError = true;
              }
              sParaTable.append(
                  "                    <tr bgcolor=\"#FFFFFF\">\n");
              sParaTable.append("                      <td class=\"frmText\" style=\"FONT-WEIGHT: normal; FONT-SIZE: 0.7em; COLOR: #000000; FONT-FAMILY: Verdana\"><span>" +
                                encodedName + "</span></td>\n");
              sParaTable.append("                      <td class=\"frmText\" style=\"FONT-WEIGHT: normal; FONT-SIZE: 0.7em; COLOR: #000000; FONT-FAMILY: Verdana\"><span>" +
                                encodedVelue + "</span></td>\n");
              if (encodedError != null) {
                sParaTable.append("                      <td class=\"frmText\" style=\"FONT-WEIGHT: normal; FONT-SIZE: 0.7em; COLOR: #000000; FONT-FAMILY: Verdana\">" +
                                  encodedError + "</td>\n");
              }
              sParaTable.append("                    </tr>\n");
            }
            sParaTable.append("                  </tbody>\n");
            sParaTable.append("                </table>\n");
            sParaTable.append("              </td>\n");
            sParaTable.append("            </tr>\n");
            sParaTable.append("          </table>\n");
            if (paramsError)
              throw new IllegalArgumentException(Message.getMessage(
                  "ERR_Servlet_paramProErr"));
          }
                    List responseParts = bindingOperation.getOperation().
              getOutput().getMessage().getOrderedParts(null);
          if (responseParts != null && responseParts.size() > 0) {
            Part responsePart = (Part) responseParts.get(0);
            call.setReturnType(responsePart.getTypeName());
                        Object result = call.invoke(paramValues.toArray());
            sResult = getArrayValue(result, 0).toString();           }
          else {
                        call.invoke(paramValues.toArray());
          }
                    ByteArrayOutputStream tmpStream = new ByteArrayOutputStream();
          call.getMessageContext().getRequestMessage().writeTo( tmpStream );
          requestMessage = tmpStream.toString();
          requestMessage = getHtmlEncodedString( requestMessage );
          tmpStream.reset();
          call.getMessageContext().getResponseMessage().writeTo( tmpStream );
          responseMessage = tmpStream.toString();
          responseMessage = getHtmlEncodedString( responseMessage );
        }
        catch (Exception ex) {
          sResult = null;
          sError = "<font color=\"red\">" +
              getHtmlEncodedString(ex.getMessage()) + "</font>";
                  }
        retString.append(sParaTable);
        retString.append("          <p></p>\n");
        if (sResult != null) {
          retString.append("          <table width=\"95%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" align=\"center\" class=\"unnamed1\">\n");
          retString.append("            <tr>\n");
          retString.append("              <td>\n");
          retString.append("                <p><span><font face=\"Times New Roman, Times, serif\"><b><font size=\"2\" face=\"Georgia, Times New Roman, Times, serif\">ؽ<br></font></b></font></span></p>\n");
          retString.append("              </td>\n");
          retString.append("            </tr>\n");
          retString.append("          </table>\n");
          retString.append("          <p><pre>" + sResult + "</pre></p>\n");
        }
        if (sError != null) {
          retString.append("          <table width=\"95%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" align=\"center\" class=\"unnamed1\">\n");
          retString.append("            <tr>\n");
          retString.append("              <td>\n");
          retString.append("                <p><span><font face=\"Times New Roman, Times, serif\"><b><font size=\"2\" face=\"Georgia, Times New Roman, Times, serif\"><font color=\"red\"></font><br></font></b></font></span></p>\n");
          retString.append("              </td>\n");
          retString.append("            </tr>\n");
          retString.append("          </table>\n");
          retString.append("          <p><pre>" + sError + "</pre></p>\n");
        }
        if (requestMessage != null) {
          retString.append("          <table width=\"95%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" align=\"center\" class=\"unnamed1\">\n");
          retString.append("            <tr>\n");
          retString.append("              <td>\n");
          retString.append("                <p><span><font face=\"Times New Roman, Times, serif\"><b><font size=\"2\" face=\"Georgia, Times New Roman, Times, serif\">SOAPϢ<br></font></b></font></span></p>\n");
          retString.append("              </td>\n");
          retString.append("            </tr>\n");
          retString.append("          </table>\n");
          retString.append("          <p><pre>" + requestMessage +
                           "</pre></p>\n");
        }
        if (responseMessage != null) {
          retString.append("          <table width=\"95%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" align=\"center\" class=\"unnamed1\">\n");
          retString.append("            <tr>\n");
          retString.append("              <td>\n");
          retString.append("                <p><span><font face=\"Times New Roman, Times, serif\"><b><font size=\"2\" face=\"Georgia, Times New Roman, Times, serif\">SOAPӦϢ<br></font></b></font></span></p>\n");
          retString.append("              </td>\n");
          retString.append("            </tr>\n");
          retString.append("          </table>\n");
          retString.append("          <p><pre>" + responseMessage +
                           "</pre></p>\n");
        }
      }
      else {
                String sRequestSOAP = req.getParameter("request");
        if (sRequestSOAP == null) {
          retString.append(
              getWebserviceErrorPage(sOperationName, "SOAPϢΪ."));
        }
        else {
                              org.act.soap.server.MessageContext reqIvkCtx =
              new org.act.soap.server.MessageContext();
                    sRequestSOAP =
              "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n" +
              sRequestSOAP;
          reqIvkCtx.setProperty("senderIP", req.getRemoteAddr());
                    reqIvkCtx.setTransportProtocol(req.getProtocol());
                    reqIvkCtx.setProperty("serviceName", sServiceName);
                    String sResponseSOAP = "";
          sRequestSOAP = getHtmlEncodedString(getUTF8String(sRequestSOAP));
          retString.append("          <table width=\"95%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" align=\"center\" class=\"unnamed1\">\n");
          retString.append("            <tr>\n");
          retString.append("              <td>\n");
          retString.append("                <p><span><font face=\"Times New Roman, Times, serif\"><b><font size=\"2\" face=\"Georgia, Times New Roman, Times, serif\">SOAPϢ<br></font></b></font></span></p>\n");
          retString.append("              </td>\n");
          retString.append("            </tr>\n");
          retString.append("          </table>\n");
          retString.append("          <p><pre>" + sRequestSOAP +
                           "</pre></p>\n");
          sResponseSOAP = getHtmlEncodedString(sResponseSOAP);
          retString.append("          <table width=\"95%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" align=\"center\" class=\"unnamed1\">\n");
          retString.append("            <tr>\n");
          retString.append("              <td>\n");
          retString.append("                <p><span><font face=\"Times New Roman, Times, serif\"><b><font size=\"2\" face=\"Georgia, Times New Roman, Times, serif\">SOAPӦϢ<br></font></b></font></span></p>\n");
          retString.append("              </td>\n");
          retString.append("            </tr>\n");
          retString.append("          </table>\n");
          retString.append("          <p><pre>" + sResponseSOAP +
                           "</pre></p>\n");
        }
      }
      retString.append("          <p></p>\n");
      retString.append("          <table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" align=\"center\" class=\"unnamed1\">\n");
      retString.append("            <tr>\n");
      retString.append("              <td>\n");
      retString.append(
          "                <hr size=\"1\" width=\"100%\" align=\"center\">\n");
      retString.append("                <div align=\"center\"><span class=\"unnamed1\">Ȩ (C) պѧ¼ʵ 1999-2004 </span></div>\n");
      retString.append("              </td>\n");
      retString.append("            </tr>\n");
      retString.append("          </table>\n");
      retString.append("     </body>\n");
      retString.append("</html>\n");
      return retString;
    }
  }
  
  private StringBuffer displayWebOperationNotFoundHtml(HttpServletRequest req,
      String sOperationName) {
    StringBuffer retString = new StringBuffer("");
        String sServiceName = req.getParameter("service");
        retString.append("<html>\n");
    retString.append("     <head>\n");
    retString.append("          <meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n");
    retString.append("          <style type=\"text/css\">\n");
    retString.append("          <!--\n");
    retString.append("          pre { margin-left: 30px; background-color: #e5e5cc; padding: 5px; font-family: \"Courier New\"; font-size: x-small; margin-top: -5px; border: 1px #f0f0e0 solid; }\n");
    retString.append("          .unnamed1 {  font-size: 12px; text-decoration: none; line-height: 21px; font-family: \"Arial\", \"Helvetica\", \"sans-serif\"}\n");
    retString.append("          .frmheader { color: #000000; background: #dcdcdc; font-family: \"Verdana\"; font-size: .7em; font-weight: normal; border-bottom: 1px solid #dcdcdc; padding-top: 2px; padding-bottom: 2px; }\n");
    retString.append("          .frmtext { font-family: \"Verdana\"; font-size: .7em; margin-top: 8px; margin-bottom: 0px; margin-left: 32px; }\n");
    retString.append("          -->\n");
    retString.append("          </style>\n");
    retString.append("          <title>Web Operation: " + sServiceName + "." +
                     sOperationName + "</title>\n");
    retString.append("     </head>\n");
    retString.append("     <body bgcolor=\"#FFFFFF\" text=\"#000000\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\">\n");
    retString.append("          <table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n");
    retString.append("            <tr>\n");
    retString.append("              <td background=\"image/photo2.jpg\" height=\"91\" align=\"left\" valign=\"top\"><img src=\"image/photo1.jpg\" width=\"501\" height=\"91\"></td>\n");
    retString.append("              <td background=\"image/photo2.jpg\" height=\"91\" align=\"right\" valign=\"top\"><img src=\"image/photo3.gif\" width=\"215\" height=\"91\"></td>\n");
    retString.append("            </tr>\n");
    retString.append("            <tr>\n");
    retString.append("              <td colspan=\"2\" class=\"unnamed1\" valign=\"middle\" align=\"left\" height=\"25\" bgcolor=\"#13628C\"><font color=\"#FFFFFF\" size=\"5\" face=\"Arial, Helvetica, sans-serif\">&nbsp;&nbsp;&nbsp;&nbsp;<font size=\"4\">" +
                     sServiceName + "</font></font></td>\n");
    retString.append("            </tr>\n");
    retString.append("          </table>\n");
    retString.append("          <table width=\"95%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" align=\"center\" class=\"unnamed1\">\n");
    retString.append("            <tr>\n");
    retString.append("              <td><br>\n");
    retString.append(
        "                <h2><span><font size=\"3\"></font></span></h2>\n");
    retString.append("                Web Service '" + sServiceName +
                     "' ûΪ '" + sOperationName + "' Ĳ\n");
    retString.append("                <p></p>\n");
    retString.append("              </td>\n");
    retString.append("            </tr>\n");
    retString.append("          </table>\n");
    retString.append("          <table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" align=\"center\" class=\"unnamed1\">\n");
    retString.append("            <tr> \n");
    retString.append("              <td> \n");
    retString.append(
        "                <hr size=\"1\" width=\"100%\" align=\"center\">\n");
    retString.append("                <div align=\"center\"><span class=\"unnamed1\">Ȩ (C) պѧ¼ʵ 1999-2004 </span></div>\n");
    retString.append("              </td>\n");
    retString.append("            </tr>\n");
    retString.append("          </table>\n");
    retString.append("     </body>\n");
    retString.append("</html>\n");
    return retString;
  }
  
  private String getHtmlEncodedString(String str) {
    if (str == null)
      return null;
    StringReader sr = new StringReader(str);
    StringWriter sw = new StringWriter();
    try {
      int c = sr.read();
      while (c != -1) {
        switch ( (char) c) {
          case '<':
            sw.write("&lt;");
            break;
          case '>':
            sw.write("&gt;");
            break;
          case ' ':
            sw.write("&nbsp;");
            break;
          case '&':
            sw.write("&amp;");
            break;
          case '\n':
            sw.write("<br>");
            break;
          case '\r':
            break;
          default:
            sw.write(c);
        }
        c = sr.read();
      }
    }
    catch (Exception ex) {
    }
    return sw.toString();
  }
  
  private Object getParaValue(String value, QName type) throws java.lang.
      IllegalArgumentException {
    try {
      if (type.equals(XMLType.XSD_STRING) || type.equals(XMLType.SOAP_STRING)) {
        return value;
      }
      if (type.equals(XMLType.XSD_INTEGER)) {
        return new Integer(value);
      }
      if (type.equals(XMLType.XSD_INT) || type.equals(XMLType.SOAP_INT)) {
        return new Integer(value);
      }
      if (type.equals(XMLType.XSD_LONG) || type.equals(XMLType.SOAP_LONG)) {
        return new Long(value);
      }
      if (type.equals(XMLType.XSD_SHORT) || type.equals(XMLType.SOAP_SHORT)) {
        return new Short(value);
      }
      if (type.equals(XMLType.XSD_BYTE) || type.equals(XMLType.SOAP_BYTE)) {
        return new Byte(value);
      }
      if (type.equals(XMLType.XSD_FLOAT) || type.equals(XMLType.SOAP_FLOAT)) {
        return new Float(value);
      }
      if (type.equals(XMLType.XSD_DOUBLE) || type.equals(XMLType.SOAP_DOUBLE)) {
        return new Double(value);
      }
      if (type.equals(XMLType.XSD_BOOLEAN) || type.equals(XMLType.SOAP_BOOLEAN)) {
        return new Boolean(value);
      }
      
      else
        throw new IllegalArgumentException("Unsupport type : " + type.toString());
    }
    catch (java.lang.NumberFormatException ex) {
      throw new IllegalArgumentException("IllegalNumberFormat");
    }
  }
  
  private StringBuffer getArrayValue(Object object, int depth) {
    StringBuffer result = new StringBuffer("");
    if (object == null)
      result = new StringBuffer("<i>null</i>");
    else if (object instanceof ArrayList) {
      ArrayList rs = (ArrayList) object;
      result = getArrayValue(rs.toArray(), depth);
    }
    else if (object.getClass().isArray()) {
      Class type = object.getClass().getComponentType();
      result = new StringBuffer(
          "<font color=\"gray\">[Array of " + type.getName() + "]</font>\n");
      if (type.isPrimitive()) {
                if (type.equals(Integer.TYPE)) {
          int[] rs = (int[]) object;
          for (int i = 0; i < rs.length; i++) {
            if (i > 0) result.append("\n");
            result.append(repeatString("\t", depth));
            result.append("<font color=\"gray\">[" + String.valueOf(i) +
                          "] = </font>");
            result.append(String.valueOf(rs[i]));
          }
        }
        else if (type.equals(Short.TYPE)) {
          short[] rs = (short[]) object;
          for (int i = 0; i < rs.length; i++) {
            if (i > 0) result.append("\n");
            result.append(repeatString("\t", depth));
            result.append("<font color=\"gray\">[" + String.valueOf(i) +
                          "] = </font>");
            result.append(String.valueOf(rs[i]));
          }
        }
        else if (type.equals(Byte.TYPE)) {
          byte[] rs = (byte[]) object;
          for (int i = 0; i < rs.length; i++) {
            if (i > 0) result.append("\n");
            result.append(repeatString("\t", depth));
            result.append("<font color=\"gray\">[" + String.valueOf(i) +
                          "] = </font>");
            result.append(String.valueOf(rs[i]));
          }
        }
        else if (type.equals(Long.TYPE)) {
          long[] rs = (long[]) object;
          for (int i = 0; i < rs.length; i++) {
            if (i > 0) result.append("\n");
            result.append(repeatString("\t", depth));
            result.append("<font color=\"gray\">[" + String.valueOf(i) +
                          "] = </font>");
            result.append(String.valueOf(rs[i]));
          }
        }
        else if (type.equals(Double.TYPE)) {
          double[] rs = (double[]) object;
          for (int i = 0; i < rs.length; i++) {
            if (i > 0) result.append("\n");
            result.append(repeatString("\t", depth));
            result.append("<font color=\"gray\">[" + String.valueOf(i) +
                          "] = </font>");
            result.append(String.valueOf(rs[i]));
          }
        }
        else if (type.equals(Short.TYPE)) {
          short[] rs = (short[]) object;
          for (int i = 0; i < rs.length; i++) {
            if (i > 0) result.append("\n");
            result.append(repeatString("\t", depth));
            result.append("<font color=\"gray\">[" + String.valueOf(i) +
                          "] = </font>");
            result.append(String.valueOf(rs[i]));
          }
        }
        else if (type.equals(Boolean.TYPE)) {
          boolean[] rs = (boolean[]) object;
          for (int i = 0; i < rs.length; i++) {
            if (i > 0) result.append("\n");
            result.append(repeatString("\t", depth));
            result.append("<font color=\"gray\">[" + String.valueOf(i) +
                          "] = </font>");
            result.append(String.valueOf(rs[i]));
          }
        }
        else if (type.equals(Character.TYPE)) {
          char[] rs = (char[]) object;
          for (int i = 0; i < rs.length; i++) {
            if (i > 0) result.append("\n");
            result.append(repeatString("\t", depth));
            result.append("<font color=\"gray\">[" + String.valueOf(i) +
                          "] = </font>");
            result.append(String.valueOf(rs[i]));
          }
        }
      }
      else {
                Object[] rs = (Object[]) object;
        for (int i = 0; i < rs.length; i++) {
          if (i > 0) result.append("\n");
          result.append(repeatString("\t", depth));
          result.append("<font color=\"gray\">[" + String.valueOf(i) +
                        "] = </font>");
          result.append(getArrayValue(rs[i], depth + 1));
        }
      }
    }
    else {
            result.append(getHtmlEncodedString(object.toString()));
    }
    return result;
  }
  
  private StringBuffer getWebserviceErrorPage(String sOperationName,
                                              String sMsg) {
    StringBuffer sBuffer = new StringBuffer("");
    sBuffer.append("<h2>!</h2>\n");
    sBuffer.append(" '" + sOperationName + "' " + sMsg + ".\n");
    sBuffer.append("<p>&nbsp;</p><br/>\n");
    return sBuffer;
  }
  
  private String getUTF8String(String s) {
    if (s == null)return null;
    try {
      return new String(s.getBytes("ISO-8859-1"), "UTF-8");
    }
    catch (Exception ex) {
      return null;
    }
  }
  
  private String repeatString(String origin, int repeat) {
    if (origin == null)return null;
    if (repeat < 0)return "";
    String result = "";
    for (int i = 0; i < repeat; i++) {
      result += origin;
    }
    return result;
  }
}
