package org.act.soap.server.provider;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Hashtable;
import javax.xml.soap.MessageFactory;
import javax.xml.soap.SOAPBody;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPEnvelope;
import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPMessage;
import javax.xml.soap.SOAPPart;
import javax.wsdl.BindingOperation;
import javax.wsdl.Operation;
import javax.xml.rpc.encoding.TypeMapping;
import org.act.soap.encoding.TypeMappingImpl;
import javax.wsdl.Part;
import javax.xml.namespace.QName;
import org.act.soap.util.i18n.Message;
import org.act.soap.encoding.DeserializationContextImpl;
import org.act.soap.encoding.DeserializerImpl;
import org.act.soap.encoding.SerializationContextImpl;
import org.act.soap.encoding.SerializerImpl;
import org.act.soap.server.MessageContext;
import org.act.soap.server.WebServiceObject;
import org.act.soap.util.TMConstants;
import org.act.soap.util.SOAPUtils;
import org.act.soap.server.*;
import java.lang.reflect.InvocationTargetException;
import javax.activation.DataHandler;
import org.act.soap.util.Constants;
import java.util.Arrays;
import javax.xml.soap.AttachmentPart;
import org.act.soap.server.provider.CORBAProviderInfo;
import javax.xml.rpc.encoding.DeserializerFactory;
import org.act.soap.encoding.TypeMappingException;
import java.util.MissingResourceException;
import javax.xml.rpc.encoding.SerializerFactory;
public class CORBAProvider extends Provider {
    
    private MessageFactory mMessageFactory = null;
        private Object[] parameters;
    public CORBAProvider() {
        mMessageFactory = SOAPUtils.MESSAGEFACTORY_INSTANCE;
    }
    
    public void init( org.act.soap.wsdd.Provider wsddProvider ) throws
        ProviderException {
    }
    public void doRPCProcess( MessageContext msgContext ) throws
        ProviderException, ServiceImplementationException {
    }
    public void doDocumentProcess( MessageContext msgContext ) throws
        ProviderException, ServiceImplementationException {
    }
        private CORBAProviderInfo getWSDDInfo( org.act.soap.wsdd.Provider
                                           wsddProvider ) throws
        ProviderException {
        String providerType = "";
        String homeFinderURL = "";
        String componentName = "";
        String repositoryURL = "";
        String homeInterfaceName = "";
        String interfaceName = "";
        String facetInterfaceNames = "";
        CORBAProviderInfo CPI = new CORBAProviderInfo();
        try {
            homeFinderURL = wsddProvider.getParameter( "homeFinderURL" ).
                getValue();
            componentName = wsddProvider.getParameter( "componentName" ).
                getValue();
            repositoryURL = wsddProvider.getParameter( "repositoryURL" ).
                getValue();
            homeInterfaceName = wsddProvider.getParameter( "homeInterfaceName" ).
                getValue();
            interfaceName = wsddProvider.getParameter( "interfaceName" ).
                getValue();
            facetInterfaceNames = wsddProvider.getParameter(
                "facetInterfaceNames" ).getValue();
            providerType = wsddProvider.getType();
                        CPI.SetHomeFinderURL( homeFinderURL );
            CPI.SetComponentName( componentName );
            CPI.SetFacetInterfaceNames( facetInterfaceNames );
            CPI.SetHomeInterfaceName( homeInterfaceName );
            CPI.SetRepositoryURL( repositoryURL );
            CPI.SetHomeInterfaceName( interfaceName );
            CPI.SetProviderType( providerType );
        } catch ( Exception ex ) {
            throw new ProviderException(
                org.act.soap.util.i18n.Message.getMessage(
                "WSDDException", ex.getMessage() ), ex );
        }
        return CPI;
    }
    private String getMethodName( MessageContext msgContext ) {
        return msgContext.getBindingOperation().getOperation().getName();
    }
    private String getServiceName( MessageContext msgContext ) {
        return msgContext.getWebServiceName();
    }
    private Object[] getInParams( MessageContext msgContext ) throws
        MissingResourceException, ProviderException {
        BindingOperation bindingOperation = msgContext.getBindingOperation();
        Operation operation = bindingOperation.getOperation();
                TypeMapping mTypeMapping = msgContext.getTypeMappingRegistry().
            getDefaultTypeMapping();
        TypeMappingImpl impl = ( TypeMappingImpl ) mTypeMapping;
                QName[] xmlTypes = getXMLTypes( operation );
        Object[] paramObjects = new Object[xmlTypes.length];
        Class[] javaType = new Class[xmlTypes.length];
                for ( int i = 0; i < xmlTypes.length; i++ ) {
            javaType[i] = impl.getJavaType( xmlTypes[i] );
        }
        try {
            SOAPMessage requestMessage = msgContext.getRequestMessage();
                        SOAPElement[] paramElements = getParamElements( requestMessage );
            for ( int i = 0; i < paramElements.length; i++ ) {
                DeserializationContextImpl deserializeContext = new
                    DeserializationContextImpl(
                    msgContext.getRequestMessage(),
                    msgContext.getTypeMappingRegistry() );
                DeserializerFactory deserializerFactory = mTypeMapping.
                    getDeserializer( javaType[i], xmlTypes[i] );
                DeserializerImpl deserializer = ( DeserializerImpl )
                    deserializerFactory.getDeserializerAs(
                    TMConstants.ENCODING_MECHANISMTYPE );
                paramObjects[i] = deserializer.deserialize( paramElements[i],
                    xmlTypes[i],
                    javaType[i],
                    deserializeContext );
            }
                        this.SetParameters( paramObjects );
            return paramObjects;
        } catch ( TypeMappingException ex ) {
            throw new ProviderException(
                Message.getMessage( "actTypeMappingException", ex.getMessage() ),
                ex );
        }
    }
    private void setOutParamsAndReturnValue( MessageContext msgContext,
                                             Hashtable outParams,
                                             java.lang.Object retObj ) throws
        ProviderException {
        Class returnType = retObj.getClass();
        Object[] parameters = this.GetParameters();
        System.out.println(returnType +":"+parameters[0]);
        try {
                        SOAPMessage responseMessage = mMessageFactory.createMessage();
            responseMessage.setProperty( SOAPMessage.CHARACTER_SET_ENCODING,
                                         "UTF-8" );
            responseMessage.setProperty( SOAPMessage.WRITE_XML_DECLARATION,
                                         "true" );
            SOAPPart soapPart = responseMessage.getSOAPPart();
            SOAPEnvelope envelope = soapPart.getEnvelope();
                        envelope.addNamespaceDeclaration(
                TMConstants.NS_XSI_TYPE_PREFIX,
                TMConstants.URI_2001_SCHEMA_XSI );
            envelope.addNamespaceDeclaration(
                TMConstants.URI_DEFAULT_SCHEMA_XSD_PREFIX,
                TMConstants.URI_DEFAULT_SCHEMA_XSD );
            envelope.addNamespaceDeclaration(
                TMConstants.URI_DEFAULT_SOAP_ENC_PREFIX,
                TMConstants.URI_DEFAULT_SOAP_ENC );
            SOAPBody soapBody = null;
            try {
                soapBody = responseMessage.getSOAPBody();
            } catch ( SOAPException ex ) {
                throw new ProviderException(
                    Message.getMessage( "javaSOAPException", ex.getMessage() ),
                    ex );
            }
                        BindingOperation bindingOperation =
                msgContext.getBindingOperation();
            Operation operation = bindingOperation.getOperation();
            SOAPElement responseSOAPElement = null;
            try {
                QName responseQName = operation.getOutput().getMessage().
                    getQName();
                responseSOAPElement =
                    soapBody.addChildElement( responseQName.getLocalPart() );
            } catch ( SOAPException ex ) {
                throw new ProviderException(
                    Message.getMessage( "javaSOAPException", ex.getMessage() ),
                    ex );
            }
                        QName xmlType = getReturnXMLType( operation );
            if ( null == xmlType ) {
                return;
            }
            TypeMapping mTypeMapping = msgContext.getTypeMappingRegistry().
                getDefaultTypeMapping();
                        SerializerFactory serializerFactory =
                mTypeMapping.getSerializer( returnType, xmlType );
            if ( null == serializerFactory ) {
                String methodName = operation.getName();
                throw new ProviderException(
                    Message.getMessage( "noServiceMethod", methodName ) );
            }
            List returnElements = new ArrayList( 1 );
            try {
                SerializerImpl serializer =
                    ( SerializerImpl ) serializerFactory.getSerializerAs(
                    TMConstants.ENCODING_MECHANISMTYPE );
                SerializationContextImpl serializeContext =
                    new SerializationContextImpl(
                    null, msgContext.getTypeMappingRegistry() );
                QName returnName = getReturnName( operation );
                returnElements.add(
                    serializer.serialize( retObj,
                                          returnName,
                                          returnType,
                                          xmlType,
                                          serializeContext ) );
                SOAPElement[] serializeTrailingBlocks =
                    serializeContext.serializeTrailingBlocks();
                if ( null != serializeTrailingBlocks ) {
                    returnElements.addAll( Arrays.asList(
                        serializeTrailingBlocks ) );
                }
            } catch ( TypeMappingException ex ) {
                throw new ProviderException(
                    Message.getMessage(
                    "actTypeMappingException", ex.getMessage() ), ex );
            }
                        try {
                for ( int i = 0; i < returnElements.size(); i++ ) {
                    responseSOAPElement.addChildElement(
                        ( SOAPElement ) returnElements.get( i ) );
                }
            } catch ( SOAPException ex ) {
                throw new ProviderException(
                    Message.getMessage( "javaSOAPException", ex.getMessage() ),
                    ex );
            }
                        msgContext.setResponseMessage( responseMessage );
        } catch ( SOAPException ex ) {
            throw new ProviderException(
                org.act.soap.util.i18n.Message.getMessage(
                "javaSOAPException", ex.getMessage() ), ex );
        }
    }
    
    private static QName getReturnName( Operation operation ) {
        javax.wsdl.Message outputMessage = operation.getOutput().getMessage();
        Iterator parts = outputMessage.getParts().values().iterator();
        return
            parts.hasNext() ? new QName( ( ( Part ) parts.next() ).getName() ) : null;
    }
    
    private static QName[] getXMLTypes( Operation operation ) {
        List paramOrdering = operation.getParameterOrdering();
        List inputParts =
            operation.getInput().getMessage().getOrderedParts( paramOrdering );
        List inputTypes = new ArrayList( inputParts.size() );
        for ( int i = 0; i < inputParts.size(); i++ ) {
            Part part = ( Part ) inputParts.get( i );
            inputTypes.add( part.getTypeName() );
        }
        return ( QName[] ) inputTypes.toArray( new QName[inputTypes.size()] );
    }
    
    private static QName getReturnXMLType( Operation operation ) {
        javax.wsdl.Message outputMessage = operation.getOutput().getMessage();
        Iterator parts = outputMessage.getParts().values().iterator();
        return parts.hasNext() ? ( ( Part ) parts.next() ).getTypeName() : null;
    }
    
    private static SOAPElement[] getParamElements( SOAPMessage requestMsg ) throws
        ProviderException {
        try {
            javax.xml.soap.SOAPBody body = requestMsg.getSOAPBody();
            SOAPElement opElement = null;
            for ( Iterator elements = body.getChildElements();
                  elements.hasNext(); ) {
                Object subElement = elements.next();
                if ( subElement instanceof SOAPElement ) {
                    opElement = ( SOAPElement ) subElement;
                    break;
                }
            }
            if ( null == opElement ) {
                throw new ProviderException(
                    Message.getMessage( "noSOAPElementInSOAPBody" ) );
            }
            List paramList = new ArrayList( 0 );
            for ( Iterator elements = opElement.getChildElements();
                  elements.hasNext(); ) {
                Object subElement = elements.next();
                if ( subElement instanceof SOAPElement ) {
                    paramList.add( ( SOAPElement ) subElement );
                }
            }
            return ( SOAPElement[] ) paramList.toArray(
                new SOAPElement[paramList.size()] );
        } catch ( SOAPException ex ) {
            throw new ProviderException(
                Message.getMessage( "javaSOAPException", ex.getMessage() ), ex );
        }
    }
    private void SetParameters( Object[] para ) {this.parameters = para;
    }
    private Object[] GetParameters() {
        return this.parameters;
    }
}
