package org.act.soap.server.rbac;
import org.act.rbac.*;

public class RBACPermission
    implements IPermission {
    
    private String mPermissionID;
    
    public RBACPermission ( String sPermissionID ) throws RBACHandlerException {
        if ( sPermissionID == null ) {
            throw new RBACHandlerException( "PermissionID can not be null." );
        }
        mPermissionID = sPermissionID;
    }
    
    public RBACPermission ( String sWebServiceName, String sWebMethodName ) throws
        RBACHandlerException {
        if ( sWebServiceName == null || sWebMethodName == null ) {
            throw new RBACHandlerException(
                "WebServiceName and WebServiceName can not be null." );
        }
        mPermissionID = sWebServiceName + "." + sWebMethodName;
    }
    
    public String getPermissionID () {
        return mPermissionID;
    }
    
    public String toString () {
        return "PermissionID = " + mPermissionID;
    }
    
    public boolean equals ( Object obj ) throws RBACHandlerException {
        if ( ! ( obj instanceof RBACPermission ) ) {
            throw new RBACHandlerException(
                "The argument is not a reference permission type variable!" );
        }
        return mPermissionID.equals( ( ( RBACPermission ) obj ).getPermissionID() );
    }
    
    public int hashCode () {
        return mPermissionID.hashCode();
    }
    
    public int compareTo ( Object o ) throws RBACHandlerException {
        if ( ! ( o instanceof RBACPermission ) ) {
            throw new RBACHandlerException(
                "The argument is not a reference Permission typemission type variable!" );
        }
        return mPermissionID.compareTo( ( ( RBACPermission ) o ).
                                        getPermissionID() );
    }
}
