package org.act.soap.server.rbac;
import org.act.rbac.*;

public class RBACRole
    implements IRole {
    
    private String mRoleID;
    
    public RBACRole ( String sRoleID ) throws RBACHandlerException {
        if ( sRoleID == null ) {
            throw new RBACHandlerException( "RoleID can not be null." );
        }
        mRoleID = sRoleID;
    }
    
    public String getRoleID () {
        return mRoleID;
    }
    
    public String toString () {
        return "RoleID = " + mRoleID;
    }
    
    public boolean equals ( Object obj ) throws RBACHandlerException {
        if ( ! ( obj instanceof RBACRole ) ) {
            throw new RBACHandlerException(
                "The argument is not a reference Role type variable!" );
        }
        return mRoleID.equals( ( ( RBACRole ) obj ).getRoleID() );
    }
    
    public int hashCode () {
        return mRoleID.hashCode();
    }
    
    public int compareTo ( Object o ) throws RBACHandlerException {
        if ( ! ( o instanceof RBACRole ) ) {
            throw new RBACHandlerException(
                "The argument is not a reference Role type variable!" );
        }
        return mRoleID.compareTo( ( ( RBACRole ) o ).getRoleID() );
    }
}
