package org.act.soap.server.rbac;
import org.act.rbac.*;

public class RBACSession
    implements ISession {
    
    private String mSessionID;
    
    public RBACSession ( String sSessionID ) throws RBACHandlerException {
        if ( sSessionID == null ) {
            throw new RBACHandlerException( "SessionID can not be null." );
        }
        mSessionID = sSessionID;
    }
    
    public String getSessionID () {
        return mSessionID;
    }
    
    public String toString () {
        return "SessionID = " + mSessionID;
    }
    
    public boolean equals ( Object obj ) throws RBACHandlerException {
        if ( ! ( obj instanceof RBACSession ) ) {
            throw new RBACHandlerException(
                "The argument is not a reference session type variable!" );
        }
        return mSessionID.equals( ( ( RBACSession ) obj ).getSessionID() );
    }
    
    public int hashCode () {
        return mSessionID.hashCode();
    }
    
    public int compareTo ( Object o ) throws RBACHandlerException {
        if ( ! ( o instanceof RBACSession ) ) {
            throw new RBACHandlerException(
                "The argument is not a reference session type variable!" );
        }
        return mSessionID.compareTo( ( ( RBACSession ) o ).getSessionID() );
    }
    
    public boolean terminate () {
        return true;
    }
}
