package org.act.soap.server.rbac;
import org.act.rbac.*;

public class RBACUser
    implements IUser {
    
    private String mUserID;
    
    public RBACUser ( String sUserID ) throws RBACHandlerException {
        if ( sUserID == null ) {
            throw new RBACHandlerException( "UserID can not be null." );
        }
        mUserID = sUserID;
    }
    
    public String getUserID () {
        return mUserID;
    }
    
    public String toString () {
        return "UserID = " + mUserID;
    }
    
    public boolean equals ( Object obj ) throws RBACHandlerException {
        if ( ! ( obj instanceof RBACUser ) ) {
            throw new RBACHandlerException(
                "The argument is not a reference User type variable!" );
        }
        return mUserID.equals( ( ( RBACUser ) obj ).getUserID() );
    }
    
    public int hashCode () {
        return mUserID.hashCode();
    }
    
    public int compareTo ( Object o ) throws RBACHandlerException {
        if ( ! ( o instanceof RBACUser ) ) {
            throw new RBACHandlerException(
                "The argument is not a reference User type variable!" );
        }
        return mUserID.compareTo( ( ( RBACUser ) o ).getUserID() );
    }
}
