package org.act.soap.server.secmanager;
import java.sql.*;
import java.util.*;
import org.act.soap.server.*;
import org.act.soap.util.i18n.*;
import org.act.soap.util.logging.*;
import org.w3c.dom.Document;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import java.io.FileInputStream;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Element;
import java.io.FileOutputStream;
import org.act.xdsec.util.DOMWriter;

public class RBACManager {
    public static final String EVERYONE_ROLE_NAME = "everyone";
    public static final String ADMIN_ROLE_NAME = "admin";
    private String JDBC_Driver;
    private String JDBC_URL;
    private String JDBC_Username;
    private String JDBC_Password;
    private String JDBC_Database = "tbUserRole";
    private static Log log = LogFactory.getLog( RBACManager.class.getName() );
        public static final String ITEM_USERID = "userid";
    public static final String ITEM_WSARNAME = "wsarname";
    public static final String ITEM_WSNAME = "wsname";
    public static final String ITEM_ROLENAME = "rolename";
    Connection conn = null;
    UserManager userManager = null;
        Document userDoc = null;
    String mFilePath = null;
    private boolean useDataBase = false;
    
    public RBACManager( String driver, String url, String username,
                        String password ) throws Exception {
        JDBC_Driver = driver;
        JDBC_URL = url;
        JDBC_Username = username;
        JDBC_Password = password;
        conn = getConnection();
                StringBuffer sb = new StringBuffer( url );
        int index = sb.lastIndexOf( ":" );
        sb.delete( index + 1, sb.length() );
        sb.append( "ACT_XLinker_UserDB" );
        String userDBURL = sb.toString();
        this.userManager = new UserManager( driver, userDBURL, username,
                                            password );
    }
    
    public RBACManager( String filePath ) throws Exception {
        DocumentBuilderFactory documentBuilderFactory =
            DocumentBuilderFactory.newInstance();
        DocumentBuilder documentBuilder = documentBuilderFactory.
            newDocumentBuilder();
        this.userDoc = documentBuilder.parse( new FileInputStream( filePath ) );
        this.useDataBase = false;
        this.mFilePath = filePath;
                                StringBuffer buffer = new StringBuffer( filePath );
        int indexWin = buffer.lastIndexOf( "\\" );
        int indexLin = buffer.lastIndexOf( "/" );
        if( 0 > indexLin ){
                        buffer.delete( indexWin + 1, buffer.length() );
        }else{
                        buffer.delete( indexLin + 1, buffer.length() );
        }
        buffer.append( "GlobalUser.xml" );
        String userFilePath = buffer.toString();
        this.userManager = new UserManager( userFilePath );
    }
    
    public void asignUserToRole( int userID, String roleName ) throws
        Exception {
        Vector roleVect = this.parseRole( roleName );
        String vWSARName = ( String ) roleVect.elementAt( 0 );
        String vWSName = ( String ) roleVect.elementAt( 1 );
        String vRole = ( String ) roleVect.elementAt( 2 );
        if ( userID == UserManager.INVALID_USERID
             || this.userManager.getUserName( userID ) == null ) {
            throw new Exception( "No such userID ...." + userID );
        }
        this.addItem( userID, vWSARName, vWSName, vRole );
                        SOAPEngine soapengine = SOAPEngine.getInstance();
        if ( soapengine != null ) {
            ServiceManager sm = soapengine.getServiceManager();
            if ( sm != null ) {
                sm.removeWebServiceObject( vWSName );
            }
        }
    }
    
    public void asignUserToRole( String userName, String roleName ) throws
        Exception {
        int vUserID = userManager.getUserID( userName );
        if ( vUserID == UserManager.INVALID_USERID ) {
            throw new Exception( "No such username ..." + userName );
        }
        this.asignUserToRole( vUserID, roleName );
    }
    
    public void deleteUserToRoleAsignment( int userID, String roleName ) throws
        Exception {
        Vector roleVect = this.parseRole( roleName );
        String vWSARName = ( String ) roleVect.elementAt( 0 );
        String vWSName = ( String ) roleVect.elementAt( 1 );
        String vRole = ( String ) roleVect.elementAt( 2 );
        this.delItem( userID, vWSARName, vWSName, vRole );
                        SOAPEngine soapengine = SOAPEngine.getInstance();
        if ( soapengine != null ) {
            ServiceManager sm = soapengine.getServiceManager();
            if ( sm != null ) {
                sm.removeWebServiceObject( vWSName );
            }
        }
    }
    
    public void deleteUserToRoleAsignment( String userName, String roleName ) throws
        Exception {
        int vUserID = userManager.getUserID( userName );
        if ( vUserID == UserManager.INVALID_USERID ) {
            throw new Exception( "No such username ..." + userName );
        }
        this.deleteUserToRoleAsignment( vUserID, roleName );
    }
    
    public Vector getUserPlayingRoleNames( int userID ) throws Exception {
        Vector vect = this.getItemValue( ITEM_USERID, userID );
        if ( vect == null || vect.size() == 0 ) {
            return null;
        }
        Vector vectRole = new Vector();
        for ( int i = 0; i < vect.size(); i++ ) {
            Vector v = ( Vector ) vect.elementAt( i );
            vectRole.addElement( ( String ) v.elementAt( 1 ) + "."
                                 + ( String ) v.elementAt( 2 )
                                 + "." + ( String ) v.elementAt( 3 ) );
        }
        return vectRole;
    }
    
    public Vector queryUserPlayingRoleNames( int userID ) throws Exception {
        return null;
    }
    
    public Vector getUserPlayingRoleNames( String userName ) throws Exception {
        int vUserID = userManager.getUserID( userName );
        if ( vUserID == UserManager.INVALID_USERID ) {
            return null;
        }
        return this.getUserPlayingRoleNames( vUserID );
    }
    
    public Vector queryUserPlayingRoleNames( String userName ) throws
        Exception {
        return null;
    }
    
    public int[] getUserIDsInRole( String roleName ) throws Exception {
        Vector roleVect = this.parseRole( roleName );
        String vWSARName = ( String ) roleVect.elementAt( 0 );
        String vWSName = ( String ) roleVect.elementAt( 1 );
        String vRole = ( String ) roleVect.elementAt( 2 );
        Vector roleUserID = this.getUserIDITEM( vWSARName, vWSName, vRole );
        int[] result = new int[roleUserID.size()];
        for ( int i = 0; i < result.length; i++ ) {
            result[i] = ( (Integer)roleUserID.elementAt( i ) ).intValue();
        }
        return result;
    }
    
    public int[] queryUserIDsInRole( String roleName ) throws Exception {
        return null;
    }
    
    public Vector getUserNamesInRole( String roleName ) throws Exception {
        int[] userID = this.getUserIDsInRole( roleName );
        Vector userName = new Vector();
        for ( int i = 0; i < userID.length; i++ ) {
            String s = this.userManager.getUserName( userID[i] );
            if ( s != null ) {
                userName.addElement( s );
            }
        }
        return userName;
    }
    
    public Vector queryUserNamesInRole( String roleName ) throws Exception {
        return null;
    }
    
    public boolean isUserInRole( int userID, String roleName ) throws
        Exception {
        return false;
    }
    
    public boolean isUserInRole( String userName, String roleName ) throws
        Exception {
        return false;
    }
    
    public Vector getAllUserAndRoles() throws Exception {
        Vector data = new Vector();
                Vector roleData = this.getAllItemValue();
        try {
            for ( int i = 0; i < roleData.size(); i++ ) {
                Vector dataVect = ( Vector ) roleData.elementAt( i );
                Vector newVect = new Vector();
                String userID = String.valueOf( dataVect.elementAt( 0 ) );
                newVect.addElement( userID );
                String userName = this.userManager.getUserName( new Integer(
                    userID ).intValue() );
                if ( userName != null ) {
                    newVect.addElement( userName );
                } else {
                    newVect.addElement( "null" );
                }
                newVect.addElement( ( String ) dataVect.elementAt( 1 ) );
                newVect.addElement( ( String ) dataVect.elementAt( 2 ) );
                newVect.addElement( ( String ) dataVect.elementAt( 3 ) );
                data.addElement( newVect );
            }
        } catch ( Exception e ) {
            log.debug( e );
        }
        return data;
    }
            private Vector getAllItemValue() {
        Vector result = new Vector();
        if ( this.useDataBase ) {
                        try {
                if ( conn == null ) {
                    conn = this.getConnection();
                }
                Statement stmt = conn.createStatement( ResultSet.
                    TYPE_SCROLL_INSENSITIVE,
                    ResultSet.CONCUR_READ_ONLY );
                String strSQL = "select * from " + JDBC_Database;
                ResultSet rs = stmt.executeQuery( strSQL );
                while ( rs.next() ) {
                    Vector rec_vector = new Vector();
                    rec_vector.addElement( rs.getString( 1 ) );
                    rec_vector.addElement( rs.getString( 2 ) );
                    rec_vector.addElement( rs.getString( 3 ) );
                    rec_vector.addElement( rs.getString( 4 ) );
                    result.addElement( rec_vector );
                }
                stmt.close();
                return result;
            } catch ( Exception e ) {
                log.debug( e );
                return null;
            }
        }
                Node textNode = null;
        Element itemEle = null;
        int userID = -1;
        String wsarName = null;
        String wsName = null;
        String roleName = null;
                NodeList tmpList = this.userDoc.getElementsByTagName( "Item" );
        for ( int i = 0; i < tmpList.getLength(); i++ ) {
            Vector mVector = new Vector();
            itemEle = ( Element ) tmpList.item( i );
                        NodeList childList = itemEle.getElementsByTagName( "UserID" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    userID = Integer.parseInt( textNode.getNodeValue() );
                    mVector.addElement( new Integer( userID ) );
                }
            } else {
                                continue;
            }
                        childList = itemEle.getElementsByTagName( "WSARName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element wsarNameEle = ( Element ) childList.item( 0 );
                textNode = wsarNameEle.getFirstChild();
                if ( null != textNode ) {
                    wsarName = textNode.getNodeValue();
                    mVector.addElement( wsarName );
                }
            } else {
                                continue;
            }
                        childList = itemEle.getElementsByTagName( "WSName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element wsNameEle = ( Element ) childList.item( 0 );
                textNode = wsNameEle.getFirstChild();
                if ( null != textNode ) {
                    wsName = textNode.getNodeValue();
                    mVector.addElement( wsName );
                }
            } else {
                                continue;
            }
                        childList = itemEle.getElementsByTagName( "RoleName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element roleNameEle = ( Element ) childList.item( 0 );
                textNode = roleNameEle.getFirstChild();
                if ( null != textNode ) {
                    roleName = textNode.getNodeValue();
                    mVector.addElement( roleName );
                }
            } else {
                                continue;
            }
            result.add( mVector );
        }
        return result;
    }
    
    private Vector getUserIDITEM( String vWSARName, String vWSName,
                                  String vRoleName ) {
        Vector result = new Vector();
        if ( this.useDataBase ) {
            try {
                Statement stmt = conn.createStatement( ResultSet.
                    TYPE_SCROLL_INSENSITIVE,
                    ResultSet.CONCUR_READ_ONLY );
                String strSQL = "Select " + ITEM_USERID + " From "
                    + JDBC_Database +
                    " WHERE " + ITEM_WSARNAME + "='" + vWSARName + "' And " +
                    ITEM_WSNAME + "='" + vWSName + "' And " + ITEM_ROLENAME
                    + "='" + vRoleName + "'";
                ResultSet rs = stmt.executeQuery( strSQL );
                while ( rs.next() ) {
                    result.addElement( rs.getString( 1 ) );
                }
                stmt.close();
                return result;
            } catch ( Exception e ) {
                e.printStackTrace();
                return null;
            }
        }
                Node textNode = null;
        Element itemEle = null;
        int userID = -1;
        String wsarName = null;
        String wsName = null;
        String roleName = null;
                NodeList tmpList = this.userDoc.getElementsByTagName( "Item" );
        for ( int i = 0; i < tmpList.getLength(); i++ ) {
            itemEle = ( Element ) tmpList.item( i );
                        NodeList childList = itemEle.getElementsByTagName( "WSARName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element wsarNameEle = ( Element ) childList.item( 0 );
                textNode = wsarNameEle.getFirstChild();
                if ( null != textNode ) {
                    wsarName = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( !wsarName.equalsIgnoreCase( vWSARName ) ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "WSName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element wsNameEle = ( Element ) childList.item( 0 );
                textNode = wsNameEle.getFirstChild();
                if ( null != textNode ) {
                    wsName = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( !wsName.equalsIgnoreCase( vWSName ) ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "RoleName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element roleNameEle = ( Element ) childList.item( 0 );
                textNode = roleNameEle.getFirstChild();
                if ( null != textNode ) {
                    roleName = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( !roleName.equalsIgnoreCase( vRoleName ) ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "UserID" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    userID = Integer.parseInt( textNode.getNodeValue() );
                }
            } else {
                                continue;
            }
            result.add( new Integer( userID ) );
        }
        return result;
    }
    
    private Vector getItemValue( String vIndex, int vValue ) {
        Vector result = new Vector();
        if ( this.useDataBase ) {
            try {
                if ( conn == null ) {
                    conn = this.getConnection();
                }
                Statement stmt = conn.createStatement( ResultSet.
                    TYPE_SCROLL_INSENSITIVE,
                    ResultSet.CONCUR_READ_ONLY );
                String strSQL = "select * from " + JDBC_Database + " Where " +
                    vIndex + " =" + vValue;
                ResultSet rs = stmt.executeQuery( strSQL );
                while ( rs.next() ) {
                    Vector rec_vector = new Vector();
                    rec_vector.addElement( rs.getString( 1 ) );
                    rec_vector.addElement( rs.getString( 2 ) );
                    rec_vector.addElement( rs.getString( 3 ) );
                    rec_vector.addElement( rs.getString( 4 ) );
                    result.addElement( rec_vector );
                }
                stmt.close();
                return result;
            } catch ( Exception e ) {
                log.debug( e );
                return null;
            }
        }
                Node textNode = null;
        Element itemEle = null;
        int indexValue = -1;
        int userID = -1;
        String wsarName = null;
        String wsName = null;
        String roleName = null;
                if( vIndex.equalsIgnoreCase( "userid" ) ){
            vIndex = "UserID";
        }else if( vIndex.equalsIgnoreCase( "wsarname" ) ){
            vIndex = "WSARName";
        }else if( vIndex.equalsIgnoreCase( "wsname" ) ){
            vIndex = "WSName";
        }else if( vIndex.equalsIgnoreCase( "rolename" ) ){
            vIndex = "RoleName";
        }
                NodeList tmpList = this.userDoc.getElementsByTagName( "Item" );
        for ( int i = 0; i < tmpList.getLength(); i++ ) {
            itemEle = ( Element ) tmpList.item( i );
            Vector mVector = new Vector();
                        NodeList childList = itemEle.getElementsByTagName( vIndex );
            if ( null != childList && 0 != childList.getLength() ) {
                Element indexEle = ( Element ) childList.item( 0 );
                textNode = indexEle.getFirstChild();
                if ( null != textNode ) {
                    indexValue = Integer.parseInt( textNode.getNodeValue() );
                }
            } else {
                                continue;
            }
            if ( indexValue != vValue ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "UserID" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    userID = Integer.parseInt( textNode.getNodeValue() );
                    mVector.addElement( new Integer( userID ) );
                }
            } else {
                                continue;
            }
                        childList = itemEle.getElementsByTagName( "WSARName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element wsarNameEle = ( Element ) childList.item( 0 );
                textNode = wsarNameEle.getFirstChild();
                if ( null != textNode ) {
                    wsarName = textNode.getNodeValue();
                    mVector.addElement( wsarName );
                }
            } else {
                                continue;
            }
                        childList = itemEle.getElementsByTagName( "WSName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element wsNameEle = ( Element ) childList.item( 0 );
                textNode = wsNameEle.getFirstChild();
                if ( null != textNode ) {
                    wsName = textNode.getNodeValue();
                    mVector.addElement( wsName );
                }
            } else {
                                continue;
            }
                        childList = itemEle.getElementsByTagName( "RoleName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element roleNameEle = ( Element ) childList.item( 0 );
                textNode = roleNameEle.getFirstChild();
                if ( null != textNode ) {
                    roleName = textNode.getNodeValue();
                    mVector.addElement( roleName );
                }
            } else {
                                continue;
            }
            result.add( mVector );
        }
        return result;
    }
    
    private void setItemValue( Vector oldVect, Vector newVect ) throws
        Exception {
                if ( oldVect == null || newVect == null ||
             oldVect.size() != 4 || newVect.size() != 4 ) {
            return;
        }
                int vUserID = -1;
        String vWSARName = null;
        String vWSName = null;
        String vRoleName = null;
        if ( this.useDataBase ) {
            try {
                if ( conn == null ) {
                    conn = this.getConnection();
                }
                Statement stmt = conn.createStatement( ResultSet.
                    TYPE_SCROLL_SENSITIVE,
                    ResultSet.CONCUR_UPDATABLE );
                                vUserID = ( ( Integer ) newVect.elementAt( 0 ) ).intValue();
                vWSARName = ( String ) newVect.elementAt( 1 );
                vWSName = ( String ) newVect.elementAt( 2 );
                vRoleName = ( String ) newVect.elementAt( 3 );
                String strSQL = "Update " + JDBC_Database + " Set "
                    + ITEM_USERID +
                    "=" + vUserID + " , " + ITEM_WSARNAME + "='" + vWSARName
                    + "' , " + ITEM_WSNAME + "='" + vWSName + "' , " +
                    ITEM_ROLENAME + "='" + vRoleName + "'";
                                vUserID = ( ( Integer ) oldVect.elementAt( 0 ) ).intValue();
                vWSARName = ( String ) oldVect.elementAt( 1 );
                vWSName = ( String ) oldVect.elementAt( 2 );
                vRoleName = ( String ) oldVect.elementAt( 3 );
                strSQL = strSQL + " Where " + ITEM_USERID + "=" + vUserID
                    + " AND "
                    + ITEM_WSARNAME + "='" + vWSARName + "' AND " + ITEM_WSNAME +
                    "='" + vWSName + "' AND " + ITEM_ROLENAME + "='"
                    + vRoleName
                    + "'";
                                if ( stmt.executeUpdate( strSQL ) == 0 ) {
                    throw new Exception(
                        "The Error occurs when Server is operating RBAC Database..." );
                }
                stmt.close();
            } catch ( Exception e ) {
                log.debug( e );
                log.info( Message.getMessage(
                    "The Error occurs when Server is operating RBAC Database..." ) );
                throw e;
            }
        }
                Node textNode = null;
        Element itemEle = null;
        int userID = -1;
        String wsarName = null;
        String wsName = null;
        String roleName = null;
                NodeList tmpList = this.userDoc.getElementsByTagName( "Item" );
        for ( int i = 0; i < tmpList.getLength(); i++ ) {
            itemEle = ( Element ) tmpList.item( i );
                        vUserID = ( ( Integer ) oldVect.elementAt( 0 ) ).intValue();
            vWSARName = ( String ) oldVect.elementAt( 1 );
            vWSName = ( String ) oldVect.elementAt( 2 );
            vRoleName = ( String ) oldVect.elementAt( 3 );
                        NodeList childList = itemEle.getElementsByTagName( "UserID" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    userID = Integer.parseInt( textNode.getNodeValue() );
                }
            } else {
                                continue;
            }
            if ( userID != vUserID ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "WSARName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element wsarNameEle = ( Element ) childList.item( 0 );
                textNode = wsarNameEle.getFirstChild();
                if ( null != textNode ) {
                    wsarName = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( wsarName.equalsIgnoreCase( vWSARName ) ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "WSName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element wsNameEle = ( Element ) childList.item( 0 );
                textNode = wsNameEle.getFirstChild();
                if ( null != textNode ) {
                    wsName = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( wsName.equalsIgnoreCase( vWSName ) ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "RoleName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element roleNameEle = ( Element ) childList.item( 0 );
                textNode = roleNameEle.getFirstChild();
                if ( null != textNode ) {
                    roleName = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( !roleName.equalsIgnoreCase( vRoleName ) ) {
                continue;
            }
                                    vUserID = ( ( Integer ) newVect.elementAt( 0 ) ).intValue();
            vWSARName = ( String ) newVect.elementAt( 1 );
            vWSName = ( String ) newVect.elementAt( 2 );
            vRoleName = ( String ) newVect.elementAt( 3 );
            Element newEle = userDoc.createElement( "Item" );
            Element tmpEle = userDoc.createElement( "UserID" );
            newEle.appendChild( tmpEle );
            textNode = userDoc.createTextNode( String.valueOf( vUserID ) );
            tmpEle.appendChild( textNode );
            tmpEle = userDoc.createElement( "WSARName" );
            newEle.appendChild( tmpEle );
            textNode = userDoc.createTextNode( vWSARName );
            tmpEle.appendChild( textNode );
            tmpEle = userDoc.createElement( "WSName" );
            newEle.appendChild( tmpEle );
            textNode = userDoc.createTextNode( vWSName );
            tmpEle.appendChild( textNode );
            tmpEle = userDoc.createElement( "RoleName" );
            newEle.appendChild( tmpEle );
            textNode = userDoc.createTextNode( vRoleName );
            tmpEle.appendChild( textNode );
            this.userDoc.replaceChild( newEle, itemEle );
                        try {
                FileOutputStream fout = new FileOutputStream( this.mFilePath );
                fout.write( DOMWriter.nodeToString( this.userDoc ).getBytes() );
                fout.close();
            } catch ( Exception e ) {
                e.printStackTrace();
            }
        }
    }
    
    private void addItem( int vUserID, String vWSARName,
                          String vWSName, String vRoleName ) throws Exception {
        if ( this.useDataBase ) {
            try {
                if ( conn == null ) {
                    conn = this.getConnection();
                }
                Statement stmt = conn.createStatement( ResultSet.
                    TYPE_SCROLL_SENSITIVE,
                    ResultSet.CONCUR_UPDATABLE );
                String strSQL = "Insert Into " + JDBC_Database + " Values (" +
                    vUserID + ",'" + vWSARName + "','" + vWSName + "','" +
                    vRoleName + "')";
                if ( stmt.executeUpdate( strSQL ) == 0 ) {
                    throw new Exception( "Not Added." );
                }
                stmt.close();
            } catch ( Exception e ) {
                log.debug( e );
                log.info( Message.getMessage(
                    "The Error occurs when Server is operating RBAC Database..." ) );
                throw e;
            }
        }
                Node textNode = null;
        Element itemEle = null;
        int userID = -1;
        String wsarName = null;
        String wsName = null;
        String roleName = null;
                NodeList tmpList = this.userDoc.getElementsByTagName( "Item" );
        for ( int i = 0; i < tmpList.getLength(); i++ ) {
            itemEle = ( Element ) tmpList.item( i );
                        NodeList childList = itemEle.getElementsByTagName( "UserID" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    userID = Integer.parseInt( textNode.getNodeValue() );
                }
            } else {
                                continue;
            }
            if ( userID != vUserID ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "WSARName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element wsarNameEle = ( Element ) childList.item( 0 );
                textNode = wsarNameEle.getFirstChild();
                if ( null != textNode ) {
                    wsarName = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( !wsarName.equalsIgnoreCase( vWSARName ) ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "WSName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element wsNameEle = ( Element ) childList.item( 0 );
                textNode = wsNameEle.getFirstChild();
                if ( null != textNode ) {
                    wsName = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( !wsName.equalsIgnoreCase( vWSName ) ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "RoleName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element roleNameEle = ( Element ) childList.item( 0 );
                textNode = roleNameEle.getFirstChild();
                if ( null != textNode ) {
                    roleName = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( roleName.equalsIgnoreCase( vRoleName ) ) {
                                return;
            }
        }
                Element newEle = userDoc.createElement( "Item" );
        Element tmpEle = userDoc.createElement( "UserID" );
        newEle.appendChild( tmpEle );
        textNode = userDoc.createTextNode( String.valueOf( vUserID ) );
        tmpEle.appendChild( textNode );
        tmpEle = userDoc.createElement( "WSARName" );
        newEle.appendChild( tmpEle );
        textNode = userDoc.createTextNode( vWSARName );
        tmpEle.appendChild( textNode );
        tmpEle = userDoc.createElement( "WSName" );
        newEle.appendChild( tmpEle );
        textNode = userDoc.createTextNode( vWSName );
        tmpEle.appendChild( textNode );
        tmpEle = userDoc.createElement( "RoleName" );
        newEle.appendChild( tmpEle );
        textNode = userDoc.createTextNode( vRoleName );
        tmpEle.appendChild( textNode );
        this.userDoc.getFirstChild().appendChild( newEle );
                try {
            FileOutputStream fout = new FileOutputStream( this.mFilePath );
            fout.write( DOMWriter.nodeToString( this.userDoc ).getBytes() );
            fout.close();
        } catch ( Exception e ) {
            e.printStackTrace();
        }
    }
        
    private void delItem( int vUserID, String vWSARName,
                          String vWSName, String vRoleName ) throws Exception {
        if ( this.useDataBase ) {
            try {
                if ( conn == null ) {
                    conn = this.getConnection();
                }
                Statement stmt = conn.createStatement( ResultSet.
                    TYPE_SCROLL_SENSITIVE,
                    ResultSet.CONCUR_UPDATABLE );
                String strSQL = "DELETE FROM " + JDBC_Database + " WHERE " +
                    ITEM_USERID + "=" + vUserID + " And " + ITEM_WSARNAME
                    + "='" +
                    vWSARName + "' And " + ITEM_WSNAME + "='" + vWSName
                    + "' And " +
                    ITEM_ROLENAME + "='" + vRoleName + "'";
                if ( stmt.executeUpdate( strSQL ) == 0 ) {
                    throw new Exception( "Not Deleted." );
                }
                stmt.close();
            } catch ( Exception e ) {
                log.debug( e );
                log.info( Message.getMessage
                          (
                    "The Error occurs when Server is operating RBAC Database..." ) );
                throw e;
            }
        }
                Node textNode = null;
        Element itemEle = null;
        int userID = -1;
        String wsarName = null;
        String wsName = null;
        String roleName = null;
        boolean modified = false;
                NodeList tmpList = this.userDoc.getElementsByTagName( "Item" );
        for ( int i = 0; i < tmpList.getLength(); i++ ) {
            itemEle = ( Element ) tmpList.item( i );
                        NodeList childList = itemEle.getElementsByTagName( "UserID" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    userID = Integer.parseInt( textNode.getNodeValue() );
                }
            } else {
                                continue;
            }
            if ( userID != vUserID ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "WSARName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element wsarNameEle = ( Element ) childList.item( 0 );
                textNode = wsarNameEle.getFirstChild();
                if ( null != textNode ) {
                    wsarName = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( !wsarName.equalsIgnoreCase( vWSARName ) ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "WSName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element wsNameEle = ( Element ) childList.item( 0 );
                textNode = wsNameEle.getFirstChild();
                if ( null != textNode ) {
                    wsName = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( !wsName.equalsIgnoreCase( vWSName ) ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "RoleName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element roleNameEle = ( Element ) childList.item( 0 );
                textNode = roleNameEle.getFirstChild();
                if ( null != textNode ) {
                    roleName = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( roleName.equalsIgnoreCase( vRoleName ) ) {
                                this.userDoc.getFirstChild().removeChild( itemEle );
                modified = true;
            }
        }
                if( modified ){
            try {
                FileOutputStream fout = new FileOutputStream( this.mFilePath );
                fout.write( DOMWriter.nodeToString( this.userDoc ).getBytes() );
                fout.close();
            } catch ( Exception e ) {
                e.printStackTrace();
            }
        }
    }
    
    private Connection getConnection() throws ClassNotFoundException,
        SQLException {
        Connection conn = null;
                Class.forName( JDBC_Driver );
                conn = DriverManager.getConnection( JDBC_URL, JDBC_Username,
                                            JDBC_Password );
        return conn;
    }
    
    public void close() {
        try {
            if ( conn != null ) {
                conn.close();
                conn = null;
            }
        } catch ( Exception e ) {
            log.debug( e );
        }
    }
    
    public static Vector parseRole( String vrole ) {
        Vector rolename = new Vector();
        char[] chars = vrole.toCharArray();
        int start = 0;
        int number = 0;
        for ( int i = 0; i < chars.length; i++ ) {
            if ( chars[i] == '.' ) {
                rolename.addElement( vrole.copyValueOf( chars, start, i - start ) );
                start = i + 1;
                number++;
                if ( number == 2 ) {
                    break;
                }
            }
        }
        rolename.addElement( vrole.copyValueOf( chars, start,
                                                chars.length - start ) );
        return rolename;
    }
}
