package org.act.soap.server.secmanager;
import java.sql.*;
import java.util.*;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import org.act.soap.util.logging.*;
import org.w3c.dom.Document;
import org.w3c.dom.NodeList;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.act.xdsec.util.DOMWriter;

public class UserManager {
    public static final String GUEST_USERNAME = "guest";
    public static final int GUEST_USERID = 0;
    public static final int INVALID_USERID = -1;
    
    private static Log log = LogFactory.getLog( UserManager.class.getName() );
    private String JDBC_Driver;
    private String JDBC_URL;
    private String JDBC_Username;
    private String JDBC_Password;
    Connection conn = null;
        Document userDoc = null;
    String mFilePath = null;
    private boolean useDataBase = false;
    
    public UserManager ( String driver, String url, String username,
                         String password ) throws Exception {
        JDBC_Driver = driver;
        JDBC_URL = url;
        JDBC_Username = username;
        JDBC_Password = password;
        this.conn = getConnection();
        this.useDataBase = true;
    }
    
    public UserManager ( String filePath ) throws Exception {
        DocumentBuilderFactory documentBuilderFactory =
            DocumentBuilderFactory.newInstance();
        DocumentBuilder documentBuilder = documentBuilderFactory.
            newDocumentBuilder();
        this.userDoc = documentBuilder.parse( new FileInputStream( filePath ) );
        this.useDataBase = false;
        this.mFilePath = filePath;
    }
    protected void finalize () throws Throwable {
        this.close();
    }
    
    public String getUserName ( int userID ) {
        if ( userID == this.GUEST_USERID ) {
            return this.GUEST_USERNAME;
        }
        if ( this.useDataBase ) {
            Statement st;
            ResultSet rs;
            String userName = null;
            try {
                if ( conn == null ) {
                    conn = getConnection();
                }
                st = conn.createStatement();
                String strSql = "select * from UserInfo where UserID=" + userID;
                rs = st.executeQuery( strSql );
                if ( rs.next() ) {
                    userName = rs.getString( "UserName" );
                    rs.close();
                    st.close();
                }
                return userName;
            } catch ( Exception e ) {
                log.debug( e );
                                return null;
            }
        }
                Node textNode = null;
        String userIDValue = null;
        NodeList tmpList = this.userDoc.getElementsByTagName( "UserInfo" );
        Element tmpNode = ( Element ) tmpList.item( 0 );
        tmpList = tmpNode.getElementsByTagName( "Item" );
        for ( int i = 0; i < tmpList.getLength(); i++ ) {
            Element itemEle = ( Element ) tmpList.item( i );
            NodeList userIDList = itemEle.getElementsByTagName( "UserID" );
            if ( null != userIDList && 0 != userIDList.getLength() ) {
                Element userIDEle = ( Element ) userIDList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    userIDValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( userID == Integer.parseInt( userIDValue ) ) {
                                NodeList userNameList = itemEle.getElementsByTagName(
                    "UserName" );
                if ( null != userNameList && 0 != userNameList.getLength() ) {
                    Element userNameEle = ( Element ) userNameList.item( 0 );
                    textNode = userNameEle.getFirstChild();
                    if ( null != textNode ) {
                        return textNode.getNodeValue();
                    }
                } else {
                                        continue;
                }
            }
        }
                return null;
    }
    
    public int verifyPassword ( String userName, String passWord ) {
        if ( this.useDataBase ) {
                        String strSql = "select UserID from UserInfo where UserName='"
                + userName + "'";
            int localID = getLocalIDbySql( strSql );
            if ( localID == this.INVALID_USERID ) {
                return this.INVALID_USERID;             } else {
                strSql = "select UserID from UserProperty where UserID="
                    + localID
                    + " and PropertyName='PassWord' and PropertyValue='"
                    + passWord
                    + "'";
                localID = getLocalIDbySql( strSql );
                return localID;
            }
        }
                int localID = this.getUserID( userName );
        if ( localID == this.INVALID_USERID ) {
            return this.INVALID_USERID;         }
                Node textNode = null;
        String userIDValue = null;
        String propertyNameValue = null;
        String passwordValue = null;
        NodeList tmpList = this.userDoc.getElementsByTagName( "UserProperty" );
        Element tmpNode = ( Element ) tmpList.item( 0 );
        tmpList = tmpNode.getElementsByTagName( "Item" );
        for ( int i = 0; i < tmpList.getLength(); i++ ) {
            Element itemEle = ( Element ) tmpList.item( i );
                        NodeList childList = itemEle.getElementsByTagName( "UserID" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    userIDValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( localID != Integer.parseInt( userIDValue ) ) {
                                continue;
            }
                        childList = itemEle.getElementsByTagName( "PropertyName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    propertyNameValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( !propertyNameValue.equalsIgnoreCase( "PassWord" ) ) {
                                continue;
            }
                        childList = itemEle.getElementsByTagName( "PropertyValue" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    passwordValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( !passwordValue.equals( passWord ) ) {
                                continue;
            }else{
                return localID;
            }
        }
                return this.INVALID_USERID;
    }
    
    public int getIDbyDN ( String DN ) {
        if ( DN == null || DN.equals( "" ) ) {             return this.INVALID_USERID;
        }
        int localID = -1;
        if( this.useDataBase ){
                        String strSql =
                "select UserID from UserProperty where PropertyName='DN' and PropertyValue='"
                + DN + "'";
            localID = getLocalIDbySql( strSql );
            return localID;
        }
                Node textNode = null;
        String propertyValue = null;
        String propertyNameValue = null;
        NodeList tmpList = this.userDoc.getElementsByTagName( "UserProperty" );
        Element tmpNode = ( Element ) tmpList.item( 0 );
        tmpList = tmpNode.getElementsByTagName( "Item" );
        for ( int i = 0; i < tmpList.getLength(); i++ ) {
            Element itemEle = ( Element ) tmpList.item( i );
                        NodeList childList = itemEle.getElementsByTagName( "PropertyName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    propertyNameValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( !propertyNameValue.equalsIgnoreCase( "DN" ) ) {
                                continue;
            }
                        childList = itemEle.getElementsByTagName( "PropertyValue" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    propertyValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( !propertyValue.equalsIgnoreCase( DN ) ) {
                                continue;
            }
                        childList = itemEle.getElementsByTagName( "UserID" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    localID = Integer.parseInt( textNode.getNodeValue() );
                }
            } else {
                                continue;
            }
        }
        return localID;
    }
    
    public String getDNbyID ( int userID ) {
        String propertyValue = null;
        if( this.useDataBase ){
                        Statement st;
            ResultSet rs;
            try {
                if ( conn == null ) {
                    conn = getConnection();
                }
                st = conn.createStatement();
                String strSql = "select * from UserProperty where UserID="
                    + userID
                    + " and PropertyName='DN'";
                rs = st.executeQuery( strSql );
                if ( rs.next() ) {
                    propertyValue = rs.getString( "PropertyValue" );
                    rs.close();
                    st.close();
                }
                return propertyValue;
            } catch ( Exception e ) {
                e.printStackTrace();
                                return null;
            }
        }
                Node textNode = null;
        String userIDValue = null;
        String propertyNameValue = null;
        NodeList tmpList = this.userDoc.getElementsByTagName( "UserProperty" );
        Element tmpNode = ( Element ) tmpList.item( 0 );
        tmpList = tmpNode.getElementsByTagName( "Item" );
        for ( int i = 0; i < tmpList.getLength(); i++ ) {
            Element itemEle = ( Element ) tmpList.item( i );
                        NodeList childList = itemEle.getElementsByTagName( "UserID" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    userIDValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( userID != Integer.parseInt( userIDValue ) ) {
                                continue;
            }
                        childList = itemEle.getElementsByTagName( "PropertyName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    propertyNameValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( !propertyNameValue.equalsIgnoreCase( "DN" ) ) {
                                continue;
            }
                        childList = itemEle.getElementsByTagName( "PropertyValue" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    propertyValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
        }
        return propertyValue;
    }
    
    public int createUser ( String userName ) {
        int newID = this.INVALID_USERID;
        if( this.useDataBase ){
                                    Statement st;
            ResultSet rs;
            int result = 0;
            int total = 0;
            try {
                if ( conn == null ) {
                    conn = getConnection();
                }
                                st = conn.createStatement();
                String strSql = "select *  from UserInfo where UserName='"
                    + userName + "'";
                rs = st.executeQuery( strSql );
                while ( rs.next() ) {
                    total++;
                }
                if ( total == 0 ) {
                    strSql = "select max(UserID) as MaxLocalID from UserInfo";
                    rs = st.executeQuery( strSql );
                    if ( rs.next() ) {
                        newID = rs.getInt( "MaxLocalID" );
                    }
                    rs.close();
                                        newID++;
                    strSql = "insert into UserInfo (UserID,UserName) values("
                        + newID + ",'" + userName + "'" + ")";
                    int r = st.executeUpdate( strSql );
                    st.close();
                }
                return newID;
            } catch ( Exception e ) {
                e.printStackTrace();
                                return this.INVALID_USERID;
            }
        }
                int maxID = this.INVALID_USERID;
        Node textNode = null;
        String userIDValue = null;
        String userNameValue = null;
                NodeList tmpList = this.userDoc.getElementsByTagName( "UserInfo" );
        Element tmpNode = ( Element ) tmpList.item( 0 );
        tmpList = tmpNode.getElementsByTagName( "Item" );
        for ( int i = 0; i < tmpList.getLength(); i++ ) {
            Element itemEle = ( Element ) tmpList.item( i );
            NodeList childList = itemEle.getElementsByTagName( "UserID" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    userIDValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( maxID < Integer.parseInt( userIDValue ) ) {
                maxID = Integer.parseInt( userIDValue );
            }
            childList = itemEle.getElementsByTagName( "UserName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    userNameValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( userNameValue.equals( userName ) ) {
                return this.INVALID_USERID;
            }
        }
                newID = ++maxID;
        Node textNode1 = this.userDoc.createTextNode( "\n" );
        Element newEle = userDoc.createElement( "Item" );
        tmpNode.appendChild( textNode1 );
        tmpNode.appendChild( newEle );
        tmpNode.appendChild( textNode1 );
        Element tmpEle = userDoc.createElement( "UserID" );
        tmpNode.appendChild( textNode1 );
        newEle.appendChild( tmpEle );
        tmpNode.appendChild( textNode1 );
        textNode = userDoc.createTextNode( String.valueOf( maxID ) );
        tmpEle.appendChild( textNode );
        tmpEle = userDoc.createElement( "UserName" );
        tmpNode.appendChild( textNode1 );
        newEle.appendChild( tmpEle );
        tmpNode.appendChild( textNode1 );
        textNode = userDoc.createTextNode( userName );
        tmpEle.appendChild( textNode );
                try {
            FileOutputStream fout = new FileOutputStream( this.mFilePath );
            fout.write( DOMWriter.nodeToString( this.userDoc ).getBytes() );
            fout.close();
        } catch ( Exception e ) {
            e.printStackTrace();
        }
        return newID;
    }
    
    public boolean setProperty ( int userID, String propertyName,
                                 String propertyValue ) {
                if ( modifyProperty( userID, propertyName, propertyValue ) ) {
            return true;
        }
        if( this.useDataBase ){
                        Statement st;
            ResultSet rs;
            boolean bUserFound = false;
            int total = 0;
            try {
                if ( conn == null ) {
                    conn = getConnection();
                }
                st = conn.createStatement();
                String strSql = "select * from UserProperty where UserID=" +
                    userID + " and PropertyName='" + propertyName + "'";
                rs = st.executeQuery( strSql );
                while ( rs.next() ) {
                    total++;
                }
                rs.close();
                st.close();
            } catch ( Exception e ) {
                e.printStackTrace();
                                return false;
            }
            if ( total == 0 ) {
                String strSql =
                    "insert into UserProperty (UserID,PropertyName,PropertyValue) values (" +
                    userID + ",'" + propertyName + "','" + propertyValue + "')";
                if ( !updateDBbySql( strSql ) ) {
                    return false;
                }
            }else{
                return false;
            }
            return true;
        }
                int maxID = this.INVALID_USERID;
        Node textNode = null;
        String userIDValue = null;
        String propertyNameValue = null;
        String propertyValueValue = null;
                NodeList tmpList = this.userDoc.getElementsByTagName( "UserProperty" );
        Element tmpNode = ( Element ) tmpList.item( 0 );
        tmpList = tmpNode.getElementsByTagName( "Item" );
        for ( int i = 0; i < tmpList.getLength(); i++ ) {
            Element itemEle = ( Element ) tmpList.item( i );
                        NodeList childList = itemEle.getElementsByTagName( "UserID" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    userIDValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( userID != Integer.parseInt( userIDValue ) ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "PropertyName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    propertyNameValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( !propertyNameValue.equals( propertyName ) ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "PropertyValue" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    propertyValueValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
                        if ( propertyValueValue.equals( propertyValue ) ) {
                return false;
            }
        }
                Element newEle = userDoc.createElement( "Item" );
        tmpNode.appendChild( newEle );
        Element tmpEle = userDoc.createElement( "UserID" );
        newEle.appendChild( tmpEle );
        textNode = userDoc.createTextNode( String.valueOf( userID ) );
        tmpEle.appendChild( textNode );
        tmpEle = userDoc.createElement( "PropertyName" );
        newEle.appendChild( tmpEle );
        textNode = userDoc.createTextNode( propertyName );
        tmpEle.appendChild( textNode );
        tmpEle = userDoc.createElement( "PropertyValue" );
        newEle.appendChild( tmpEle );
        textNode = userDoc.createTextNode( propertyValue );
        tmpEle.appendChild( textNode );
                try {
            FileOutputStream fout = new FileOutputStream( this.mFilePath );
            fout.write( DOMWriter.nodeToString( this.userDoc ).getBytes() );
            fout.close();
        } catch ( Exception e ) {
            e.printStackTrace();
            return false;
        }
        return true;
    }
    
    public boolean deleteLocalUser ( int userID ) {
        if( this.useDataBase ){
            String strSql = "delete from UserInfo where UserID=" + userID;
            if ( updateDBbySql( strSql ) ) {
                String strSql2 = "delete from UserProperty where UserID=" + userID;
                if ( updateDBbySql( strSql2 ) ) {
                    return true;                 } else {
                    return false;                 }
            } else {
                return false;             }
        }
                Node textNode = null;
        String userIDValue = null;
                NodeList tmpList = this.userDoc.getElementsByTagName( "UserInfo" );
        Element tmpNode = ( Element ) tmpList.item( 0 );
        tmpList = tmpNode.getElementsByTagName( "Item" );
        for ( int i = 0; i < tmpList.getLength(); i++ ) {
            Element itemEle = ( Element ) tmpList.item( i );
                        NodeList childList = itemEle.getElementsByTagName( "UserID" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    userIDValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( userID == Integer.parseInt( userIDValue ) ) {
                tmpNode.removeChild( itemEle );
            }
        }
                tmpList = this.userDoc.getElementsByTagName( "UserProperty" );
        tmpNode = ( Element ) tmpList.item( 0 );
        tmpList = tmpNode.getElementsByTagName( "Item" );
        for ( int i = 0; i < tmpList.getLength(); i++ ) {
            Element itemEle = ( Element ) tmpList.item( i );
                        NodeList childList = itemEle.getElementsByTagName( "UserID" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    userIDValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( userID == Integer.parseInt( userIDValue ) ) {
                tmpNode.removeChild( itemEle );
            }
        }
                try {
            FileOutputStream fout = new FileOutputStream( this.mFilePath );
            fout.write( DOMWriter.nodeToString( this.userDoc ).getBytes() );
            fout.close();
        } catch ( Exception e ) {
            e.printStackTrace();
            return false;
        }
        return true;
    }
    
    public boolean delPassword ( int userID ) {
        if( this.useDataBase ){
            String strSql = "update UserInfo set UserName='' where UserID="
                + userID;
            if ( updateDBbySql( strSql ) ) {
                strSql =
                    "update UserProperty set PropertyValue='' where UserID="
                    + userID + "and PropertyName='PassWord'";
                if ( updateDBbySql( strSql ) ) {
                    return true;
                } else {
                    return false;
                }
            } else {
                return false;
            }
        }
                Node textNode = null;
        String userIDValue = null;
        String propertyNameValue = null;
                NodeList tmpList = this.userDoc.getElementsByTagName( "UserInfo" );
        Element tmpNode = ( Element ) tmpList.item( 0 );
        tmpList = tmpNode.getElementsByTagName( "Item" );
        for ( int i = 0; i < tmpList.getLength(); i++ ) {
            Element itemEle = ( Element ) tmpList.item( i );
                        NodeList childList = itemEle.getElementsByTagName( "UserID" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    userIDValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( userID != Integer.parseInt( userIDValue ) ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "UserName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userNameEle = ( Element ) childList.item( 0 );
                textNode = userNameEle.getFirstChild();
                if ( null != textNode ) {
                    userNameEle.removeChild( textNode );
                }
            } else {
                                continue;
            }
        }
                tmpList = this.userDoc.getElementsByTagName( "UserProperty" );
        tmpNode = ( Element ) tmpList.item( 0 );
        tmpList = tmpNode.getElementsByTagName( "Item" );
        for ( int i = 0; i < tmpList.getLength(); i++ ) {
            Element itemEle = ( Element ) tmpList.item( i );
                        NodeList childList = itemEle.getElementsByTagName( "UserID" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    userIDValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( userID != Integer.parseInt( userIDValue ) ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "PropertyName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element propNameEle = ( Element ) childList.item( 0 );
                textNode = propNameEle.getFirstChild();
                if ( null != textNode ) {
                    propertyNameValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( !propertyNameValue.equalsIgnoreCase( "PassWord" ) ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "PropertyValue" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element propValueEle = ( Element ) childList.item( 0 );
                textNode = propValueEle.getFirstChild();
                if ( null != textNode ) {
                    propValueEle.removeChild( textNode );
                }
            } else {
                                continue;
            }
        }
                try {
            FileOutputStream fout = new FileOutputStream( this.mFilePath );
            fout.write( DOMWriter.nodeToString( this.userDoc ).getBytes() );
            fout.close();
        } catch ( Exception e ) {
            e.printStackTrace();
            return false;
        }
        return true;
    }
    
    public boolean delDN ( int userID ) {
        if( this.useDataBase ){
            String strSql =
                "update UserProperty set PropertyValue='' where UserID="
                + userID
                + "and PropertyName='DN'";
            if ( updateDBbySql( strSql ) ) {
                return true;
            } else {
                return false;
            }
        }
                Node textNode = null;
        String userIDValue = null;
        String propertyNameValue = null;
                NodeList tmpList = this.userDoc.getElementsByTagName( "UserProperty" );
        Element tmpNode = ( Element ) tmpList.item( 0 );
        tmpList = tmpNode.getElementsByTagName( "Item" );
        for ( int i = 0; i < tmpList.getLength(); i++ ) {
            Element itemEle = ( Element ) tmpList.item( i );
                        NodeList childList = itemEle.getElementsByTagName( "UserID" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    userIDValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( userID != Integer.parseInt( userIDValue ) ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "PropertyName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element propNameEle = ( Element ) childList.item( 0 );
                textNode = propNameEle.getFirstChild();
                if ( null != textNode ) {
                    propertyNameValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( !propertyNameValue.equalsIgnoreCase( "DN" ) ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "PropertyValue" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element propValueEle = ( Element ) childList.item( 0 );
                textNode = propValueEle.getFirstChild();
                if ( null != textNode ) {
                    propValueEle.removeChild( textNode );
                }
            } else {
                                continue;
            }
        }
                try {
            FileOutputStream fout = new FileOutputStream( this.mFilePath );
            fout.write( DOMWriter.nodeToString( this.userDoc ).getBytes() );
            fout.close();
        } catch ( Exception e ) {
            e.printStackTrace();
            return false;
        }
        return true;
    }
    
    public boolean deleteUserProperty ( int userID, String userProperty ) {
        if( this.useDataBase ){
            String strSql = "delete from UserProperty where UserID=" + userID
                + "and PropertyName='" + userProperty + "'";
            if ( updateDBbySql( strSql ) ) {
                return true;
            } else {
                return false;
            }
        }
                Node textNode = null;
        String userIDValue = null;
        String propertyNameValue = null;
                NodeList tmpList = this.userDoc.getElementsByTagName( "UserProperty" );
        Element tmpNode = ( Element ) tmpList.item( 0 );
        tmpList = tmpNode.getElementsByTagName( "Item" );
        for ( int i = 0; i < tmpList.getLength(); i++ ) {
            Element itemEle = ( Element ) tmpList.item( i );
                        NodeList childList = itemEle.getElementsByTagName( "UserID" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    userIDValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( userID != Integer.parseInt( userIDValue ) ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "PropertyName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element propNameEle = ( Element ) childList.item( 0 );
                textNode = propNameEle.getFirstChild();
                if ( null != textNode ) {
                    propertyNameValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( !propertyNameValue.equalsIgnoreCase( userProperty ) ) {
                continue;
            }
                        tmpNode.removeChild( itemEle );
        }
                try {
            FileOutputStream fout = new FileOutputStream( this.mFilePath );
            fout.write( DOMWriter.nodeToString( this.userDoc ).getBytes() );
            fout.close();
        } catch ( Exception e ) {
            e.printStackTrace();
            return false;
        }
        return true;
    }
    
    public boolean modifyUserName ( int userID, String userName ) {
        if( this.useDataBase ){
            String strSql = "update UserInfo set UserName='" + userName
                + "' where UserID=" + userID;
            if ( updateDBbySql( strSql ) ) {
                return true;
            } else {
                return false;
            }
        }
                Node textNode = null;
        String userIDValue = null;
                NodeList tmpList = this.userDoc.getElementsByTagName( "UserInfo" );
        Element tmpNode = ( Element ) tmpList.item( 0 );
        tmpList = tmpNode.getElementsByTagName( "Item" );
        for ( int i = 0; i < tmpList.getLength(); i++ ) {
            Element itemEle = ( Element ) tmpList.item( i );
                        NodeList childList = itemEle.getElementsByTagName( "UserID" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    userIDValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( userID != Integer.parseInt( userIDValue ) ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "UserName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userNameEle = ( Element ) childList.item( 0 );
                textNode = userNameEle.getFirstChild();
                Node newNode = this.userDoc.createTextNode( userName );
                userNameEle.replaceChild( newNode, textNode );
            } else {
                                continue;
            }
        }
                try {
            FileOutputStream fout = new FileOutputStream( this.mFilePath );
            fout.write( DOMWriter.nodeToString( this.userDoc ).getBytes() );
            fout.close();
        } catch ( Exception e ) {
            e.printStackTrace();
            return false;
        }
        return true;
    }
    
    public boolean modifyPassword ( int userID, String PassWord ) {
        if( this.useDataBase ){
            String strSql = "update UserProperty set PropertyValue='"
                + PassWord
                + "' where UserID=" + userID
                + " and PropertyName='PassWord'";
            if ( updateDBbySql( strSql ) ) {
                return true;
            } else {
                return false;
            }
        }
                Node textNode = null;
        String userIDValue = null;
        String propertyNameValue = null;
                NodeList tmpList = this.userDoc.getElementsByTagName( "UserProperty" );
        Element tmpNode = ( Element ) tmpList.item( 0 );
        tmpList = tmpNode.getElementsByTagName( "Item" );
        for ( int i = 0; i < tmpList.getLength(); i++ ) {
            Element itemEle = ( Element ) tmpList.item( i );
                        NodeList childList = itemEle.getElementsByTagName( "UserID" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    userIDValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( userID != Integer.parseInt( userIDValue ) ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "PropertyName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element propNameEle = ( Element ) childList.item( 0 );
                textNode = propNameEle.getFirstChild();
                if ( null != textNode ) {
                    propertyNameValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( !propertyNameValue.equalsIgnoreCase( "PassWord" ) ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "PropertyValue" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element propValueEle = ( Element ) childList.item( 0 );
                textNode = propValueEle.getFirstChild();
                Node newNode = this.userDoc.createTextNode( PassWord );
                propValueEle.replaceChild( newNode, textNode );
            } else {
                                continue;
            }
        }
                try {
            FileOutputStream fout = new FileOutputStream( this.mFilePath );
            fout.write( DOMWriter.nodeToString( this.userDoc ).getBytes() );
            fout.close();
        } catch ( Exception e ) {
            e.printStackTrace();
            return false;
        }
        return true;
    }
    
    public boolean modifyDN ( int userID, String DN ) {
        if( this.useDataBase ){
            String strSql = "update UserProperty set PropertyValue='" + DN
                + "' where UserID=" + userID
                + " and PropertyName='DN'";
            if ( updateDBbySql( strSql ) ) {
                return true;
            } else {
                return false;
            }
        }
                Node textNode = null;
        String userIDValue = null;
        String propertyNameValue = null;
                NodeList tmpList = this.userDoc.getElementsByTagName( "UserProperty" );
        Element tmpNode = ( Element ) tmpList.item( 0 );
        tmpList = tmpNode.getElementsByTagName( "Item" );
        for ( int i = 0; i < tmpList.getLength(); i++ ) {
            Element itemEle = ( Element ) tmpList.item( i );
                        NodeList childList = itemEle.getElementsByTagName( "UserID" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    userIDValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( userID != Integer.parseInt( userIDValue ) ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "PropertyName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element propNameEle = ( Element ) childList.item( 0 );
                textNode = propNameEle.getFirstChild();
                if ( null != textNode ) {
                    propertyNameValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( !propertyNameValue.equalsIgnoreCase( "DN" ) ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "PropertyValue" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element propValueEle = ( Element ) childList.item( 0 );
                textNode = propValueEle.getFirstChild();
                Node newNode = this.userDoc.createTextNode( DN );
                propValueEle.replaceChild( newNode, textNode );
            } else {
                                continue;
            }
        }
                try {
            FileOutputStream fout = new FileOutputStream( this.mFilePath );
            fout.write( DOMWriter.nodeToString( this.userDoc ).getBytes() );
            fout.close();
        } catch ( Exception e ) {
            e.printStackTrace();
            return false;
        }
        return true;
    }
    
    public boolean modifyProperty ( int userID, String propertyName,
                                    String propertyValue ) {
        if( this.useDataBase ){
            String strSql = "update UserProperty set PropertyValue='"
                + propertyValue
                + "' where UserID=" + userID
                + " and PropertyName='" + propertyName + "'";
            if ( updateDBbySql( strSql ) ) {
                return true;
            } else {
                return false;
            }
        }
                Node textNode = null;
        String userIDValue = null;
        String propertyNameValue = null;
        boolean modified = false;
                NodeList tmpList = this.userDoc.getElementsByTagName( "UserProperty" );
        Element tmpNode = ( Element ) tmpList.item( 0 );
        tmpList = tmpNode.getElementsByTagName( "Item" );
        for ( int i = 0; i < tmpList.getLength(); i++ ) {
            Element itemEle = ( Element ) tmpList.item( i );
                        NodeList childList = itemEle.getElementsByTagName( "UserID" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    userIDValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( userID != Integer.parseInt( userIDValue ) ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "PropertyName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element propNameEle = ( Element ) childList.item( 0 );
                textNode = propNameEle.getFirstChild();
                if ( null != textNode ) {
                    propertyNameValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( !propertyNameValue.equalsIgnoreCase( propertyName ) ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "PropertyValue" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element propValueEle = ( Element ) childList.item( 0 );
                textNode = propValueEle.getFirstChild();
                Node newNode = this.userDoc.createTextNode( propertyValue );
                propValueEle.replaceChild( newNode, textNode );
                modified = true;
            } else {
                                continue;
            }
        }
        if( modified ){
                        try {
                FileOutputStream fout = new FileOutputStream( this.mFilePath );
                fout.write( DOMWriter.nodeToString( this.userDoc ).getBytes() );
                fout.close();
            } catch ( Exception e ) {
                e.printStackTrace();
                return false;
            }
        }else{
                        return false;
        }
        return true;
    }
    
    public int getUserID ( String userName ) {
        if ( userName.equalsIgnoreCase( this.GUEST_USERNAME ) ) {
            return this.GUEST_USERID;
        }
        if( this.useDataBase ){
            Statement st;
            ResultSet rs;
            int userID = this.INVALID_USERID;
            try {
                if ( conn == null ) {
                    conn = getConnection();
                }
                st = conn.createStatement();
                String strSql = "select * from UserInfo where UserName='"
                    + userName + "'";
                rs = st.executeQuery( strSql );
                if ( rs.next() ) {
                    userID = rs.getInt( "UserID" );
                    rs.close();
                    st.close();
                }
                return userID;
            } catch ( Exception e ) {
                                log.debug( e );
                return this.INVALID_USERID;
            }
        }
                Node textNode = null;
        String userNameValue = null;
        int userIDValue = this.INVALID_USERID;
                NodeList tmpList = this.userDoc.getElementsByTagName( "UserInfo" );
        Element tmpNode = ( Element ) tmpList.item( 0 );
        tmpList = tmpNode.getElementsByTagName( "Item" );
        for ( int i = 0; i < tmpList.getLength(); i++ ) {
            Element itemEle = ( Element ) tmpList.item( i );
                        NodeList childList = itemEle.getElementsByTagName( "UserName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userNameEle = ( Element ) childList.item( 0 );
                textNode = userNameEle.getFirstChild();
                if ( null != textNode ) {
                    userNameValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( !userName.equals( userNameValue ) ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "UserID" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    userIDValue = Integer.parseInt( textNode.getNodeValue() );
                }
            } else {
                                continue;
            }
        }
        return userIDValue;
    }
    
    public String getProperty ( int userID, String propertyName ) {
        if( this.useDataBase ){
            Statement st;
            ResultSet rs;
            String propertyValue = null;
            try {
                if ( conn == null ) {
                    conn = getConnection();
                }
                st = conn.createStatement();
                String strSql = "select * from UserProperty where UserID="
                    + userID
                    + " and PropertyName='" + propertyName + "'";
                rs = st.executeQuery( strSql );
                if ( rs.next() ) {
                    propertyValue = rs.getString( "PropertyValue" );
                    rs.close();
                    st.close();
                }
                return propertyValue;
            } catch ( Exception e ) {
                e.printStackTrace();
                                return null;
            }
        }
                Node textNode = null;
        int userIDValue = this.INVALID_USERID;
        String propNameValue = null;
        String propValueValue = null;
                NodeList tmpList = this.userDoc.getElementsByTagName( "UserProperty" );
        Element tmpNode = ( Element ) tmpList.item( 0 );
        tmpList = tmpNode.getElementsByTagName( "Item" );
        for ( int i = 0; i < tmpList.getLength(); i++ ) {
            Element itemEle = ( Element ) tmpList.item( i );
                        NodeList childList = itemEle.getElementsByTagName( "UserID" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    userIDValue = Integer.parseInt( textNode.getNodeValue() );
                }
            } else {
                                continue;
            }
            if ( userIDValue != userID ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "PropertyName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element propNameEle = ( Element ) childList.item( 0 );
                textNode = propNameEle.getFirstChild();
                if ( null != textNode ) {
                    propNameValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if ( !propNameValue.equals( propertyName ) ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "PropertyValue" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element propValueEle = ( Element ) childList.item( 0 );
                textNode = propValueEle.getFirstChild();
                if ( null != textNode ) {
                    propValueValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
        }
        return propValueValue;
    }
    
    public Hashtable getProperties ( int userID ) {
        Hashtable result = new Hashtable();
        if( this.useDataBase ){
            Statement st;
            ResultSet rs;
            try {
                if ( conn == null ) {
                    conn = getConnection();
                }
                st = conn.createStatement();
                String strSql = "select * from UserProperty where UserID="
                    + userID;
                rs = st.executeQuery( strSql );
                result = new Hashtable();
                while ( rs.next() ) {
                    String propertyName = rs.getString( "PropertyName" );
                    String propertyValue = rs.getString( "PropertyValue" );
                    result.put( propertyName, propertyValue );
                }
                rs.close();
                st.close();
            } catch ( Exception e ) {
                e.printStackTrace();
                            }
            return result;
        }
                Node textNode = null;
        int userIDValue = this.INVALID_USERID;
        String propNameValue = null;
        String propValueValue = null;
                NodeList tmpList = this.userDoc.getElementsByTagName( "UserProperty" );
        Element tmpNode = ( Element ) tmpList.item( 0 );
        tmpList = tmpNode.getElementsByTagName( "Item" );
        for ( int i = 0; i < tmpList.getLength(); i++ ) {
            Element itemEle = ( Element ) tmpList.item( i );
                        NodeList childList = itemEle.getElementsByTagName( "UserID" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    userIDValue = Integer.parseInt( textNode.getNodeValue() );
                }
            } else {
                                continue;
            }
            if ( userIDValue != userID ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "PropertyName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element propNameEle = ( Element ) childList.item( 0 );
                textNode = propNameEle.getFirstChild();
                if ( null != textNode ) {
                    propNameValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
                        childList = itemEle.getElementsByTagName( "PropertyValue" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element propValueEle = ( Element ) childList.item( 0 );
                textNode = propValueEle.getFirstChild();
                if ( null != textNode ) {
                    propValueValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            result.put( propNameValue, propValueValue );
        }
        return result;
    }
    
    public Vector getAllUserIDs () {
        Vector result = new Vector();
        if( this.useDataBase ){
            result.add( new Integer( this.GUEST_USERID ) );
            Statement st;
            ResultSet rs;
            boolean bUserFound = false;
            String sql = "select UserID from UserInfo order by UserID";
            try {
                if ( conn == null ) {
                    conn = getConnection();
                }
                st = conn.createStatement();
                rs = st.executeQuery( sql );
                while ( rs.next() ) {
                    result.add( new Integer( rs.getInt( "UserID" ) ) );
                }
                rs.close();
                st.close();
            } catch ( Exception e ) {
                                log.debug( e );
                return null;
            }
            return result;
        }
                Node textNode = null;
        int userIDValue = this.INVALID_USERID;
                NodeList tmpList = this.userDoc.getElementsByTagName( "UserInfo" );
        Element tmpNode = ( Element ) tmpList.item( 0 );
        tmpList = tmpNode.getElementsByTagName( "Item" );
        for ( int i = 0; i < tmpList.getLength(); i++ ) {
            Element itemEle = ( Element ) tmpList.item( i );
                        NodeList childList = itemEle.getElementsByTagName( "UserID" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    userIDValue = Integer.parseInt( textNode.getNodeValue() );
                }
            } else {
                                continue;
            }
            result.add( new Integer( userIDValue ) );
        }
        return result;
    }
    
    public boolean setPassword ( int userID, String password ) {
        if( this.useDataBase ){
            Statement st;
            ResultSet rs;
            boolean bUserFound = false;
            int total = 0;
            try {
                if ( conn == null ) {
                    conn = getConnection();
                }
                st = conn.createStatement();
                String strSql = "select * from UserProperty where UserID="
                    + userID
                    + " and PropertyName='PassWord'";
                rs = st.executeQuery( strSql );
                while ( rs.next() ) {
                    total++;
                }
                rs.close();
                st.close();
            } catch ( Exception e ) {
                                return false;
            }
            if ( total == 0 ) {
                String strSql =
                    "insert into UserProperty (UserID,PropertyName,PropertyValue) values ("
                    + userID + ",'PassWord','" + password + "')";
                if ( updateDBbySql( strSql ) ) {
                    return true;
                } else {
                    return false;
                }
            } else {
                return false;
            }
        }
                Node textNode = null;
        int userIDValue = this.INVALID_USERID;
        String propNameValue = null;
                NodeList tmpList = this.userDoc.getElementsByTagName( "UserProperty" );
        Element tmpNode = ( Element ) tmpList.item( 0 );
        tmpList = tmpNode.getElementsByTagName( "Item" );
        for ( int i = 0; i < tmpList.getLength(); i++ ) {
            Element itemEle = ( Element ) tmpList.item( i );
                        NodeList childList = itemEle.getElementsByTagName( "UserID" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    userIDValue = Integer.parseInt( textNode.getNodeValue() );
                }
            } else {
                                continue;
            }
            if ( userIDValue != userID ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "PropertyName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element propNameEle = ( Element ) childList.item( 0 );
                textNode = propNameEle.getFirstChild();
                if ( null != textNode ) {
                    propNameValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
                        if( propNameValue.equalsIgnoreCase( "PassWord" ) ){
                return false;
            }
        }
                Element newEle = userDoc.createElement( "Item" );
        tmpNode.appendChild( newEle );
        Element tmpEle = userDoc.createElement( "UserID" );
        newEle.appendChild( tmpEle );
        textNode = userDoc.createTextNode( String.valueOf( userID ) );
        tmpEle.appendChild( textNode );
        tmpEle = userDoc.createElement( "PropertyName" );
        newEle.appendChild( tmpEle );
        textNode = userDoc.createTextNode( "PassWord" );
        tmpEle.appendChild( textNode );
        tmpEle = userDoc.createElement( "PropertyValue" );
        newEle.appendChild( tmpEle );
        textNode = userDoc.createTextNode( password );
        tmpEle.appendChild( textNode );
                try {
            FileOutputStream fout = new FileOutputStream( this.mFilePath );
            fout.write( DOMWriter.nodeToString( this.userDoc ).getBytes() );
            fout.close();
        } catch ( Exception e ) {
            e.printStackTrace();
            return false;
        }
        return true;
    }
    
    public boolean setDN ( int userID, String DN ) {
        if( this.useDataBase ){
            Statement st;
            ResultSet rs;
            boolean bUserFound = false;
            int total = 0;
            try {
                if ( conn == null ) {
                    conn = getConnection();
                }
                st = conn.createStatement();
                String strSql = "select * from UserProperty where UserID="
                    + userID
                    + " and PropertyName='DN'";
                rs = st.executeQuery( strSql );
                while ( rs.next() ) {
                    total++;
                }
                rs.close();
                st.close();
            } catch ( Exception e ) {
                e.printStackTrace();
                                return false;
            }
            if ( total == 0 ) {
                String strSql =
                    "insert into UserProperty (UserID,PropertyName,PropertyValue) values ("
                    + userID + ",'DN','" + DN + "')";
                if ( updateDBbySql( strSql ) ) {
                    return true;
                } else {
                    return false;
                }
            } else {
                return false;
            }
        }
                Node textNode = null;
        int userIDValue = this.INVALID_USERID;
        String propNameValue = null;
                NodeList tmpList = this.userDoc.getElementsByTagName( "UserProperty" );
        Element tmpNode = ( Element ) tmpList.item( 0 );
        tmpList = tmpNode.getElementsByTagName( "Item" );
        for ( int i = 0; i < tmpList.getLength(); i++ ) {
            Element itemEle = ( Element ) tmpList.item( i );
                        NodeList childList = itemEle.getElementsByTagName( "UserID" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    userIDValue = Integer.parseInt( textNode.getNodeValue() );
                }
            } else {
                                continue;
            }
            if ( userIDValue != userID ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "PropertyName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element propNameEle = ( Element ) childList.item( 0 );
                textNode = propNameEle.getFirstChild();
                if ( null != textNode ) {
                    propNameValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
                        if( propNameValue.equalsIgnoreCase( "DN" ) ){
                return false;
            }
        }
                Element newEle = userDoc.createElement( "Item" );
        tmpNode.appendChild( newEle );
        Element tmpEle = userDoc.createElement( "UserID" );
        newEle.appendChild( tmpEle );
        textNode = userDoc.createTextNode( String.valueOf( userID ) );
        tmpEle.appendChild( textNode );
        tmpEle = userDoc.createElement( "PropertyName" );
        newEle.appendChild( tmpEle );
        textNode = userDoc.createTextNode( "DN" );
        tmpEle.appendChild( textNode );
        tmpEle = userDoc.createElement( "PropertyValue" );
        newEle.appendChild( tmpEle );
        textNode = userDoc.createTextNode( DN );
        tmpEle.appendChild( textNode );
                try {
            FileOutputStream fout = new FileOutputStream( this.mFilePath );
            fout.write( DOMWriter.nodeToString( this.userDoc ).getBytes() );
            fout.close();
        } catch ( Exception e ) {
            e.printStackTrace();
            return false;
        }
        return true;
    }
    
    public String getPassword ( int userID ) {
        if( this.useDataBase ){
            Statement st;
            ResultSet rs;
            String propertyValue = null;
            try {
                if ( conn == null ) {
                    conn = getConnection();
                }
                st = conn.createStatement();
                String strSql = "select * from UserProperty where UserID="
                    + userID
                    + " and PropertyName='PassWord'";
                rs = st.executeQuery( strSql );
                if ( rs.next() ) {
                    propertyValue = rs.getString( "PropertyValue" );
                    rs.close();
                    st.close();
                }
                return propertyValue;
            } catch ( Exception e ) {
                e.printStackTrace();
                return null;
            }
        }
                Node textNode = null;
        int userIDValue = this.INVALID_USERID;
        String propNameValue = null;
        String propValueValue = null;
                NodeList tmpList = this.userDoc.getElementsByTagName( "UserProperty" );
        Element tmpNode = ( Element ) tmpList.item( 0 );
        tmpList = tmpNode.getElementsByTagName( "Item" );
        for ( int i = 0; i < tmpList.getLength(); i++ ) {
            Element itemEle = ( Element ) tmpList.item( i );
                        NodeList childList = itemEle.getElementsByTagName( "UserID" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    userIDValue = Integer.parseInt( textNode.getNodeValue() );
                }
            } else {
                                continue;
            }
            if ( userIDValue != userID ) {
                continue;
            }
                        childList = itemEle.getElementsByTagName( "PropertyName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element propNameEle = ( Element ) childList.item( 0 );
                textNode = propNameEle.getFirstChild();
                if ( null != textNode ) {
                    propNameValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if( !propNameValue.equalsIgnoreCase( "PassWord" ) ){
                continue;
            }
                        childList = itemEle.getElementsByTagName( "PropertyValue" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element propValueEle = ( Element ) childList.item( 0 );
                textNode = propValueEle.getFirstChild();
                if ( null != textNode ) {
                    propValueValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
        }
        return propValueValue;
    }
    
    public Vector getAllIDsByProperty ( String propertyName,
                                        String propertyValue ) {
        Vector userIDs = new Vector();
        if( this.useDataBase ){
            Statement st;
            ResultSet rs;
            try {
                if ( conn == null ) {
                    conn = getConnection();
                }
                st = conn.createStatement();
                String strSql =
                    "select * from UserProperty where PropertyName= '"
                    + propertyName + "' and PropertyValue='" + propertyValue
                    + "'";
                rs = st.executeQuery( strSql );
                                while ( rs.next() ) {
                    int userID = rs.getInt( "UserID" );
                    userIDs.add( new Integer( userID ) );
                }
                rs.close();
                st.close();
                return userIDs;
            } catch ( Exception e ) {
                e.printStackTrace();
                return null;
            }
        }
                Node textNode = null;
        int userIDValue = this.INVALID_USERID;
        String propNameValue = null;
        String propValueValue = null;
                NodeList tmpList = this.userDoc.getElementsByTagName( "UserProperty" );
        Element tmpNode = ( Element ) tmpList.item( 0 );
        tmpList = tmpNode.getElementsByTagName( "Item" );
        for ( int i = 0; i < tmpList.getLength(); i++ ) {
            Element itemEle = ( Element ) tmpList.item( i );
                        NodeList childList = itemEle.getElementsByTagName( "PropertyName" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element propNameEle = ( Element ) childList.item( 0 );
                textNode = propNameEle.getFirstChild();
                if ( null != textNode ) {
                    propNameValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if( !propNameValue.equalsIgnoreCase( propertyName ) ){
                continue;
            }
                        childList = itemEle.getElementsByTagName( "PropertyValue" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element propValueEle = ( Element ) childList.item( 0 );
                textNode = propValueEle.getFirstChild();
                if ( null != textNode ) {
                    propValueValue = textNode.getNodeValue();
                }
            } else {
                                continue;
            }
            if( !propValueValue.equalsIgnoreCase( propertyValue ) ){
                continue;
            }
                        childList = itemEle.getElementsByTagName( "UserID" );
            if ( null != childList && 0 != childList.getLength() ) {
                Element userIDEle = ( Element ) childList.item( 0 );
                textNode = userIDEle.getFirstChild();
                if ( null != textNode ) {
                    userIDValue = Integer.parseInt( textNode.getNodeValue() );
                    userIDs.add( new Integer( userIDValue ) );
                }
            } else {
                                continue;
            }
        }
        return userIDs;
    }
    
    public Vector getLikeUserID ( String userName ) {
        if( this.useDataBase ){
            Statement st;
            ResultSet rs;
            try {
                if ( conn == null ) {
                    conn = getConnection();
                }
                st = conn.createStatement();
                String strSql = "select * from UserInfo where UserName like '%"
                    + userName + "%'";
                rs = st.executeQuery( strSql );
                Vector IDs = new Vector();
                                while ( rs.next() ) {
                    int userID = rs.getInt( "UserID" );
                    IDs.add( new Integer( userID ) );
                }
                rs.close();
                st.close();
                return IDs;
            } catch ( Exception e ) {
                e.printStackTrace();
                return null;
            }
        }
                return null;
    }
        
    private Connection getConnection () throws ClassNotFoundException,
        SQLException {
        Connection conn = null;
                Class.forName( JDBC_Driver );
                conn = DriverManager.getConnection( JDBC_URL, JDBC_Username,
                                            JDBC_Password );
        return conn;
    }
    
    private String getStringbySql ( String sql, String fieldName ) throws
        Exception {
        String ret = null;
        Statement st;
        ResultSet rs;
        boolean bUserFound = false;
        try {
            if ( conn == null ) {
                conn = getConnection();
            }
            st = conn.createStatement();
            rs = st.executeQuery( sql );
            if ( rs.next() ) {
                ret = rs.getString( fieldName );
                bUserFound = true;
            }
            rs.close();
            st.close();
        } catch ( Exception e ) {
            e.printStackTrace();
                        throw new Exception( "No such property!" );
        }
        if ( bUserFound ) {
            return ret;
        } else {
            throw new Exception( "This userID does not exist!" );
        }
    }
    
    private int getLocalIDbySql ( String sql ) {
        int localID = this.INVALID_USERID;
        Statement st;
        ResultSet rs;
        try {
            if ( conn == null ) {
                conn = getConnection();
            }
            st = conn.createStatement();
            rs = st.executeQuery( sql );
            if ( rs.next() ) {
                localID = rs.getInt( "UserID" );
            }
            rs.close();
            st.close();
        } catch ( Exception e ) {
            log.debug( e );
        }
        return localID;
    }
    
    private boolean updateDBbySql ( String sql ) {
        String ret = null;
        Statement st;
        int result = 0;
        try {
            if ( conn == null ) {
                conn = getConnection();
            }
            st = conn.createStatement();
            result = st.executeUpdate( sql );
            st.close();
        } catch ( Exception e ) {
                        log.debug( e );
        }
        if ( result == 0 ) {             return false;
        } else {
            return true;
        }
    }
    
    public void close () {
        try {
            if ( conn != null ) {
                conn.close();
                conn = null;
            }
        } catch ( Exception e ) {
            log.debug( e );
        }
    }
}
