package org.act.soap.server.transport.http;
import java.io.IOException;
import java.io.OutputStream;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.wsdl.Definition;
import javax.wsdl.factory.WSDLFactory;
import javax.wsdl.xml.WSDLWriter;
import org.act.soap.server.EmbededWSServer;
import org.act.soap.server.SOAPEngine;
import org.act.soap.util.Constants;
import org.act.soap.util.logging.Log;
import org.act.soap.util.logging.LogFactory;

public class ACTSoapServlet
    extends HttpServlet {
  
  private static Log log = LogFactory.getLog(ACTSoapServlet.class.getName());
  
  private static EmbededWSServer embededWSServer = null;
  
  private static SOAPEngine soapEngine = null;
  
  public void init() throws ServletException {
    try {
      if (null == embededWSServer) {
                if (System.getProperty(Constants.PROPERTY_NAME_CONFIG_FILE_PATH) == null) {
            System.setProperty(Constants.PROPERTY_NAME_CONFIG_FILE_PATH,
                               this.getServletContext().getRealPath(Constants.DEFAULT_CONFIG_FILE_PATH));
        }
        String strRootPath=System.getProperty(Constants.PROPERTY_NAME_CONFIG_FILE_PATH);
        String strConfigfile=Constants.DEFAULT_CONFIG_FILE_PATH.substring(5);
        strRootPath=strRootPath.substring(0,strRootPath.indexOf(strConfigfile)-6);
        System.setProperty(Constants.PROPERTY_NAME_ROOT_PATH,strRootPath);
                embededWSServer = new EmbededWSServer();
                embededWSServer.init();
        soapEngine = SOAPEngine.getInstance();
      }
    }
    catch (Exception e) {
      log.error(e);
      throw new ServletException(e);
    }
  }
  
  public void doGet(HttpServletRequest req, HttpServletResponse res) throws
      ServletException, IOException {
    OutputStream outStream = null;
    try {
            byte[] response = null;
            String queryString = req.getQueryString();
            if ( (null != queryString) &&
          queryString.equalsIgnoreCase(Constants.QUERYSTRING_WSDL)) {
                res.setContentType("text/xml;charset=UTF-8");
        outStream = res.getOutputStream();
        Definition definition = soapEngine.getWSDLDefination(req.
            getPathInfo());
        WSDLWriter wsdlWriter = WSDLFactory.newInstance().newWSDLWriter();
        wsdlWriter.writeWSDL(definition, outStream);
      }
      else {
                        
        String sHtml = "";
        sHtml += "<html>\n";
        sHtml += "   <body>\n";
        sHtml += "   </body>\n";
        sHtml += "you are welcome! to do...\n";
        sHtml += "</html>\n";
        response = sHtml.getBytes("UTF-8");
        res.setContentType("text/html;charset=UTF-8");
        outStream = res.getOutputStream();
        outStream.write(response);
      }
    }
    catch (Exception ex) {
      outStream = null;
      log.error(ex);
      res.sendError(HttpServletResponse.SC_INTERNAL_SERVER_ERROR,
                    ex.getMessage());
    }
    finally {
      if (null != outStream) {
        outStream.close();
      }
    }
  }
  
  public void doPost(HttpServletRequest req, HttpServletResponse res) throws
      ServletException, IOException {
    try {
            HTTPTransportContext reqCtx = new HTTPTransportContext();
      reqCtx.setHttpServletRequest(req);
      reqCtx.setHttpServletResponse(res);
            reqCtx.setRequestURL(req.getPathInfo());
                  HTTPTransportContext resCtx = (HTTPTransportContext) soapEngine.
          invoke(reqCtx);
    }
    catch (Exception ex) {
      log.error(ex);
      res.sendError(HttpServletResponse.SC_INTERNAL_SERVER_ERROR,
                    ex.getMessage());
    }
  }
}
