package org.act.soap.server.transport.http;
import java.util.Stack;

public class ThreadPool
{
         
   private Stack pool = new Stack();
   
   private int maxSize = 10;
         
   public ThreadPool()
   {
   }
      
   public void setMaximumSize(int size)
   {
      maxSize = size;
   }
   
   public synchronized void run(Runnable work)
   {
      if (pool.size() == 0) {
         new Worker(work);
      } else {
         Worker w = (Worker)pool.pop();
         w.run(work);
      }
   }
      
   private synchronized void returnWorker(Worker w)
   {
      if (pool.size() < maxSize)
         pool.push(w);
      else
         w.die();
   }
      class Worker extends Thread
   {
      
      boolean running = true;
      
      Runnable work;
      
      Worker(Runnable work)
      {
         this.work = work;
                  setDaemon(false);
         start();
      }
      
      public synchronized void die()
      {
         running = false;
         notify();
      }
      
      public synchronized void run(Runnable work)
      {
         if (this.work != null)
           throw new IllegalStateException("Worker already has work to do.");
         this.work = work;
         notify();
      }
      
      public void run()
      {
         while (running) {
                        if (work != null) {
               try {
                  work.run();
               } catch (Exception e) {
                                 }
                              work = null;
            }
                        returnWorker(this);
                        synchronized (this) {
               while (running && work == null) {
                  try {
                     wait();
                  } catch (InterruptedException e) {
                                       }
               }
            }
         }
      }
   }
}
