package org.act.soap.soapsec;

public class SOAPException
    extends Exception {
    private String faultCode;
    private Throwable targetException;
    public SOAPException ( String faultCode, String msg ) {
        super( msg );
        this.faultCode = faultCode;
    }
    public SOAPException ( String faultCode, String msg,
                           Throwable targetException ) {
        this( faultCode, msg );
        this.targetException = targetException;
    }
    public void setFaultCode ( String faultCode ) {
        this.faultCode = faultCode;
    }
    public String getFaultCode () {
        return faultCode;
    }
    public void setTargetException ( Throwable targetException ) {
        this.targetException = targetException;
    }
    public Throwable getTargetException () {
        return targetException;
    }
    public Throwable getRootException () {
        return targetException != null ? targetException : this;
    }
    public String getMessage () {
        String superMsg = super.getMessage();
        String targetMsg = ( targetException != null )
            ? targetException.getMessage()
            : null;
        String msg = ( ( superMsg == null || superMsg.equals( "" ) )
                       && ( targetMsg != null && !targetMsg.equals( "" ) ) )
            ? targetMsg
            : superMsg;
        if ( msg == null || msg.equals( "" ) ) {
            msg = ( targetException != null )
                ? targetException.toString()
                : this.toString();
        }
        return msg;
    }
    public String toString () {
        return "[SoapException: faultCode=" + faultCode + "; msg=" +
            super.getMessage() + ( ( targetException != null )
                                   ? ( "; targetException=" + targetException ) :
                                   "" ) + "]";
    }
}
