package org.act.soap.soapsec;
import org.w3c.dom.*;

public class SOAPSecurityElement {
    protected String localName = null;
    public String getLocalName () {
        return this.localName;
    }
    public void setLocalName ( String localName ) {
        this.localName = localName;
    }
    protected String namespaceURI = null;
    public String getNamespaceURI () {
        return this.namespaceURI;
    }
    public void setNamespaceURI ( String namespaceURI ) {
        this.namespaceURI = namespaceURI;
    }
    protected String prefix = null;
    public String getPrefix () {
        return this.prefix;
    }
    public void setPrefix ( String prefix ) {
        this.prefix = prefix;
    }
    protected String wsuId = null;
    public String getId () {
        return this.wsuId;
    }
    public void setId ( String wsuId ) {
        this.wsuId = wsuId;
    }
    protected Element element = null;
    public Element getElement () {
        return this.element;
    }
    public void setElement ( Element element ) {
        this.element = element;
    }
    
    public SOAPSecurityElement ( Element element ) {
        this.element = element;
        this.localName = element.getLocalName();
        this.namespaceURI = element.getNamespaceURI();
        this.prefix = element.getPrefix();
        this.wsuId = element.getAttributeNS( Constants.NS_URI_WSU,
                                             Constants.ATTR_WSU_ID );
    }
    public SOAPSecurityElement () {
    }
    
    public Element toElement ( Document doc ) throws SOAPException {
        String tagName = ( this.prefix == null || this.prefix == "" ) ?
            this.localName : ( this.prefix + ":" + this.localName );
        Element result = doc.createElementNS( this.namespaceURI, tagName );
        if ( this.wsuId != null ) {
            String wsuIdTagName = Constants.NS_PRE_WSU + ":" +
                Constants.ATTR_WSU_ID;
            result.setAttribute( wsuIdTagName, this.wsuId );
        }
        return result;
    }
}
