package org.act.soap.soapsec.securitytoken;
import java.security.*;
import org.act.soap.soapsec.*;
import org.act.soap.soapsec.Constants;
import org.act.soap.util.*;
import org.w3c.dom.*;

public class SecurityToken
    extends SOAPSecurityElement {
    SecurityToken securitytoken = null;
    
    protected Key signKey = null;
    
    protected String signKeyName = null;
    
    protected Key verifyKey = null;
    
    protected String signAlgorithm = null;
    
    protected Key encryptKey = null;
    
    protected Key decryptKey = null;
    
    protected String encryptAlgorithm = null;
    
    public SecurityToken () {
                this.wsuId = "SecurityToken-" + UUID.generate().toString();
    }
    
    public SecurityToken ( Element eToken ) {
        super( eToken );
    }
    
    public Key getSignKey () {
        return this.signKey;
    }
    
    public String getSignKeyName () {
        return this.signKeyName;
    }
    
    public void setSignKey ( Key key ) {
        this.signKey = key;
    }
    
    public void setSignKeyName ( String name ) {
        this.signKeyName = name;
    }
    
    public Key getVerifyKey () {
        return this.verifyKey;
    }
    
    public void setVerifyKey ( Key key ) {
        this.verifyKey = key;
    }
    
    public String getSignAlgorithm () {
        return this.signAlgorithm;
    }
    
    public void setSignAlgorithm ( String signAlgorithm ) {
        this.signAlgorithm = signAlgorithm;
    }
    
    public Key getEncryptKey () {
        return this.encryptKey;
    }
    
    public void setEncryptKey ( Key key ) {
        this.encryptKey = key;
    }
    
    public Key getDecryptKey () {
        return this.decryptKey;
    }
    
    public void setDecryptKey ( Key key ) {
        this.decryptKey = key;
    }
    
    public String getEncryptAlgorithm () {
        return this.encryptAlgorithm;
    }
    
    public void setEncryptAlgorithm ( String encryptAlgorithm ) {
        this.encryptAlgorithm = encryptAlgorithm;
    }
    
    
    public static String getSecTokenType ( Element eToken ) {
        if ( Constants.NS_URI_WSSE.equals( eToken.getNamespaceURI() ) &&
             Constants.ELEM_USERNAMETOKEN.equals( eToken.getLocalName() ) ) {
            return Constants.TYPE_ST_USERNAMETOKEN;
        }
        else if ( Constants.NS_URI_WSSE.equals( eToken.getNamespaceURI() ) &&
                  Constants.ELEM_BINARYSECURITYTOKEN.equals( eToken.
            getLocalName() ) ) {
            return Constants.TYPE_ST_BINARYSECURITYTOKEN;
        }
        else if ( Constants.NS_URI_WSSE.equals( eToken.getNamespaceURI() ) &&
                  Constants.ELEM_SECURITYCONTEXTTOKEN.equals( eToken.
            getLocalName() ) ) {
            return Constants.TYPE_ST_SECURITYCONTEXTTOKEN;
        }
        else if ( Constants.NS_URI_WSSE.equals( eToken.getNamespaceURI() ) &&
                  Constants.ELEM_TICKETTOKEN.equals( eToken.getLocalName() ) ) {
            return Constants.TYPE_ST_TICKETTOKEN;
        }
        else {
            return Constants.TYPE_ST_UNKNOWNTOKEN;
        }
    }
    
    public static SecurityToken createToken ( Element eToken ) throws
        SOAPException {
        if ( Constants.NS_URI_WSSE.equals( eToken.getNamespaceURI() ) &&
             Constants.ELEM_USERNAMETOKEN.equals( eToken.getLocalName() ) ) {
            return new UsernameToken( eToken );
        }
        else if ( Constants.NS_URI_WSSE.equals( eToken.getNamespaceURI() ) &&
                  Constants.ELEM_BINARYSECURITYTOKEN.equals( eToken.
            getLocalName() ) ) {
                        return BinarySecurityToken.createBinarySecurityToken( eToken );
        }
        else if ( Constants.NS_URI_WSSE.equals( eToken.getNamespaceURI() ) &&
                  Constants.ELEM_SECURITYCONTEXTTOKEN.equals( eToken.
            getLocalName() ) ) {
            return new SecurityContextToken( eToken );
        }
        else {
            return new SecurityToken( eToken );
        }
    }
}
