package org.act.soap.soapsec.securitytoken;
import java.util.*;
import org.act.soap.soapsec.*;
import org.act.soap.soapsec.Constants;
import org.act.soap.util.*;
import org.w3c.dom.*;

public class SecurityTokenReference
    extends SOAPSecurityElement {
    
    private Vector references = new Vector();
    
    public SecurityTokenReference () {
        this.namespaceURI = Constants.NS_URI_WSSE;
        this.prefix = Constants.NS_PRE_WSSE;
        this.localName = Constants.ELEM_SECURITYTOKENREFERENCE;
        this.wsuId = UUID.generate().toString();
    }
    
    public SecurityTokenReference ( Element eSTR ) {
        super( eSTR );         Vector eRefs = XMLUtils.getChildElementsByNS( eSTR,
            Constants.NS_URI_WSSE, Constants.ELEM_REFERENCE );
        if ( eRefs != null ) {
            for ( int i = 0; i < eRefs.size(); i++ ) {
                Element eRef = ( Element ) eRefs.get( i );
                String uri = eRef.getAttribute( Constants.ATTR_WSSE_URI );
                if ( uri != null && !uri.equals( "" ) ) {
                    this.references.add( uri );
                }
                eRef = null;
            }
        }
    }
    
    public String[] getReferenceURIs () {
        if ( references.size() == 0 ) {
            return null;
        }
        else {
            String[] refs = new String[this.references.size()];
            this.references.toArray( refs );
            return refs;
        }
    }
    
    public void addReference ( String refURI ) {
        references.add( refURI );
    }
    
    public void addReference ( SecurityToken securityToken ) {
        if ( securityToken.getId() != null ) {
            references.add( Constants.S_Ref + securityToken.getId() );
        }
    }
    
    public Element toElement ( Document doc ) throws SOAPException {
        Element eSTR = super.toElement( doc );         for ( int i = 0; i < references.size(); i++ ) {
            Element eRef = doc.createElementNS( Constants.NS_URI_WSSE,
                                                Constants.NS_PRE_WSSE + ":" +
                                                Constants.ELEM_REFERENCE );
            eRef.setAttribute( Constants.ATTR_WSSE_URI,
                               ( String ) references.get( i ) );
            eSTR.appendChild( eRef );
        }
        this.element = eSTR;
        return eSTR;
    }
}
