package org.act.soap.soapsec.securitytoken;
import org.act.soap.soapsec.*;
import org.act.soap.soapsec.Constants;
import org.act.soap.util.*;
import org.w3c.dom.*;

public class TicketToken
    extends SecurityToken {
    
    private String TicketString = null;
    private static String DefaultSTId = Constants.ELEM_TICKETTOKEN;
    
    public TicketToken () {
    }
    
    public TicketToken ( Element eToken ) {
        this.wsuId = eToken.getAttribute( Constants.ATTR_WSU_ID );
        NodeList ticketList = eToken.getElementsByTagNameNS( Constants.
            NS_URI_SOAPSEC, Constants.ELEM_TICKET );
        if ( ticketList != null && ticketList.getLength() > 0 ) {
                        Element ticket = ( Element ) ticketList.item( 0 );
            this.TicketString = XMLUtils.getTextValueOfElement( ticket );
        }
        else {
                        this.TicketString = "";
        }
    }
    
    public String getTicketString () {
        return TicketString;
    }
    
    public void setTicketString ( String ticket ) {
        this.TicketString = ticket;
    }
    
    public Element toElement ( Document doc ) throws SOAPException {
        Element eTicket = doc.createElement( Constants.Q_ELEM_TICKETTOKEN.
                                             toString() );
        if ( this.wsuId != null && this.wsuId != "" ) {
            eTicket.setAttribute( Constants.ATTR_WSU_ID, this.wsuId );
        }
        else {
            eTicket.setAttribute( Constants.ATTR_WSU_ID, DefaultSTId );
        }
        if ( TicketString == null ) {
            throw new SOAPException( Constants.FAULT_CODE_InvalidSecToken,
                                     "TicketToken's content can not be null." );
        }
        else {
            Element ticket = doc.createElement( Constants.Q_ELEM_TICKET.
                                                toString() );
            ticket.appendChild( doc.createTextNode( TicketString ) );
            eTicket.appendChild( doc.createTextNode( Constants.S_Line ) );
            eTicket.appendChild( ticket );
            eTicket.appendChild( doc.createTextNode( Constants.S_Line ) );
        }
        return eTicket;
    }
}
