package org.act.soap.soapsec.securitytoken.keyprocessor;
import java.security.*;
import org.act.soap.soapsec.securitytoken.*;

public class DefaultSecurityKeyProcessor
    implements SecurityTokenKeyProcessor {
    
    public Key getKey ( SecurityToken token, int usage ) {
        if ( token != null ) {
            switch ( usage ) {
                case USAGE_SIGN:
                    return token.getSignKey();
                case USAGE_VERIFY:
                    return token.getVerifyKey();
                case USAGE_ENCRYPT:
                    return token.getEncryptKey();
                case USAGE_DECRYPT:
                    return token.getDecryptKey();
                default:
                    return null;
            }
        }
        else {
            return null;
        }
    }
}
