package org.act.soap.soapsec.securitytoken.keyprocessor;
import java.security.*;
import org.act.soap.soapsec.*;
import org.act.soap.soapsec.securitytoken.*;
import org.act.soap.util.*;
import org.w3c.dom.*;


public class SecurityTokenReferenceKeyProcessor
    implements org.act.xdsec.extension.keyinfo.KeyProcessor {
    
    private SecurityTokenReference securityTokenReference = null;
    
    private SecurityToken securityToken = null;
    
    private SecurityTokenKeyProcessor securityTokenKeyProcessor = null;
    
    public SecurityTokenReferenceKeyProcessor ( SecurityTokenKeyProcessor
                                                securityTokenKeyProcessor ) {
        this.securityTokenKeyProcessor = securityTokenKeyProcessor;
    }
    
    public Key getKey ( Node key, boolean publickey ) throws
        NoSuchAlgorithmException, InvalidKeyException {
        if ( key == null ) {
            return null;
        }
        if ( publickey == false ) {
            return null;
        }
        if ( key.getNodeType() != Node.ELEMENT_NODE ) {
            return null;
        }
                Element eSTR = ( Element ) key;
        this.securityTokenReference = new SecurityTokenReference( eSTR );
                String[] refs = this.securityTokenReference.getReferenceURIs();
        if ( refs == null || refs.length <= 0 ) {
            return null;
        }
                Document doc = eSTR.getOwnerDocument();
        Element eToken = XMLUtils.getElementById( doc, refs[0].substring( 1 ) );         try {
            this.securityToken = SecurityToken.createToken( eToken );
            if ( this.securityTokenKeyProcessor != null ) {
                                return this.securityTokenKeyProcessor.getKey( this.
                    securityToken,
                    SecurityTokenKeyProcessor.USAGE_VERIFY );
            }
            else {
                return this.securityToken.getVerifyKey();
            }
        }
        catch ( SOAPException ex ) {
            ex.printStackTrace();
            return null;
        }
    }
    
    public SecurityToken getSecurityToken () {
        return this.securityToken;
    }
}
