package org.act.soap.util;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.IOException;
import java.net.URL;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;

public class FileUtil {
    
    public static void copyFile(File src,File des) throws IOException {
          FileInputStream in=new FileInputStream(src);
          OutputStream out=new FileOutputStream(des);
          write(in,out);
          out.close ();
          in.close();
    }
    
    public static void copyFile(byte[] src,File des) throws IOException {
          OutputStream out=new FileOutputStream(des);
          out.write(src);
          out.flush ();
          out.close ();
    }
    
    public static void downLoadFile(URL src,File dest) throws IOException {
                              InputStream in;
          OutputStream out;
          
          in = src.openStream ();
          out = new FileOutputStream (dest);
          write (in, out);
          out.close ();
          in.close ();
    }
    
    public static void write (InputStream in, OutputStream out) throws IOException{
          byte[] buffer = new byte[1024*512];
          int read;
          while (true){
                read =in.read(buffer);
                if (read == -1)
                        break;
                 out.write(buffer, 0, read);
          }
          out.flush ();
   }
    
    public static void deleteRecursive(File _file) throws IOException{
        if (_file.isDirectory()){
            File[] files = _file.listFiles();
            for (int i = 0, l = files.length; i < l; ++i)
                deleteRecursive(files[i]);
        }
        _file.delete();
    }
    
    public static void inflate( File zipFile, String _destDir )
            throws IOException {
        FileInputStream fis = new FileInputStream( zipFile );
        ZipInputStream _in = new ZipInputStream( fis );
        try {
            OutputStream out;
            ZipEntry entry;
                        File destDir = new File(_destDir);
            if (!destDir.exists())
                destDir.mkdir();
            while ( (entry = _in.getNextEntry()) != null) {
                String name = entry.getName();
                if (entry.isDirectory()) {
                                        File dir = new File(_destDir, name);
                    if (!dir.exists())
                        dir.mkdirs();
                }
                else {
                                        int index_java = name.lastIndexOf("/");
                    int index_win = name.lastIndexOf("\\");
                    int index = -1;
                    if ( (index = index_java) != -1 || (index = index_win) != -1) {
                                                File dir = new File(_destDir, name.substring(0, index));
                        if (!dir.exists())
                            dir.mkdirs();
                    }
                                                            File file = new File(_destDir, name);
                                        if (file.isDirectory()){
                      continue;
                    }
                                        out = new FileOutputStream(file);
                    copy(_in, out, false, true);
                                        long time = entry.getTime();
                    if (time > 0)
                        file.setLastModified(time);
                }
            }
        }
        finally {
            _in.close();
        }
    }
    
    public static void inflate( InputStream in, String _destDir )
            throws IOException {
        ZipInputStream _in = new ZipInputStream(in);
        try {
            OutputStream out;
            ZipEntry entry;
                        File destDir = new File(_destDir);
            if (!destDir.exists())
                destDir.mkdir();
            while ( (entry = _in.getNextEntry()) != null) {
                String name = entry.getName();
                if (entry.isDirectory()) {
                                        File dir = new File(_destDir, name);
                    if (!dir.exists())
                        dir.mkdirs();
                }
                else {
                                        int index_java = name.lastIndexOf("/");
                    int index_win = name.lastIndexOf("\\");
                    int index = -1;
                    if ( (index = index_java) != -1 || (index = index_win) != -1) {
                                                File dir = new File(_destDir, name.substring(0, index));
                        if (!dir.exists())
                            dir.mkdirs();
                    }
                                                            File file = new File(_destDir, name);
                                        if (file.isDirectory()){
                      continue;
                    }
                                        out = new FileOutputStream(file);
                    copy(_in, out, false, true);
                                        long time = entry.getTime();
                    if (time > 0)
                        file.setLastModified(time);
                }
            }
        }
        finally {
            _in.close();
        }
    }
    
    public static void copy(InputStream _in, OutputStream _out, boolean _closeInput, boolean _closeOutput)
            throws IOException {
        byte[] buffer = new byte[1024 * 512];
        int read;
        while (true) {
            read = _in.read(buffer);
            if (read == -1)
                break;
            _out.write(buffer, 0, read);
        }
        _out.flush();
        if (_closeOutput)
            _out.close();
        if (_closeInput)
            _in.close();
    }
}
