package org.act.soap.util ;
import java.io.ByteArrayOutputStream;
import org.act.soap.util.i18n.Message;

public class HexBinary extends Object implements java.io.Serializable{
            public static final int[] DEC = {
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
        00, 01, 02, 03, 04, 05, 06, 07,  8,  9, -1, -1, -1, -1, -1, -1,
        -1, 10, 11, 12, 13, 14, 15, -1, -1, -1, -1, -1, -1, -1, -1, -1,
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
        -1, 10, 11, 12, 13, 14, 15, -1, -1, -1, -1, -1, -1, -1, -1, -1,
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    };
    
    public static byte[] decode(String digits) {
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        for (int i = 0; i < digits.length(); i += 2) {
            char c1 = digits.charAt(i);
            if ((i+1) >= digits.length())
                throw new IllegalArgumentException(Message.getMessage("ERR_TM_oddDigits"));
            char c2 = digits.charAt(i + 1);
            byte b = 0;
            if ((c1 >= '0') && (c1 <= '9'))
                b += ((c1 - '0') * 16);
            else if ((c1 >= 'a') && (c1 <= 'f'))
                b += ((c1 - 'a' + 10) * 16);
            else if ((c1 >= 'A') && (c1 <= 'F'))
                b += ((c1 - 'A' + 10) * 16);
            else
                throw new IllegalArgumentException(Message.getMessage("ERR_TM_badChars") );
            if ((c2 >= '0') && (c2 <= '9'))
                b += (c2 - '0');
            else if ((c2 >= 'a') && (c2 <= 'f'))
                b += (c2 - 'a' + 10);
            else if ((c2 >= 'A') && (c2 <= 'F'))
                b += (c2 - 'A' + 10);
            else
                throw new IllegalArgumentException(Message.getMessage("ERR_TM_badChars") );
            baos.write(b);
        }
        return (baos.toByteArray());
    }
    
    public static String encode(byte bytes[]) {
        StringBuffer sb = new StringBuffer(bytes.length * 2);
        for (int i = 0; i < bytes.length; i++) {
            sb.append(convertDigit((int) (bytes[i] >> 4)));
            sb.append(convertDigit((int) (bytes[i] & 0x0f)));
        }
        return (sb.toString());
    }
    
    public static int convert2Int( byte[] hex ) {
                                int len;
        if(hex.length < 4 ) return 0;
        if( DEC[hex[0]]<0 )
            throw new IllegalArgumentException(Message.getMessage("ERR_TM_badChars") );
        len = DEC[hex[0]];
        len = len << 4;
        if( DEC[hex[1]]<0 )
            throw new IllegalArgumentException(Message.getMessage("ERR_TM_badChars") );
        len += DEC[hex[1]];
        len = len << 4;
        if( DEC[hex[2]]<0 )
            throw new IllegalArgumentException(Message.getMessage("ERR_TM_badChars") );
        len += DEC[hex[2]];
        len = len << 4;
        if( DEC[hex[3]]<0 )
            throw new IllegalArgumentException(Message.getMessage("ERR_TM_badChars") );
        len += DEC[hex[3]];
        return len;
    }
    
    private static char convertDigit(int value) {
        value &= 0x0f;
        if (value >= 10)
            return ((char) (value - 10 + 'a'));
        else
            return ((char) (value + '0'));
    }
    private static final String HEX_TABLE = "0123456789ABCDEF";
    private static String hexEncode(byte[] ab) {
                StringBuffer buffer = new StringBuffer(ab.length * 2);
        for (int i = 0; i < ab.length; i++) {
                                    buffer.append( (char) HEX_TABLE.charAt( (ab[i] >> 4) & 0x0f));
            buffer.append( (char) HEX_TABLE.charAt(ab[i] & 0x0f));
        }
        return new String(buffer);
    }
    private static byte[] hexDecode(String hexString) {
                ByteArrayOutputStream baos = new ByteArrayOutputStream();
        for (int i = 0; i < hexString.length() - 1; i += 2) {
            char hi = hexString.charAt(i);
            char lo = hexString.charAt(i + 1);
            byte b = (byte) (HEX_TABLE.indexOf(hi) << 4);
            b += HEX_TABLE.indexOf(lo);
            baos.write(b);
        }
        return baos.toByteArray();
    }
        public static void main( String[] args ) {
        System.out.println( hexEncode("asdf".getBytes()) );
        byte[] bs = hexDecode("61736466");
        for( int i=0; i<bs.length; i++ ) {
            System.out.print( (char)bs[i] );
        }
                {
            long t1 = System.currentTimeMillis();
            for ( int i=0; i<1000000; i++ ) {
                hexEncode("asdf".getBytes());
                hexDecode("61736466");
            }
            long t2 = System.currentTimeMillis();
            System.out.println();
            System.out.println( "hexEncode/hexDecode" + (t2-t1) );
        }
        {
            long t1 = System.currentTimeMillis();
            for ( int i=0; i<1000000; i++ ) {
                encode("asdf".getBytes());
                decode("61736466");
            }
            long t2 = System.currentTimeMillis();
            System.out.println();
            System.out.println( "encode/decode" + (t2-t1) );
        }
    }
}
