package org.act.soap.util;
import java.util.Enumeration;
import javax.xml.soap.*;
import javax.mail.internet.MimeBodyPart;
import javax.mail.MessagingException;
import javax.mail.Header;
import org.act.soap.util.i18n.Message;

public class MimeUtils {
    
    public static String getFirstMimeHeader(MimeHeaders headers, String header) {
        if (null == headers)
            throw new IllegalArgumentException(Message.getMessage(
                "nullArguments01", "getFirstMimeHeader", "headers"));
        if (null == header)
            throw new IllegalArgumentException(Message.getMessage(
                "nullArguments01", "getFirstMimeHeader", "header"));
        String[] values = headers.getHeader(header);
        if ( (values != null) && (values.length > 0)) {
            return values[0];
        }
        return null;
    }
    public static void copyMimeHeaders(MimeBodyPart mbp, AttachmentPart ap)
        throws SOAPException
    {
        Header hdr;
        Enumeration e;
        try {
            e = mbp.getAllHeaders();
        }
        catch( MessagingException me ) {
            throw new SOAPException(me);
        }
        while( e.hasMoreElements() ) {
            hdr = (Header)e.nextElement();
            ap.addMimeHeader(hdr.getName(), hdr.getValue());
        }
    }
}
