package org.act.soap.util.logging.impl;
import java.util.logging.Level;
import java.util.logging.Logger;
import  org.act.soap.util.logging.Log;
import java.io.InputStream;
import java.util.logging.LogManager;
import java.io.StringWriter;
import java.io.PrintWriter;
public final class Jdk14Logger implements Log {
  static{
       try {
     InputStream is = Jdk14Logger.class.getClassLoader().getResourceAsStream("jdklog.properties");
     LogManager.getLogManager().readConfiguration(is);
   }
   catch(Exception ex) {
     ex.printStackTrace() ;
   }
 }
        
    public Jdk14Logger(String name) {
        logger = Logger.getLogger(name);
                            }
        
    protected Logger logger = null;
        private void log( Level level, String msg, Throwable ex ) {
        if (logger.isLoggable(level)) {
                        Throwable dummyException=new Throwable();
            StackTraceElement locations[]=dummyException.getStackTrace();
                        String cname="unknown";
            String method="unknown";
            if( locations!=null && locations.length >2 ) {
                StackTraceElement caller=locations[2];
                cname=caller.getClassName();
                method=caller.getMethodName();
            }
            if( ex==null ) {
                logger.logp( level, cname, method, msg );
            } else {
                logger.logp( level, cname, method, msg, ex );
            }
        }
    }
    
    public void debug(Object message) {
        log(Level.FINE, String.valueOf(message), null);
    }
    
    public void debug(Object message, Throwable exception) {
        log(Level.FINE, String.valueOf(message), exception);
    }
    
    public void error(Object message) {
        log(Level.SEVERE, String.valueOf(message), null);
    }
    
    public void error(Object message, Throwable exception) {
        log(Level.SEVERE, String.valueOf(message), exception);
    }
    
    public void fatal(Object message) {
        log(Level.SEVERE, String.valueOf(message), null);
    }
    
    public void fatal(Object message, Throwable exception) {
        log(Level.SEVERE, String.valueOf(message), exception);
    }
    
    public Logger getLogger() {
        return (this.logger);
    }
    
    public void info(Object message) {
        log(Level.INFO, String.valueOf(message), null);
    }
    
    public void info(Object message, Throwable exception) {
        log(Level.INFO, String.valueOf(message), exception);
    }
    
    public boolean isDebugEnabled() {
        return (logger.isLoggable(Level.FINE));
    }
    
    public boolean isErrorEnabled() {
        return (logger.isLoggable(Level.SEVERE));
    }
    
    public boolean isFatalEnabled() {
        return (logger.isLoggable(Level.SEVERE));
    }
    
    public boolean isInfoEnabled() {
        return (logger.isLoggable(Level.INFO));
    }
    
    public boolean isTraceEnabled() {
        return (logger.isLoggable(Level.FINEST));
    }
    
    public boolean isWarnEnabled() {
        return (logger.isLoggable(Level.WARNING));
    }
    
    public void trace(Object message) {
        log(Level.FINEST, String.valueOf(message), null);
    }
    
    public void trace(Object message, Throwable exception) {
        log(Level.FINEST, String.valueOf(message), exception);
    }
    
    public void warn(Object message) {
        log(Level.WARNING, String.valueOf(message), null);
    }
    
    public void warn(Object message, Throwable exception) {
        log(Level.WARNING, String.valueOf(message), exception);
    }
}
