
package org.act.soap.wsdd;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.act.soap.util.XMLUtils;
import org.act.soap.util.i18n.Message;

public class Documentation
    extends WSDDElement {
    
    public static final String TAG_NAME = "Documentation";
    
    private String eComment = "";
    
    public Documentation () {
    }
    
    public Documentation (String comment) {
        this.setDocumentation(comment);
    }
    
    public Documentation (Element eDocumentation) throws WSDDException {
        
        if (!isValidElement(eDocumentation, TAG_NAME)) {
            throw new WSDDException(Message.getMessage("wrongWSDDElement",
                TAG_NAME));
        }
        String comment = XMLUtils.getTextValueOfElement(eDocumentation);
        setDocumentation(comment);
    }
    
    public String getDocumentation () {
        return this.eComment;
    }
    
    public void setDocumentation (String comment) {
        if (null == comment) {
            this.eComment = "";
        }
        else {
            this.eComment = comment;
        }
    }
    
    public Element toElement (Document doc) {
        Element result = null;
        if (null != doc) {
            
            result = doc.createElementNS(WSDD_URI, TAG_NAME);
            
            result.appendChild(doc.createTextNode(this.eComment));
        }
        return result;
    }
}
