
package org.act.soap.wsdd;
import java.util.Vector;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.act.soap.util.i18n.Message;

public class Handlers
    extends WSDDElement {
    
    public static final String TAG_NAME = "Handlers";
    
    private Vector handlersVector = new Vector();
    
    public Handlers () {
    }
    
    public Handlers (Element eHandlers) throws WSDDException {
        
        if (!isValidElement(eHandlers, TAG_NAME)) {
            throw new WSDDException(Message.getMessage("invalidWSDDElement"));
        }
        this.handlersVector = new Vector();
        
        NodeList nodeList = eHandlers.getChildNodes();
        final int sum = nodeList.getLength();
        Node childNode = null;
        
        for (int i = 0; i < sum; i++) {
            childNode = nodeList.item(i);
            
            if (isValidElement(childNode, Handler.TAG_NAME)) {
                
                this.handlersVector.add(new Handler( (Element) childNode));
                continue;
            }
            
            if (isValidElement(childNode, Documentation.TAG_NAME)) {
                this.documentation = new Documentation( (Element) childNode);
                continue;
            }
        }
    }
    
    public void addHandler (Handler newHandler) {
        if (null == this.handlersVector) {
            this.handlersVector = new Vector();
        }
        if (null != newHandler) {
            this.handlersVector.add(newHandler);
        }
    }
    
    public Vector getAllHandler () {
        return this.handlersVector;
    }
    
    public boolean removeHandler (String type) {
        boolean isTrue = false;
        if (null == this.handlersVector) {
            isTrue = false;
        }else {
            Handler handler = new Handler();
            for (int i = (this.handlersVector.size() - 1); 0 <= i; i--) {
                handler = (Handler) handlersVector.get(i);
                if ((null != handler) && (handler.getType().equals(type))) {
                    handlersVector.remove(i);
                    isTrue = true;
                }
            }
        }
        return isTrue;
    }
    
    public Element toElement (Document doc) {
        Element result = null;
        if (null != doc) {
            result = doc.createElementNS(WSDD_URI, TAG_NAME);
            
            if (null != this.documentation) {
                result.appendChild(this.documentation.toElement(doc));
            }
            
            if (null != handlersVector) {
                
                for (int i = 0; i < handlersVector.size(); i++) {
                    if (null != this.handlersVector.get(i)) {
                        Element eHandler = ( (Handler) this.handlersVector.
                                            get(i)).toElement(doc);
                        result.appendChild(eHandler);
                    }
                }
            }
        }
        return result;
    }
}
