
package org.act.soap.wsdd;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.act.soap.util.i18n.Message;

public class Parameter
    extends WSDDElement {
    
    public static final String TAG_NAME = "Parameter";
    
    public static final String ATTR_NAME = "Name";
    
    public static final String ATTR_VALUE = "Value";
    
    private String name = null;
    
    private String value = null;
    
    private Element eParameter = null;
    
    public Parameter () {
    }
    
    public Parameter (Element newParameter) throws WSDDException {
        
        if (!isValidElement(newParameter, TAG_NAME)) {
            throw new WSDDException(Message.getMessage("invalidWSDDElement"));
        }
        
        this.eParameter = newParameter;
        name = newParameter.getAttribute(ATTR_NAME);
        value = newParameter.getAttribute(ATTR_VALUE);
    }
    
    public void setName (String newName) throws WSDDException {
        try {
            if (null == this.eParameter) {
                DocumentBuilder builder = DocumentBuilderFactory.newInstance().
                    newDocumentBuilder();
                Document doc = builder.newDocument();
                Element result = doc.createElementNS(WSDD_URI, TAG_NAME);
                
                result.setAttributeNS(WSDD_URI, ATTR_NAME, this.name);
                result.setAttributeNS(WSDD_URI, ATTR_VALUE, this.value);
                this.eParameter = result;
            }
            this.name = newName;
            this.eParameter.setAttributeNS(WSDD_URI, ATTR_NAME, this.name);
        }
        catch (Exception ex) {
            throw new WSDDException(Message.getMessage("invalidWSDDElement"),
                                    ex);
        }
    }
    
    public String getName () {
        return this.name;
    }
    
    public void setValue (String newValue) throws WSDDException {
        try {
            if (null == this.eParameter) {
                DocumentBuilder builder = DocumentBuilderFactory.newInstance().
                    newDocumentBuilder();
                Document doc = builder.newDocument();
                Element result = doc.createElementNS(WSDD_URI, TAG_NAME);
                
                result.setAttributeNS(WSDD_URI, ATTR_NAME, this.name);
                result.setAttributeNS(WSDD_URI, ATTR_VALUE, this.value);
                this.eParameter = result;
            }
            this.value = newValue;
            this.eParameter.setAttributeNS(WSDD_URI, ATTR_VALUE, this.value);
        }
        catch (Exception ex) {
            throw new WSDDException(Message.getMessage("invalidWSDDElement"),
                                    ex);
        }
    }
    
    public String getValue () {
        return this.value;
    }
    
    public void setParameterElement (Element newParameter) 
            throws WSDDException {
        if (!isValidElement(newParameter, TAG_NAME)) {
            throw new WSDDException(Message.getMessage("invalidWSDDElement"));
        }
        this.eParameter = newParameter;
    }
    
    public Element getParameterElement () {
        return this.eParameter;
    }
    
    public Element toElement (Document doc) {
        Element result = null;
        if (null != doc) {
            result = doc.createElementNS(WSDD_URI, TAG_NAME);
            
            result.setAttributeNS(WSDD_URI, ATTR_NAME, this.name);
            result.setAttributeNS(WSDD_URI, ATTR_VALUE, this.value);
        }
        return result;
    }
}
