package org.act.soap.wsdl.java2wsdl;
import java.io.File;
import java.io.FileOutputStream;
import javax.wsdl.Definition;
import javax.wsdl.factory.WSDLFactory;
import javax.wsdl.xml.WSDLWriter;

public class Java2WSDL {
    
    public Java2WSDL() {
    }
    
    public void run (String[] args) throws Exception {
        String mWSDLFileName = args[0];
        String className = args[1];
        String targetNamespace = args[2];
        String locationURI = args[3];
        String soapBindingStyle = "rpc";
        if (4 < args.length) {
            soapBindingStyle = args[4];
        }
        Emitter emitter = new Emitter();
        emitter.setStyle(soapBindingStyle);
        emitter.setServiceClassName(className);
        emitter.setTargetNamespace(targetNamespace);
        emitter.setLocationURI(locationURI);
        Definition definition = emitter.emit();
        File outFile = new File(mWSDLFileName);
        File outDir = outFile.getParentFile();
        if (null != outDir && !outDir.exists()) {
            outDir.mkdirs();
        }
        FileOutputStream fileOutputStream = new FileOutputStream(outFile);
        WSDLFactory factory = WSDLFactory.newInstance();
        WSDLWriter writer = factory.newWSDLWriter();
                writer.writeWSDL(definition, fileOutputStream);
        
    }
    public static void main(String args[]) {
        Java2WSDL java2WSDL = new Java2WSDL();
        try {
            java2WSDL.run(args);
        } catch (Exception ex) {
            System.err.println(ex.getMessage());
        }
    }
}
