package org.act.soap.wsdl.wsdl2java;
import javax.xml.namespace.QName;
import java.util.HashMap;
import javax.xml.rpc.encoding.XMLType;

public class TypeMappingRegistry {
  private HashMap mappingRegistry = new HashMap();
  public static final String XSD_URI = "http://www.w3.org/2001/XMLSchema";
  public  static final String SOAPENC_URI="http://schemas.xmlsoap.org/soap/encoding/";
  public  static final String APACHESOAP_URI="http://xml.apache.org/xml-soap";
  public  static final String ACT_ENCODING_URI="http://act.buaa.edu.cn/encoding/";
  
  static final QName XSD_nonPositiveInteger =new QName(XSD_URI, "nonPositiveInteger");
  static final QName XSD_negativeInteger  =new QName(XSD_URI, "negativeInteger");
  static final QName XSD_nonNegativeInteger  =new QName(XSD_URI, "nonNegativeInteger");
  static final QName XSD_unsignedLong   =new QName(XSD_URI, "unsignedLong");
  static final QName XSD_unsignedShort   =new QName(XSD_URI, "unsignedShort");
  static final QName XSD_positiveInteger =new QName(XSD_URI, "positiveInteger");
  static final QName XSD_Integer =new QName(XSD_URI, "integer");
  static final QName XSD_BigDecimal =new QName(XSD_URI, "decimal");
    static final QName ACT_List=new QName(ACT_ENCODING_URI,"List");
  static final QName ACT_Vector=new QName(ACT_ENCODING_URI,"Vector");
  static final QName ACT_Map=new QName(ACT_ENCODING_URI,"Map");
    public static final QName SOAPENC_ARRAY= new QName(SOAPENC_URI,"Array");    public static final QName APACHE_VECTOR =new QName (APACHESOAP_URI,"Vector");  public static final QName APACHE_MAP =new QName (APACHESOAP_URI,"Map");  public TypeMappingRegistry() {
       mappingRegistry.put(XMLType.XSD_BOOLEAN, "boolean");
    mappingRegistry.put(XMLType.XSD_BYTE, "byte");
    mappingRegistry.put(XMLType.XSD_BASE64,"byte[]");
    mappingRegistry.put(XMLType.XSD_DOUBLE, "double");
    mappingRegistry.put(XMLType.XSD_FLOAT, "float");
    mappingRegistry.put(XMLType.XSD_INT, "int");
    mappingRegistry.put(XMLType.XSD_LONG, "long");
    mappingRegistry.put(XMLType.XSD_SHORT, "short");
    mappingRegistry.put(XMLType.XSD_STRING, "java.lang.String");
    mappingRegistry.put(XMLType.XSD_HEXBINARY,"byte[]");
    mappingRegistry.put(XMLType.XSD_DATETIME,"java.util.Calendar");
    mappingRegistry.put(XMLType.XSD_QNAME, "javax.xml.namespace.QName");
        mappingRegistry.put(XMLType.SOAP_BOOLEAN, "java.lang.Boolean");
    mappingRegistry.put(XMLType.SOAP_BYTE,  "java.lang.Byte");
    mappingRegistry.put(XMLType.SOAP_FLOAT,  "java.lang.Float");
    mappingRegistry.put(XMLType.SOAP_INT, "java.lang.Integer");
    mappingRegistry.put(XMLType.SOAP_LONG, "java.lang.Long");
    mappingRegistry.put(XMLType.SOAP_SHORT, "java.lang.Short");
    mappingRegistry.put(XMLType.SOAP_STRING, "java.lang.String");
    mappingRegistry.put(XMLType.SOAP_DOUBLE,"java.lang.Double");
    mappingRegistry.put(XMLType.SOAP_BASE64, "byte[]");
        mappingRegistry.put(this.XSD_BigDecimal, "java.math.BigDecimal");
        mappingRegistry.put(this.XSD_negativeInteger, "java.math.BigInteger");
    mappingRegistry.put(this.XSD_nonNegativeInteger, "java.math.BigInteger");
    mappingRegistry.put(this.XSD_nonPositiveInteger, "java.math.BigInteger");
    mappingRegistry.put(this.XSD_positiveInteger, "java.math.BigInteger");
    mappingRegistry.put(this.XSD_unsignedLong, "java.math.BigInteger");
    mappingRegistry.put(this.XSD_Integer, "java.math.BigInteger");
    mappingRegistry.put(this.XSD_unsignedShort,  "java.lang.Integer");
        mappingRegistry.put(this.ACT_List, "java.util.List");
    mappingRegistry.put(this.ACT_Vector, "java.util.Vector");
    mappingRegistry.put(this.ACT_Map, "java.util.HashMap");
                 }
  
  public String getJavaType(QName xmlType) {
    if(xmlType.equals(this.APACHE_VECTOR) ){
      return "java.util.Vector";
    }
    if(xmlType.equals(this.APACHE_MAP) ){
      return "java.util.HashMap";
    }
    if(xmlType.equals(this.SOAPENC_ARRAY) ){
      return "java.lang.Object[]";
    }
    return  (String) mappingRegistry.get(xmlType);
  }
  
  public void registerComplexType(QName qname,String javaType){
    mappingRegistry.put(qname,javaType);
  }
}
