package org.act.soap.wsdl.wsdl2java;
import java.io.*;
import java.net.*;
import java.util.*;
import javax.wsdl.*;
import javax.wsdl.extensions.soap.*;
import javax.wsdl.factory.*;
import javax.wsdl.xml.*;
import javax.xml.namespace.*;
import org.act.soap.util.*;
import org.act.soap.util.logging.*;
import org.w3c.dom.*;
import org.xml.sax.*;
import javax.wsdl.extensions.UnknownExtensibilityElement;

public class WSDL2Java {
  private TypeMappingRegistry tmr = null;
  private String sourceWSDLFile = null;   
  private String outputDir = null;     private static Log log = LogFactory.getLog(WSDL2Java.class.getName());
  
  public WSDL2Java() {
    tmr = new TypeMappingRegistry();
  }
  
  public static void main(String[] args) {
    if (1 > args.length) {
      usage();
      return;
    }      WSDL2Java w2j = new WSDL2Java();
        w2j.sourceWSDLFile = args[0];
    Definition def = null;
    def = w2j.loadWSDLDocument(w2j.sourceWSDLFile);     if(null == def){
      System.err.println("WSDL_TO_JAVA: loadWSDLDocument ERROR");
      return;
    }
    if (2 == args.length) {       w2j.outputDir = args[1];
    }
    else {
          }
    if (null != w2j.outputDir) {       boolean exists = (new File(w2j.outputDir)).exists();
      if (exists) {              } else {        boolean success = (new File(w2j.outputDir)).mkdirs();
        if (!success) {
          System.err.println("WSDL_TO_JAVA:ERROR Can't creat Output Directory!");
          return;
        }
      }    }
        w2j.complexTypeGenerator(def);
        w2j.generateIF(def);
        w2j.generateStub(def);
  }   
  private static void usage() {
    System.out.println("ACT WSDL2Java StubGenerator:");
    System.out.println(" org.act.soap.wsdl.wsdl2java.WSDL2Java [wsdlfilename] [outputDir]");
    System.out.println("For example:");
    System.out.println("  D:\\SOAP\\src\\org\\act\\soap\\wsdl\\wsdl2java\\echo.wsdl D:\\output_java_stub");
    System.out.println("or:");
    System.out.println("  http://202.112.137.7:8080/axis/services/Echo?wsdl d:\\output");
  }   
  private static Definition loadWSDLDocument(String wsdlDoc) {     Definition def = null;
    if ( !wsdlDoc.startsWith("http://")) {       try {
        WSDLFactory factory = WSDLFactory.newInstance();
        WSDLReader reader = factory.newWSDLReader();
        def = reader.readWSDL(wsdlDoc);
      }
      catch (WSDLException ex) {
        log.error(ex);
        ex.printStackTrace();
      }
    }
    else {       URL wsdlDocLocation = null;
      try {
        wsdlDocLocation = new URL(wsdlDoc);
        InputStream is = wsdlDocLocation.openStream();
        
        WSDLReader reader = WSDLFactory.newInstance().newWSDLReader();
        def = reader.readWSDL(null, new InputSource(is));
      }
      catch (WSDLException e) {
        e.printStackTrace();
      }
      catch (IOException e) {
        e.printStackTrace();
      }
    }
    return def;
  }   
  private void generateIF(Definition def) {
    if (1 < def.getServices().size()) {
      System.err.println("WSDL_TO_JAVA:WSDL Definition дڶService");
          }
    Service service = (Service) (def.getServices().values().iterator().next());
    QName serviceName = service.getQName();
    String packageName = WSDL2Java.namespaceToPackage(serviceName.getNamespaceURI());
    String outputIFFileName = serviceName.getLocalPart();
        final int nameIndex = outputIFFileName.indexOf("Service");
    outputIFFileName = outputIFFileName.substring(0, nameIndex);
        String packageDir = WSDL2Java.packageNameToOutputDir(packageName);
    PrintWriter out = null;
    try {
      FileWriter fileWriter = null;
      if (null != this.outputDir) {
      (new File(this.outputDir + File.separatorChar + packageDir)).mkdirs();          fileWriter = new FileWriter(this.outputDir + File.separatorChar + packageDir + File.separatorChar + outputIFFileName + ".java");       }
      else {
          (new File( packageDir)).mkdirs();          fileWriter = new FileWriter(packageDir + File.separatorChar + outputIFFileName +".java");       }
      out = new PrintWriter(new BufferedWriter(fileWriter));
            Date now = new Date();
      String sDate = now.toString();
      out.println(
          "/* This file is generated by BUAA ACT, WSDL2JavaStub Generator, " +
          sDate + " */");
      out.println("");
      out.println("/**");
      out.println("* ˽ӿڵıInterfaceӿļWSDL2Java");
      out.println("* <p>Copyright: Copyright (c) 2004</p>");
      out.println("* <p>Company: BUAA ACT</p>");
      String userName = System.getProperty("user.name");
      out.println("* @author: "+userName);
      out.println("* @version 1.0");
      out.println("*/");
            out.println("package " + packageName + ";");
      out.println();
                  out.println("import java.rmi.Remote;");
      out.println("import java.rmi.RemoteException;");
      out.println();
      out.println();
            out.println("public interface " + outputIFFileName + " extends java.rmi.Remote" + "{");
      if (1 < service.getPorts().values().size()) {
        System.err.println("WSDL_TO_JAVA:WSDL Service дڶPort");
      }
      Port port = (Port) (service.getPorts().values().iterator().next());
      Binding binding = port.getBinding();
      PortType porttype = binding.getPortType();
      Iterator operationIterator = porttype.getOperations().iterator();
      while (operationIterator.hasNext()) {
        Operation operation = (Operation) (operationIterator.next());
                if((operation.getOutput()==null)&&(operation.getInput()==null)){          continue;
        }
                this.printIndent(1,out);        out.print("public ");
        this.methodReturnTypeGenerator(operation.getOutput(), out);         this.methodNameGenerator(operation, out);         String[] parasOrder = null;
        if (null == operation.getParameterOrdering()) {
          parasOrder = new String[0];
        }
        else {          parasOrder = (String[]) operation.getParameterOrdering().toArray(new String[operation.getParameterOrdering().size()]);
        }
        this.methodParaGenerator(operation.getInput(), parasOrder, out);                 out.println(";") ;
      }       out.println("}");       out.close();
    }
    catch (Exception ex) {
      log.error(ex);
      ex.printStackTrace();
    }
  }   
  public static final String namespaceToPackage(String namespaceURI) {
    String ts = null;
        int index = namespaceURI.indexOf("//");
    if (-1 != index) {
      ts = namespaceURI.substring(index + 2);
    }
    else {
      ts = namespaceURI;
    }
        ts = ts.trim();
    while (ts.charAt(ts.length() - 1) == '/') {
      ts = ts.substring(0, ts.length() - 1);
    }         for(int i=0;i<ts.length();i++){
      if(isSeparator(ts.charAt(i))){
        ts=ts.replace(ts.charAt(i), '.');
      }
    }
        String packageName = null;
    int lastIndex;
    while (0 < ts.lastIndexOf('.')) {
      lastIndex = ts.lastIndexOf('.');
      if (null == packageName) {
        packageName = ts.substring(lastIndex + 1) + ".";
      }
      else {
        packageName = packageName + ts.substring(lastIndex + 1) + ".";
      }
      ts = ts.substring(0, lastIndex);
    }
    packageName = packageName + ts;
    return packageName;
  }   
  static boolean  isSeparator(char c){
    
    if(c>='A'&&c<='Z') return false;
    if(c>='a'&&c<='z') return false;
    if(c>='0'&&c<='9') return false;
    if('_'==c) return false;    return true;  }
  
  private final void methodReturnTypeGenerator(Output output, PrintWriter writer) {
    String typeReturned = null;
    if (0 < output.getMessage().getParts().size()) {       Part part = (Part) (output.getMessage().
                          getParts().values().iterator().
                          next());       typeReturned = tmr.getJavaType(part.getTypeName());
    }
    else {       typeReturned = "void";
    }
    writer.print(typeReturned + " ");
  }
  
  private  final void methodNameGenerator(Operation operation, PrintWriter out) {
    out.print(operation.getName() + " ");
  }   
  private final void methodParaGenerator(Input input, String[] parasOrder, PrintWriter out) throws
      Exception {
    if (0 == parasOrder.length) {       out.print("( )");
      this.methodExceptionGenerator(out);
      out.println();
      return;
    }
    Part[] inputParas = (Part[]) input.getMessage().getParts().values().toArray(new
        Part[input.getMessage().getParts().size()]);
    if (0 < inputParas.length) {       out.print("( ");
      boolean paraBeginFlag = true;       for (int t = 0; t < inputParas.length; t++) {
        if (paraBeginFlag) {
          paraBeginFlag = false;
        }
        else {
          out.print(", ");
        }
                Part part = null;         Part tempPart = null;
        for (int i = 0; i < parasOrder.length; i++) {           tempPart = inputParas[i];
          if (tempPart.getName().equals(parasOrder[t])) {             part = tempPart;
            break;
          }         }                 out.print(this.tmr.getJavaType(part.getTypeName()) + " ");
        out.print(part.getName());
      }       out.print(" )");
      this.methodExceptionGenerator(out);
          }
    else {       out.println("( )");       this.methodExceptionGenerator(out);
    }
  }   
  private void generateStub(Definition def) {
    PrintWriter out = null;
    FileWriter fileWriter = null;
    if (1 < def.getServices().size()) {
      System.err.println("WSDL_TO_JAVA:DefinitionдڶService");
         }
    Service service = (Service) (def.getServices().values().iterator().next());
    QName serviceName = service.getQName();
    String packageName = WSDL2Java.namespaceToPackage(serviceName.getNamespaceURI());
        String outputIFFileName = serviceName.getLocalPart();
    final int nameIndex = outputIFFileName.indexOf("Service");
    outputIFFileName = outputIFFileName.substring(0, nameIndex);
        String packageDir = WSDL2Java.packageNameToOutputDir(packageName);
    try {
      if (null != this.outputDir) {
        (new File(this.outputDir + File.separatorChar + packageDir)).mkdirs();
        fileWriter = new FileWriter(this.outputDir + File.separatorChar + packageDir + File.separatorChar +
                                    outputIFFileName + "_Stub.java");
      }
      else {
        (new File(packageDir)).mkdirs();
        fileWriter = new FileWriter(packageDir + File.separatorChar + outputIFFileName +"_Stub.java");       }
      out = new PrintWriter(new BufferedWriter(fileWriter));
            Date now = new Date();
      String sDate = now.toString();
      out.println(
          "/* This file is generated by BUAA ACT: WSDL2JavaStub Generator, " +
          sDate + " */");
      out.println("");
      out.println("/**");
      out.println("* ˽ӿڵıStubӿļWSDL2Java");
      out.println("* <p>Copyright: Copyright (c) 2004</p>");
      out.println("* <p>Company: BUAA ACT</p>");
      out.println("* @author "+System.getProperty("user.name"));
      out.println("* @version 1.0");
      out.println("*/");
            out.println("package " + packageName + ";");
      out.println();
            out.println("import java.util.Iterator;");
      out.println("import java.rmi.RemoteException;");
      out.println("import javax.xml.rpc.*;");
      out.println("import javax.xml.rpc.encoding.*;");
      out.println("import javax.xml.namespace.QName;");
      out.println("import org.act.soap.encoding.*;");
      out.println("import org.act.soap.encoding.ser.*;");
            out.println();
            out.println("public class " + outputIFFileName + "_Stub " +
                  "extends org.act.soap.client.Stub implements " +
                  outputIFFileName + "{");
      if (1 < service.getPorts().values().size()) {
        System.err.println("TOPGUN:WSDL Service дڶPort");
      }
            out.println();
      this.printIndent(1,out);      out.println("public " + outputIFFileName + "_Stub ( ) throws ServiceException{");
      out.println("");
      this.printIndent(1,out);      out.println("}");
            Port port = (Port) (service.getPorts().values().iterator().next());
      Binding binding = port.getBinding();
      PortType porttype = binding.getPortType();
      Iterator operationIterator = porttype.getOperations().iterator();
      while (operationIterator.hasNext()) {
        Operation operation = (Operation) (operationIterator.next());
                if((operation.getOutput()==null)&&(operation.getInput()==null)){          continue;
        }
                out.println();
        this.printIndent(1,out);
        out.println("//a logic method");
        this.printIndent(1,out);
        out.print("public ");
        this.methodReturnTypeGenerator(operation.getOutput(), out);         this.methodNameGenerator(operation, out);         String[] parasOrder = null;
        if (null == operation.getParameterOrdering()) {          parasOrder = new String[0];
        }
        else {
          parasOrder = (String[]) operation.getParameterOrdering().toArray(new
              String[operation.getParameterOrdering().size()]);
        }
        this.methodParaGenerator(operation.getInput(), parasOrder, out);         this.methodBodyGenerator(def,service, operation, out);       }             out.println("}");             out.close();
    }
    catch (Exception ex) {
      log.error(ex);
      ex.printStackTrace();
    }
  }   
  private final void methodBodyGenerator(Definition def,Service service, Operation operation, PrintWriter out) {
    out.println("  {");     this.printIndent(2, out);     out.println("try {");     this.printIndent(3, out);     out.println("Call call = super.createCall();");
    SOAPAddress soapAddress = null;
    Port addressPort = (Port) (service.getPorts().values().iterator().next());
    soapAddress = (SOAPAddress) (addressPort.getExtensibilityElements().get(0));
    if (null == soapAddress) {
      System.err.println("WSDL_TO_JAVA: SOAPAddress is NULL");
      return;
    }
    String endpoint = soapAddress.getLocationURI();
    if (null == endpoint) {
      System.err.println("WSDL_TO_JAVA: SOAPAddress endpoint is NULL");
      return;
    }
    endpoint = endpoint.trim();
        Iterator myit = operation.getInput().getMessage().getParts().values().iterator();     boolean TMRflag=false;    Collection typeSet= new HashSet();    while (myit.hasNext()) {
      Part mypart = (Part) myit.next();
      QName xmlType = mypart.getTypeName();
      String myns = xmlType.getNamespaceURI();
      if (!myns.equals("http://www.w3.org/2001/XMLSchema")) {                 if(myns.equals(TypeMappingRegistry.ACT_ENCODING_URI)){
          continue;        }
                if(xmlType.equals(TypeMappingRegistry.SOAPENC_ARRAY) ){          continue;
        }
        String javaType = this.tmr.getJavaType(xmlType);
        if(null == javaType){
                    System.err.println("WSDL_TO_JAVA: ERROR :Can't get JavaType from TMR!"+"The xmlType is: "+xmlType);
          return;
        }
                        Element ctElement = this.getComplexTypeByPart(xmlType,def);
                if (this.isJavaComplexClass(ctElement)) {                    if(typeSet.contains(xmlType)){            continue;          }
          if(TMRflag==false){
                      this.printIndent(3,out);
            out.println("TypeMappingRegistry tmr = super.service.getTypeMappingRegistry();");
            this.printIndent(3,out);
            out.println("TypeMapping tm = tmr.getTypeMapping( (String)call.getProperty( Call.ENCODINGSTYLE_URI_PROPERTY ) );");
            TMRflag=true;          }
                  this.serializerCodeGenerator(xmlType, javaType, out);
          typeSet.add(xmlType);        }         else{          if(this.isCustomTypeArray(xmlType,def)){                        xmlType=this.getBaseTypeOfArray(xmlType,def);                        final int index = javaType.indexOf('[');
            javaType = javaType.substring(0, index);
            javaType=javaType.trim();
            if(typeSet.contains(xmlType)){              continue;            }
            if(TMRflag==false){
                            this.printIndent(3,out);
              out.println("TypeMappingRegistry tmr = super.service.getTypeMappingRegistry();");
              this.printIndent(3,out);
              out.println("TypeMapping tm = tmr.getTypeMapping( (String)call.getProperty( Call.ENCODINGSTYLE_URI_PROPERTY ) );");
              TMRflag=true;            }
                    this.serializerCodeGenerator(xmlType, javaType, out);
          typeSet.add(xmlType);          }        }      }    }            out.println();
    this.printIndent(3,out);    out.println("String endpoint = \"" + endpoint + "\";");
    out.println();
    this.printIndent(3,out);    out.println("if (null == call.getTargetEndpointAddress()){");
    this.printIndent(4,out);    out.println("call.setTargetEndpointAddress(endpoint);");
    this.printIndent(3,out);    out.println("}");
    this.printIndent(3,out);    out.println("call.setOperationName(new QName(\"" + operation.getName() + "\"));");     out.println();
    Part[] inputParas = (Part[]) operation.getInput().getMessage().getParts().
        values().toArray(new Part[operation.getInput().getMessage().getParts().
                         size()]);
    String[] parasOrder = null;     if (null == operation.getParameterOrdering()) {      parasOrder = new String[0];
    }
    else {
      parasOrder = (String[]) operation.getParameterOrdering().toArray(new  String[operation.getParameterOrdering().size()]);
    }
    if (0 < inputParas.length) {       Part part = null;       Part tempPart = null;       for (int t = 0; t < inputParas.length; t++) {        for (int i = 0; i < parasOrder.length; i++) {           tempPart = inputParas[i];
          if (tempPart.getName().equals(parasOrder[t])) {             part = tempPart;
            break;
          }         }                 this.printIndent(3,out);                if(this.isArrayType(part.getTypeName(),def)){
          out.println("call.addParameter(\"" + part.getName() + "\",XMLType.SOAP_ARRAY,ParameterMode.IN );");
          out.println();
        }else{
          out.println("QName " + part.getName() + "paraQname = new QName(\"" +
                      part.getTypeName().getNamespaceURI() + "\", \"" +
                      part.getTypeName().getLocalPart() + "\" );");
          this.printIndent(3,out);          out.println("call.addParameter(\"" + part.getName() + "\"," +
                      part.getName() + "paraQname" + ", " + "ParameterMode.IN );");
          out.println();
        }
              }     }     if (0 < operation.getOutput().getMessage().getParts().size()) {       Part part = (Part) (operation.getOutput().getMessage().getParts().values().
                          iterator().next());
      this.printIndent(3,out);                  if(this.isArrayType(part.getTypeName(),def)){
                out.println("call.setReturnType(XMLType.SOAP_ARRAY);");
      } else{
        out.println("QName returnType = new QName (\"" +
                    part.getTypeName().getNamespaceURI() + "\" , \"" +
                    part.getTypeName().getLocalPart() + "\");");
        this.printIndent(3,out);
        out.println("call.setReturnType(returnType);");
        out.println();
      }
          }
    else {     }
    this.printIndent(3,out);
    out.println(" // invoke ");
    Part returnPart=null;                             if (0 < operation.getOutput().getMessage().getParts().size()) {       this.printIndent(3,out);
      this.methodReturnTypeGenerator(operation.getOutput(), out);       this.methodReturnValueGenerator(operation.getOutput(), out);       out.print(" = ");
      returnPart = this.invokeReturnType_Part1(operation.getOutput(), out);
    }
    else {       out.print("  ");
    }
    if (0 < inputParas.length) {       out.print("call.invoke(new Object[] { ");
      boolean paraBeginFlag = true;       for (int t = 0; t < inputParas.length; t++) {
        if (paraBeginFlag) {
          paraBeginFlag = false;
        }
        else {
          out.print(", ");
        }
                Part part = null;         Part tempPart = null;
        for (int i = 0; i < parasOrder.length; i++) {           tempPart = inputParas[i];
          if (tempPart.getName().equals(parasOrder[t])) {             part = tempPart;
            break;
          }         }         if (partIsPrimitiveType(part)) {                     generateWrapperObject(part, out);
        }
        else {           out.print(part.getName());
        }
      }            invokeReturnType_Part2(returnPart,out);
        }
    else {       out.println("call.invoke(null );");
    }
    this.printIndent(3,out);    out.println("super.isResponse = true;");
        this.printIndent(3,out);    out.print("return ");
    this.methodReturnValueGenerator(operation.getOutput(), out);     out.println(";  ");
        out.println();
    this.printIndent(2,out);    out.println("}catch (Exception ex) {");     this.printIndent(3,out);    
      out.println("throw new java.rmi.RemoteException(ex.getMessage());");
       this.printIndent(2,out);    out.println("}");     this.printIndent(1,out);    out.println("}");     out.println();
  }   
  private  void methodReturnValueGenerator(Output output, PrintWriter out) {
    if (0 < output.getMessage().getParts().size()) {
      Part part = (Part) (output.getMessage().getParts().values().iterator().
                          next());
      out.print(" " + part.getName() + " ");
    }
    else {           }
  }   
  private final void complexTypeGenerator(Definition def) {
    Iterator schemas=def.getTypes().getExtensibilityElements().iterator();    if(null == schemas){
      return;       }
    while(schemas.hasNext()){
          NodeList complexTypes =null;
          Element schema=((UnknownExtensibilityElement)schemas.next()).getElement();
                    String tns=schema.getAttribute("targetNamespace") ;
          tns=tns.trim();
          if (tns.equalsIgnoreCase("http://xml.apache.org/xml-soap")){
            continue;          }
          if (tns.equalsIgnoreCase("http://act.buaa.edu.cn/encoding/")){
            continue;          }
                    complexTypes = schema.getElementsByTagName("complexType");          for (int j = 0; j < complexTypes.getLength(); j++) {            Element node = (Element) complexTypes.item(j);
            this.registerComplexType(node);
          }          for (int j = 0; j < complexTypes.getLength(); j++) {            Element node = (Element) complexTypes.item(j);
            if (isJavaComplexClass(node)) {
                            this.genarateJavaComplexClass(node);
            }
          }        }      }   
  protected static final boolean isJavaComplexClass(Element complexType) {
    if (0 < complexType.getElementsByTagNameNS("*", "sequence").getLength()) {
      return true;
    }
    return false;
  }
  
   boolean isCustomTypeArray(QName xmlType,Definition def){
     Element ele=this.getComplexTypeByPart(xmlType,def);
     Element restriction = (Element) (ele.getElementsByTagNameNS("*", "restriction").item(0));
     Element typeRes = (Element) (restriction.getElementsByTagName("attribute").item(0));
     String arrayType = typeRes.getAttribute("wsdl:arrayType");      String preFix = XMLUtils.getPrefixFromQName(arrayType);     String ns = XMLUtils.getNamespaceByPrefix(typeRes, preFix);      String localname = XMLUtils.getLocalNameFromQName(arrayType);          if( localname.indexOf('[')<-1){
              return false;
     }else{       if(ns.equals(TypeMappingRegistry.XSD_URI)){
         return false;       }
       if(ns.equals(TypeMappingRegistry.SOAPENC_URI)){
         return true;       }
       if(ns.equals(TypeMappingRegistry.APACHESOAP_URI)){
         return true;       }
       if(ns.equals(TypeMappingRegistry.ACT_ENCODING_URI)){
         return false;       }
     }        return true;
      }  
  private final void genarateJavaComplexClass(Element complexType) {
    String className = complexType.getAttribute("name");
    className = className.trim();
    Element parent = ( (Element) (complexType.getParentNode()));
    String s = parent.getAttributeNode("targetNamespace").toString().replace('"', ' ');
    String packageName = WSDL2Java.namespaceToPackage(s);     packageName = packageName.trim();     String packageDir = WSDL2Java.packageNameToOutputDir(packageName);
    FileWriter javaBeanFile = null;
    PrintWriter out=null;
    try {
      if (null != this.outputDir) {
      new File(this.outputDir + File.separatorChar + packageDir).mkdirs();
        javaBeanFile = new FileWriter(this.outputDir + File.separatorChar + packageDir + File.separatorChar +
                                      className + ".java");
      }
      else {
        new File(packageDir).mkdirs();
        javaBeanFile = new FileWriter(packageDir + File.separatorChar + className + ".java");
      }
      out = new PrintWriter(new BufferedWriter(javaBeanFile));
    }
    catch (IOException ex) {
      log.error(ex);
      ex.printStackTrace();
    }
            Date now = new Date();
    String sDate = now.toString();
    out.println(
        "/* This file is generated by BUAA ACT: WSDL2JavaStub Generator, " +
        sDate + " */");
    out.println("");
    out.println("/**");
    out.println("* ˽ӿõĸJavaBeanӿļWSDL2Java");
    out.println("* <p>Copyright: Copyright (c) 2004</p>");
    out.println("* <p>Company: BUAA ACT</p>");
    out.println("* @author :"+System.getProperty("user.name"));
    out.println("* @version 1.0");
    out.println("*/");
        out.println("package " + packageName + ";");
    out.println();
            out.println();
        out.println("public class " + className + "{");
    NodeList varList = complexType.getElementsByTagName("element");
    Element var = null;
    for (int i = 0; i < varList.getLength(); i++) {
      var = (Element) (varList.item(i));       this.varDeclarationGenerator(var, out);       this.varGetSetGenerator(var, out);     }         out.println("}// end of JavaBean class");
        out.close();
  }   
  private void registerComplexType(Element ele) {
    String localnameOfComplexType = ele.getAttribute("name");     localnameOfComplexType = localnameOfComplexType.trim();
        String targetNamespace = ( (Element) (ele.getParentNode())).getAttribute("targetNamespace");
    targetNamespace = targetNamespace.trim();
    QName qnameOfComplexType = new QName(targetNamespace, localnameOfComplexType);
    if (0 != ele.getElementsByTagNameNS("*", "restriction").getLength()) {       Element restriction = (Element) (ele.getElementsByTagNameNS("*", "restriction").item(0));             if (!restriction.getAttribute("base").equals("soapenc:Array")) {
        System.err.println("TOPGUN:鸴ע쳣ĵṹ");       }
      Element typeRes = (Element) (restriction.getElementsByTagName("attribute").item(0));
      String arrayBaseType = typeRes.getAttribute("wsdl:arrayType");       String preFix = XMLUtils.getPrefixFromQName(arrayBaseType);
      String ns = XMLUtils.getNamespaceByPrefix(typeRes, preFix);
            final int index = arrayBaseType.indexOf('[');
      String baseType = arrayBaseType.substring(0, index);       baseType = baseType.trim();
      String baseTypeLocalname = XMLUtils.getLocalNameFromQName(baseType);
      String dimensionOfArray = arrayBaseType.substring(index);       dimensionOfArray=dimensionOfArray.trim();
      QName baseTypeQname = new QName(ns, baseTypeLocalname);
      String registerName = tmr.getJavaType(baseTypeQname);       if(null == registerName){                String temps=this.namespaceToPackage(ns);        registerName=temps+"."+baseTypeLocalname;      }
      registerName = registerName + dimensionOfArray;             tmr.registerComplexType(qnameOfComplexType, registerName);
                }
    else {       if (!WSDL2Java.isJavaComplexClass(ele)) {
        log.error("TOPGUN:ComplexTypeȲ ҲJava࣬޷");
        return;
      }
            Element parent = ( (Element) (ele.getParentNode()));
      String ss = parent.getAttributeNode("targetNamespace").toString().replace('"', ' ');
      String packageName = WSDL2Java.namespaceToPackage(ss);       packageName = packageName.trim();       String className = ele.getAttribute("name");
      className = className.trim();       String registerName = packageName + "." + className;
      tmr.registerComplexType(qnameOfComplexType, registerName);
                }   }   
  private void varDeclarationGenerator(Element var, PrintWriter out) {
    String varType = var.getAttribute("type");
    String preFix = XMLUtils.getPrefixFromQName(varType);
    String ns = XMLUtils.getNamespaceByPrefix(var, preFix);
    ns = ns.trim();
    String localname = XMLUtils.getLocalPartFromQName(varType);
    localname=localname.trim();
    QName qname = new QName(ns, localname);
    String javaType = tmr.getJavaType(qname);
    if(null == javaType){
      System.err.println("WSDL_TO_JAVA: ERROR :Can't get JavaType from TMR!! The XML type is:"+qname );
      return;
    }
    this.printIndent(1,out);
    out.println("///////////////// >>>>> ///////////// >>>>>>> //////////////////////");
    this.printIndent(1,out);
    out.print(javaType + " ");
    String varName = var.getAttribute("name");
    varName = varName.trim();
    out.println("  " + varName + " ;");
    out.println();
    out.flush();   }   
  private void varGetSetGenerator(Element var, PrintWriter out) {
        String varType = var.getAttribute("type");
    String preFix = XMLUtils.getPrefixFromQName(varType);
    String ns = XMLUtils.getNamespaceByPrefix(var, preFix);
    ns = ns.trim();
    String localname = XMLUtils.getLocalPartFromQName(varType);
    localname=localname.trim();
    QName qname = new QName(ns, localname);
    String javaType = tmr.getJavaType(qname);
    String varName = var.getAttribute("name");
    varName = varName.trim();
    this.printIndent(1,out);
    out.print("public " + javaType + " ");
    
    String uppercaseName = null;
    if ( (varName.charAt(0) >= 'a') && (varName.charAt(0) <= 'z')) {
      uppercaseName = ( (char) (varName.charAt(0) - 32)) + varName.substring(1);
    }
    out.println("get" + uppercaseName + "( ){ return " + varName + "; }");     out.println();
        this.printIndent(1,out);
    out.print("public void ");
    out.println("set" + uppercaseName + "( " + javaType + " new" + varName +
                " ) ");
    this.printIndent(1,out);
    out.println("{ " + varName + " = " + " new" + varName + "; }");
    out.println();
  }   
  private  void methodExceptionGenerator(PrintWriter out) {
    out.print("throws RemoteException");
  }
  
  private  void serializerCodeGenerator(QName xmlType, String javaType, PrintWriter out) {
        String serializerFactoryType=null;
    String deserializerFactoryType=null;
    String javatype=xmlType.getLocalPart();
    
   if (xmlType.equals(TypeMappingRegistry.APACHE_VECTOR)) {
     serializerFactoryType = "VectorSerializerFactory";
     deserializerFactoryType = "VectorDeserializerFactory";
   }
   if (xmlType.equals(TypeMappingRegistry.APACHE_MAP)) {
     serializerFactoryType = "MapSerializerFactory";
     deserializerFactoryType = "MapDeserializerFactory";
   }
    if(null==serializerFactoryType){
      serializerFactoryType="BeanSerializerFactory";
      deserializerFactoryType="BeanDeserializerFactory";
    }
        out.println();
    this.printIndent(3,out);
    out.println("/** עõĸ */");
    this.printIndent(3,out);
    out.println("Class javaType = null;");
    this.printIndent(3,out);
    out.println("QName xmlType =null;");
    out.println();
    this.printIndent(3,out);
    out.println("javaType = " + javaType + ".class ;");
    this.printIndent(3,out);
    out.println("xmlType = new QName( \"" + xmlType.getNamespaceURI() +
                "\", \"" + xmlType.getLocalPart() + "\",\"tns\" );");
    this.printIndent(3,out);
    out.println("tm.register( javaType, xmlType, new "+serializerFactoryType+"( javaType, xmlType ), new "+deserializerFactoryType+"( javaType, xmlType ) );");
    this.printIndent(3,out);
    out.println("/** עõĸ end*/");
  }   
  public static String packageNameToOutputDir(String packageName) {
    String des = null;
    des = packageName.replace('.', File.separatorChar);
    return des;
  }   
  public static boolean partIsPrimitiveType(Part part) {
    QName xmlType = part.getTypeName();
    if ( (xmlType.equals(TMConstants.XSD_BOOLEAN)) ||
        (xmlType.equals(TMConstants.XSD_BYTE)) ||
        (xmlType.equals(TMConstants.XSD_SHORT)) ||
        (xmlType.equals(TMConstants.XSD_INT)) ||
        (xmlType.equals(TMConstants.XSD_LONG)) ||
        (xmlType.equals(TMConstants.XSD_FLOAT)) ||
        (xmlType.equals(TMConstants.XSD_DOUBLE))) {       return true;
    }     return false;
  }   
  public  void generateWrapperObject(Part part, PrintWriter out) {
    String className = getWrapperClass(part.getTypeName());
    out.print(" new ");
    out.print(className + "(" + part.getName() + ")");
  }   
  public static final String getWrapperClass(QName primType) {
    if (primType.equals(TMConstants.XSD_BOOLEAN)) {
      return "java.lang.Boolean";
    }
    if (primType.equals(TMConstants.XSD_BYTE)) {
      return "java.lang.Byte";
    }
    if (primType.equals(TMConstants.XSD_SHORT)) {
      return "java.lang.Short";
    }
    if (primType.equals(TMConstants.XSD_INT)) {
      return "java.lang.Integer";
    }
    if (primType.equals(TMConstants.XSD_LONG)) {
      return "java.lang.Long";
    }
    if (primType.equals(TMConstants.XSD_FLOAT)) {
      return "java.lang.Float";
    }
    if (primType.equals(TMConstants.XSD_DOUBLE)) {
      return "java.lang.Double";
    }
    return null;   }   
  public static void  printIndent(int indent,PrintWriter out) {
   int indentSize = 4;       for (int i = 0; i < indentSize * indent; i++) {
      out.print(" ");
   }
}
 
 public Element getComplexTypeByPart(QName typeQName,Definition def){
   String partNS=typeQName.getNamespaceURI();
   partNS=partNS.trim();
   String partLocalName=typeQName.getLocalPart();
   Iterator schemas = def.getTypes().getExtensibilityElements().iterator();    NodeList complexTypes = null;
   while (schemas.hasNext()) {
     Element schema = ( (UnknownExtensibilityElement) schemas.next()).
         getElement();
     String s = schema.getAttribute("targetNamespace");
     s = s.trim();
     if (!s.equalsIgnoreCase(partNS)) {        continue;      }
     complexTypes = schema.getElementsByTagName("complexType");      for (int j = 0; j < complexTypes.getLength(); j++) {
       Element complexType = (Element) complexTypes.item(j);
       String localname = complexType.getAttribute("name");
       localname = localname.trim();
       if (localname.equals(partLocalName)) {
         return complexType;
       }
     }    }    System.err.println("WSDL_TO_JAVA:ûҵӦĸͣWSDLĵд");
   System.err.println("typeQName:"+typeQName);
   return null;
 }    
    public Part invokeReturnType_Part1(Output output,PrintWriter out){
      out.print("(");
      Part part=null;
      if (0 < output.getMessage().getParts().size()) {         part = (Part) (output.getMessage().
                       getParts().values().iterator().
                       next());       }
      else {       }
      if (this.partIsPrimitiveType(part)) {         out.print("(");         String s = this.getWrapperClass(part.getTypeName());
        out.print(s);
      }
      else {         this.methodReturnTypeGenerator(output, out);
      }       out.print(")");
      return part;     }     
    public void invokeReturnType_Part2(Part returnPart,PrintWriter out){
                  if(this.partIsPrimitiveType(returnPart)){        String primitiveValueMethod = this.getPrimitiveMethod(returnPart.getTypeName());
        out.println(" }))."+primitiveValueMethod+";");
      }else{        out.println(" });");
      }
    }    
    public static String getPrimitiveMethod(QName primType) {
      if (primType.equals(TMConstants.XSD_BOOLEAN)) {
        return "booleanValue()";
      }
      if (primType.equals(TMConstants.XSD_BYTE)) {
        return "byteValue()";
      }
      if (primType.equals(TMConstants.XSD_SHORT)) {
        return "shortValue()";
      }
      if (primType.equals(TMConstants.XSD_INT)) {
        return "intValue()";
      }
      if (primType.equals(TMConstants.XSD_LONG)) {
        return "longValue()";
      }
      if (primType.equals(TMConstants.XSD_FLOAT)) {
        return "floatValue()";
      }
      if (primType.equals(TMConstants.XSD_DOUBLE)) {
        return "doubleValue()";
      }
      return null;    }    
    QName getBaseTypeOfArray(QName xmlType,Definition def){
      Element ele=this.getComplexTypeByPart(xmlType,def);
      Element restriction = (Element) (ele.getElementsByTagNameNS("*", "restriction").item(0));
      Element typeRes = (Element) (restriction.getElementsByTagName("attribute").item(0));
      String arrayType = typeRes.getAttribute("wsdl:arrayType");       String preFix = XMLUtils.getPrefixFromQName(arrayType);      String ns = XMLUtils.getNamespaceByPrefix(typeRes, preFix);       String localname = XMLUtils.getLocalNameFromQName(arrayType);      ns=ns.trim();
      final int index = localname.indexOf('[');
      String baseType = localname.substring(0, index);      baseType=baseType.trim();
      return new QName(ns,baseType);
    }
    
    boolean isArrayType(QName type, Definition def){
      
      if(type.getNamespaceURI().equalsIgnoreCase("http://schemas.xmlsoap.org/soap/encoding/")&&type.getLocalPart().equalsIgnoreCase("Array")){
        return true;
      }
      if(type.getNamespaceURI().equalsIgnoreCase("http://www.w3.org/2001/XMLSchema")){
        return false;      }
      Element ele=this.getComplexTypeByPart(type,def);
      Element restriction = (Element) (ele.getElementsByTagNameNS("*", "restriction").item(0));
            if(null == restriction){
        return false;      }
            Element typeRes = (Element) (restriction.getElementsByTagName("attribute").item(0));
      String arrayType = typeRes.getAttribute("wsdl:arrayType");       String preFix = XMLUtils.getPrefixFromQName(arrayType);      String ns = XMLUtils.getNamespaceByPrefix(typeRes, preFix);       String localname = XMLUtils.getLocalNameFromQName(arrayType);      ns=ns.trim();
      if(localname.indexOf('[')>-1)
        return true;
      else
        return false;
    }
  } 