package org.act.xdsec.core.com;
import java.io.*;
import org.act.xdsec.util.*;
import org.w3c.dom.*;

public class DataObject {
    
    private String type;
    
    private InputStream dataStream;
    
    private Node dataNode;     
    private NodeList nodeList;
    
    private byte[] bytes;
    
    public DataObject () {
        type = null;
        dataStream = null;
        dataNode = null;
        nodeList = null;
        bytes = null;
    }
    
    public DataObject ( InputStream data ) {
        setDataStream( data );
        dataNode = null;
        nodeList = null;
        bytes = null;
    }
    
    public DataObject ( byte[] data ) {
        setBytes( data );
        dataStream = null;
        dataNode = null;
        nodeList = null;
    }
    
    public DataObject ( Node data ) {
        setDataNode( data );
        dataStream = null;
        nodeList = null;
        bytes = null;
    }
    
    public DataObject ( NodeList data ) {
        setNodeList( data );
        dataStream = null;
        dataNode = null;
        bytes = null;
    }
    
    public final String getType () {
        return this.type;
    }
    
    public final void setType ( String iType ) {
        this.type = iType;
    }
    
    public final void setDataStream ( InputStream data ) {
        this.dataStream = data;
        setType( Constant.DAT_TYPE_STREAM );
    }
    
    public final void setBytes ( byte[] data ) {
        this.bytes = data;
        setType( Constant.DAT_TYPE_BYTE );
    }
    
    public final void setDataNode ( Node data ) {
        this.dataNode = data;
        setType( Constant.DAT_TYPE_NODE );
    }
    
    public final void setNodeList ( NodeList data ) {
        this.nodeList = data;
        setType( Constant.DAT_TYPE_NODELIST );
    }
    
    public final InputStream getDataStream () {
        return this.dataStream;
    }
    
    public final Node getDataNode () {
        return this.dataNode;
    }
    
    public final NodeList getNodeList () {
        return this.nodeList;
    }
    
    public final byte[] getBytes () {
        return this.bytes;
    }
}
