package org.act.xdsec.core.enc;


import java.io.*;
import java.security.*;
import org.act.xdsec.core.exception.*;
import org.act.xdsec.util.*;
import org.w3c.dom.*;

public class EncryptedData
    extends EncryptedItem {
    public EncryptedData () {
        super( EncryptedItem.ENCRYPTEDDATA );
    }
    public void setEncData ( Element encData ) {
                this.mencItem = encData;
    }
    
    public byte[] encrypt ( Element dataObject, Key key ) throws
        NoSuchAlgorithmException,
        EncryptException {         return this.encrypt( dataObject, key, false, true, null );
    }
    public byte[] encrypt ( Element dataObject, Key key, boolean isContentOnly ) throws
        NoSuchAlgorithmException,
        EncryptException {         return this.encrypt( dataObject, key, isContentOnly, true, null );
    }
    public byte[] encrypt ( Element dataObject, Key key, boolean isContentOnly,
                            boolean isRepleased ) throws
        NoSuchAlgorithmException,
        EncryptException {         return this.encrypt( dataObject, key, isContentOnly, isRepleased, null );
    }
    
    public byte[] encrypt ( Element dataObject, Key key, boolean isContentOnly,
                            boolean isReplaced, String algName ) throws
        NoSuchAlgorithmException,
        EncryptException {                 byte[] data = null;
        if ( isContentOnly ) {
            NodeList nodes = null;
                        try {
                                                nodes = dataObject.getChildNodes();
            }
            catch ( Exception ex ) {
                throw new EncryptException( "select nodelist exception" );             }
            nodes = dataObject.getChildNodes();
                                    data = XMLUtils.canonicalizeNodeList( nodes, true );
            String strTemp = null;
            Node node = null;
            for ( int i = 0; i < nodes.getLength(); i++ ) {
                node = nodes.item( i );
                if ( strTemp == null ) {
                    strTemp = DOMWriter.nodeToString( node );
                }
                else {
                    strTemp = strTemp + DOMWriter.nodeToString( node );
                }
            }
            data = strTemp.getBytes();
        }
        else {
                        data = DOMWriter.nodeToString( dataObject ).getBytes();
        }
                                byte[] cipher = innerEncrypt( data, key, algName );
                if ( isContentOnly ) {
                        this.mencItem.setAttribute( Constant.ATT_TYPE,
                                        Constant.ENC_TYPE_CONTENT );
        }
        else {
            this.mencItem.setAttribute( Constant.ATT_TYPE,
                                        Constant.ENC_TYPE_ELEMENT );
                    }
                if ( isReplaced && isContentOnly ) {
            XMLUtils.removeChildNodes( dataObject );
            Document doc = dataObject.getOwnerDocument();
            dataObject.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
            dataObject.appendChild( this.mencItem );
            dataObject.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
        }
        if ( isReplaced && !isContentOnly ) {
            Node parent = dataObject.getParentNode();
            parent.replaceChild( this.mencItem, dataObject );
                                }
                return cipher;
    }
    
    public byte[] encrypt ( InputStream dataObject, Key key ) throws
        NoSuchAlgorithmException,
        EncryptException {         return this.encrypt( dataObject, key );
    }
    
    public byte[] encrypt ( InputStream dataObject, Key key, String algName ) throws
        NoSuchAlgorithmException,
        EncryptException {                 byte[] data = null;
                try {
            data = JavaUtils.getBytesFromStream( dataObject );
        }
        catch ( IOException e2 ) {
            Log.setMsg(
                "Enctypted.encrypt():Failue to get bytes from inputstream." );
            throw new EncryptException( "get bytes from inputstream" );
        }
                byte[] cipher = innerEncrypt( data, key, algName );
                return cipher;
    }
    public byte[] decrypt ( String baseURI, boolean isRestore ) throws
        CipherDataNotFoundException,
        DataObjectNotFoundException,
        NoSuchAlgorithmException,
                        TransformationException,
        KeyResolverException,         DecryptException {         return this.decrypt( null, null, baseURI, isRestore, null );
    }
    public byte[] decrypt ( byte[] keyData, String baseURI, boolean isRestore ) throws
        CipherDataNotFoundException,
        DataObjectNotFoundException,
        NoSuchAlgorithmException,
                        TransformationException,
        KeyResolverException,         DecryptException {         return this.decrypt( keyData, baseURI, isRestore, null );
    }
    public byte[] decrypt ( Key key, String baseURI, boolean isRestore ) throws
        CipherDataNotFoundException,
        DataObjectNotFoundException,
        NoSuchAlgorithmException,
                        TransformationException,
        KeyResolverException,         DecryptException {         return this.decrypt( key, baseURI, isRestore, null );
    }
    
    public byte[] decrypt ( String baseURI, boolean isRestore, String algName ) throws
        NoSuchAlgorithmException,
        DataObjectNotFoundException,
        CipherDataNotFoundException,
                        TransformationException,
        KeyResolverException,         DecryptException {         return this.decrypt( null, null, baseURI, isRestore, algName );
    }
    public byte[] decrypt ( byte[] keyData, String baseURI, boolean isRestore,
                            String algName ) throws NoSuchAlgorithmException,
        DataObjectNotFoundException,
        CipherDataNotFoundException,
                        TransformationException,
        KeyResolverException,         DecryptException {         Element encData = this.mencItem;
        return this.decrypt( null, keyData, baseURI, isRestore, algName );
    }
    public byte[] decrypt ( Key key, String baseURI, boolean isRestore,
                            String algName ) throws NoSuchAlgorithmException,
        DataObjectNotFoundException,
        CipherDataNotFoundException,
                        TransformationException,
        KeyResolverException,         DecryptException {         return this.decrypt( key, null, baseURI, isRestore, algName );
    }
    
    public byte[] getDecryptResult () {
        return this.plaintext;
    }
        private byte[] decrypt ( Key key, byte[] keyData, String baseURI,
                             boolean isRestore, String algName ) throws
        NoSuchAlgorithmException,
        DataObjectNotFoundException,
        CipherDataNotFoundException,
                        TransformationException,
        KeyResolverException,         DecryptException {         Document doc = null;
        Element encData = this.mencItem;
        byte[] data = innerDecrypt( key, keyData, baseURI, algName );
                String tmpString = null;
                if ( 13 == data[0] && 10 == data[1] ) {
            tmpString = new String( data );
            tmpString = tmpString.substring( 2 );
            data = tmpString.getBytes();
        }
                int length = data.length;
        if ( 13 == data[length - 2] && 10 == data[length - 1] ) {
            tmpString = new String( data );
            tmpString = tmpString.substring( 0, length - 2 );
            data = tmpString.getBytes();
        }
        this.plaintext = ( new String( data ) ).getBytes();
                String type = encData.getAttribute( Constant.ATT_TYPE );
        if ( isRestore &&
             ( type.equals( Constant.ENC_TYPE_ELEMENT ) ||
               type.equals( Constant.ENC_TYPE_CONTENT ) ) ) {
                                    String plaintext = new String( data );
            Node parent = encData.getParentNode();
            Document vdoc = parent.getOwnerDocument();
            parent.replaceChild( vdoc.createTextNode( "###new###" ), encData );
            String strDoc = DOMWriter.nodeToString( vdoc );
            int UniqueSymbolStart = strDoc.indexOf( "###new###" );
            int UniqueSymbolEnd = UniqueSymbolStart + "###new###".length() - 1;
            strDoc = strDoc.substring( 0, UniqueSymbolStart )
                + new String( data ) +
                strDoc.substring( UniqueSymbolEnd + 1 );
            doc = DOMWriter.StringToDocument( strDoc, true );
                        Element node = doc.getDocumentElement();
            node = ( Element ) vdoc.importNode( node, true );
            vdoc.replaceChild( node, vdoc.getDocumentElement() );
                    }
        return data;
    }
    
    public NodeList getReferenceList () {
                return null;
    }
    public String getKeyType () {
        return null;
    }
}
