package org.act.xdsec.core.enc;

import java.security.*;
import org.act.xdsec.core.exception.*;
import org.w3c.dom.*;

public class EncryptedKey
    extends EncryptedItem {
    
    public EncryptedKey () {
        super( EncryptedItem.ENCRYPTEDKEY );
    }
    
    public final void setEncKey ( Element encKey ) {
        this.mencItem = encKey;
    }
    
    public byte[] encrypt ( Key keyData, Key key ) throws
        CipherDataNotFoundException,
        DataObjectNotFoundException,
        NoSuchAlgorithmException,
        EncryptException {         return encrypt( keyData, key, null );
    }
    
    public byte[] encrypt ( Key keyData, Key key, String algName ) throws
        CipherDataNotFoundException,
        DataObjectNotFoundException,
        NoSuchAlgorithmException,
        EncryptException {                 final byte[] cipher = innerEncrypt( keyData.getEncoded(), key, algName );
        return cipher;
    }
    
    public byte[] decrypt ( String baseURI ) throws CipherDataNotFoundException,
        DataObjectNotFoundException,
        NoSuchAlgorithmException,
                        TransformationException,
        KeyResolverException,         DecryptException {         return decrypt( null, null, baseURI, null );
    }
    
    public byte[] decrypt ( byte[] keyData, String baseURI ) throws
        CipherDataNotFoundException,
        DataObjectNotFoundException,
        NoSuchAlgorithmException,
                        TransformationException,
        KeyResolverException,         DecryptException {         return decrypt( null, keyData, baseURI, null );
    }
    
    public byte[] decrypt ( Key key, String baseURI ) throws
        CipherDataNotFoundException,
        DataObjectNotFoundException,
        NoSuchAlgorithmException,
                        TransformationException,
        KeyResolverException,         DecryptException {         return decrypt( key, null, baseURI, null );
    }
    
    public byte[] decrypt ( String baseURI, String algName ) throws
        CipherDataNotFoundException,
        DataObjectNotFoundException,
        NoSuchAlgorithmException,
                        TransformationException,
        KeyResolverException,         DecryptException {         return decrypt( null, null, baseURI, null );
    }
    
    public byte[] decrypt ( Key key, byte[] keyData, String baseURI,
                            String algName ) throws
        CipherDataNotFoundException,
        DataObjectNotFoundException,
        NoSuchAlgorithmException,
                        TransformationException,
        KeyResolverException,         DecryptException {                 final byte[] data = innerDecrypt( key, keyData, baseURI, algName );
        return data;
    }
}
