package org.act.xdsec.extension.algorithm;

import java.io.*;
import java.security.*;
import javax.crypto.*;
import javax.crypto.spec.*;
import org.act.xdsec.core.exception.*;
import org.act.xdsec.util.*;


public class BlockEncryptionAlgImpl
    extends BlockEncryptionAlgorithm {
    
    public BlockEncryptionAlgImpl () {
    }
    
    public byte[] encrypt ( byte[] data, Key key ) throws EncryptException {         try {
                        Log.setStartTime( "dataencrypt_getInstance" );
            Cipher cipher = getCipherInstance();
            Log.setEndTime( "dataencrypt_getInstance" );
                        Log.setStartTime( "dataencrypt_init" );
            cipher.init( Cipher.ENCRYPT_MODE, key );
            Log.setEndTime( "dataencrypt_init" );
            ByteArrayOutputStream baos = new ByteArrayOutputStream();
                        final byte[] iv = cipher.getIV();
            if ( null != iv ) {
                baos.write( iv, 0, iv.length );             }
                        
            Log.setStartTime( "dataencrypt_encrypt" );
            final byte[] result3 = cipher.doFinal( data );
            if ( result3 != null && result3.length > 0 ) {
                baos.write( result3, 0, result3.length );
            }
            final byte[] result = baos.toByteArray();
            baos.close();
            Log.setEndTime( "dataencrypt_encrypt" );
            return result;
        }
        catch ( Exception ex ) {
            ex.printStackTrace();
        }
        
        return new byte[0];
    }
    
    public byte[] decrypt ( byte[] data, Key key ) throws DecryptException {         try {
                        Log.setStartTime( "datadecrypt_getInstance" );
            Cipher cipher = getCipherInstance();
            Log.setEndTime( "datadecrypt_getInstance" );
                        AlgorithmParameters algParam = getCipherParameters( data );
                        Log.setStartTime( "datadecrypt_init" );
            cipher.init( Cipher.DECRYPT_MODE, key, algParam );
            Log.setEndTime( "datadecrypt_init" );
            ByteArrayOutputStream baos = new ByteArrayOutputStream();
                        
            Log.setStartTime( "datadecrypt_decrypt" );
                        final int length = getParamLength();             ByteArrayOutputStream ndata = new ByteArrayOutputStream();
            ndata.write( data, length, data.length - length );
            data = ndata.toByteArray();
            ndata.close();
            final byte[] result3 = cipher.doFinal( data );
            if ( null != result3 && 0 < result3.length ) {
                baos.write( result3, 0, result3.length );
            }
            final byte[] result = baos.toByteArray();
            baos.close();
            Log.setEndTime( "datadecrypt_decrypt" );
            return result;
            
        }
        catch ( Exception ex ) {
            ex.printStackTrace();
            return new byte[0];
        }
            }
    
    public Key generateKey () {
        String salgname = this.getAlgId();
        final int index = salgname.indexOf( "/" );
        if ( 0 < index ) {
            salgname = salgname.substring( 0, index );
        }
        Key key = null;
        try {
            KeyGenerator keyg = KeyGenerator.getInstance( salgname,
                this.getProvider() );
            key = keyg.generateKey();
        }
        catch ( NoSuchProviderException ex ) {
        }
        catch ( NoSuchAlgorithmException ex ) {
        }
        return key;
    }
            
    public Key generateKey ( byte[] keyData ) {
        Key key = null;
        key = new SecretKeySpec( keyData, this.getAlgName() );
                return key;
    }
    
    private int getParamLength () {
        int length = 0;
        final int INSTANT_LENGTH = 16;
        if ( this.uri.equals( Constant.ALG_DES_URI ) ) {
            length = 8;
        }
        else if ( this.uri.equals( Constant.ALG_AES128_URI ) ) {
            length = INSTANT_LENGTH;
        }
        else if ( this.uri.equals( Constant.ALG_AES192_URI ) ) {
            length = INSTANT_LENGTH;
        }
        else if ( this.uri.equals( Constant.ALG_AES256_URI ) ) {
            length = INSTANT_LENGTH;
        }
        else {
            length = -1;
        }
        return length;
    }
    
    private AlgorithmParameters getCipherParameters ( byte[] data ) {
                        final int length = getParamLength();
        if ( 0 > length || length > data.length ) {
                        return null;
        }
        AlgorithmParameters algParam = null;
        try {
            final byte[] params = JavaUtils.getBytes( data, 0, length );
            if ( null == this.getProvider() ) {
                algParam = AlgorithmParameters.getInstance( this.getAlgId() );
            }
            else {
                String salgname2 = this.getAlgId();
                final int index = salgname2.indexOf( "/" );
                if ( 0 < index ) {
                    salgname2 = salgname2.substring( 0, index );
                }
                algParam = AlgorithmParameters.getInstance( salgname2,
                    this.getProvider() );
            }
            algParam.init( params );
        }
        catch ( NoSuchAlgorithmException e ) {
        }
        catch ( NoSuchProviderException ex ) {
        }
        catch ( IOException ex ) {
        }
        return algParam;
    }
}
