package org.act.xdsec.extension.algorithm;
import java.security.*;

class DigestAlgorithmImpl
    extends DigestAlgorithm {
    private MessageDigest mDigest = null;
    public byte[] digest ( byte[] input ) {
        this.buildAlg();
        return mDigest.digest( input );
    }
    
    public int getOutputLength () {
        this.buildAlg();
        return mDigest.getDigestLength();
    }
    
    private void buildAlg () {
        try {
            if ( mDigest == null ) {
                if ( this.getProvider() == null ) {
                    mDigest = MessageDigest.getInstance( this.getAlgId() );
                }
                else {
                    mDigest = MessageDigest.getInstance(
                        this.getAlgId(), this.getProvider() );
                }
            }
            else {
                mDigest.reset();
            }
        }
        catch ( NoSuchAlgorithmException e ) {
                    }
        catch ( NoSuchProviderException ex ) {
                    }
    }
}
