package org.act.xdsec.extension.algorithm;
import java.security.*;
import org.act.xdsec.core.exception.*;

public abstract class EncryptionAlgorithm
    extends JCEAlgorithm {
    public EncryptionAlgorithm () {
        super( "Cipher" );
    }
    public abstract byte[] encrypt ( byte[] data, Key key ) throws
        EncryptException;     public abstract byte[] decrypt ( byte[] data, Key key ) throws
        DecryptException;     public abstract Key generateKey ();
            
    public abstract Key generateKey ( byte[] keyData );
    protected String getAlgName () {
        String salgname = this.getAlgId();
        int index = salgname.indexOf( "/" );
        if ( index > 0 ) {
            salgname = salgname.substring( 0, index );
        }
        return salgname;
    }
}

