package org.act.xdsec.extension.algorithm.transform;
import java.io.*;
import org.act.xdsec.core.com.*;
import org.act.xdsec.core.exception.*;
import org.act.xdsec.extension.algorithm.*;
import org.act.xdsec.util.*;
import org.w3c.dom.*;


public class TransformBase64Decode
    extends TransformAlgorithm {
    
    public DataObject transform ( DataObject input, Element sig ) throws
        IOException, CanonicalizationException,
        TransformationException {
        String base64String = "";
        byte[] decodedBytes;
                if ( input.getType().equals( Constant.DAT_TYPE_BYTE ) ) {
            base64String = new String( input.getBytes() );
        }
        else if ( input.getType().equals( Constant.DAT_TYPE_STREAM ) ) {
            base64String = new String( JavaUtils.getBytesFromStream( input.
                getDataStream() ) );
        }
        else if ( input.getType().equals( Constant.DAT_TYPE_NODE ) ) {
                        base64String = NodeToString( input.getDataNode() );
        }
        else if ( input.getType().equals( Constant.DAT_TYPE_NODELIST ) ) {             NodeList inputNodeSet = input.getNodeList();
            for ( int i = 0; i < inputNodeSet.getLength(); i++ ) {
                Node node = inputNodeSet.item( i );
                base64String += NodeToString( node );
            }
        }
        else {
            throw new TransformationException( "Base64 Decode Transform" );
        }                         decodedBytes = JavaUtils.Base64Decode( base64String );
        return new DataObject( decodedBytes );
    }     private String NodeToString ( Node node ) throws TransformationException {
        String base64String = "";
        try {
                        
            if ( node.getNodeType() != Node.ELEMENT_NODE ) {
                return base64String;
            }
            NodeList resultNodeSet = node.getChildNodes();
                        int resultNodeSetGetLength = resultNodeSet.getLength();
            if ( resultNodeSetGetLength == 1 ) {
                base64String += ( ( Text ) resultNodeSet.item( 0 ) ).getData();
            }
            else if ( resultNodeSetGetLength > 1 ) {
                Object exArgs[] = {
                    "Something fishy is going on: 'self::text()' returned "
                    + resultNodeSetGetLength + " nodes"};
                throw new TransformationException( "generic.EmptyMessage",
                    exArgs );
            }
        }
        catch ( Exception ex ) {
                        throw new TransformationException( "Base64Decode Transform" );
        }
        return base64String;
    }
}
