package org.act.xdsec.extension.algorithm.transform;
import java.io.*;
import javax.xml.parsers.*;
import org.act.xdsec.core.com.*;
import org.act.xdsec.core.exception.*;
import org.act.xdsec.extension.algorithm.*;
import org.act.xdsec.util.*;
import org.w3c.dom.*;
import org.xml.sax.*;

public class TransformC14N
    extends TransformAlgorithm {
    public DataObject transform ( DataObject input, Element sig ) throws
        IOException, CanonicalizationException,
        TransformationException {
        byte[] result = null;
        try {
                        if ( input.getType().equals( Constant.DAT_TYPE_NODELIST ) ) {
                result = XPathCanonicalizer.serializeSubset( input.getNodeList(), false );
            }
            else if ( input.getType().equals( Constant.DAT_TYPE_NODE ) ) {
                result = XPathCanonicalizer.serializeSubset( input.getDataNode(), false );
            }
            else if ( input.getType().equals( Constant.DAT_TYPE_STREAM )
                      || input.getType().equals( Constant.DAT_TYPE_BYTE ) ) {
                InputSource in = null;
                if ( input.getType().equals( Constant.DAT_TYPE_BYTE ) ) {
                    ByteArrayInputStream bais = new ByteArrayInputStream( input.
                        getBytes() );
                    in = new InputSource( bais );
                }
                else {
                    in = new InputSource( input.getDataStream() );
                }
                
                DocumentBuilderFactory dfactory = DocumentBuilderFactory.
                    newInstance();
                                                                DocumentBuilder db = dfactory.newDocumentBuilder();
                Document document = db.parse( in );
                result = XPathCanonicalizer.serializeAll( document, false );
            }
        }
        catch ( ParserConfigurationException ex ) {
        }
        catch ( SAXException ex ) {
        }
        ByteArrayInputStream bais = new ByteArrayInputStream( result );
        return new DataObject( bais );
    }
}
