package org.act.xdsec.extension.algorithm.transform;

import java.io.*;
import javax.xml.parsers.*;
import javax.xml.transform.*;
import org.act.xdsec.core.com.*;
import org.act.xdsec.core.exception.*;
import org.act.xdsec.extension.algorithm.*;
import org.act.xdsec.util.*;
import org.apache.xml.utils.*;
import org.apache.xpath.objects.*;
import org.w3c.dom.*;
import org.w3c.dom.Node;
import org.xml.sax.*;
public class TransformXPath
    extends TransformAlgorithm {
    public DataObject transform ( DataObject input, Element sig ) throws
        TransformationException, IOException
        , CanonicalizationException {
        try {
            NodeList inputNodes = null;
                        if ( input.getType().equals( Constant.DAT_TYPE_STREAM ) ) {
                                inputNodes = XMLUtils.buildNodeSetFromStream( input.
                    getDataStream(), Constant.XPATH_C14N_WITH_COMMENTS );
            }
            else if ( input.getType().equals( Constant.DAT_TYPE_NODELIST ) ) {
                inputNodes = input.getNodeList();
            }
            if ( inputNodes.getLength() == 0 ) {
                Object exArgs[] = {
                    "input node set contains no nodes"};
                throw new TransformationException( "generic.EmptyMessage",
                    exArgs );
            }
                        Log.setStartTime( "TransformXPath_getXPath" );
            Element transformElement = getParameter();
            Document doc = transformElement.getOwnerDocument();
            Element nscontext = XMLUtils.createXSecCtx( doc, "ds",
                Constant.NS_XMLDSIG_NAME );
                        
            NodeList xpathNodeList = transformElement.getElementsByTagNameNS(
                Constant.NS_XMLDSIG_NAME, Constant.TAG_XPATH_NAME );
            Element xpathElement = null;
            if ( xpathNodeList == null || xpathNodeList.getLength() == 0 ) {
                Object exArgs[] = {
                    "ds:XPath", "Transform"};
                throw new TransformationException( "xml.WrongContent", exArgs );
            }
            else {
                xpathElement = ( Element ) xpathNodeList.item( 0 );
            }
                        Log.setEndTime( "TransformXPath_getXPath" );
                        HelperNodeList resultNodes = new HelperNodeList();
            
            PrefixResolverDefault prefixResolver =
                new PrefixResolverDefault( xpathElement );
            Node xpathnode = xpathElement.getChildNodes().item( 0 );
            if ( xpathnode == null ) {
                throw new DOMException( DOMException.HIERARCHY_REQUEST_ERR,
                                        "Text must be in ds:Xpath" );
            }
            Log.setStartTime( "TransformXPath_transform" );
            for ( int i = 0; i < inputNodes.getLength(); i++ ) {
                XObject includeInResult = XPathFuncHereAPI.eval(
                    inputNodes.item( i ), xpathnode, prefixResolver );
                                                if ( includeInResult.bool() ) {
                    resultNodes.appendChild( inputNodes.item( i ) );
                }
                else {
                }
            }
            Log.setEndTime( "TransformXPath_transform" );
            DataObject result = new DataObject( resultNodes );
            return result;
        }
        catch ( DOMException ex ) {
            throw new TransformationException( "generic.EmptyMessage", ex );
        }
        catch ( TransformerException ex ) {
            ex.printStackTrace();
            throw new TransformationException( "generic.EmptyMessage", ex );
        }
        catch ( ParserConfigurationException ex ) {
            throw new TransformationException( "generic.EmptyMessage", ex );
        }
        catch ( SAXException ex ) {
            throw new TransformationException( "generic.EmptyMessage", ex );
        }
    }
}
