package org.act.xdsec.extension.algorithm.transform;

import java.io.*;
import java.util.*;
import javax.xml.parsers.*;
import javax.xml.transform.*;
import org.act.xdsec.core.com.*;
import org.act.xdsec.core.exception.*;
import org.act.xdsec.extension.algorithm.*;
import org.act.xdsec.util.*;
import org.apache.xml.utils.*;
import org.apache.xpath.*;
import org.apache.xpath.objects.*;
import org.w3c.dom.*;
import org.w3c.dom.Node;
import org.xml.sax.*;
public class TransformXPathFilter
    extends TransformAlgorithm {
    
    public DataObject transform ( DataObject input, Element sig ) throws
        TransformationException, IOException
        , CanonicalizationException {
        try {
            NodeList inputNodes = null;
                        
            if ( input.getType().equals( Constant.DAT_TYPE_STREAM ) ) {
                                inputNodes = XMLUtils.buildNodeSetFromStream( input.
                    getDataStream(), Constant.XPATH_C14N_WITH_COMMENTS );
            }
            else if ( input.getType().equals( Constant.DAT_TYPE_NODELIST ) ) {
                inputNodes = input.getNodeList();
            }
            if ( inputNodes.getLength() == 0 ) {
                Object exArgs[] = {
                    "input node set contains no nodes"};
                throw new TransformationException( "generic.EmptyMessage",
                    exArgs );
            }
                        Vector oldVec = new Vector();
                        for ( int i = 0; i < inputNodes.getLength(); i++ ) {
                                oldVec.addElement( inputNodes.item( i ) );
            }
                        Vector outputVec = new Vector();
            HelperNodeList resultNodes = new HelperNodeList();
                        Element transformElement = getParameter();
            Document doc = transformElement.getOwnerDocument();
                                    
            NodeList xpathElement = transformElement.getChildNodes();
            if ( xpathElement == null || xpathElement.getLength() == 0 ) {
                Object exArgs[] = {
                    "ds:XPath", "Transform"};
                throw new TransformationException( "xml.WrongContent", exArgs );
            }
                                    for ( int i = 0; i < xpathElement.getLength(); i++ ) {
                if ( xpathElement.item( i ).getNodeType() == Node.ELEMENT_NODE ) {
                                        Element focuselt = ( Element ) xpathElement.item( i );
                    PrefixResolverDefault prefixResolver =
                        new PrefixResolverDefault( focuselt );
                    Node xpathnode = focuselt.getChildNodes().item( 0 );
                    if ( xpathnode == null ) {
                        throw new DOMException( DOMException.
                                                HIERARCHY_REQUEST_ERR,
                                                "Text must be in ds:Xpath" );
                    }
                    String type = focuselt.getAttribute( Constant.ATT_FILTER );
                                                                                XObject xpathObject = XPathAPI.eval( doc,
                        xpathnode.getNodeValue(),
                        prefixResolver );
                    NodeList xpathNodeList = xpathObject.nodelist();
                                                                                                    for ( int j = 0; j < xpathNodeList.getLength(); j++ ) {
                                                NodeList focusNodes = XPathAPI.selectNodeList(
                            xpathNodeList.item( j ),
                            Constant.XPATH_C14N_OMIT_COMMENTS_SINGLE_NODE );
                        for ( int n = 0; n < focusNodes.getLength(); n++ ) {
                            Node elt = focusNodes.item( n );
                            if ( type.equalsIgnoreCase( Constant.
                                ATT_FILTER_INTERSECT ) ) {
                                                                                                if ( oldVec.contains( elt ) ) {
                                    outputVec.addElement( elt );
                                }
                            }
                            else {
                                if ( type.equalsIgnoreCase( Constant.
                                    ATT_FILTER_SUBTRACT ) ) {
                                                                        if ( outputVec.contains( elt ) ) {
                                        outputVec.removeElement( elt );
                                    }
                                }
                                else {
                                    if ( type.equalsIgnoreCase( Constant.
                                        ATT_FILTER_UNION ) ) {
                                                                                if ( !outputVec.contains( elt ) ) {
                                            outputVec.addElement( elt );
                                        }
                                    }
                                }
                            }
                        }
                    }
                    
                }
            }
            for ( int i = 0; i < outputVec.size(); i++ ) {
                resultNodes.appendChild( ( Node ) outputVec.elementAt( i ) );
            }
            DataObject result = new DataObject( resultNodes );
                                    return result;
        }
        catch ( DOMException ex ) {
            throw new TransformationException( "generic.EmptyMessage", ex );
        }
        catch ( TransformerException ex ) {
                        throw new TransformationException( "generic.EmptyMessage", ex );
        }
        catch ( ParserConfigurationException ex ) {
            throw new TransformationException( "generic.EmptyMessage", ex );
        }
        catch ( SAXException ex ) {
            throw new TransformationException( "generic.EmptyMessage", ex );
        }
    }
}
