package org.act.xdsec.extension.keyinfo;
import java.io.*;
import java.security.*;
import java.security.cert.*;
import org.act.xdsec.core.exception.*;
import org.act.xdsec.util.*;
import org.apache.xpath.*;
import org.w3c.dom.*;


public class X509DataProcessorImpl
    implements X509DataProcessor {
        public X509Certificate cert = null;
        public X509DataProcessorImpl () {
    }
    
    public Key getKey ( Node key, boolean ispublic ) throws InvalidKeyException,
        NoSuchAlgorithmException {
                        Element x509data = null;
        Log.setMsg( "X509DataProcessorImpl.getKey():get into this function." );
        if ( key instanceof Element ) {
            x509data = ( Element ) key;
        }
        else {
                                }
        NodeList x509childNodes = null;
        Log.setMsg(
            "X509DataProcessorImpl.getKey():get all child nodes of x509data." );
        try {
            Element nscontext = XMLUtils.createXSecCtx( x509data.
                getOwnerDocument(), "ds", Constant.NS_XMLDSIG_NAME );
            x509childNodes = XPathAPI.selectNodeList( x509data,
                "./ds:*", nscontext );
        }
        catch ( Exception ex ) {
            System.err.println( ex );
        }
        Log.setMsg( "X509DataProcessorImpl.getKey():" );
        X509Certificate cert = null;
        X509Certificate oldCert = null;         Element subKey;
        for ( int i = 0; i < x509childNodes.getLength(); i++ ) {
            if ( x509childNodes.item( i ) instanceof Element ) {
                subKey = ( Element ) x509childNodes.item( i );
            }
            else {
                continue;
            }
            try {
                if ( subKey.getLocalName().equals( Constant.
                    TAG_X509CERTIFICATE_NAME ) ) {
                    Log.setMsg(
                        "X509DataProcessorImpl.getKey():find a certificate." );
                    cert = this.processCertificate( subKey );
                    Log.setMsg(
                        "X509DataProcessorImpl.getKey():get a key from certificate." );
                }
                else if ( subKey.getLocalName().equals( Constant.
                    TAG_X509SKI_NAME ) ) {
                    Log.setMsg( "X509DataProcessorImpl.getKey():find a ski" );
                    cert = this.processSki( subKey );
                    Log.setMsg(
                        "X509DataProcessorImpl.getKey():get a key from ski" );
                }
                else if ( subKey.getLocalName().equals( Constant.
                    TAG_X509ISSUERSERIAL_NAME ) ) {
                    Log.setMsg(
                        "X509DataProcessorImpl.getKey():find a issuerserial" );
                    cert = this.processIssuerSerial( subKey );
                    Log.setMsg(
                        "X509DataProcessorImpl.getKey():get a key from issuerserial" );
                }
                else if ( subKey.getLocalName().equals( Constant.
                    TAG_X509SUBJECTNAME_NAME ) ) {
                    Log.setMsg(
                        "X509DataProcessorImpl.getKey():find a subjectname" );
                    cert = this.processSubjectName( subKey );
                    Log.setMsg(
                        "X509DataProcessorImpl.getKey():get a key from subjectname" );
                }
            }
            catch ( Exception e ) {
                Log.setMsg( "X509DataProcessorImpl.getKey():catch exception." );
            }
            if ( cert != null && oldCert != null ) {
            }
        }
        if ( cert != null ) {
                        
            this.cert = cert;                         Log.setMsg( "X509DataProcessorImpl.getKey():get the key, exit..." );
            return cert.getPublicKey();
        }
        Log.setMsg(
            "X509DataProcessorImpl.getKey(): fail to get a valid key, exit..." );
        return null;
    }
    private X509Certificate processCertificate ( Element x509cert ) throws
        KeyResolverException {
        if ( x509cert == null ) {
            return null;
        }
        try {
            CertificateFactory certFact =
                CertificateFactory.getInstance( Constant.JCA_CERT_ID );
                        X509Certificate cert = ( X509Certificate ) certFact
                .generateCertificate( new ByteArrayInputStream( XMLUtils.
                getBytesFromElement( x509cert ) ) );
            return cert;
        }
        catch ( CertificateException ex ) {
            throw new KeyResolverException( "generic.EmptyMessage" );
        }
        catch ( Exception ex ) {
            return null;
        }
    }
    
    private X509Certificate processSubjectName ( Element subjectName ) throws
        KeyResolverException {
        
        return null;
    }
    
    private X509Certificate processIssuerSerial ( Element issuerSerial ) throws
        KeyResolverException {
        
        return null;
    }
    
    public X509Certificate processSki ( Element ski ) throws
        KeyResolverException {
        
        return null;
    }
}
