
package org.act.xdsec.syntax.dsig;
import java.util.*;
import org.act.xdsec.util.*;
import org.w3c.dom.*;

public class XManifest {
    Document doc;
    String id;
    Vector refs;
    public XManifest ( Document doc ) {
        this.doc = doc;
    }
    
    public void addReference ( XReference reference ) {
        if ( refs == null ) {
            refs = new Vector();
        }
        refs.add( reference );
    }
    
    public XReference createReference () {
        return new XReference();
    }
    
    public String getId () {
        return this.id;
    }
    
    public XReference[] getReferences () {
        return ( XReference[] ) ( this.refs.toArray() );
    }
    
    public void removeReference ( XReference reference ) {
        this.refs.remove( reference );
    }
    
    public void setId ( String id ) {
        this.id = id;
    }
    
    public Element toElement () {
        Element el;
                        el = XMLUtils.createElementInSignatureSpace( doc,
            Constant.TAG_MANIFEST_NAME );
        if ( this.id != null ) {
            el.setAttribute( Constant.ATT_ID, this.id );
        }
        if ( this.refs != null ) {
            el.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
            for ( int i = 0; i < refs.size(); i++ ) {
                el.appendChild( ( ( XReference ) ( refs.elementAt( i ) ) ).
                                toElement(
                                    doc ) );
                el.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
            }
        }
        return el;
    }
}
