package org.act.xdsec.syntax.dsig;

import java.util.*;
import org.act.xdsec.util.*;
import org.w3c.dom.*;

public class XObject {
    private Document doc;
    private String id;
    private String mimeType;
    private String encode;
    private Vector content;
    
    public Element toElement () {
                                Element rtn = XMLUtils.createElementInSignatureSpace( doc,
            Constant.TAG_OBJECT_NAME );
        if ( this.id != null ) {
            rtn.setAttribute( Constant.ATT_ID, this.id );
        }
        if ( this.encode != null ) {
            rtn.setAttribute( Constant.ATT_ENCODE, this.encode );
        }
        if ( this.mimeType != null ) {
            rtn.setAttribute( Constant.ATT_MIMETYPE, this.mimeType );
        }
        if ( this.content != null ) {
            rtn.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
            for ( int i = 0; i < content.size(); i++ ) {
                rtn.appendChild( ( Node ) content.elementAt( i ) );
                rtn.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
            }
        }
        return rtn;
    }
    
    public String getEncoding () {
        return this.encode;
    }
    
    public String getId () {
        return this.id;
    }
    
    public String getMimeType () {
        return this.mimeType;
    }
    
    public void setEncoding ( String encoding ) {
        this.encode = encoding;
    }
    
    public void setId ( String id ) {
        this.id = id;
    }
    
    public void setMimeType ( String mimeType ) {
        this.mimeType = mimeType;
    }
    public void addStringContent ( String str ) {
        addContent( doc.createTextNode( str ) );
    }
    public void addNodeContent ( Node node ) {
        addContent( node );
    }
    public void addNodeListContent ( NodeList nodes ) {
        if ( nodes != null ) {
            for ( int i = 0; i < nodes.getLength(); i++ ) {
                addContent( nodes.item( i ) );
            }
        }
    }
    public void addProperty ( XSignatureProperties properties ) {
        addContent( properties.toElement() );
    }
    public void addManifest ( XManifest manifest ) {
        addContent( manifest.toElement() );
    }
    private void addContent ( Object obj ) {
        if ( this.content == null ) {
            this.content = new Vector();
        }
        content.add( obj );
    }
}
