
package org.act.xdsec.syntax.dsig;
import java.util.*;
import org.act.xdsec.util.*;
import org.w3c.dom.*;

public class XTransform {
    String uri;
    String xpath = null;
    Vector params = null;
    Vector xpathFilter = null;
    
    public void setXPath ( String expr ) {
                if ( this.uri.equalsIgnoreCase( Constant.ALG_XPATH_URI ) ) {
            this.xpath = expr;
        }
            }
    
    public void setURI ( String uriReference ) {
        this.uri = uriReference;
    }
    
    public void addParam ( Node param ) {
        if ( params == null ) {
            this.params = new Vector();
        }
        this.params.add( param );
    }
    
    public void addParams ( NodeList ps ) {
        if ( ps != null ) {
            for ( int i = 0; i < ps.getLength(); i++ ) {
                addParam( ps.item( i ) );
            }
        }
    }
    
    public void addXPathFilter ( String type, String xpath ) {
        if ( type != null && xpath != null ) {
            if ( this.xpathFilter == null ) {
                this.xpathFilter = new Vector();
            }
            Vector vect = new Vector();
            vect.addElement( type );
            vect.addElement( xpath );
            this.xpathFilter.addElement( vect );
        }
    }
    
    public Vector getEncData ( Document doc ) {
        Vector encdata = null;
        Vector exceptNode = null;
        NodeList encNode = null;
        encNode = doc.getElementsByTagNameNS( Constant.NS_XMLENC_NAME,
                                              Constant.ENC_ENCRYPTEDDATA_TAG );
        int i;
        String idstr;
        if ( encNode != null ) {
            encdata = new Vector();
            encdata.removeAllElements();
            for ( i = 0; i < encNode.getLength(); i++ ) {
                idstr = ( ( Element ) encNode.item( i ) ).getAttribute(
                    Constant.
                    ATT_ID );
                encdata.addElement( idstr );
            }
        }
        encNode = doc.getElementsByTagNameNS( Constant.NS_XMLENC_NAME,
                                              Constant.ENC_ENCRYPTEDKEY_TAG );
        if ( encNode != null ) {
            if ( encdata == null ) {
                encdata = new Vector();
                encdata.removeAllElements();
            }
            for ( i = 0; i < encNode.getLength(); i++ ) {
                idstr = ( ( Element ) encNode.item( i ) ).getAttribute(
                    Constant.
                    ATT_ID );
                encdata.addElement( idstr );
            }
        }
        if ( encdata != null || !encdata.isEmpty() ) {
            exceptNode = new Vector();
            exceptNode.removeAllElements();
            Element elt = null;
            for ( i = 0; i < encdata.size(); i++ ) {
                elt = doc.createElementNS( Constant.NS_XMLDECRYPT_NAME,
                                           Constant.PREFIX_DECRYPTION + ":" +
                                           Constant.TAG_EXCEPT_NAME );
                elt.setAttribute( Constant.ATT_URI, "#" + encdata.elementAt( i ) );
                exceptNode.addElement( elt );
            }
        }
        return exceptNode;
    }
    
    public Element toElement ( Document doc ) {
        Element transform;
                        transform = XMLUtils.createElementInSignatureSpace( doc,
            Constant.TAG_TRANSFORM_NAME );
        transform.setAttribute( Constant.ATT_ALGORITHM, uri );
                        if ( this.uri.equalsIgnoreCase( Constant.ALG_XPATH_URI )
             && this.xpath != null ) {
            Element node = XMLUtils.createElementInSignatureSpace( doc,
                Constant.TAG_XPATH_NAME );
            node.appendChild( doc.createTextNode( this.xpath ) );
            this.addParam( node );
        }
                if ( this.uri.equalsIgnoreCase( Constant.ALG_XPATHFILTER2_URI ) ) {
            transform.setAttribute(
                Constant.NS_XMLNS + ":" + Constant.PREFIX_XPATHFILTER,
                Constant.NS_XMLXPATHFILTER_NAME );
            for ( int i = 0; i < xpathFilter.size(); i++ ) {
                Element xpathelt = doc.createElementNS( Constant.
                    NS_XMLXPATHFILTER_NAME,
                    Constant.PREFIX_XPATHFILTER +
                    ":" +
                    Constant.TAG_XPATH_NAME );
                Vector vect = ( Vector )this.xpathFilter.elementAt( i );
                String filter = ( String ) vect.elementAt( 0 );
                String xpathStr = ( String ) vect.elementAt( 1 );
                if ( filter != null ) {
                    xpathelt.setAttribute( Constant.ATT_FILTER, filter );
                }
                if ( xpathStr != null ) {
                    xpathelt.appendChild( doc.createTextNode( xpathStr ) );
                }
                this.addParam( xpathelt );
            }
        }
                        if ( this.uri.equalsIgnoreCase( Constant.ALG_DECTRANSFORM_URI ) ) {
                                    transform.setAttribute(
                Constant.NS_XMLNS + ":" + Constant.PREFIX_DECRYPTION,
                Constant.NS_XMLDECRYPT_NAME );
            Vector exceptNode = this.getEncData( doc );
            for ( int i = 0; i < exceptNode.size(); i++ ) {
                this.addParam( ( Element ) exceptNode.elementAt( i ) );
            }
        }
                if ( params != null ) {
            transform.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
            for ( int i = 0; i < params.size(); i++ ) {
                transform.appendChild( ( Node ) params.elementAt( i ) );
                transform.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
            }
        }
        return transform;
    }
}
