package org.act.xdsec.syntax.enc;

import org.act.xdsec.syntax.dsig.*;
import org.act.xdsec.util.*;
import org.w3c.dom.*;

public class XCipherData {
    String ciphervalue;
    XCipherReference reference;
    XAlgorithm digestmethod;
    String digestvalue;
    public void setCipherValue ( String value ) {
        this.ciphervalue = value;
        this.reference = null;
    }
    public void setCipherReference ( XCipherReference reference ) {
        this.reference = reference;
        this.ciphervalue = null;
    }
    public void setDigest ( XAlgorithm method, String value ) {
        this.digestmethod = method;
        this.digestvalue = value;
    }
        public Element toElement ( Document doc ) {
                Element cipherdata = XMLUtils.createElementInEncryptionSpace( doc,
            Constant.ENC_CIPHERDATA_TAG );
                if ( this.ciphervalue != null ) {
            Element el = XMLUtils.createTextElementInEnc( doc,
                Constant.ENC_CIPHERVALUE_TAG, this.ciphervalue );
            cipherdata.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
            cipherdata.appendChild( el );
            cipherdata.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
        }
        if ( this.reference != null ) {
            cipherdata.appendChild( this.reference.toElement( doc ) );
        }
                if ( this.digestmethod != null ) {
            cipherdata.appendChild( this.digestmethod.toElement( doc ) );
                        cipherdata.appendChild( XMLUtils.createElementInEncryptionSpace(
                doc,
                Constant.ENC_CIPHERVALUE_TAG ) );
        }
        return cipherdata;
    }
}
