package org.act.xdsec.syntax.enc;

import java.security.*;
import org.act.xdsec.syntax.keyinfo.*;
import org.act.xdsec.util.*;
import org.w3c.dom.*;

public abstract class XEncryptedItem {
    String id;
    XEncryptionMethod encMethod;
        XKeyInfo keyinfo;
    XCipherData cipherdata;
        public void setEncryptionMethod ( String uri ) {
        setEncryptionMethod( uri, null );
    }
    public void setEncryptionMethod ( String uri, NodeList params ) {
                XEncryptionMethod em = new XEncryptionMethod( Constant.
            ENC_ENCRYPTIONMETHOD_TAG );         em.setAlgorithmUri( uri );
        if ( params != null ) {
            for ( int i = 0; i < params.getLength(); i++ ) {
                em.addParam( params.item( i ) );
            }
        }
        this.setEncryptionMehtod( em );
    }
    
    public void setEncryptionMehtod ( XEncryptionMethod xencMethod ) {
        this.encMethod = xencMethod;
    }
        public void addKeyValue ( Key value ) {
        if ( this.keyinfo == null ) {
            keyinfo = new XKeyInfo();
        }
        keyinfo.addKeyValue( value );
    }
    public void addKeyName ( String name ) {
        if ( this.keyinfo == null ) {
            keyinfo = new XKeyInfo();
        }
        keyinfo.addKeyName( name );
    }
    public void addRetrievalMethod ( XRetrievalMethod method ) {
        if ( this.keyinfo == null ) {
            keyinfo = new XKeyInfo();
        }
        keyinfo.addRetrievalMethod( method );
    }
    public void addEncryptedKey ( XEncryptedKey key ) {
        if ( this.keyinfo == null ) {
            keyinfo = new XKeyInfo();
        }
        keyinfo.addEncryptedKey( key );
    }
        public void setKeyInfo ( XKeyInfo keyinfo ) {
        this.keyinfo = keyinfo;
    }
        public void setCipherData ( XCipherData xcipher ) {
        this.cipherdata = xcipher;
    }
    public void setCipherValue ( String value ) {
        if ( this.cipherdata == null ) {
            this.cipherdata = new XCipherData();
        }
        cipherdata.setCipherValue( value );
    }
    public void setCipherReference ( XCipherReference reference ) {
        if ( this.cipherdata == null ) {
            this.cipherdata = new XCipherData();
        }
        cipherdata.setCipherReference( reference );
    }
        public void setId ( String sid ) {
        this.id = sid;
    }
            public abstract Element toElement ( Document doc );
        protected void itemToElement ( Document doc, Element item ) {
        if ( this.id != null ) {
            item.setAttribute( Constant.ATT_ID, this.id );
        }
        if ( this.encMethod != null ) {
            item.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
            item.appendChild( this.encMethod.toElement( doc ) );
            item.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
        }
        if ( this.keyinfo != null ) {
            item.appendChild( this.keyinfo.toElement( doc ) );
            item.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
        }
        if ( this.cipherdata != null ) {
            item.appendChild( this.cipherdata.toElement( doc ) );
            item.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
        }
    }
}
