package org.act.xdsec.syntax.enc;

import org.act.xdsec.syntax.keyinfo.*;
import org.act.xdsec.util.*;
import org.w3c.dom.*;

public class XEncryptedKey
    extends XEncryptedItem implements XKeyType {
    XReferenceList referencelist;
    String carriedKeyName;
    String recipient;
            public void setReferenceList ( XReferenceList xlist ) {
        this.referencelist = xlist;
    }
    public void setCarriedKeyName ( String name ) {
        this.carriedKeyName = name;
    }
    public void setRecipient ( String recipent ) {
        this.recipient = recipient;
    }
            public Element toElement ( Document doc ) {
                Element key = XMLUtils.createElementInEncryptionSpace( doc,
            Constant.ENC_ENCRYPTEDKEY_TAG );
                key.setAttribute( Constant.ATT_XMLNS + ":" + Constant.PREFIX_ENCRYPTION,
                          Constant.NS_XMLENC_NAME );
        itemToElement( doc, key );
        if ( this.referencelist != null ) {
            key.appendChild( this.referencelist.toElement( doc ) );
            key.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
        }
        if ( this.carriedKeyName != null ) {
            key.setAttribute( Constant.ATT_CARRIEDKEYNAME, this.carriedKeyName );
        }
        if ( this.recipient != null ) {
            key.setAttribute( Constant.ATT_RECIPIENT, this.recipient );
        }
        return key;
    }
}
