package org.act.xdsec.syntax.enc;

import org.act.xdsec.syntax.dsig.*;
import org.act.xdsec.util.*;
import org.w3c.dom.*;

class XEncryptionMethod
    extends XAlgorithm {
            public XEncryptionMethod () {
        this( null, null, null );
    }
    public XEncryptionMethod ( String algType ) {
        this( algType, null, null );
    }
    public XEncryptionMethod ( String algType, String uri ) {
        this( algType, uri, null );
    }
    public XEncryptionMethod ( String algType, String uri, NodeList params ) {
        setAlgorithmType( algType );
        setAlgorithmUri( uri );
        if ( params != null ) {
            for ( int i = 0; i < params.getLength(); i++ ) {
                this.params.add( params.item( i ) );
            }
        }
    }
    public Element toElement ( Document doc ) {
        Element alg;
                        alg = XMLUtils.createElementInEncryptionSpace( doc, this.algType );
        alg.setAttribute( Constant.ATT_ALGORITHM, this.uriReference );
        processEncContent( doc, alg );
        if ( params != null ) {
            alg.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
            for ( int i = 0; i < params.size(); i++ ) {
                alg.appendChild( ( Node ) params.elementAt( i ) );
                alg.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
            }
        }
        return alg;
    }
}
