package org.act.xdsec.syntax.enc;

import java.util.*;
import org.act.xdsec.util.*;
import org.w3c.dom.*;

public class XReferenceList {
    Vector dataRefs;
    Vector keyRefs;
    public void addDataReference ( String uri, NodeList content ) {
        if ( dataRefs == null ) {
            dataRefs = new Vector();
        }
        XDataReference data = new XDataReference( uri, content );
        dataRefs.add( data );
    }
    public void addKeyReference ( String uri, NodeList content ) {
        if ( keyRefs == null ) {
            keyRefs = new Vector();
        }
        XKeyReference data = new XKeyReference( uri, content );
        keyRefs.add( data );
    }
    public Element toElement ( Document doc ) {
        Element el;
                el = XMLUtils.createElementInEncryptionSpace( doc,
            Constant.ENC_REFERENCELIST_TAG );
        el.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
        if ( this.dataRefs != null ) {
            for ( int i = 0; i < dataRefs.size(); i++ ) {
                el.appendChild( ( ( XDataReference ) ( dataRefs.elementAt( i ) ) ).
                                toElement( doc ) );
                el.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
            }
        }
        if ( this.keyRefs != null ) {
            for ( int i = 0; i < keyRefs.size(); i++ ) {
                el.appendChild( ( ( XKeyReference ) ( dataRefs.elementAt( i ) ) ).
                                toElement( doc ) );
                el.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
            }
        }
        return el;
    }
}
