package org.act.xdsec.syntax.keyinfo;

import java.util.*;
import org.act.xdsec.syntax.dsig.*;
import org.act.xdsec.util.*;
import org.w3c.dom.*;

class XAgreementMethod
    implements XKeyType {
    String uri;
    Vector params;
    String nonce;
    XAlgorithm digest;
    XKeyInfo origin;
    XKeyInfo recipient;
    public void setURI ( String uri ) {
        this.uri = uri;
    }
    public void setNonce ( String value ) {
        this.nonce = ( value );
    }
    public void setDigestMethod ( XAlgorithm digest ) {
        this.digest = ( digest );
    }
    public void setOriginatorKeyInfo ( XKeyInfo keyinfo ) {
        this.origin = ( keyinfo );
    }
    public void setRecipientKeyInfo ( XKeyInfo keyinfo ) {
        this.recipient = ( keyinfo );
    }
    public void addParam ( Node node ) {
        if ( this.params == null ) {
            params = new Vector();
        }
        params.add( node );
    }
    public Element toElement ( Document doc ) {
        Element method = null;
                method = XMLUtils.createElementInSignatureSpace( doc,
            Constant.KEY_AGREEMENTMETHOD_TAG );
        method.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
        if ( this.nonce != null ) {
            method.appendChild( XMLUtils.createTextElementInSig( doc,
                Constant.KEY_NONCE_TAG, this.nonce ) );
            method.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
        }
        if ( this.digest != null ) {
            method.appendChild( digest.toElement( doc ) );
            method.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
        }
        if ( this.origin != null ) {
            method.appendChild( this.origin.toElement( doc ) );
            method.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
        }
        if ( this.recipient != null ) {
            method.appendChild( this.recipient.toElement( doc ) );
            method.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
        }
        if ( params != null ) {
            for ( int i = 0; i < params.size(); i++ ) {
                method.appendChild( ( Node ) params.elementAt( i ) );
                method.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
            }
        }
        return method;
    }
}
