
package org.act.xdsec.syntax.keyinfo;
import java.security.*;
import java.util.*;
import javax.xml.parsers.*;
import org.act.xdsec.syntax.enc.*;
import org.act.xdsec.util.*;
import org.w3c.dom.*;

public class XKeyInfo {
    String id;     Vector keys;     
    public XKeyInfo () {
        this( null );
    }
    
    public XKeyInfo ( String sID ) {
        this.setId( sID );
    }
    
    public void setId ( String sID ) {
        this.id = sID;
    }
    
    public void addKeyName ( String sKeyName ) {
        this.addKey( new XKeyName( sKeyName ) );
    }
    
    public void addKeyName ( XKeyName xKeyName ) {
        this.addKey( xKeyName );
    }
    
    public void addKeyValue ( Key key ) {
        Log.setMsg( "XKeyInfo.addKeyValue, in..." );
        this.addKey( new XKeyValue( key ) );
        Log.setMsg( "XKeyInfo.addKeyValue, exit..." );
    }
    
    public void addPGPData ( XPGPData xPGPData ) {
        this.addKey( xPGPData );
    }
    
    public void addSPKIData ( XSPKIData xSPKIdata ) {
        this.addKey( xSPKIdata );
    }
    
    public void addX509Data ( X509Data x509Data ) {
        this.addKey( x509Data );
    }
    
    public void addRetrievalMethod ( XRetrievalMethod xRetrievalMethod ) {
        this.addKey( xRetrievalMethod );
    }
    
    public void addEncryptedKey ( XEncryptedKey xKey ) {
        this.addKey( xKey );
    }
    
    public void addMgmtData ( String sMgmt ) {
        this.addKey( new XMGMT( sMgmt ) );
    }
    
    public void addMgmtData ( XMGMT xMgmt ) {
        this.addKey( xMgmt );
    }
    
    public void addAnyKey ( XKeyType xKey ) {
        this.addKey( xKey );
    }
    
    void addKey ( XKeyType xKey ) {
        if ( this.keys == null ) {
            keys = new Vector( 1, 1 );
        }
        keys.add( xKey );
    }
    
    public Element toElement ( Document doc ) {
        Element keyinfo;
                keyinfo = XMLUtils.createElementInSignatureSpace( doc,
            Constant.TAG_KEYINFO_NAME );
        keyinfo.setAttribute(
            Constant.ATT_XMLNS + ":" + Constant.PREFIX_SIGNATURE,
            Constant.NS_XMLDSIG_NAME );
        if ( this.id != null ) {
            keyinfo.setAttribute( Constant.ATT_ID, this.id );
        }
        if ( this.keys != null ) {
            for ( int i = 0; i < keys.size(); i++ ) {
                keyinfo.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
                keyinfo.appendChild( ( ( XKeyType ) keys.elementAt( i ) ).
                                     toElement(
                                         doc ) );
                keyinfo.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
            }
        }
        return keyinfo;
    }
    
    public Element toElement () {
        try {
            DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
            factory.setNamespaceAware( true );
            DocumentBuilder builder = factory.newDocumentBuilder();
            Document doc = builder.newDocument();
            return this.toElement( doc );
        }
        catch ( ParserConfigurationException ex ) {
            Log.setMsg( ex.toString() );
            return null;
        }
    }
    public String getKeyName () {
        return null;
            }
    
    public String[] getKeyNames () {
        return null;
            }
    
    public Key getKeyValue () {
        return null;
            }
    
    public String[] getMgmtData () {
        return null;
    }
    
    public XPGPData[] getPGPData () {
        return null;
    }
    
    public Element[] getRetrievalMethods () {
        return null;
    }
    
    public XSPKIData[] getSPKIData () {
        return null;
    }
    
    public Element[] getUnknownChildren () {
        return null;
    }
    
    public X509Data[] getX509Data () {
        return null;
    }
}
