
package org.act.xdsec.syntax.keyinfo;
import java.util.*;
import org.act.xdsec.util.*;
import org.w3c.dom.*;

public class XPGPData
    implements XKeyType {
    
    String keyId;
    
    byte[] packet;
    
    Vector contents;
    
    public XPGPData ( String keyId ) {
        this( keyId, null );
    }
    
    public XPGPData ( byte[] packet ) {
        this( null, packet );
    }
    
    public XPGPData ( String keyId, byte[] packet ) {
        this.keyId = keyId;
        this.packet = packet;
        this.contents = null;
    }
    
    public String getKeyID () {
        return this.keyId;
    }
    
    public byte[] getKeyPacket () {
        return this.packet;
    }
    
    public void setKeyID ( String keyid ) {
        this.keyId = keyid;
    }
    
    public void setKeyPacket ( byte[] packet ) {
        this.packet = packet;
    }
    
    public void addAnyContent ( Element content ) {
        if ( this.contents == null ) {
            this.contents = new Vector( 1, 1 );
        }
        this.contents.add( content );
    }
    
    public Element toElement ( Document doc ) {
                                        if ( this.keyId == null && this.packet == null ) {
            Log.setMsg(
                "PGPData: <PGPKeyID> == null and <PGPKeyPacket> == null !" );
                    }
        Element pgp, el;
                pgp = XMLUtils.createElementInSignatureSpace( doc,
            Constant.TAG_PGPDATA_NAME );
        pgp.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
        if ( this.keyId != null ) {
            el = XMLUtils.createElementInSignatureSpace( doc,
                Constant.TAG_PGPDATA_ID );
            el.appendChild( doc.createTextNode( this.keyId ) );
                                    pgp.appendChild( el );
            pgp.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
        }
        if ( this.packet != null ) {
            el = XMLUtils.createElementInSignatureSpace( doc,
                Constant.TAG_PGPDATA_PACKET );
            el.appendChild( doc.createTextNode( JavaUtils.Base64Encode( this.
                packet ) ) );
                                    pgp.appendChild( el );
            pgp.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
        }
                if ( contents != null ) {
            for ( int i = 0; i < contents.size(); i++ ) {
                el = ( Element ) contents.get( i );
                pgp.appendChild( el );
                pgp.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
            }
        }
                return pgp;
    }
}
