
package org.act.xdsec.syntax.keyinfo;
import java.util.*;
import org.act.xdsec.syntax.dsig.*;
import org.act.xdsec.util.*;
import org.w3c.dom.*;

public class XRetrievalMethod
    implements XKeyType {
    
    String attUri;
    
    String attType;
    
    Vector trans;
    
    public XRetrievalMethod ( String uri ) {
        this.attUri = uri;
    }
    
    public void setURI ( String uri ) {
        this.attUri = uri;
    }
    
    public void setType ( String type ) {
        this.attType = type;
    }
    
    public void addTransform ( XTransform tran ) {
        if ( this.trans == null ) {
            trans = new Vector( 0, 1 );
        }
        trans.add( tran );
    }
    
    public Element toElement ( Document doc ) {
                Element ret = XMLUtils.createElementInSignatureSpace( doc,
            Constant.KEY_RETIREVALMETHOD_TAG );
        if ( this.attUri != null ) {
            ret.setAttribute( Constant.ATT_URI, this.attUri );
        }
        if ( this.attType != null ) {
            ret.setAttribute( Constant.ATT_TYPE, this.attType );
        }
        if ( this.trans != null ) {
                        Element el = XMLUtils.createElementInSignatureSpace( doc,
                Constant.TAG_TRANSFORMS_NAME );
            for ( int i = 0; i < trans.size(); i++ ) {
                XTransform tran = ( XTransform ) trans.elementAt( i );
                el.appendChild( tran.toElement( doc ) );
            }
            ret.appendChild( el );
        }
        return ret;
    }
}
