
package org.act.xdsec.syntax.keyinfo;
import java.util.*;
import org.act.xdsec.util.*;
import org.w3c.dom.*;

public class XSPKIData
    implements XKeyType {
    
    Vector contents;
    
    public XSPKIData ( byte[] exp ) {
        this.contents = new Vector( 1, 1 );
        this.contents.add( exp );
    }
    
    public void addSexp ( byte[] exp ) {
        if ( this.contents == null ) {
            this.contents = new Vector( 1, 1 );
        }
        this.contents.add( exp );
    }
    
    public void addAnyContent ( Element content ) {
        if ( this.contents == null ) {
                        this.contents = new Vector( 1, 1 );
        }
        contents.add( content );
    }
    
    public Element toElement ( Document doc ) {
                Element elSPKIData, elSPKISexp;
                elSPKIData = XMLUtils.createElementInSignatureSpace( doc,
            Constant.TAG_SPKIDATA_NAME );
        elSPKIData.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
        for ( int i = 0; i < contents.size(); i++ ) {
            Object content = contents.get( i );
            if ( content instanceof byte[] ) {
                                elSPKISexp = XMLUtils.createElementInSignatureSpace( doc,
                    Constant.TAG_SPKISEXP_NAME );
                elSPKISexp.appendChild( doc.createTextNode( JavaUtils.
                    Base64Encode( ( byte[] ) content ) ) );
                elSPKIData.appendChild( elSPKISexp );
                elSPKIData.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
            }
            else if ( content instanceof Element ) {
                elSPKIData.appendChild( ( Element ) content );
                elSPKIData.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
            }
        }
                return elSPKIData;
    }
    
}
