package org.act.xdsec.syntax.keyinfo.keyvalues;

import org.act.xdsec.syntax.keyinfo.*;
import org.act.xdsec.util.*;
import org.w3c.dom.*;

class XDHKeyValue
    implements XKeyType {
    String keyprime;
    String keygenerator;
    String keypublic;
    public XDHKeyValue () {
        this( null, null, null );
    }
    public XDHKeyValue ( String prime, String generator, String pub ) {
        this.setPrime( prime );
        this.setGenerator( generator );
        this.setPublic( pub );
    }
    public void setPrime ( String prime ) {
        this.keyprime = prime;
    }
    public void setGenerator ( String generator ) {
        this.keygenerator = generator;
    }
    public void setPublic ( String pub ) {
        this.keypublic = pub;
    }
    public Element toElement ( Document doc ) {
                Element key = XMLUtils.createElementInSignatureSpace( doc,
            Constant.KEY_DHKEYVALUE_TAG );
        if ( this.keyprime != null ) {
            key.appendChild( XMLUtils.createTextElementInSig( doc,
                Constant.KEY_PRIME_TAG, this.keyprime ) );
        }
        if ( this.keygenerator != null ) {
            key.appendChild( XMLUtils.createTextElementInSig( doc,
                Constant.KEY_GENERATOR_TAG, this.keygenerator ) );
        }
        if ( this.keypublic != null ) {
            key.appendChild( XMLUtils.createTextElementInSig( doc,
                Constant.KEY_PUBLIC_TAG, this.keypublic ) );
        }
        return key;
    }
}
