package org.act.xdsec.syntax.keyinfo.x509;
import org.act.xdsec.core.exception.*;
import org.act.xdsec.syntax.keyinfo.*;
import org.act.xdsec.util.*;
import org.w3c.dom.*;

public class XMLX509CRL
    implements XKeyType {
    byte[] crl;
    
    public XMLX509CRL ( byte[] crlBytes ) {
        this.crl = crlBytes;
    }
    public Element toElement ( Document doc ) {
        Element el;
                el = XMLUtils.createElementInSignatureSpace( doc,
            Constant.TAG_X509CRL_NAME );
        el.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
        el.appendChild( doc.createTextNode( JavaUtils.Base64Encode( this.crl ) ) );
        el.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
        return el;
    }
    
    public byte[] getCRLBytes () throws XMLSecurityException {
        return this.crl;
    }
}
