package org.act.xdsec.syntax.keyinfo.x509;
import java.security.cert.*;
import org.act.xdsec.core.exception.*;
import org.act.xdsec.syntax.keyinfo.*;
import org.act.xdsec.util.*;
import org.w3c.dom.*;

public class XMLX509Certificate
    implements XKeyType {
    byte[] cert;
    
    public XMLX509Certificate ( byte[] certificateBytes ) {
        this.cert = certificateBytes;
    }
    
    public XMLX509Certificate ( X509Certificate x509certificate ) throws
        XMLSecurityException {
        try {
            this.cert = x509certificate.getEncoded();
        }
        catch ( java.security.cert.CertificateEncodingException ex ) {
            throw new XMLSecurityException( "empty", ex );
        }
    }
    public Element toElement ( Document doc ) {
        Element el;
                el = XMLUtils.createElementInSignatureSpace( doc,
            Constant.TAG_X509CERTIFICATE_NAME );
        el.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
        el.appendChild( doc.createTextNode( JavaUtils.Base64Encode( this.cert ) ) );
        el.appendChild( doc.createTextNode( Constant.X_CTRLF ) );
        return el;
    }
    
    public byte[] getCertificateBytes () throws XMLSecurityException {
        return this.cert;
    }
}
