package org.act.xdsec.util;
import java.io.*;
import java.math.*;
import java.util.*;

public class JavaUtils {
                public static InputStream getResourceAsStream ( String fileName ) throws
        FileNotFoundException, IOException {
        FileInputStream fisRef = new FileInputStream( fileName );
        return fisRef;
    }
    
    public static byte[] getBytesFromFile ( String fileName ) throws
        FileNotFoundException, IOException {
        byte refBytes[] = null;
        {
            FileInputStream fisRef = new FileInputStream( fileName );
            ByteArrayOutputStream baos = new ByteArrayOutputStream();
            byte buf[] = new byte[1024];
            int len;
            while ( ( len = fisRef.read( buf ) ) > 0 ) {
                baos.write( buf, 0, len );
            }
            refBytes = baos.toByteArray();
        }
        return refBytes;
    }
    
    public static void writeBytesToFilename ( String filename, byte[] bytes ) {
        try {
            if ( filename != null && bytes != null ) {
                File f = new File( filename );
                FileOutputStream fos = new FileOutputStream( f );
                fos.write( bytes );
                fos.close();
            }
            else {
            }
        }
        catch ( Exception ex ) {}
    }
    
    public static byte[] getBytesFromStream ( InputStream inputStream ) throws
        FileNotFoundException, IOException {
        byte refBytes[] = null;
        {
            ByteArrayOutputStream baos = new ByteArrayOutputStream();
            byte buf[] = new byte[1024];
            int len;
            while ( ( len = inputStream.read( buf ) ) > 0 ) {
                baos.write( buf, 0, len );
            }
            refBytes = baos.toByteArray();
        }
        return refBytes;
    }
    
    public static byte[] getBytes ( byte[] src, int start, int length ) {
        if ( start > src.length || start < 0 ) {
            return null;
        }
        else if ( start + length > src.length ) {
            return null;
        }
        byte[] des = new byte[length];
        for ( int i = 0; i < length; i++ ) {
            des[i] = src[start + i];
        }
        return des;
    }
    
    public static byte[] combine2Bytes ( byte[] b1, byte[] b2 ) {
        byte[] result = new byte[b1.length + b2.length];
        for ( int i = 0; i < b1.length; i++ ) {
            result[i] = b1[i];
        }
        for ( int i = 0; i < b2.length; i++ ) {
            result[b1.length + i] = b2[i];
        }
        return result;
    }
    
    public static byte[] reverseBytes ( byte[] src ) {
        byte[] result = new byte[src.length];
        for ( int i = 0; i < src.length; i++ ) {
            result[i] = src[src.length - i - 1];
        }
        return result;
    }
    
    public static void decompose2Bytes ( byte[] src, byte[] d1, byte[] d2,
                                         int nindex ) {
        for ( int i = 0; i < nindex; i++ ) {
            d1[i] = src[i];
        }
        for ( int i = 0; i < src.length - nindex; i++ ) {
            d2[i] = src[i + nindex];
        }
    }
    
    public static int compare2Bytes ( byte[] b1, byte[] b2 ) {
        int len1 = b1.length;
        int len2 = b2.length;
        int len = len1;         if ( len1 > len2 ) {
            len = len2;
        }
        int result = 0;
        for ( int i = 0; i < len; i++ ) {
            if ( b1[i] > b2[i] ) {
                result = 1;
                break;
            }
            if ( b1[i] < b2[i] ) {
                result = -1;
                break;
            }
        }
        if ( result == 0 ) {
            if ( len1 > len2 ) {
                result = 1;
            }
            if ( len1 < len2 ) {
                result = -1;
            }
        }
        return result;
    }
                public static String Base64BigIntegerToString ( BigInteger bint ) {
                byte[] data = bint.toByteArray();
        int off = 0;
        while ( data[off] == 0 ) {
            off++;
        }
        return Base64.encode( data, off, data.length - off );
    }
    public static String Base64Encode ( byte[] data ) {
        return Base64.encode( data );
    }
    public static byte[] Base64Decode ( String str ) {
        return Base64.decode( str );
    }
                
    public static Object searchHashtable ( Hashtable table, Object key ) {
        if ( table == null || key == null ) {
            return null;
        }
        return table.get( key );
    }
                
    public static void heapSort ( int[] indexMap, String[] pd, int length ) {
        int i;
        for ( i = length / 2; i >= 0; i-- ) {             fall( indexMap, pd, length, i );
        }
        for ( i = length - 1; i > 0; i-- ) {
            int t = indexMap[0];
            indexMap[0] = indexMap[i];
            indexMap[i] = t;
            fall( indexMap, pd, i, 0 );
        }
    }
    private static void fall ( int[] indexMap, String[] pd, int n, int i ) {
        int j = 2 * i + 1;
        if ( j < n ) {             if ( j + 1 < n ) {                                 if ( 0 > pd[indexMap[j]].compareTo( pd[indexMap[j + 1]] ) ) {
                    j = 2 * i + 2;
                }
            }
            else {             }
            if ( 0 > compareInUCS( pd[indexMap[i]], pd[indexMap[j]] ) ) {
                                int t = indexMap[i];
                indexMap[i] = indexMap[j];
                indexMap[j] = t;
                fall( indexMap, pd, n, j );
            }
        }
    }
    private static final int lengthInUCS ( String str ) {
        int length = 0;
        for ( int i = 0; i < str.length(); i++ ) {
            int ch = str.charAt( i );
            if ( 0xd800 <= ch && ch < 0xdc00 ) {
                i++;
            }
            length++;
        }
        return length;
    }
    private static final int compareInUCS_old ( String s1, String s2 ) {
        int len1 = lengthInUCS( s1 );
        int len2 = lengthInUCS( s2 );
        int minlen = len1 < len2 ? len1 : len2;
        int i1 = 0;
        int i2 = 0;
        while ( minlen-- != 0 ) {
            int c1 = s1.charAt( i1++ );
            if ( 0xd800 <= c1 && c1 < 0xdc00 && i1 < s1.length() ) {
                c1 = 0x10000 + ( ( c1 - 0xd800 ) << 10 ) + s1.charAt( i1++ ) -
                    0xdc00;
            }
            int c2 = s2.charAt( i2++ );
            if ( 0xd800 <= c2 && c2 < 0xdc00 && i2 < s2.length() ) {
                c2 = 0x10000 + ( ( c2 - 0xd800 ) << 10 ) + s2.charAt( i2++ ) -
                    0xdc00;
            }
            if ( c1 != c2 ) {
                return c1 - c2;
            }
        }
        return len1 - len2;
    }
    private static final int[] fixTable = {
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0x2000, -0x800, -0x800, -0x800, -0x800
    };
    
    private static final int compareInUCS ( String s1, String s2 ) {
        int len1 = s1.length();
        int len2 = s2.length();
        int minlen = len1 < len2 ? len1 : len2;
        int i1 = 0;
        int i2 = 0;
        while ( minlen-- != 0 ) {
            int c1 = s1.charAt( i1++ );
            c1 += fixTable[c1 >> 11];
            int c2 = s2.charAt( i2++ );
            c2 += fixTable[c2 >> 11];
            if ( c1 != c2 ) {
                return c1 - c2;
            }
        }
        return len1 - len2;
    }
    
    public static boolean implementsInterface ( Object object,
                                                String interfaceName ) {
        Vector allClasses = new Vector();
        Vector allInterfaces = new Vector();
        Class c = object.getClass();
        while ( !c.getName().equals( "java.lang.Object" ) ) {
            Class interfaces[] = c.getInterfaces();
            String className = c.getName();
            allClasses.add( className );
            for ( int i = 0; i < interfaces.length; i++ ) {
                String ifName = interfaces[i].getName();
                allInterfaces.add( ifName );
            }
            c = c.getSuperclass();
        }
        for ( int i = 0; i < allInterfaces.size(); i++ ) {
            if ( ( ( String ) allInterfaces.get( i ) ).equals( interfaceName ) ) {
                return true;
            }
        }
        return false;
    }
    
    public static boolean instanceOf ( Object object, String className ) {
        if ( object.getClass().getName().equals( className ) ) {
            return true;
        }
        return implementsInterface( object, className );
    }
    
    public static boolean binaryCompare ( byte refBytes[], byte c14nBytes[] ) {
        
        return java.security.MessageDigest.isEqual( refBytes, c14nBytes );
    }
    
    
    
    public static void runGC () {
        Runtime runtime = Runtime.getRuntime();
        long lFreeMemBefore = runtime.freeMemory();
        long lTotalMemBefore = runtime.totalMemory();
        long lStart = System.currentTimeMillis();
        runtime.gc();
        runtime.runFinalization();
        long lEnd = System.currentTimeMillis();
        double time = ( lEnd - lStart ) / 1000.0;
        long lFreeMemAfter = runtime.freeMemory();
        long lTotalMemAfter = runtime.totalMemory();
    }
}
