package org.act.xdsec.util;
import java.util.*;

public class PerfoRecorder
    implements java.io.Serializable {
    
    private HashMap startMap = null;
    
    private HashMap stopMap = null;
    public PerfoRecorder () {
        startMap = new HashMap();
        stopMap = new HashMap();
    }
    
    public HashMap getStartMap () {
        return startMap;
    }
    
    public HashMap getEndMap () {
        return stopMap;
    }
    
    public void setStartTime ( String moduleName ) {
        startMap.put( moduleName, new Long( System.currentTimeMillis() ) );
    }
    
    public void setEndTime ( String moduleName ) {
        stopMap.put( moduleName, new Long( System.currentTimeMillis() ) );
    }
    
    public Long getStartTime ( String moduleName ) {
        return ( Long ) startMap.get( moduleName );
    }
    
    public Long getEndTime ( String moduleName ) {
        return ( Long ) stopMap.get( moduleName );
    }
    
    public Long getTotalTime ( String moduleName ) {
        Long start = ( Long ) startMap.get( moduleName );
        Long end = ( Long ) stopMap.get( moduleName );
        long total = 0;
        if ( start != null && end != null ) {
            total = end.longValue() - start.longValue();
        }
        return new Long( total );
    }
    
    public Vector getAllModuleTime () {
        Vector vect = new Vector();
        Iterator startiter = startMap.keySet().iterator();
        while ( startiter.hasNext() ) {
            String name = null;
            name = ( String ) startiter.next();
            Long time = getTotalTime( name );
            if ( time != null ) {
                Vector v = new Vector();
                v.addElement( name );
                v.addElement( time );
                vect.addElement( v );
            }
        }
        return vect;
    }
}
